/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/platform","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/network","vs/nls","vs/nls!vs/server/remoteExtensionHostAgent","vs/base/common/errors","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/platform/log/common/log","vs/base/node/pfs","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/process","os","vs/base/common/cancellation","vs/base/common/map","fs","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/registry/common/platform","vs/base/common/extpath","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/configuration/common/configuration","child_process","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetry","vs/base/common/json","vs/base/common/codicons","vs/platform/configuration/common/configurationRegistry","vs/server/remoteUriTransformer","vs/base/common/stream","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/platform/product/common/productService","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/performance","vs/base/common/semver/semver","vs/base/parts/ipc/node/ipc.net","vs/base/common/iterator","vs/base/common/labels","vs/base/common/mime","vs/base/common/uriIpc","vs/editor/common/core/range","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/environment/node/shellEnv","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","crypto","vs/platform/files/node/diskFileSystemProvider","vs/platform/request/common/request","url","vs/platform/telemetry/common/telemetryUtils","vs/server/serverEnvironmentService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/severity","vs/base/common/htmlContent","vs/base/common/normalization","vs/base/node/decoder","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/node/processes","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/localizations/node/localizations","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/files/common/fileService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/server/remoteLanguagePacks","vs/workbench/api/common/extHostTypes","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/editor/common/editorService","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/filters","vs/base/common/iconLabels","vs/base/node/languagePacks","vs/base/node/macAddress","util","vs/base/node/extpath","vs/base/node/ports","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/editor/common/modes/languageSelector","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/server/remoteAgentEnvironmentImpl","vs/nls!vs/server/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/common/ipcFileSystemProvider","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/editor/common/modes","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/argvHelper","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/markers/common/markers","vs/platform/notification/common/notification","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/workspaces/common/workspaces","vs/server/remoteExtensionManagement","vs/server/remoteAgentFileSystemImpl","vs/server/webClientServer","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/testing/common/testId","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/node/extensionPoints","vs/server/remoteAgentEnvironmentImpl","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/server/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/remoteTerminalChannel","vs/server/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","cookie","vs/base/common/marked/marked","yauzl","yazl","http","vs/server/remoteExtensionHostAgent"],ue=function(X){for(var e=[],E=0,P=X.length;E<P;E++)e[E]=ce[X[E]];return e};define(ce[110],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class E{static get(){const g=new Map,D=new Map,I=new Map,C=new Map;function p(m,u){m.has(u.detail)||m.set(u.detail,-u.timestamp)}function w(m,u){let h=m.get(u.detail);!h||h>=0||m.set(u.detail,h+u.timestamp)}const n=X.getStats().slice(0).sort((m,u)=>m.timestamp-u.timestamp);for(const m of n)switch(m.type){case 10:p(g,m);break;case 11:case 12:w(g,m);break;case 21:p(D,m);break;case 22:w(D,m);break;case 33:p(I,m);break;case 34:w(I,m);break;case 31:p(C,m);break;case 32:w(C,m);break}let A=0;I.forEach(m=>A+=m);function b(m){let u=[];return m.forEach((h,S)=>u.push([S,h])),u}return{amdLoad:b(g),amdInvoke:b(D),nodeRequire:b(I),nodeEval:b(C),nodeRequireTotal:A}}static toMarkdownTable(g,D){let I="",C=[];return g.forEach((p,w)=>{C[w]=p.length}),D.forEach(p=>{p.forEach((w,n)=>{typeof w=="undefined"&&(w=p[n]="-");const A=w.toString().length;C[n]=Math.max(A,C[n])})}),g.forEach((p,w)=>{I+=`| ${p+" ".repeat(C[w]-p.toString().length)} `}),I+=`|
`,g.forEach((p,w)=>{I+=`| ${"-".repeat(C[w])} `}),I+=`|
`,D.forEach(p=>{p.forEach((w,n)=>{typeof w!="undefined"&&(I+=`| ${w+" ".repeat(C[n]-w.toString().length)} `)}),I+=`|
`}),I}}e.LoaderStats=E}),define(ce[111],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(P,g){if(!P)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=E}),define(ce[71],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function E(I){return(C,p,w)=>{let n=null,A=null;if(typeof w.value=="function"?(n="value",A=w.value):typeof w.get=="function"&&(n="get",A=w.get),!A)throw new Error("not supported");w[n]=I(A,p)}}e.createDecorator=E;function P(I,C,p){let w=null,n=null;if(typeof p.value=="function"?(w="value",n=p.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(w="get",n=p.get),!n)throw new Error("not supported");const A=`$memoize$${C}`;p[w]=function(...b){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,b)}),this[A]}}e.memoize=P;function g(I,C,p){return E((w,n)=>{const A=`$debounce$${n}`,b=`$debounce$result$${n}`;return function(...m){this[b]||(this[b]=p?p():void 0),clearTimeout(this[A]),C&&(this[b]=C(this[b],...m),m=[this[b]]),this[A]=setTimeout(()=>{w.apply(this,m),this[b]=p?p():void 0},I)}})}e.debounce=g;function D(I,C,p){return E((w,n)=>{const A=`$throttle$timer$${n}`,b=`$throttle$result$${n}`,m=`$throttle$lastRun$${n}`,u=`$throttle$pending$${n}`;return function(...h){if(this[b]||(this[b]=p?p():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),C&&(this[b]=C(this[b],...h)),this[u])return;const S=this[m]+I;S<=Date.now()?(this[m]=Date.now(),w.apply(this,[this[b]]),this[b]=p?p():void 0):(this[u]=!0,this[A]=setTimeout(()=>{this[u]=!1,this[m]=Date.now(),w.apply(this,[this[b]]),this[b]=p?p():void 0},S-Date.now()))}})}e.throttle=D}),define(ce[11],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function P(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=P;function g(a){p(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=g;function D(a){p(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=D;function I(a){if(a instanceof Error){let{name:t,message:r}=a;const i=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:i}}return a}e.transformErrorForSerialization=I;const C="Canceled";function p(a){return a instanceof Error&&a.name===C&&a.message===C}e.isPromiseCanceledError=p;class w extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=w;function n(){const a=new Error(C);return a.name=a.message,a}e.canceled=n;function A(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=A;function b(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=b;function m(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function u(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function h(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=h;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class d extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=d;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function f(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function l(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=l}),define(ce[21],ue([0,1,11]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function P(z,V=0){return z[z.length-(1+V)]}e.tail=P;function g(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=g;function D(z,V,K=(ae,fe)=>ae===fe){if(z===V)return!0;if(!z||!V||z.length!==V.length)return!1;for(let ae=0,fe=z.length;ae<fe;ae++)if(!K(z[ae],V[ae]))return!1;return!0}e.equals=D;function I(z,V,K){let ae=0,fe=z.length-1;for(;ae<=fe;){const De=(ae+fe)/2|0,Pe=K(z[De],V);if(Pe<0)ae=De+1;else if(Pe>0)fe=De-1;else return De}return-(ae+1)}e.binarySearch=I;function C(z,V){let K=0,ae=z.length;if(ae===0)return 0;for(;K<ae;){const fe=Math.floor((K+ae)/2);V(z[fe])?ae=fe:K=fe+1}return K}e.findFirstInSorted=C;function p(z,V,K){if(z=z|0,z>=V.length)throw new TypeError("invalid index");let ae=V[Math.floor(V.length*Math.random())],fe=[],De=[],Pe=[];for(let Fe of V){const Ne=K(Fe,ae);Ne<0?fe.push(Fe):Ne>0?De.push(Fe):Pe.push(Fe)}return z<fe.length?p(z,fe,K):z<fe.length+Pe.length?Pe[0]:p(z-(fe.length+Pe.length),De,K)}e.quickSelect=p;function w(z,V){const K=[];let ae;for(const fe of z.slice(0).sort(V))!ae||V(ae[0],fe)!==0?(ae=[fe],K.push(ae)):ae.push(fe);return K}e.groupBy=w;function n(z,V,K){const ae=[];function fe(Fe,Ne,ze){if(Ne===0&&ze.length===0)return;const Xe=ae[ae.length-1];Xe&&Xe.start+Xe.deleteCount===Fe?(Xe.deleteCount+=Ne,Xe.toInsert.push(...ze)):ae.push({start:Fe,deleteCount:Ne,toInsert:ze})}let De=0,Pe=0;for(;;){if(De===z.length){fe(De,0,V.slice(Pe));break}if(Pe===V.length){fe(De,z.length-De,[]);break}const Fe=z[De],Ne=V[Pe],ze=K(Fe,Ne);ze===0?(De+=1,Pe+=1):ze<0?(fe(De,1,[]),De+=1):ze>0&&(fe(De,0,[Ne]),Pe+=1)}return ae}e.sortedDiff=n;function A(z,V,K){const ae=n(z,V,K),fe=[],De=[];for(const Pe of ae)fe.push(...z.slice(Pe.start,Pe.start+Pe.deleteCount)),De.push(...Pe.toInsert);return{removed:fe,added:De}}e.delta=A;function b(z,V,K){if(K===0)return[];const ae=z.slice(0,K).sort(V);return u(z,V,ae,K,z.length),ae}e.top=b;function m(z,V,K,ae,fe){return K===0?Promise.resolve([]):new Promise((De,Pe)=>{(async()=>{const Fe=z.length,Ne=z.slice(0,K).sort(V);for(let ze=K,Xe=Math.min(K+ae,Fe);ze<Fe;ze=Xe,Xe=Math.min(Xe+ae,Fe)){if(ze>K&&await new Promise(nt=>setTimeout(nt)),fe&&fe.isCancellationRequested)throw(0,E.canceled)();u(z,V,Ne,ze,Xe)}return Ne})().then(De,Pe)})}e.topAsync=m;function u(z,V,K,ae,fe){for(const De=K.length;ae<fe;ae++){const Pe=z[ae];if(V(Pe,K[De-1])<0){K.pop();const Fe=C(K,Ne=>V(Pe,Ne)<0);K.splice(Fe,0,Pe)}}}function h(z){return z.filter(V=>!!V)}e.coalesce=h;function S(z){let V=0;for(let K=0;K<z.length;K++)z[K]&&(z[V]=z[K],V+=1);z.length=V}e.coalesceInPlace=S;function d(z,V,K){z.splice(K,0,z.splice(V,1)[0])}e.move=d;function _(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=_;function f(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=f;function l(z,V){if(!V)return z.filter((ae,fe)=>z.indexOf(ae)===fe);const K=Object.create(null);return z.filter(ae=>{const fe=V(ae);return K[fe]?!1:(K[fe]=!0,!0)})}e.distinct=l;function a(z){const V=new Set;return z.filter(K=>V.has(K)?!1:(V.add(K),!0))}e.distinctES6=a;function t(z){const V=Object.create(null);return K=>{const ae=z(K);return V[ae]?!1:(V[ae]=!0,!0)}}e.uniqueFilter=t;function r(z,V){for(let K=z.length-1;K>=0;K--){const ae=z[K];if(V(ae))return K}return-1}e.lastIndex=r;function i(z,V){return z.length>0?z[0]:V}e.firstOrDefault=i;function s(z,V,K=(ae,fe)=>ae===fe){let ae=0;for(let fe=0,De=Math.min(z.length,V.length);fe<De&&K(z[fe],V[fe]);fe++)ae++;return ae}e.commonPrefixLength=s;function c(z){return[].concat(...z)}e.flatten=c;function v(z,V){let K=typeof V=="number"?z:0;typeof V=="number"?K=z:(K=0,V=z);const ae=[];if(K<=V)for(let fe=K;fe<V;fe++)ae.push(fe);else for(let fe=K;fe>V;fe--)ae.push(fe);return ae}e.range=v;function y(z,V,K){return z.reduce((ae,fe)=>(ae[V(fe)]=K?K(fe):fe,ae),Object.create(null))}e.index=y;function T(z,V){return z.push(V),()=>R(z,V)}e.insert=T;function R(z,V){const K=z.indexOf(V);if(K>-1)return z.splice(K,1),V}e.remove=R;function o(z,V,K){const ae=z.slice(0,V),fe=z.slice(V);return ae.concat(K,fe)}e.arrayInsert=o;function k(z,V){let K;if(typeof V=="number"){let ae=V;K=()=>{const fe=Math.sin(ae++)*179426549;return fe-Math.floor(fe)}}else K=Math.random;for(let ae=z.length-1;ae>0;ae-=1){const fe=Math.floor(K()*(ae+1)),De=z[ae];z[ae]=z[fe],z[fe]=De}}e.shuffle=k;function O(z,V){const K=z.indexOf(V);K>-1&&(z.splice(K,1),z.unshift(V))}e.pushToStart=O;function Y(z,V){const K=z.indexOf(V);K>-1&&(z.splice(K,1),z.push(V))}e.pushToEnd=Y;function Q(z,V){return Array.isArray(z)?z.map(V):V(z)}e.mapArrayOrNot=Q;function me(z){return Array.isArray(z)?z:[z]}e.asArray=me;function re(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=re;function N(z,V){for(const K of z){const ae=V(K);if(ae!==void 0)return ae}}e.mapFind=N;function W(z,V,K){const ae=j(z,V),fe=z.length,De=K.length;z.length=fe+De;for(let Pe=fe-1;Pe>=ae;Pe--)z[Pe+De]=z[Pe];for(let Pe=0;Pe<De;Pe++)z[Pe+ae]=K[Pe]}e.insertInto=W;function U(z,V,K,ae){const fe=j(z,V),De=z.splice(fe,K);return W(z,fe,ae),De}e.splice=U;function j(z,V){return V<0?Math.max(V+z.length,0):Math.min(V,z.length)}function H(z,V){let K=Number.MAX_SAFE_INTEGER,ae=0;return z.forEach((fe,De)=>{const Pe=V(fe);Pe<K&&(K=Pe,ae=De)}),ae}e.minIndex=H;function M(z,V){let K=Number.MIN_SAFE_INTEGER,ae=0;return z.forEach((fe,De)=>{const Pe=V(fe);Pe>K&&(K=Pe,ae=De)}),ae}e.maxIndex=M;class q{constructor(V){this.items=V,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(V){let K=this.firstIdx;for(;K<this.items.length&&V(this.items[K]);)K++;const ae=K===this.firstIdx?null:this.items.slice(this.firstIdx,K);return this.firstIdx=K,ae}takeFromEndWhile(V){let K=this.lastIdx;for(;K>=0&&V(this.items[K]);)K--;const ae=K===this.lastIdx?null:this.items.slice(K+1,this.lastIdx+1);return this.lastIdx=K,ae}}e.ArrayQueue=q}),define(ce[72],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(P){const g=this;let D=!1,I;return function(){return D||(D=!0,I=P.apply(g,arguments)),I}}e.once=E}),define(ce[51],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(P){function g(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}P.is=g;const D=Object.freeze([]);function I(){return D}P.empty=I;function*C(a){yield a}P.single=C;function p(a){return a||D}P.from=p;function w(a){return!a||a[Symbol.iterator]().next().done===!0}P.isEmpty=w;function n(a){return a[Symbol.iterator]().next().value}P.first=n;function A(a,t){for(const r of a)if(t(r))return!0;return!1}P.some=A;function b(a,t){for(const r of a)if(t(r))return r}P.find=b;function*m(a,t){for(const r of a)t(r)&&(yield r)}P.filter=m;function*u(a,t){let r=0;for(const i of a)yield t(i,r++)}P.map=u;function*h(...a){for(const t of a)for(const r of t)yield r}P.concat=h;function*S(a){for(const t of a)for(const r of t)yield r}P.concatNested=S;function d(a,t,r){let i=r;for(const s of a)i=t(i,s);return i}P.reduce=d;function*_(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}P.slice=_;function f(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const i=a[Symbol.iterator]();for(let s=0;s<t;s++){const c=i.next();if(c.done)return[r,P.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return i}}]}P.consume=f;function l(a,t,r=(i,s)=>i===s){const i=a[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const c=i.next(),v=s.next();if(c.done!==v.done)return!1;if(c.done)return!0;if(!r(c.value,v.value))return!1}}P.equals=l})(E=e.Iterable||(e.Iterable={}))}),define(ce[38],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P=e.SyntaxKind||(e.SyntaxKind={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function I(t,r=!1){let i=0,s=t.length,c="",v=0,y=16,T=0;function R(re){let N=0,W=0;for(;N<re;){const U=t.charCodeAt(i);if(U>=48&&U<=57)W=W*16+U-48;else if(U>=65&&U<=70)W=W*16+U-65+10;else if(U>=97&&U<=102)W=W*16+U-97+10;else break;i++,N++}return N<re&&(W=-1),W}function o(re){i=re,c="",v=0,y=16,T=0}function k(){const re=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&w(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&w(t.charCodeAt(i)))for(i++;i<t.length&&w(t.charCodeAt(i));)i++;else return T=3,t.substring(re,i);let N=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&w(t.charCodeAt(i))){for(i++;i<t.length&&w(t.charCodeAt(i));)i++;N=i}else T=3;return t.substring(re,N)}function O(){let re="",N=i;for(;;){if(i>=s){re+=t.substring(N,i),T=2;break}const W=t.charCodeAt(i);if(W===34){re+=t.substring(N,i),i++;break}if(W===92){if(re+=t.substring(N,i),i++,i>=s){T=2;break}switch(t.charCodeAt(i++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:const j=R(4);j>=0?re+=String.fromCharCode(j):T=4;break;default:T=5}N=i;continue}if(W>=0&&W<=31)if(p(W)){re+=t.substring(N,i),T=2;break}else T=6;i++}return re}function Y(){if(c="",T=0,v=i,i>=s)return v=s,y=17;let re=t.charCodeAt(i);if(C(re)){do i++,c+=String.fromCharCode(re),re=t.charCodeAt(i);while(C(re));return y=15}if(p(re))return i++,c+=String.fromCharCode(re),re===13&&t.charCodeAt(i)===10&&(i++,c+=`
`),y=14;switch(re){case 123:return i++,y=1;case 125:return i++,y=2;case 91:return i++,y=3;case 93:return i++,y=4;case 58:return i++,y=6;case 44:return i++,y=5;case 34:return i++,c=O(),y=10;case 47:const N=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!p(t.charCodeAt(i));)i++;return c=t.substring(N,i),y=12}if(t.charCodeAt(i+1)===42){i+=2;const W=s-1;let U=!1;for(;i<W;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,U=!0;break}i++}return U||(i++,T=1),c=t.substring(N,i),y=13}return c+=String.fromCharCode(re),i++,y=16;case 45:if(c+=String.fromCharCode(re),i++,i===s||!w(t.charCodeAt(i)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=k(),y=11;default:for(;i<s&&Q(re);)i++,re=t.charCodeAt(i);if(v!==i){switch(c=t.substring(v,i),c){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return c+=String.fromCharCode(re),i++,y=16}}function Q(re){if(C(re)||p(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function me(){let re;do re=Y();while(re>=12&&re<=15);return re}return{setPosition:o,getPosition:()=>i,scan:r?me:Y,getToken:()=>y,getTokenValue:()=>c,getTokenOffset:()=>v,getTokenLength:()=>i-v,getTokenError:()=>T}}e.createScanner=I;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function A(t,r){const i=[],s=new Object;let c;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function T(R,o,k,O){v.value=R,v.offset=o,v.length=k,v.type=O,v.colonOffset=void 0,c=v}try{f(t,{onObjectBegin:(R,o)=>{if(r<=R)throw s;c=void 0,y=r>R,i.push("")},onObjectProperty:(R,o,k)=>{if(r<o||(T(R,o,k,"property"),i[i.length-1]=R,r<=o+k))throw s},onObjectEnd:(R,o)=>{if(r<=R)throw s;c=void 0,i.pop()},onArrayBegin:(R,o)=>{if(r<=R)throw s;c=void 0,i.push(0)},onArrayEnd:(R,o)=>{if(r<=R)throw s;c=void 0,i.pop()},onLiteralValue:(R,o,k)=>{if(r<o||(T(R,o,k,a(R)),r<=o+k))throw s},onSeparator:(R,o,k)=>{if(r<=o)throw s;if(R===":"&&c&&c.type==="property")c.colonOffset=o,y=!1,c=void 0;else if(R===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(y=!0,i[i.length-1]=""),c=void 0}}})}catch(R){if(R!==s)throw R}return{path:i,previousNode:c,isAtPropertyKey:y,matches:R=>{let o=0;for(let k=0;o<R.length&&k<i.length;k++)if(R[o]===i[k]||R[o]==="*")o++;else if(R[o]!=="**")return!1;return o===R.length}}}e.getLocation=A;function b(t,r=[],i=D.DEFAULT){let s=null,c=[];const v=[];function y(R){Array.isArray(c)?c.push(R):s!==null&&(c[s]=R)}return f(t,{onObjectBegin:()=>{const R={};y(R),v.push(c),c=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{c=v.pop()},onArrayBegin:()=>{const R=[];y(R),v.push(c),c=R,s=null},onArrayEnd:()=>{c=v.pop()},onLiteralValue:y,onError:(R,o,k)=>{r.push({error:R,offset:o,length:k})}},i),c[0]}e.parse=b;function m(t,r=[],i=D.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(R){s.type==="property"&&(s.length=R-s.offset,s=s.parent)}function v(R){return s.children.push(R),R}f(t,{onObjectBegin:R=>{s=v({type:"object",offset:R,length:-1,parent:s,children:[]})},onObjectProperty:(R,o,k)=>{s=v({type:"property",offset:o,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:R,offset:o,length:k,parent:s})},onObjectEnd:(R,o)=>{s.length=R+o-s.offset,s=s.parent,c(R+o)},onArrayBegin:(R,o)=>{s=v({type:"array",offset:R,length:-1,parent:s,children:[]})},onArrayEnd:(R,o)=>{s.length=R+o-s.offset,s=s.parent,c(R+o)},onLiteralValue:(R,o,k)=>{v({type:a(R),offset:o,length:k,parent:s,value:R}),c(o+k)},onSeparator:(R,o,k)=>{s.type==="property"&&(R===":"?s.colonOffset=o:R===","&&c(o))},onError:(R,o,k)=>{r.push({error:R,offset:o,length:k})}},i);const T=s.children[0];return T&&delete T.parent,T}e.parseTree=m;function u(t,r){if(!t)return;let i=t;for(let s of r)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let c=!1;for(const v of i.children)if(Array.isArray(v.children)&&v.children[0].value===s){i=v.children[1],c=!0;break}if(!c)return}else{const c=s;if(i.type!=="array"||c<0||!Array.isArray(i.children)||c>=i.children.length)return;i=i.children[c]}return i}e.findNodeAtLocation=u;function h(t){if(!t.parent||!t.parent.children)return[];const r=h(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=h;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const r=Object.create(null);for(let i of t.children){const s=i.children[1];s&&(r[i.children[0].value]=S(s))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function d(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=d;function _(t,r,i=!1){if(d(t,r,i)){const s=t.children;if(Array.isArray(s))for(let c=0;c<s.length&&s[c].offset<=r;c++){const v=_(s[c],r,i);if(v)return v}return t}}e.findNodeAtOffset=_;function f(t,r,i=D.DEFAULT){const s=I(t,!1);function c(K){return K?()=>K(s.getTokenOffset(),s.getTokenLength()):()=>!0}function v(K){return K?ae=>K(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const y=c(r.onObjectBegin),T=v(r.onObjectProperty),R=c(r.onObjectEnd),o=c(r.onArrayBegin),k=c(r.onArrayEnd),O=v(r.onLiteralValue),Y=v(r.onSeparator),Q=c(r.onComment),me=v(r.onError),re=i&&i.disallowComments,N=i&&i.allowTrailingComma;function W(){for(;;){const K=s.scan();switch(s.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:re||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(K){case 12:case 13:re?U(10):Q();break;case 16:U(1);break;case 15:case 14:break;default:return K}}}function U(K,ae=[],fe=[]){if(me(K),ae.length+fe.length>0){let De=s.getToken();for(;De!==17;){if(ae.indexOf(De)!==-1){W();break}else if(fe.indexOf(De)!==-1)break;De=W()}}}function j(K){const ae=s.getTokenValue();return K?O(ae):T(ae),W(),!0}function H(){switch(s.getToken()){case 11:let K=0;try{K=JSON.parse(s.getTokenValue()),typeof K!="number"&&(U(2),K=0)}catch(ae){U(2)}O(K);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return W(),!0}function M(){return s.getToken()!==10?(U(3,[],[2,5]),!1):(j(!1),s.getToken()===6?(Y(":"),W(),V()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function q(){y(),W();let K=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(K||U(4,[],[]),Y(","),W(),s.getToken()===2&&N)break}else K&&U(6,[],[]);M()||U(4,[],[2,5]),K=!0}return R(),s.getToken()!==2?U(7,[2],[]):W(),!0}function z(){o(),W();let K=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(K||U(4,[],[]),Y(","),W(),s.getToken()===4&&N)break}else K&&U(6,[],[]);V()||U(4,[],[4,5]),K=!0}return k(),s.getToken()!==4?U(8,[4],[]):W(),!0}function V(){switch(s.getToken()){case 3:return z();case 1:return q();case 10:return j(!0);default:return H()}}return W(),s.getToken()===17?i.allowEmptyContent?!0:(U(4,[],[]),!1):V()?(s.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=f;function l(t,r){let i=I(t),s=[],c,v=0,y;do switch(y=i.getPosition(),c=i.scan(),c){case 12:case 13:case 17:v!==y&&s.push(t.substring(v,y)),r!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,r)),v=i.getPosition();break}while(c!==17);return s.join("")}e.stripComments=l;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(ce[112],ue([0,1,38]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function P(p,w,n){let A,b,m,u,h;if(w){for(u=w.offset,h=u+w.length,m=u;m>0&&!C(p,m-1);)m--;let v=h;for(;v<p.length&&!C(p,v);)v++;b=p.substring(m,v),A=D(b,n)}else b=p,A=0,m=0,u=0,h=p.length;const S=I(n,p);let d=!1,_=0,f;n.insertSpaces?f=g(" ",n.tabSize||4):f="	";const l=(0,E.createScanner)(b,!1);let a=!1;function t(){return S+g(f,A+_)}function r(){let v=l.scan();for(d=!1;v===15||v===14;)d=d||v===14,v=l.scan();return a=v===16||l.getTokenError()!==0,v}const i=[];function s(v,y,T){!a&&y<h&&T>u&&p.substring(y,T)!==v&&i.push({offset:y,length:T-y,content:v})}let c=r();if(c!==17){const v=l.getTokenOffset()+m,y=g(f,A);s(y,m,v)}for(;c!==17;){let v=l.getTokenOffset()+l.getTokenLength()+m,y=r(),T="";for(;!d&&(y===12||y===13);){const o=l.getTokenOffset()+m;s(" ",v,o),v=l.getTokenOffset()+l.getTokenLength()+m,T=y===12?t():"",y=r()}if(y===2)c!==1&&(_--,T=t());else if(y===4)c!==3&&(_--,T=t());else{switch(c){case 3:case 1:_++,T=t();break;case 5:case 12:T=t();break;case 13:d?T=t():T=" ";break;case 6:T=" ";break;case 10:if(y===6){T="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?T=" ":y!==5&&y!==17&&(a=!0);break;case 16:a=!0;break}d&&(y===12||y===13)&&(T=t())}const R=l.getTokenOffset()+m;s(T,v,R),c=y}return i}e.format=P;function g(p,w){let n="";for(let A=0;A<w;A++)n+=p;return n}function D(p,w){let n=0,A=0;const b=w.tabSize||4;for(;n<p.length;){const m=p.charAt(n);if(m===" ")A++;else if(m==="	")A+=b;else break;n++}return Math.floor(A/b)}function I(p,w){for(let n=0;n<w.length;n++){const A=w.charAt(n);if(A==="\r")return n+1<w.length&&w.charAt(n+1)===`
`?`\r
`:"\r";if(A===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=I;function C(p,w){return`\r
`.indexOf(p.charAt(w))!==-1}e.isEOL=C}),define(ce[113],ue([0,1,38,112]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function g(w,n,A){return D(w,n,void 0,A)}e.removeProperty=g;function D(w,n,A,b,m){const u=n.slice(),h=[],S=(0,E.parseTree)(w,h);let d,_;for(;u.length>0&&(_=u.pop(),d=(0,E.findNodeAtLocation)(S,u),d===void 0&&A!==void 0);)typeof _=="string"?A={[_]:A}:A=[A];if(d)if(d.type==="object"&&typeof _=="string"&&Array.isArray(d.children)){const f=(0,E.findNodeAtLocation)(d,[_]);if(f!==void 0)if(A===void 0){if(!f.parent)throw new Error("Malformed AST");const l=d.children.indexOf(f.parent);let a,t=f.parent.offset+f.parent.length;if(l>0){const r=d.children[l-1];a=r.offset+r.length}else a=d.offset+1,d.children.length>1&&(t=d.children[1].offset);return I(w,{offset:a,length:t-a,content:""},b)}else return I(w,{offset:f.offset,length:f.length,content:JSON.stringify(A)},b);else{if(A===void 0)return[];const l=`${JSON.stringify(_)}: ${JSON.stringify(A)}`,a=m?m(d.children.map(r=>r.children[0].value)):d.children.length;let t;if(a>0){const r=d.children[a-1];t={offset:r.offset+r.length,length:0,content:","+l}}else d.children.length===0?t={offset:d.offset+1,length:0,content:l}:t={offset:d.offset+1,length:0,content:l+","};return I(w,t,b)}}else if(d.type==="array"&&typeof _=="number"&&Array.isArray(d.children))if(A!==void 0){const f=`${JSON.stringify(A)}`;let l;if(d.children.length===0||_===0)l={offset:d.offset+1,length:0,content:d.children.length===0?f:f+","};else{const a=_===-1||_>d.children.length?d.children.length:_,t=d.children[a-1];l={offset:t.offset+t.length,length:0,content:","+f}}return I(w,l,b)}else{const f=_,l=d.children[f];let a;if(d.children.length===1)a={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===f){const t=d.children[f-1],r=t.offset+t.length,i=d.offset+d.length;a={offset:r,length:i-2-r,content:""}}else a={offset:l.offset,length:d.children[f+1].offset-l.offset,content:""};return I(w,a,b)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${d.type}`);else{if(A===void 0)throw new Error("Can not delete in empty document");return I(w,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(A)},b)}}e.setProperty=D;function I(w,n,A){let b=C(w,n),m=n.offset,u=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;m>0&&!(0,P.isEOL)(b,m-1);)m--;for(;u<b.length&&!(0,P.isEOL)(b,u);)u++}const h=(0,P.format)(b,{offset:m,length:u-m},A);for(let d=h.length-1;d>=0;d--){const _=h[d];b=C(b,_),m=Math.min(m,_.offset),u=Math.max(u,_.offset+_.length),u+=_.content.length-_.length}const S=w.length-(b.length-u)-m;return[{offset:m,length:S,content:b.substring(m,u)}]}e.withFormatting=I;function C(w,n){return w.substring(0,n.offset)+n.content+w.substring(n.offset+n.length)}e.applyEdit=C;function p(w,n){let A=n.slice(0).sort((m,u)=>{const h=m.offset-u.offset;return h===0?m.length-u.length:h}),b=w.length;for(let m=A.length-1;m>=0;m--){let u=A[m];if(u.offset+u.length<=b)w=C(w,u);else throw new Error("Overlapping edit");b=u.offset}return w}e.applyEdits=p}),define(ce[2],ue([0,1,72,51]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const g=!1;let D=null;function I(i){D=i}if(e.setDisposableTracker=I,g){const i="__is_disposable_tracked__";I(new class{trackDisposable(s){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[i]||console.log(c)},3e3)}setParent(s,c){if(s&&s!==_.None)try{s[i]=!0}catch{}}markAsDisposed(s){if(s&&s!==_.None)try{s[i]=!0}catch{}}markAsSingleton(s){}})}function C(i){return D?.trackDisposable(i),i}function p(i){D?.markAsDisposed(i)}function w(i,s){D?.setParent(i,s)}function n(i,s){if(!!D)for(const c of i)D.setParent(c,s)}function A(i){return D?.markAsSingleton(i),i}e.markAsSingleton=A;class b extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=b;function m(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=m;function u(i){if(P.Iterable.is(i)){let s=[];for(const c of i)if(c)try{c.dispose()}catch(v){s.push(v)}if(s.length===1)throw s[0];if(s.length>1)throw new b(s);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=u;function h(...i){const s=S(()=>u(i));return n(i,s),s}e.combinedDisposable=h;function S(i){const s=C({dispose:(0,E.once)(()=>{p(s),i()})});return s}e.toDisposable=S;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return w(s,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this._store=new d,C(this),w(this._store,this)}dispose(){p(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=_,_.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&w(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&w(s,null),s}}e.MutableDisposable=f;class l{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class a{constructor(){this.references=new Map}acquire(s,...c){let v=this.references.get(s);v||(v={counter:0,object:this.createReferencedObject(s,...c)},this.references.set(s,v));const{object:y}=v,T=(0,E.once)(()=>{--v.counter==0&&(this.destroyReferencedObject(s,v.object),this.references.delete(s))});return v.counter++,{object:y,dispose:T}}}e.ReferenceCollection=a;class t{constructor(s){this.referenceCollection=s}async acquire(s,...c){const v=this.referenceCollection.acquire(s,...c);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(y){throw v.dispose(),y}}}e.AsyncReferenceCollection=t;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r}),define(ce[114],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(D){this.element=D,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class P{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let D=this._first;for(;D!==E.Undefined;){const I=D.next;D.prev=E.Undefined,D.next=E.Undefined,D=I}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,I){const C=new E(D);if(this._first===E.Undefined)this._first=C,this._last=C;else if(I){const w=this._last;this._last=C,C.prev=w,w.next=C}else{const w=this._first;this._first=C,C.next=w,w.prev=C}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(C))}}shift(){if(this._first!==E.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==E.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==E.Undefined&&D.next!==E.Undefined){const I=D.prev;I.next=D.next,D.next.prev=I}else D.prev===E.Undefined&&D.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):D.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):D.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==E.Undefined;)yield D.element,D=D.next}}e.LinkedList=P}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(he,ge){for(var ye=0;ye<ge.length;ye++){var G=ge[ye];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(he,G.key,G)}}function e(he,ge,ye){return ge&&X(he.prototype,ge),ye&&X(he,ye),he}function E(he,ge){if(!!he){if(typeof he=="string")return P(he,ge);var ye=Object.prototype.toString.call(he).slice(8,-1);if(ye==="Object"&&he.constructor&&(ye=he.constructor.name),ye==="Map"||ye==="Set")return Array.from(he);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return P(he,ge)}}function P(he,ge){(ge==null||ge>he.length)&&(ge=he.length);for(var ye=0,G=new Array(ge);ye<ge;ye++)G[ye]=he[ye];return G}function g(he,ge){var ye;if(typeof Symbol=="undefined"||he[Symbol.iterator]==null){if(Array.isArray(he)||(ye=E(he))||ge&&he&&typeof he.length=="number"){ye&&(he=ye);var G=0;return function(){return G>=he.length?{done:!0}:{done:!1,value:he[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ye=he[Symbol.iterator](),ye.next.bind(ye)}function D(he){var ge={exports:{}};return he(ge,ge.exports),ge.exports}var I=D(function(he){function ge(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ye(G){he.exports.defaults=G}he.exports={defaults:ge(),getDefaults:ge,changeDefaults:ye}}),C=/[&<>"']/,p=/[&<>"']/g,w=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,A={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ge){return A[ge]};function m(he,ge){if(ge){if(C.test(he))return he.replace(p,b)}else if(w.test(he))return he.replace(n,b);return he}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(he){return he.replace(u,function(ge,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var S=/(^|[^\[])\^/g;function d(he,ge){he=he.source||he,ge=ge||"";var ye={replace:function(J,te){return te=te.source||te,te=te.replace(S,"$1"),he=he.replace(J,te),ye},getRegex:function(){return new RegExp(he,ge)}};return ye}var _=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(he,ge,ye){if(he){var G;try{G=decodeURIComponent(h(ye)).replace(_,"").toLowerCase()}catch(J){return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}ge&&!f.test(ye)&&(ye=s(ge,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch(J){return null}return ye}var a={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(he,ge){a[" "+he]||(t.test(he)?a[" "+he]=he+"/":a[" "+he]=T(he,"/",!0)),he=a[" "+he];var ye=he.indexOf(":")===-1;return ge.substring(0,2)==="//"?ye?ge:he.replace(r,"$1")+ge:ge.charAt(0)==="/"?ye?ge:he.replace(i,"$1")+ge:he+ge}var c={exec:function(){}};function v(he){for(var ge=1,ye,G;ge<arguments.length;ge++){ye=arguments[ge];for(G in ye)Object.prototype.hasOwnProperty.call(ye,G)&&(he[G]=ye[G])}return he}function y(he,ge){var ye=he.replace(/\|/g,function(te,oe,B){for(var ie=!1,se=oe;--se>=0&&B[se]==="\\";)ie=!ie;return ie?"|":" |"}),G=ye.split(/ \|/),J=0;if(G.length>ge)G.splice(ge);else for(;G.length<ge;)G.push("");for(;J<G.length;J++)G[J]=G[J].trim().replace(/\\\|/g,"|");return G}function T(he,ge,ye){var G=he.length;if(G===0)return"";for(var J=0;J<G;){var te=he.charAt(G-J-1);if(te===ge&&!ye)J++;else if(te!==ge&&ye)J++;else break}return he.substr(0,G-J)}function R(he,ge){if(he.indexOf(ge[1])===-1)return-1;for(var ye=he.length,G=0,J=0;J<ye;J++)if(he[J]==="\\")J++;else if(he[J]===ge[0])G++;else if(he[J]===ge[1]&&(G--,G<0))return J;return-1}function o(he){he&&he.sanitize&&!he.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(he,ge){if(ge<1)return"";for(var ye="";ge>1;)ge&1&&(ye+=he),ge>>=1,he+=he;return ye+he}var O={escape:m,unescape:h,edit:d,cleanUrl:l,resolveUrl:s,noopTest:c,merge:v,splitCells:y,rtrim:T,findClosingBracket:R,checkSanitizeDeprecation:o,repeatString:k},Y=I.defaults,Q=O.rtrim,me=O.splitCells,re=O.escape,N=O.findClosingBracket;function W(he,ge,ye){var G=ge.href,J=ge.title?re(ge.title):null,te=he[1].replace(/\\([\[\]])/g,"$1");return he[0].charAt(0)!=="!"?{type:"link",raw:ye,href:G,title:J,text:te}:{type:"image",raw:ye,href:G,title:J,text:re(te)}}function U(he,ge){var ye=he.match(/^(\s+)(?:```)/);if(ye===null)return ge;var G=ye[1];return ge.split(`
`).map(function(J){var te=J.match(/^\s+/);if(te===null)return J;var oe=te[0];return oe.length>=G.length?J.slice(G.length):J}).join(`
`)}var j=function(){function he(ye){this.options=ye||Y}var ge=he.prototype;return ge.space=function(G){var J=this.rules.block.newline.exec(G);if(J)return J[0].length>1?{type:"space",raw:J[0]}:{raw:`
`}},ge.code=function(G){var J=this.rules.block.code.exec(G);if(J){var te=J[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:J[0],codeBlockStyle:"indented",text:this.options.pedantic?te:Q(te,`
`)}}},ge.fences=function(G){var J=this.rules.block.fences.exec(G);if(J){var te=J[0],oe=U(te,J[3]||"");return{type:"code",raw:te,lang:J[2]?J[2].trim():J[2],text:oe}}},ge.heading=function(G){var J=this.rules.block.heading.exec(G);if(J){var te=J[2].trim();if(/#$/.test(te)){var oe=Q(te,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(te=oe.trim())}return{type:"heading",raw:J[0],depth:J[1].length,text:te}}},ge.nptable=function(G){var J=this.rules.block.nptable.exec(G);if(J){var te={type:"table",header:me(J[1].replace(/^ *| *\| *$/g,"")),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:J[3]?J[3].replace(/\n$/,"").split(`
`):[],raw:J[0]};if(te.header.length===te.align.length){var oe=te.align.length,B;for(B=0;B<oe;B++)/^ *-+: *$/.test(te.align[B])?te.align[B]="right":/^ *:-+: *$/.test(te.align[B])?te.align[B]="center":/^ *:-+ *$/.test(te.align[B])?te.align[B]="left":te.align[B]=null;for(oe=te.cells.length,B=0;B<oe;B++)te.cells[B]=me(te.cells[B],te.header.length);return te}}},ge.hr=function(G){var J=this.rules.block.hr.exec(G);if(J)return{type:"hr",raw:J[0]}},ge.blockquote=function(G){var J=this.rules.block.blockquote.exec(G);if(J){var te=J[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:J[0],text:te}}},ge.list=function(G){var J=this.rules.block.list.exec(G);if(J){var te=J[0],oe=J[2],B=oe.length>1,ie={type:"list",raw:te,ordered:B,start:B?+oe.slice(0,-1):"",loose:!1,items:[]},se=J[0].match(this.rules.block.item),ve=!1,ee,we,_e,Te,Oe,je,qe,Ze,Je=se.length;_e=this.rules.block.listItemStart.exec(se[0]);for(var Ve=0;Ve<Je;Ve++){if(ee=se[Ve],te=ee,Ve!==Je-1){if(Te=this.rules.block.listItemStart.exec(se[Ve+1]),this.options.pedantic?Te[1].length>_e[1].length:Te[1].length>_e[0].length||Te[1].length>3){se.splice(Ve,2,se[Ve]+`
`+se[Ve+1]),Ve--,Je--;continue}else(!this.options.pedantic||this.options.smartLists?Te[2][Te[2].length-1]!==oe[oe.length-1]:B===(Te[2].length===1))&&(Oe=se.slice(Ve+1).join(`
`),ie.raw=ie.raw.substring(0,ie.raw.length-Oe.length),Ve=Je-1);_e=Te}we=ee.length,ee=ee.replace(/^ *([*+-]|\d+[.)]) ?/,""),~ee.indexOf(`
 `)&&(we-=ee.length,ee=this.options.pedantic?ee.replace(/^ {1,4}/gm,""):ee.replace(new RegExp("^ {1,"+we+"}","gm"),"")),je=ve||/\n\n(?!\s*$)/.test(ee),Ve!==Je-1&&(ve=ee.charAt(ee.length-1)===`
`,je||(je=ve)),je&&(ie.loose=!0),this.options.gfm&&(qe=/^\[[ xX]\] /.test(ee),Ze=void 0,qe&&(Ze=ee[1]!==" ",ee=ee.replace(/^\[[ xX]\] +/,""))),ie.items.push({type:"list_item",raw:te,task:qe,checked:Ze,loose:je,text:ee})}return ie}},ge.html=function(G){var J=this.rules.block.html.exec(G);if(J)return{type:this.options.sanitize?"paragraph":"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):re(J[0]):J[0]}},ge.def=function(G){var J=this.rules.block.def.exec(G);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var te=J[1].toLowerCase().replace(/\s+/g," ");return{tag:te,raw:J[0],href:J[2],title:J[3]}}},ge.table=function(G){var J=this.rules.block.table.exec(G);if(J){var te={type:"table",header:me(J[1].replace(/^ *| *\| *$/g,"")),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:J[3]?J[3].replace(/\n$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=J[0];var oe=te.align.length,B;for(B=0;B<oe;B++)/^ *-+: *$/.test(te.align[B])?te.align[B]="right":/^ *:-+: *$/.test(te.align[B])?te.align[B]="center":/^ *:-+ *$/.test(te.align[B])?te.align[B]="left":te.align[B]=null;for(oe=te.cells.length,B=0;B<oe;B++)te.cells[B]=me(te.cells[B].replace(/^ *\| *| *\| *$/g,""),te.header.length);return te}}},ge.lheading=function(G){var J=this.rules.block.lheading.exec(G);if(J)return{type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1]}},ge.paragraph=function(G){var J=this.rules.block.paragraph.exec(G);if(J)return{type:"paragraph",raw:J[0],text:J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1]}},ge.text=function(G){var J=this.rules.block.text.exec(G);if(J)return{type:"text",raw:J[0],text:J[0]}},ge.escape=function(G){var J=this.rules.inline.escape.exec(G);if(J)return{type:"escape",raw:J[0],text:re(J[1])}},ge.tag=function(G,J,te){var oe=this.rules.inline.tag.exec(G);if(oe)return!J&&/^<a /i.test(oe[0])?J=!0:J&&/^<\/a>/i.test(oe[0])&&(J=!1),!te&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?te=!0:te&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(te=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:J,inRawBlock:te,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):re(oe[0]):oe[0]}},ge.link=function(G){var J=this.rules.inline.link.exec(G);if(J){var te=J[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var oe=Q(te.slice(0,-1),"\\");if((te.length-oe.length)%2==0)return}else{var B=N(J[2],"()");if(B>-1){var ie=J[0].indexOf("!")===0?5:4,se=ie+J[1].length+B;J[2]=J[2].substring(0,B),J[0]=J[0].substring(0,se).trim(),J[3]=""}}var ve=J[2],ee="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ve);we&&(ve=we[1],ee=we[3])}else ee=J[3]?J[3].slice(1,-1):"";return ve=ve.trim(),/^</.test(ve)&&(this.options.pedantic&&!/>$/.test(te)?ve=ve.slice(1):ve=ve.slice(1,-1)),W(J,{href:ve&&ve.replace(this.rules.inline._escapes,"$1"),title:ee&&ee.replace(this.rules.inline._escapes,"$1")},J[0])}},ge.reflink=function(G,J){var te;if((te=this.rules.inline.reflink.exec(G))||(te=this.rules.inline.nolink.exec(G))){var oe=(te[2]||te[1]).replace(/\s+/g," ");if(oe=J[oe.toLowerCase()],!oe||!oe.href){var B=te[0].charAt(0);return{type:"text",raw:B,text:B}}return W(te,oe,te[0])}},ge.emStrong=function(G,J,te){te===void 0&&(te="");var oe=this.rules.inline.emStrong.lDelim.exec(G);if(!!oe&&!(oe[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=oe[1]||oe[2]||"";if(!B||B&&(te===""||this.rules.inline.punctuation.exec(te))){var ie=oe[0].length-1,se,ve,ee=ie,we=0,_e=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(_e.lastIndex=0,J=J.slice(-1*G.length+ie);(oe=_e.exec(J))!=null;)if(se=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!se){if(ve=se.length,oe[3]||oe[4]){ee+=ve;continue}else if((oe[5]||oe[6])&&ie%3&&!((ie+ve)%3)){we+=ve;continue}if(ee-=ve,!(ee>0)){if(ee+we-ve<=0&&!J.slice(_e.lastIndex).match(_e)&&(ve=Math.min(ve,ve+ee+we)),Math.min(ie,ve)%2)return{type:"em",raw:G.slice(0,ie+oe.index+ve+1),text:G.slice(1,ie+oe.index+ve)};if(Math.min(ie,ve)%2==0)return{type:"strong",raw:G.slice(0,ie+oe.index+ve+1),text:G.slice(2,ie+oe.index+ve-1)}}}}}},ge.codespan=function(G){var J=this.rules.inline.code.exec(G);if(J){var te=J[2].replace(/\n/g," "),oe=/[^ ]/.test(te),B=/^ /.test(te)&&/ $/.test(te);return oe&&B&&(te=te.substring(1,te.length-1)),te=re(te,!0),{type:"codespan",raw:J[0],text:te}}},ge.br=function(G){var J=this.rules.inline.br.exec(G);if(J)return{type:"br",raw:J[0]}},ge.del=function(G){var J=this.rules.inline.del.exec(G);if(J)return{type:"del",raw:J[0],text:J[2]}},ge.autolink=function(G,J){var te=this.rules.inline.autolink.exec(G);if(te){var oe,B;return te[2]==="@"?(oe=re(this.options.mangle?J(te[1]):te[1]),B="mailto:"+oe):(oe=re(te[1]),B=oe),{type:"link",raw:te[0],text:oe,href:B,tokens:[{type:"text",raw:oe,text:oe}]}}},ge.url=function(G,J){var te;if(te=this.rules.inline.url.exec(G)){var oe,B;if(te[2]==="@")oe=re(this.options.mangle?J(te[0]):te[0]),B="mailto:"+oe;else{var ie;do ie=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(ie!==te[0]);oe=re(te[0]),te[1]==="www."?B="http://"+oe:B=oe}return{type:"link",raw:te[0],text:oe,href:B,tokens:[{type:"text",raw:oe,text:oe}]}}},ge.inlineText=function(G,J,te){var oe=this.rules.inline.text.exec(G);if(oe){var B;return J?B=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):re(oe[0]):oe[0]:B=re(this.options.smartypants?te(oe[0]):oe[0]),{type:"text",raw:oe[0],text:B}}},he}(),H=O.noopTest,M=O.edit,q=O.merge,z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:H,table:H,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=M(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,z.item=M(z.item,"gm").replace(/bull/g,z.bullet).getRegex(),z.listItemStart=M(/^( *)(bull)/).replace("bull",z.bullet).getRegex(),z.list=M(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=M(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=M(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.blockquote=M(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=q({},z),z.gfm=q({},z.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.nptable=M(z.gfm.nptable).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.gfm.table=M(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.pedantic=q({},z.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:H,paragraph:M(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var V={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:H,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:H,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};V._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",V.punctuation=M(V.punctuation).replace(/punctuation/g,V._punctuation).getRegex(),V.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,V.escapedEmSt=/\\\*|\\_/g,V._comment=M(z._comment).replace("(?:-->|$)","-->").getRegex(),V.emStrong.lDelim=M(V.emStrong.lDelim).replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimAst=M(V.emStrong.rDelimAst,"g").replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimUnd=M(V.emStrong.rDelimUnd,"g").replace(/punct/g,V._punctuation).getRegex(),V._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,V._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,V._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,V.autolink=M(V.autolink).replace("scheme",V._scheme).replace("email",V._email).getRegex(),V._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,V.tag=M(V.tag).replace("comment",V._comment).replace("attribute",V._attribute).getRegex(),V._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,V._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,V._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,V.link=M(V.link).replace("label",V._label).replace("href",V._href).replace("title",V._title).getRegex(),V.reflink=M(V.reflink).replace("label",V._label).getRegex(),V.reflinkSearch=M(V.reflinkSearch,"g").replace("reflink",V.reflink).replace("nolink",V.nolink).getRegex(),V.normal=q({},V),V.pedantic=q({},V.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",V._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",V._label).getRegex()}),V.gfm=q({},V.normal,{escape:M(V.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),V.gfm.url=M(V.gfm.url,"i").replace("email",V.gfm._extended_email).getRegex(),V.breaks=q({},V.gfm,{br:M(V.br).replace("{2,}","*").getRegex(),text:M(V.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var K={block:z,inline:V},ae=I.defaults,fe=K.block,De=K.inline,Pe=O.repeatString;function Fe(he){return he.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ne(he){var ge="",ye,G,J=he.length;for(ye=0;ye<J;ye++)G=he.charCodeAt(ye),Math.random()>.5&&(G="x"+G.toString(16)),ge+="&#"+G+";";return ge}var ze=function(){function he(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||ae,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var G={block:fe.normal,inline:De.normal};this.options.pedantic?(G.block=fe.pedantic,G.inline=De.pedantic):this.options.gfm&&(G.block=fe.gfm,this.options.breaks?G.inline=De.breaks:G.inline=De.gfm),this.tokenizer.rules=G}he.lex=function(G,J){var te=new he(J);return te.lex(G)},he.lexInline=function(G,J){var te=new he(J);return te.inlineTokens(G)};var ge=he.prototype;return ge.lex=function(G){return G=G.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(G,this.tokens,!0),this.inline(this.tokens),this.tokens},ge.blockTokens=function(G,J,te){J===void 0&&(J=[]),te===void 0&&(te=!0),this.options.pedantic&&(G=G.replace(/^ +$/gm,""));for(var oe,B,ie,se;G;){if(oe=this.tokenizer.space(G)){G=G.substring(oe.raw.length),oe.type&&J.push(oe);continue}if(oe=this.tokenizer.code(G)){G=G.substring(oe.raw.length),se=J[J.length-1],se&&se.type==="paragraph"?(se.raw+=`
`+oe.raw,se.text+=`
`+oe.text):J.push(oe);continue}if(oe=this.tokenizer.fences(G)){G=G.substring(oe.raw.length),J.push(oe);continue}if(oe=this.tokenizer.heading(G)){G=G.substring(oe.raw.length),J.push(oe);continue}if(oe=this.tokenizer.nptable(G)){G=G.substring(oe.raw.length),J.push(oe);continue}if(oe=this.tokenizer.hr(G)){G=G.substring(oe.raw.length),J.push(oe);continue}if(oe=this.tokenizer.blockquote(G)){G=G.substring(oe.raw.length),oe.tokens=this.blockTokens(oe.text,[],te),J.push(oe);continue}if(oe=this.tokenizer.list(G)){for(G=G.substring(oe.raw.length),ie=oe.items.length,B=0;B<ie;B++)oe.items[B].tokens=this.blockTokens(oe.items[B].text,[],!1);J.push(oe);continue}if(oe=this.tokenizer.html(G)){G=G.substring(oe.raw.length),J.push(oe);continue}if(te&&(oe=this.tokenizer.def(G))){G=G.substring(oe.raw.length),this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(G)){G=G.substring(oe.raw.length),J.push(oe);continue}if(oe=this.tokenizer.lheading(G)){G=G.substring(oe.raw.length),J.push(oe);continue}if(te&&(oe=this.tokenizer.paragraph(G))){G=G.substring(oe.raw.length),J.push(oe);continue}if(oe=this.tokenizer.text(G)){G=G.substring(oe.raw.length),se=J[J.length-1],se&&se.type==="text"?(se.raw+=`
`+oe.raw,se.text+=`
`+oe.text):J.push(oe);continue}if(G){var ve="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return J},ge.inline=function(G){var J,te,oe,B,ie,se,ve=G.length;for(J=0;J<ve;J++)switch(se=G[J],se.type){case"paragraph":case"text":case"heading":{se.tokens=[],this.inlineTokens(se.text,se.tokens);break}case"table":{for(se.tokens={header:[],cells:[]},B=se.header.length,te=0;te<B;te++)se.tokens.header[te]=[],this.inlineTokens(se.header[te],se.tokens.header[te]);for(B=se.cells.length,te=0;te<B;te++)for(ie=se.cells[te],se.tokens.cells[te]=[],oe=0;oe<ie.length;oe++)se.tokens.cells[te][oe]=[],this.inlineTokens(ie[oe],se.tokens.cells[te][oe]);break}case"blockquote":{this.inline(se.tokens);break}case"list":{for(B=se.items.length,te=0;te<B;te++)this.inline(se.items[te].tokens);break}}return G},ge.inlineTokens=function(G,J,te,oe){J===void 0&&(J=[]),te===void 0&&(te=!1),oe===void 0&&(oe=!1);var B,ie,se=G,ve,ee,we;if(this.tokens.links){var _e=Object.keys(this.tokens.links);if(_e.length>0)for(;(ve=this.tokenizer.rules.inline.reflinkSearch.exec(se))!=null;)_e.includes(ve[0].slice(ve[0].lastIndexOf("[")+1,-1))&&(se=se.slice(0,ve.index)+"["+Pe("a",ve[0].length-2)+"]"+se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ve=this.tokenizer.rules.inline.blockSkip.exec(se))!=null;)se=se.slice(0,ve.index)+"["+Pe("a",ve[0].length-2)+"]"+se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ve=this.tokenizer.rules.inline.escapedEmSt.exec(se))!=null;)se=se.slice(0,ve.index)+"++"+se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;){if(ee||(we=""),ee=!1,B=this.tokenizer.escape(G)){G=G.substring(B.raw.length),J.push(B);continue}if(B=this.tokenizer.tag(G,te,oe)){G=G.substring(B.raw.length),te=B.inLink,oe=B.inRawBlock;var Te=J[J.length-1];Te&&B.type==="text"&&Te.type==="text"?(Te.raw+=B.raw,Te.text+=B.text):J.push(B);continue}if(B=this.tokenizer.link(G)){G=G.substring(B.raw.length),B.type==="link"&&(B.tokens=this.inlineTokens(B.text,[],!0,oe)),J.push(B);continue}if(B=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(B.raw.length);var Oe=J[J.length-1];B.type==="link"?(B.tokens=this.inlineTokens(B.text,[],!0,oe),J.push(B)):Oe&&B.type==="text"&&Oe.type==="text"?(Oe.raw+=B.raw,Oe.text+=B.text):J.push(B);continue}if(B=this.tokenizer.emStrong(G,se,we)){G=G.substring(B.raw.length),B.tokens=this.inlineTokens(B.text,[],te,oe),J.push(B);continue}if(B=this.tokenizer.codespan(G)){G=G.substring(B.raw.length),J.push(B);continue}if(B=this.tokenizer.br(G)){G=G.substring(B.raw.length),J.push(B);continue}if(B=this.tokenizer.del(G)){G=G.substring(B.raw.length),B.tokens=this.inlineTokens(B.text,[],te,oe),J.push(B);continue}if(B=this.tokenizer.autolink(G,Ne)){G=G.substring(B.raw.length),J.push(B);continue}if(!te&&(B=this.tokenizer.url(G,Ne))){G=G.substring(B.raw.length),J.push(B);continue}if(B=this.tokenizer.inlineText(G,oe,Fe)){G=G.substring(B.raw.length),B.raw.slice(-1)!=="_"&&(we=B.raw.slice(-1)),ee=!0,ie=J[J.length-1],ie&&ie.type==="text"?(ie.raw+=B.raw,ie.text+=B.text):J.push(B);continue}if(G){var je="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return J},e(he,null,[{key:"rules",get:function(){return{block:fe,inline:De}}}]),he}(),Xe=I.defaults,nt=O.cleanUrl,it=O.escape,rt=function(){function he(ye){this.options=ye||Xe}var ge=he.prototype;return ge.code=function(G,J,te){var oe=(J||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(G,oe);B!=null&&B!==G&&(te=!0,G=B)}return G=G.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+it(oe,!0)+'">'+(te?G:it(G,!0))+`</code></pre>
`:"<pre><code>"+(te?G:it(G,!0))+`</code></pre>
`},ge.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},ge.html=function(G){return G},ge.heading=function(G,J,te,oe){return this.options.headerIds?"<h"+J+' id="'+this.options.headerPrefix+oe.slug(te)+'">'+G+"</h"+J+`>
`:"<h"+J+">"+G+"</h"+J+`>
`},ge.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ge.list=function(G,J,te){var oe=J?"ol":"ul",B=J&&te!==1?' start="'+te+'"':"";return"<"+oe+B+`>
`+G+"</"+oe+`>
`},ge.listitem=function(G){return"<li>"+G+`</li>
`},ge.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ge.paragraph=function(G){return"<p>"+G+`</p>
`},ge.table=function(G,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+J+`</table>
`},ge.tablerow=function(G){return`<tr>
`+G+`</tr>
`},ge.tablecell=function(G,J){var te=J.header?"th":"td",oe=J.align?"<"+te+' align="'+J.align+'">':"<"+te+">";return oe+G+"</"+te+`>
`},ge.strong=function(G){return"<strong>"+G+"</strong>"},ge.em=function(G){return"<em>"+G+"</em>"},ge.codespan=function(G){return"<code>"+G+"</code>"},ge.br=function(){return this.options.xhtml?"<br/>":"<br>"},ge.del=function(G){return"<del>"+G+"</del>"},ge.link=function(G,J,te){if(G=nt(this.options.sanitize,this.options.baseUrl,G),G===null)return te;var oe='<a href="'+it(G)+'"';return J&&(oe+=' title="'+J+'"'),oe+=">"+te+"</a>",oe},ge.image=function(G,J,te){if(G=nt(this.options.sanitize,this.options.baseUrl,G),G===null)return te;var oe='<img src="'+G+'" alt="'+te+'"';return J&&(oe+=' title="'+J+'"'),oe+=this.options.xhtml?"/>":">",oe},ge.text=function(G){return G},he}(),pe=function(){function he(){}var ge=he.prototype;return ge.strong=function(G){return G},ge.em=function(G){return G},ge.codespan=function(G){return G},ge.del=function(G){return G},ge.html=function(G){return G},ge.text=function(G){return G},ge.link=function(G,J,te){return""+te},ge.image=function(G,J,te){return""+te},ge.br=function(){return""},he}(),Ce=function(){function he(){this.seen={}}var ge=he.prototype;return ge.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ge.getNextSafeSlug=function(G,J){var te=G,oe=0;if(this.seen.hasOwnProperty(te)){oe=this.seen[G];do oe++,te=G+"-"+oe;while(this.seen.hasOwnProperty(te))}return J||(this.seen[G]=oe,this.seen[te]=0),te},ge.slug=function(G,J){J===void 0&&(J={});var te=this.serialize(G);return this.getNextSafeSlug(te,J.dryrun)},he}(),Ae=I.defaults,Re=O.unescape,Me=function(){function he(ye){this.options=ye||Ae,this.options.renderer=this.options.renderer||new rt,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new Ce}he.parse=function(G,J){var te=new he(J);return te.parse(G)},he.parseInline=function(G,J){var te=new he(J);return te.parseInline(G)};var ge=he.prototype;return ge.parse=function(G,J){J===void 0&&(J=!0);var te="",oe,B,ie,se,ve,ee,we,_e,Te,Oe,je,qe,Ze,Je,Ve,le,de,Z,$=G.length;for(oe=0;oe<$;oe++)switch(Oe=G[oe],Oe.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(Oe.tokens),Oe.depth,Re(this.parseInline(Oe.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(Oe.text,Oe.lang,Oe.escaped);continue}case"table":{for(_e="",we="",se=Oe.header.length,B=0;B<se;B++)we+=this.renderer.tablecell(this.parseInline(Oe.tokens.header[B]),{header:!0,align:Oe.align[B]});for(_e+=this.renderer.tablerow(we),Te="",se=Oe.cells.length,B=0;B<se;B++){for(ee=Oe.tokens.cells[B],we="",ve=ee.length,ie=0;ie<ve;ie++)we+=this.renderer.tablecell(this.parseInline(ee[ie]),{header:!1,align:Oe.align[ie]});Te+=this.renderer.tablerow(we)}te+=this.renderer.table(_e,Te);continue}case"blockquote":{Te=this.parse(Oe.tokens),te+=this.renderer.blockquote(Te);continue}case"list":{for(je=Oe.ordered,qe=Oe.start,Ze=Oe.loose,se=Oe.items.length,Te="",B=0;B<se;B++)Ve=Oe.items[B],le=Ve.checked,de=Ve.task,Je="",Ve.task&&(Z=this.renderer.checkbox(le),Ze?Ve.tokens.length>0&&Ve.tokens[0].type==="text"?(Ve.tokens[0].text=Z+" "+Ve.tokens[0].text,Ve.tokens[0].tokens&&Ve.tokens[0].tokens.length>0&&Ve.tokens[0].tokens[0].type==="text"&&(Ve.tokens[0].tokens[0].text=Z+" "+Ve.tokens[0].tokens[0].text)):Ve.tokens.unshift({type:"text",text:Z}):Je+=Z),Je+=this.parse(Ve.tokens,Ze),Te+=this.renderer.listitem(Je,de,le);te+=this.renderer.list(Te,je,qe);continue}case"html":{te+=this.renderer.html(Oe.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(Oe.tokens));continue}case"text":{for(Te=Oe.tokens?this.parseInline(Oe.tokens):Oe.text;oe+1<$&&G[oe+1].type==="text";)Oe=G[++oe],Te+=`
`+(Oe.tokens?this.parseInline(Oe.tokens):Oe.text);te+=J?this.renderer.paragraph(Te):Te;continue}default:{var ke='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}return te},ge.parseInline=function(G,J){J=J||this.renderer;var te="",oe,B,ie=G.length;for(oe=0;oe<ie;oe++)switch(B=G[oe],B.type){case"escape":{te+=J.text(B.text);break}case"html":{te+=J.html(B.text);break}case"link":{te+=J.link(B.href,B.title,this.parseInline(B.tokens,J));break}case"image":{te+=J.image(B.href,B.title,B.text);break}case"strong":{te+=J.strong(this.parseInline(B.tokens,J));break}case"em":{te+=J.em(this.parseInline(B.tokens,J));break}case"codespan":{te+=J.codespan(B.text);break}case"br":{te+=J.br();break}case"del":{te+=J.del(this.parseInline(B.tokens,J));break}case"text":{te+=J.text(B.text);break}default:{var se='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}return te},he}(),$e=O.merge,He=O.checkSanitizeDeprecation,Ye=O.escape,tt=I.getDefaults,ne=I.changeDefaults,Se=I.defaults;function Ee(he,ge,ye){if(typeof he=="undefined"||he===null)throw new Error("marked(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");if(typeof ge=="function"&&(ye=ge,ge=null),ge=$e({},Ee.defaults,ge||{}),He(ge),ye){var G=ge.highlight,J;try{J=ze.lex(he,ge)}catch(ie){return ye(ie)}var te=function(se){var ve;if(!se)try{ve=Me.parse(J,ge)}catch(ee){se=ee}return ge.highlight=G,se?ye(se):ye(null,ve)};if(!G||G.length<3||(delete ge.highlight,!J.length))return te();var oe=0;Ee.walkTokens(J,function(ie){ie.type==="code"&&(oe++,setTimeout(function(){G(ie.text,ie.lang,function(se,ve){if(se)return te(se);ve!=null&&ve!==ie.text&&(ie.text=ve,ie.escaped=!0),oe--,oe===0&&te()})},0))}),oe===0&&te();return}try{var B=ze.lex(he,ge);return ge.walkTokens&&Ee.walkTokens(B,ge.walkTokens),Me.parse(B,ge)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+Ye(ie.message+"",!0)+"</pre>";throw ie}}Ee.options=Ee.setOptions=function(he){return $e(Ee.defaults,he),ne(Ee.defaults),Ee},Ee.getDefaults=tt,Ee.defaults=Se,Ee.use=function(he){var ge=$e({},he);if(he.renderer&&function(){var G=Ee.defaults.renderer||new rt,J=function(B){var ie=G[B];G[B]=function(){for(var se=arguments.length,ve=new Array(se),ee=0;ee<se;ee++)ve[ee]=arguments[ee];var we=he.renderer[B].apply(G,ve);return we===!1&&(we=ie.apply(G,ve)),we}};for(var te in he.renderer)J(te);ge.renderer=G}(),he.tokenizer&&function(){var G=Ee.defaults.tokenizer||new j,J=function(B){var ie=G[B];G[B]=function(){for(var se=arguments.length,ve=new Array(se),ee=0;ee<se;ee++)ve[ee]=arguments[ee];var we=he.tokenizer[B].apply(G,ve);return we===!1&&(we=ie.apply(G,ve)),we}};for(var te in he.tokenizer)J(te);ge.tokenizer=G}(),he.walkTokens){var ye=Ee.defaults.walkTokens;ge.walkTokens=function(G){he.walkTokens(G),ye&&ye(G)}}Ee.setOptions(ge)},Ee.walkTokens=function(he,ge){for(var ye=g(he),G;!(G=ye()).done;){var J=G.value;switch(ge(J),J.type){case"table":{for(var te=g(J.tokens.header),oe;!(oe=te()).done;){var B=oe.value;Ee.walkTokens(B,ge)}for(var ie=g(J.tokens.cells),se;!(se=ie()).done;)for(var ve=se.value,ee=g(ve),we;!(we=ee()).done;){var _e=we.value;Ee.walkTokens(_e,ge)}break}case"list":{Ee.walkTokens(J.items,ge);break}default:J.tokens&&Ee.walkTokens(J.tokens,ge)}}},Ee.parseInline=function(he,ge){if(typeof he=="undefined"||he===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");ge=$e({},Ee.defaults,ge||{}),He(ge);try{var ye=ze.lexInline(he,ge);return ge.walkTokens&&Ee.walkTokens(ye,ge.walkTokens),Me.parseInline(ye,ge)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+Ye(G.message+"",!0)+"</pre>";throw G}},Ee.Parser=Me,Ee.parser=Me.parse,Ee.Renderer=rt,Ee.TextRenderer=pe,Ee.Lexer=ze,Ee.lexer=ze.lex,Ee.Tokenizer=j,Ee.Slugger=Ce,Ee.parse=Ee;var Ue=Ee;return Ue}),define(ce[115],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(I,C,p){return Math.min(Math.max(I,C),p)}e.clamp=E;function P(I,C){return(C+I%C)%C}e.rot=P;class g{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=g;class D{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=D}),function(){function X(g){const D=[];typeof g=="number"&&D.push("code/timeOrigin",g);function I(p){D.push(p,Date.now())}function C(){const p=[];for(let w=0;w<D.length;w+=2)p.push({name:D[w],startTime:D[w+1]});return p}return{mark:I,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const I of performance.getEntriesByType("mark"))D.push({name:I.name,startTime:Math.round(g+I.startTime)});return D}};if(typeof process=="object"){const g=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function E(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=E(P))}(),define(ce[4],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const E="en";let P=!1,g=!1,D=!1,I=!1,C=!1,p=!1,w=!1,n,A=E,b,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const h=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=h&&u?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=u?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!h)m=navigator.userAgent,P=m.indexOf("Windows")>=0,g=m.indexOf("Macintosh")>=0,w=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=m.indexOf("Linux")>=0,p=!0,n=navigator.language,A=n;else if(typeof u=="object"){P=u.platform==="win32",g=u.platform==="darwin",D=u.platform==="linux",I=D&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,n=E,A=E;const i=u.env.VSCODE_NLS_CONFIG;if(i)try{const s=JSON.parse(i),c=s.availableLanguages["*"];n=s.locale,A=c||E,b=s._translationsConfigFile}catch(s){}C=!0}else console.error("Unable to resolve platform.");var S;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function d(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=d;let _=0;g?_=1:P?_=3:D&&(_=2),e.isWindows=P,e.isMacintosh=g,e.isLinux=D,e.isLinuxSnap=I,e.isNative=C,e.isWeb=p,e.isIOS=w,e.platform=_,e.userAgent=m,e.language=A;var f;(function(i){function s(){return e.language}i.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=c;function v(){return e.language==="en"}i.isDefault=v})(f=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeSetImmediateId)for(let T=0,R=c.length;T<R;T++){const o=c[T];if(o.id===y.data.vscodeSetImmediateId){c.splice(T,1),o.callback();return}}});let v=0;return y=>{const T=++v;c.push({id:T,callback:y}),e.globals.postMessage({vscodeSetImmediateId:T},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const s=Promise.resolve();return c=>s.then(c)}();var l;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=g||w?2:P?1:3;let a=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,a=new Uint16Array(i.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=r}),define(ce[23],ue([0,1,4]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let P;if(typeof E.globals.vscode!="undefined"&&typeof E.globals.vscode.process!="undefined"){const g=E.globals.vscode.process;P={get platform(){return g.platform},get env(){return g.env},cwd(){return g.cwd()},nextTick(D){return(0,E.setImmediate)(D)}}}else typeof process!="undefined"?P={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(g){return process.nextTick(g)}}:P={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(g){return(0,E.setImmediate)(g)},get env(){return{}},cwd(){return"/"}};e.cwd=P.cwd,e.env=P.env,e.platform=P.platform,e.nextTick=P.nextTick}),define(ce[5],ue([0,1,23]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const P=65,g=97,D=90,I=122,C=46,p=47,w=92,n=58,A=63;class b extends Error{constructor(l,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const i=l.indexOf(".")!==-1?"property":"argument";let s=`The "${l}" ${i} ${r} of type ${a}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function m(f,l){if(typeof f!="string")throw new b(l,"string",f)}function u(f){return f===p||f===w}function h(f){return f===p}function S(f){return f>=P&&f<=D||f>=g&&f<=I}function d(f,l,a,t){let r="",i=0,s=-1,c=0,v=0;for(let y=0;y<=f.length;++y){if(y<f.length)v=f.charCodeAt(y);else{if(t(v))break;v=p}if(t(v)){if(!(s===y-1||c===1))if(c===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const T=r.lastIndexOf(a);T===-1?(r="",i=0):(r=r.slice(0,T),i=r.length-1-r.lastIndexOf(a)),s=y,c=0;continue}else if(r.length!==0){r="",i=0,s=y,c=0;continue}}l&&(r+=r.length>0?`${a}..`:"..",i=2)}else r.length>0?r+=`${a}${f.slice(s+1,y)}`:r=f.slice(s+1,y),i=y-s-1;s=y,c=0}else v===C&&c!==-1?++c:c=-1}return r}function _(f,l){if(l===null||typeof l!="object")throw new b("pathObject","Object",l);const a=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return a?a===l.root?`${a}${t}`:`${a}${f}${t}`:t}e.win32={resolve(...f){let l="",a="",t=!1;for(let r=f.length-1;r>=-1;r--){let i;if(r>=0){if(i=f[r],m(i,"path"),i.length===0)continue}else l.length===0?i=E.cwd():(i=E.env[`=${l}`]||E.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==l.toLowerCase()&&i.charCodeAt(2)===w)&&(i=`${l}\\`));const s=i.length;let c=0,v="",y=!1;const T=i.charCodeAt(0);if(s===1)u(T)&&(c=1,y=!0);else if(u(T))if(y=!0,u(i.charCodeAt(1))){let R=2,o=R;for(;R<s&&!u(i.charCodeAt(R));)R++;if(R<s&&R!==o){const k=i.slice(o,R);for(o=R;R<s&&u(i.charCodeAt(R));)R++;if(R<s&&R!==o){for(o=R;R<s&&!u(i.charCodeAt(R));)R++;(R===s||R!==o)&&(v=`\\\\${k}\\${i.slice(o,R)}`,c=R)}}}else c=1;else S(T)&&i.charCodeAt(1)===n&&(v=i.slice(0,2),c=2,s>2&&u(i.charCodeAt(2))&&(y=!0,c=3));if(v.length>0)if(l.length>0){if(v.toLowerCase()!==l.toLowerCase())continue}else l=v;if(t){if(l.length>0)break}else if(a=`${i.slice(c)}\\${a}`,t=y,y&&l.length>0)break}return a=d(a,!t,"\\",u),t?`${l}\\${a}`:`${l}${a}`||"."},normalize(f){m(f,"path");const l=f.length;if(l===0)return".";let a=0,t,r=!1;const i=f.charCodeAt(0);if(l===1)return h(i)?"\\":f;if(u(i))if(r=!0,u(f.charCodeAt(1))){let c=2,v=c;for(;c<l&&!u(f.charCodeAt(c));)c++;if(c<l&&c!==v){const y=f.slice(v,c);for(v=c;c<l&&u(f.charCodeAt(c));)c++;if(c<l&&c!==v){for(v=c;c<l&&!u(f.charCodeAt(c));)c++;if(c===l)return`\\\\${y}\\${f.slice(v)}\\`;c!==v&&(t=`\\\\${y}\\${f.slice(v,c)}`,a=c)}}}else a=1;else S(i)&&f.charCodeAt(1)===n&&(t=f.slice(0,2),a=2,l>2&&u(f.charCodeAt(2))&&(r=!0,a=3));let s=a<l?d(f.slice(a),!r,"\\",u):"";return s.length===0&&!r&&(s="."),s.length>0&&u(f.charCodeAt(l-1))&&(s+="\\"),t===void 0?r?`\\${s}`:s:r?`${t}\\${s}`:`${t}${s}`},isAbsolute(f){m(f,"path");const l=f.length;if(l===0)return!1;const a=f.charCodeAt(0);return u(a)||l>2&&S(a)&&f.charCodeAt(1)===n&&u(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let l,a;for(let i=0;i<f.length;++i){const s=f[i];m(s,"path"),s.length>0&&(l===void 0?l=a=s:l+=`\\${s}`)}if(l===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&u(a.charCodeAt(0))){++r;const i=a.length;i>1&&u(a.charCodeAt(1))&&(++r,i>2&&(u(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<l.length&&u(l.charCodeAt(r));)r++;r>=2&&(l=`\\${l.slice(r)}`)}return e.win32.normalize(l)},relative(f,l){if(m(f,"from"),m(l,"to"),f===l)return"";const a=e.win32.resolve(f),t=e.win32.resolve(l);if(a===t||(f=a.toLowerCase(),l=t.toLowerCase(),f===l))return"";let r=0;for(;r<f.length&&f.charCodeAt(r)===w;)r++;let i=f.length;for(;i-1>r&&f.charCodeAt(i-1)===w;)i--;const s=i-r;let c=0;for(;c<l.length&&l.charCodeAt(c)===w;)c++;let v=l.length;for(;v-1>c&&l.charCodeAt(v-1)===w;)v--;const y=v-c,T=s<y?s:y;let R=-1,o=0;for(;o<T;o++){const O=f.charCodeAt(r+o);if(O!==l.charCodeAt(c+o))break;O===w&&(R=o)}if(o!==T){if(R===-1)return t}else{if(y>T){if(l.charCodeAt(c+o)===w)return t.slice(c+o+1);if(o===2)return t.slice(c+o)}s>T&&(f.charCodeAt(r+o)===w?R=o:o===2&&(R=3)),R===-1&&(R=0)}let k="";for(o=r+R+1;o<=i;++o)(o===i||f.charCodeAt(o)===w)&&(k+=k.length===0?"..":"\\..");return c+=R,k.length>0?`${k}${t.slice(c,v)}`:(t.charCodeAt(c)===w&&++c,t.slice(c,v))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const l=e.win32.resolve(f);if(l.length<=2)return f;if(l.charCodeAt(0)===w){if(l.charCodeAt(1)===w){const a=l.charCodeAt(2);if(a!==A&&a!==C)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(S(l.charCodeAt(0))&&l.charCodeAt(1)===n&&l.charCodeAt(2)===w)return`\\\\?\\${l}`;return f},dirname(f){m(f,"path");const l=f.length;if(l===0)return".";let a=-1,t=0;const r=f.charCodeAt(0);if(l===1)return u(r)?f:".";if(u(r)){if(a=t=1,u(f.charCodeAt(1))){let c=2,v=c;for(;c<l&&!u(f.charCodeAt(c));)c++;if(c<l&&c!==v){for(v=c;c<l&&u(f.charCodeAt(c));)c++;if(c<l&&c!==v){for(v=c;c<l&&!u(f.charCodeAt(c));)c++;if(c===l)return f;c!==v&&(a=t=c+1)}}}}else S(r)&&f.charCodeAt(1)===n&&(a=l>2&&u(f.charCodeAt(2))?3:2,t=a);let i=-1,s=!0;for(let c=l-1;c>=t;--c)if(u(f.charCodeAt(c))){if(!s){i=c;break}}else s=!1;if(i===-1){if(a===-1)return".";i=a}return f.slice(0,i)},basename(f,l){l!==void 0&&m(l,"ext"),m(f,"path");let a=0,t=-1,r=!0,i;if(f.length>=2&&S(f.charCodeAt(0))&&f.charCodeAt(1)===n&&(a=2),l!==void 0&&l.length>0&&l.length<=f.length){if(l===f)return"";let s=l.length-1,c=-1;for(i=f.length-1;i>=a;--i){const v=f.charCodeAt(i);if(u(v)){if(!r){a=i+1;break}}else c===-1&&(r=!1,c=i+1),s>=0&&(v===l.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=c))}return a===t?t=c:t===-1&&(t=f.length),f.slice(a,t)}for(i=f.length-1;i>=a;--i)if(u(f.charCodeAt(i))){if(!r){a=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":f.slice(a,t)},extname(f){m(f,"path");let l=0,a=-1,t=0,r=-1,i=!0,s=0;f.length>=2&&f.charCodeAt(1)===n&&S(f.charCodeAt(0))&&(l=t=2);for(let c=f.length-1;c>=l;--c){const v=f.charCodeAt(c);if(u(v)){if(!i){t=c+1;break}continue}r===-1&&(i=!1,r=c+1),v===C?a===-1?a=c:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||r===-1||s===0||s===1&&a===r-1&&a===t+1?"":f.slice(a,r)},format:_.bind(null,"\\"),parse(f){m(f,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return l;const a=f.length;let t=0,r=f.charCodeAt(0);if(a===1)return u(r)?(l.root=l.dir=f,l):(l.base=l.name=f,l);if(u(r)){if(t=1,u(f.charCodeAt(1))){let R=2,o=R;for(;R<a&&!u(f.charCodeAt(R));)R++;if(R<a&&R!==o){for(o=R;R<a&&u(f.charCodeAt(R));)R++;if(R<a&&R!==o){for(o=R;R<a&&!u(f.charCodeAt(R));)R++;R===a?t=R:R!==o&&(t=R+1)}}}}else if(S(r)&&f.charCodeAt(1)===n){if(a<=2)return l.root=l.dir=f,l;if(t=2,u(f.charCodeAt(2))){if(a===3)return l.root=l.dir=f,l;t=3}}t>0&&(l.root=f.slice(0,t));let i=-1,s=t,c=-1,v=!0,y=f.length-1,T=0;for(;y>=t;--y){if(r=f.charCodeAt(y),u(r)){if(!v){s=y+1;break}continue}c===-1&&(v=!1,c=y+1),r===C?i===-1?i=y:T!==1&&(T=1):i!==-1&&(T=-1)}return c!==-1&&(i===-1||T===0||T===1&&i===c-1&&i===s+1?l.base=l.name=f.slice(s,c):(l.name=f.slice(s,i),l.base=f.slice(s,c),l.ext=f.slice(i,c))),s>0&&s!==t?l.dir=f.slice(0,s-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let l="",a=!1;for(let t=f.length-1;t>=-1&&!a;t--){const r=t>=0?f[t]:E.cwd();m(r,"path"),r.length!==0&&(l=`${r}/${l}`,a=r.charCodeAt(0)===p)}return l=d(l,!a,"/",h),a?`/${l}`:l.length>0?l:"."},normalize(f){if(m(f,"path"),f.length===0)return".";const l=f.charCodeAt(0)===p,a=f.charCodeAt(f.length-1)===p;return f=d(f,!l,"/",h),f.length===0?l?"/":a?"./":".":(a&&(f+="/"),l?`/${f}`:f)},isAbsolute(f){return m(f,"path"),f.length>0&&f.charCodeAt(0)===p},join(...f){if(f.length===0)return".";let l;for(let a=0;a<f.length;++a){const t=f[a];m(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(f,l){if(m(f,"from"),m(l,"to"),f===l||(f=e.posix.resolve(f),l=e.posix.resolve(l),f===l))return"";const a=1,t=f.length,r=t-a,i=1,s=l.length-i,c=r<s?r:s;let v=-1,y=0;for(;y<c;y++){const R=f.charCodeAt(a+y);if(R!==l.charCodeAt(i+y))break;R===p&&(v=y)}if(y===c)if(s>c){if(l.charCodeAt(i+y)===p)return l.slice(i+y+1);if(y===0)return l.slice(i+y)}else r>c&&(f.charCodeAt(a+y)===p?v=y:y===0&&(v=0));let T="";for(y=a+v+1;y<=t;++y)(y===t||f.charCodeAt(y)===p)&&(T+=T.length===0?"..":"/..");return`${T}${l.slice(i+v)}`},toNamespacedPath(f){return f},dirname(f){if(m(f,"path"),f.length===0)return".";const l=f.charCodeAt(0)===p;let a=-1,t=!0;for(let r=f.length-1;r>=1;--r)if(f.charCodeAt(r)===p){if(!t){a=r;break}}else t=!1;return a===-1?l?"/":".":l&&a===1?"//":f.slice(0,a)},basename(f,l){l!==void 0&&m(l,"ext"),m(f,"path");let a=0,t=-1,r=!0,i;if(l!==void 0&&l.length>0&&l.length<=f.length){if(l===f)return"";let s=l.length-1,c=-1;for(i=f.length-1;i>=0;--i){const v=f.charCodeAt(i);if(v===p){if(!r){a=i+1;break}}else c===-1&&(r=!1,c=i+1),s>=0&&(v===l.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=c))}return a===t?t=c:t===-1&&(t=f.length),f.slice(a,t)}for(i=f.length-1;i>=0;--i)if(f.charCodeAt(i)===p){if(!r){a=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":f.slice(a,t)},extname(f){m(f,"path");let l=-1,a=0,t=-1,r=!0,i=0;for(let s=f.length-1;s>=0;--s){const c=f.charCodeAt(s);if(c===p){if(!r){a=s+1;break}continue}t===-1&&(r=!1,t=s+1),c===C?l===-1?l=s:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||t===-1||i===0||i===1&&l===t-1&&l===a+1?"":f.slice(l,t)},format:_.bind(null,"/"),parse(f){m(f,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return l;const a=f.charCodeAt(0)===p;let t;a?(l.root="/",t=1):t=0;let r=-1,i=0,s=-1,c=!0,v=f.length-1,y=0;for(;v>=t;--v){const T=f.charCodeAt(v);if(T===p){if(!c){i=v+1;break}continue}s===-1&&(c=!1,s=v+1),T===C?r===-1?r=v:y!==1&&(y=1):r!==-1&&(y=-1)}if(s!==-1){const T=i===0&&a?1:i;r===-1||y===0||y===1&&r===s-1&&r===i+1?l.base=l.name=f.slice(T,s):(l.name=f.slice(T,r),l.base=f.slice(T,s),l.ext=f.slice(r,s))}return i>0?l.dir=f.slice(0,i-1):a&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ce[116],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var E;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(E=e.Source||(e.Source={}));var P;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function g(D,...I){const C=I.reduce((n,A)=>(n[A]=!0,n),{}),p=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(n=>!C[n]).forEach(n=>{for(let A=0;A<p.length;A++)if(n.search(p[A])!==-1){delete D[n];break}})}e.sanitizeProcessEnvironment=g}),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var P in E)(typeof exports=="object"?exports:X)[P]=E[P]}}(typeof self!="undefined"?self:this,function(){return function(X){var e={};function E(P){if(e[P])return e[P].exports;var g=e[P]={i:P,l:!1,exports:{}};return X[P].call(g.exports,g,g.exports,E),g.l=!0,g.exports}return E.m=X,E.c=e,E.d=function(P,g,D){E.o(P,g)||Object.defineProperty(P,g,{enumerable:!0,get:D})},E.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},E.t=function(P,g){if(1&g&&(P=E(P)),8&g||4&g&&typeof P=="object"&&P&&P.__esModule)return P;var D=Object.create(null);if(E.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:P}),2&g&&typeof P!="string")for(var I in P)E.d(D,I,function(C){return P[C]}.bind(null,I));return D},E.n=function(P){var g=P&&P.__esModule?function(){return P.default}:function(){return P};return E.d(g,"a",g),g},E.o=function(P,g){return Object.prototype.hasOwnProperty.call(P,g)},E.p="",E(E.s=0)}([function(X,e,E){(function(P){var g;e=X.exports=fe,g=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var ne=Array.prototype.slice.call(arguments,0);ne.unshift("SEMVER"),console.log.apply(console,ne)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],p=e.src=[],w=0,n=w++;p[n]="0|[1-9]\\d*";var A=w++;p[A]="[0-9]+";var b=w++;p[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=w++;p[m]="("+p[n]+")\\.("+p[n]+")\\.("+p[n]+")";var u=w++;p[u]="("+p[A]+")\\.("+p[A]+")\\.("+p[A]+")";var h=w++;p[h]="(?:"+p[n]+"|"+p[b]+")";var S=w++;p[S]="(?:"+p[A]+"|"+p[b]+")";var d=w++;p[d]="(?:-("+p[h]+"(?:\\."+p[h]+")*))";var _=w++;p[_]="(?:-?("+p[S]+"(?:\\."+p[S]+")*))";var f=w++;p[f]="[0-9A-Za-z-]+";var l=w++;p[l]="(?:\\+("+p[f]+"(?:\\."+p[f]+")*))";var a=w++,t="v?"+p[m]+p[d]+"?"+p[l]+"?";p[a]="^"+t+"$";var r="[v=\\s]*"+p[u]+p[_]+"?"+p[l]+"?",i=w++;p[i]="^"+r+"$";var s=w++;p[s]="((?:<|>)?=?)";var c=w++;p[c]=p[A]+"|x|X|\\*";var v=w++;p[v]=p[n]+"|x|X|\\*";var y=w++;p[y]="[v=\\s]*("+p[v]+")(?:\\.("+p[v]+")(?:\\.("+p[v]+")(?:"+p[d]+")?"+p[l]+"?)?)?";var T=w++;p[T]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[_]+")?"+p[l]+"?)?)?";var R=w++;p[R]="^"+p[s]+"\\s*"+p[y]+"$";var o=w++;p[o]="^"+p[s]+"\\s*"+p[T]+"$";var k=w++;p[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=w++;p[O]="(?:~>?)";var Y=w++;p[Y]="(\\s*)"+p[O]+"\\s+",C[Y]=new RegExp(p[Y],"g");var Q=w++;p[Q]="^"+p[O]+p[y]+"$";var me=w++;p[me]="^"+p[O]+p[T]+"$";var re=w++;p[re]="(?:\\^)";var N=w++;p[N]="(\\s*)"+p[re]+"\\s+",C[N]=new RegExp(p[N],"g");var W=w++;p[W]="^"+p[re]+p[y]+"$";var U=w++;p[U]="^"+p[re]+p[T]+"$";var j=w++;p[j]="^"+p[s]+"\\s*("+r+")$|^$";var H=w++;p[H]="^"+p[s]+"\\s*("+t+")$|^$";var M=w++;p[M]="(\\s*)"+p[s]+"\\s*("+r+"|"+p[y]+")",C[M]=new RegExp(p[M],"g");var q=w++;p[q]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var z=w++;p[z]="^\\s*("+p[T]+")\\s+-\\s+("+p[T]+")\\s*$";var V=w++;p[V]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)g(K,p[K]),C[K]||(C[K]=new RegExp(p[K]));function ae(ne,Se){if(ne instanceof fe)return ne;if(typeof ne!="string"||ne.length>D||!(Se?C[i]:C[a]).test(ne))return null;try{return new fe(ne,Se)}catch(Ee){return null}}function fe(ne,Se){if(ne instanceof fe){if(ne.loose===Se)return ne;ne=ne.version}else if(typeof ne!="string")throw new TypeError("Invalid Version: "+ne);if(ne.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof fe))return new fe(ne,Se);g("SemVer",ne,Se),this.loose=Se;var Ee=ne.trim().match(Se?C[i]:C[a]);if(!Ee)throw new TypeError("Invalid Version: "+ne);if(this.raw=ne,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var he=+Ue;if(he>=0&&he<I)return he}return Ue}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ne,Se){var Ee=ae(ne,Se);return Ee?Ee.version:null},e.clean=function(ne,Se){var Ee=ae(ne.trim().replace(/^[=v]+/,""),Se);return Ee?Ee.version:null},e.SemVer=fe,fe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},fe.prototype.toString=function(){return this.version},fe.prototype.compare=function(ne){return g("SemVer.compare",this.version,this.loose,ne),ne instanceof fe||(ne=new fe(ne,this.loose)),this.compareMain(ne)||this.comparePre(ne)},fe.prototype.compareMain=function(ne){return ne instanceof fe||(ne=new fe(ne,this.loose)),Pe(this.major,ne.major)||Pe(this.minor,ne.minor)||Pe(this.patch,ne.patch)},fe.prototype.comparePre=function(ne){if(ne instanceof fe||(ne=new fe(ne,this.loose)),this.prerelease.length&&!ne.prerelease.length)return-1;if(!this.prerelease.length&&ne.prerelease.length)return 1;if(!this.prerelease.length&&!ne.prerelease.length)return 0;var Se=0;do{var Ee=this.prerelease[Se],Ue=ne.prerelease[Se];if(g("prerelease compare",Se,Ee,Ue),Ee===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==Ue)return Pe(Ee,Ue)}while(++Se)},fe.prototype.inc=function(ne,Se){switch(ne){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+ne)}return this.format(),this.raw=this.version,this},e.inc=function(ne,Se,Ee,Ue){typeof Ee=="string"&&(Ue=Ee,Ee=void 0);try{return new fe(ne,Ee).inc(Se,Ue).version}catch(he){return null}},e.diff=function(ne,Se){if(Xe(ne,Se))return null;var Ee=ae(ne),Ue=ae(Se);if(Ee.prerelease.length||Ue.prerelease.length){for(var he in Ee)if((he==="major"||he==="minor"||he==="patch")&&Ee[he]!==Ue[he])return"pre"+he;return"prerelease"}for(var he in Ee)if((he==="major"||he==="minor"||he==="patch")&&Ee[he]!==Ue[he])return he},e.compareIdentifiers=Pe;var De=/^[0-9]+$/;function Pe(ne,Se){var Ee=De.test(ne),Ue=De.test(Se);return Ee&&Ue&&(ne=+ne,Se=+Se),Ee&&!Ue?-1:Ue&&!Ee?1:ne<Se?-1:ne>Se?1:0}function Fe(ne,Se,Ee){return new fe(ne,Ee).compare(new fe(Se,Ee))}function Ne(ne,Se,Ee){return Fe(ne,Se,Ee)>0}function ze(ne,Se,Ee){return Fe(ne,Se,Ee)<0}function Xe(ne,Se,Ee){return Fe(ne,Se,Ee)===0}function nt(ne,Se,Ee){return Fe(ne,Se,Ee)!==0}function it(ne,Se,Ee){return Fe(ne,Se,Ee)>=0}function rt(ne,Se,Ee){return Fe(ne,Se,Ee)<=0}function pe(ne,Se,Ee,Ue){var he;switch(Se){case"===":typeof ne=="object"&&(ne=ne.version),typeof Ee=="object"&&(Ee=Ee.version),he=ne===Ee;break;case"!==":typeof ne=="object"&&(ne=ne.version),typeof Ee=="object"&&(Ee=Ee.version),he=ne!==Ee;break;case"":case"=":case"==":he=Xe(ne,Ee,Ue);break;case"!=":he=nt(ne,Ee,Ue);break;case">":he=Ne(ne,Ee,Ue);break;case">=":he=it(ne,Ee,Ue);break;case"<":he=ze(ne,Ee,Ue);break;case"<=":he=rt(ne,Ee,Ue);break;default:throw new TypeError("Invalid operator: "+Se)}return he}function Ce(ne,Se){if(ne instanceof Ce){if(ne.loose===Se)return ne;ne=ne.value}if(!(this instanceof Ce))return new Ce(ne,Se);g("comparator",ne,Se),this.loose=Se,this.parse(ne),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(ne,Se){return Pe(Se,ne)},e.major=function(ne,Se){return new fe(ne,Se).major},e.minor=function(ne,Se){return new fe(ne,Se).minor},e.patch=function(ne,Se){return new fe(ne,Se).patch},e.compare=Fe,e.compareLoose=function(ne,Se){return Fe(ne,Se,!0)},e.rcompare=function(ne,Se,Ee){return Fe(Se,ne,Ee)},e.sort=function(ne,Se){return ne.sort(function(Ee,Ue){return e.compare(Ee,Ue,Se)})},e.rsort=function(ne,Se){return ne.sort(function(Ee,Ue){return e.rcompare(Ee,Ue,Se)})},e.gt=Ne,e.lt=ze,e.eq=Xe,e.neq=nt,e.gte=it,e.lte=rt,e.cmp=pe,e.Comparator=Ce;var Ae={};function Re(ne,Se){if(ne instanceof Re)return ne.loose===Se?ne:new Re(ne.raw,Se);if(ne instanceof Ce)return new Re(ne.value,Se);if(!(this instanceof Re))return new Re(ne,Se);if(this.loose=Se,this.raw=ne,this.set=ne.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ne);this.format()}function Me(ne){return!ne||ne.toLowerCase()==="x"||ne==="*"}function $e(ne,Se,Ee,Ue,he,ge,ye,G,J,te,oe,B,ie){return((Se=Me(Ee)?"":Me(Ue)?">="+Ee+".0.0":Me(he)?">="+Ee+"."+Ue+".0":">="+Se)+" "+(G=Me(J)?"":Me(te)?"<"+(+J+1)+".0.0":Me(oe)?"<"+J+"."+(+te+1)+".0":B?"<="+J+"."+te+"."+oe+"-"+B:"<="+G)).trim()}function He(ne,Se){for(var Ee=0;Ee<ne.length;Ee++)if(!ne[Ee].test(Se))return!1;if(Se.prerelease.length){for(Ee=0;Ee<ne.length;Ee++)if(g(ne[Ee].semver),ne[Ee].semver!==Ae&&ne[Ee].semver.prerelease.length>0){var Ue=ne[Ee].semver;if(Ue.major===Se.major&&Ue.minor===Se.minor&&Ue.patch===Se.patch)return!0}return!1}return!0}function Ye(ne,Se,Ee){try{Se=new Re(Se,Ee)}catch(Ue){return!1}return Se.test(ne)}function tt(ne,Se,Ee,Ue){var he,ge,ye,G,J;switch(ne=new fe(ne,Ue),Se=new Re(Se,Ue),Ee){case">":he=Ne,ge=rt,ye=ze,G=">",J=">=";break;case"<":he=ze,ge=it,ye=Ne,G="<",J="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ne,Se,Ue))return!1;for(var te=0;te<Se.set.length;++te){var oe=Se.set[te],B=null,ie=null;if(oe.forEach(function(se){se.semver===Ae&&(se=new Ce(">=0.0.0")),B=B||se,ie=ie||se,he(se.semver,B.semver,Ue)?B=se:ye(se.semver,ie.semver,Ue)&&(ie=se)}),B.operator===G||B.operator===J||(!ie.operator||ie.operator===G)&&ge(ne,ie.semver)||ie.operator===J&&ye(ne,ie.semver))return!1}return!0}Ce.prototype.parse=function(ne){var Se=this.loose?C[j]:C[H],Ee=ne.match(Se);if(!Ee)throw new TypeError("Invalid comparator: "+ne);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new fe(Ee[2],this.loose):this.semver=Ae},Ce.prototype.toString=function(){return this.value},Ce.prototype.test=function(ne){return g("Comparator.test",ne,this.loose),this.semver===Ae||(typeof ne=="string"&&(ne=new fe(ne,this.loose)),pe(ne,this.operator,this.semver,this.loose))},Ce.prototype.intersects=function(ne,Se){if(!(ne instanceof Ce))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new Re(ne.value,Se),Ye(this.value,Ee,Se);if(ne.operator==="")return Ee=new Re(this.value,Se),Ye(ne.semver,Ee,Se);var Ue=!(this.operator!==">="&&this.operator!==">"||ne.operator!==">="&&ne.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||ne.operator!=="<="&&ne.operator!=="<"),ge=this.semver.version===ne.semver.version,ye=!(this.operator!==">="&&this.operator!=="<="||ne.operator!==">="&&ne.operator!=="<="),G=pe(this.semver,"<",ne.semver,Se)&&(this.operator===">="||this.operator===">")&&(ne.operator==="<="||ne.operator==="<"),J=pe(this.semver,">",ne.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(ne.operator===">="||ne.operator===">");return Ue||he||ge&&ye||G||J},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(ne){return ne.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(ne){var Se=this.loose;ne=ne.trim(),g("range",ne,Se);var Ee=Se?C[z]:C[q];ne=ne.replace(Ee,$e),g("hyphen replace",ne),ne=ne.replace(C[M],"$1$2$3"),g("comparator trim",ne,C[M]),ne=(ne=(ne=ne.replace(C[Y],"$1~")).replace(C[N],"$1^")).split(/\s+/).join(" ");var Ue=Se?C[j]:C[H],he=ne.split(" ").map(function(ge){return function(ye,G){return g("comp",ye),ye=function(J,te){return J.trim().split(/\s+/).map(function(oe){return function(B,ie){g("caret",B,ie);var se=ie?C[U]:C[W];return B.replace(se,function(ve,ee,we,_e,Te){var Oe;return g("caret",B,ve,ee,we,_e,Te),Me(ee)?Oe="":Me(we)?Oe=">="+ee+".0.0 <"+(+ee+1)+".0.0":Me(_e)?Oe=ee==="0"?">="+ee+"."+we+".0 <"+ee+"."+(+we+1)+".0":">="+ee+"."+we+".0 <"+(+ee+1)+".0.0":Te?(g("replaceCaret pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Oe=ee==="0"?we==="0"?">="+ee+"."+we+"."+_e+Te+" <"+ee+"."+we+"."+(+_e+1):">="+ee+"."+we+"."+_e+Te+" <"+ee+"."+(+we+1)+".0":">="+ee+"."+we+"."+_e+Te+" <"+(+ee+1)+".0.0"):(g("no pr"),Oe=ee==="0"?we==="0"?">="+ee+"."+we+"."+_e+" <"+ee+"."+we+"."+(+_e+1):">="+ee+"."+we+"."+_e+" <"+ee+"."+(+we+1)+".0":">="+ee+"."+we+"."+_e+" <"+(+ee+1)+".0.0"),g("caret return",Oe),Oe})}(oe,te)}).join(" ")}(ye,G),g("caret",ye),ye=function(J,te){return J.trim().split(/\s+/).map(function(oe){return function(B,ie){var se=ie?C[me]:C[Q];return B.replace(se,function(ve,ee,we,_e,Te){var Oe;return g("tilde",B,ve,ee,we,_e,Te),Me(ee)?Oe="":Me(we)?Oe=">="+ee+".0.0 <"+(+ee+1)+".0.0":Me(_e)?Oe=">="+ee+"."+we+".0 <"+ee+"."+(+we+1)+".0":Te?(g("replaceTilde pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Oe=">="+ee+"."+we+"."+_e+Te+" <"+ee+"."+(+we+1)+".0"):Oe=">="+ee+"."+we+"."+_e+" <"+ee+"."+(+we+1)+".0",g("tilde return",Oe),Oe})}(oe,te)}).join(" ")}(ye,G),g("tildes",ye),ye=function(J,te){return g("replaceXRanges",J,te),J.split(/\s+/).map(function(oe){return function(B,ie){B=B.trim();var se=ie?C[o]:C[R];return B.replace(se,function(ve,ee,we,_e,Te,Oe){g("xRange",B,ve,ee,we,_e,Te,Oe);var je=Me(we),qe=je||Me(_e),Ze=qe||Me(Te);return ee==="="&&Ze&&(ee=""),je?ve=ee===">"||ee==="<"?"<0.0.0":"*":ee&&Ze?(qe&&(_e=0),Ze&&(Te=0),ee===">"?(ee=">=",qe?(we=+we+1,_e=0,Te=0):Ze&&(_e=+_e+1,Te=0)):ee==="<="&&(ee="<",qe?we=+we+1:_e=+_e+1),ve=ee+we+"."+_e+"."+Te):qe?ve=">="+we+".0.0 <"+(+we+1)+".0.0":Ze&&(ve=">="+we+"."+_e+".0 <"+we+"."+(+_e+1)+".0"),g("xRange return",ve),ve})}(oe,te)}).join(" ")}(ye,G),g("xrange",ye),ye=function(J,te){return g("replaceStars",J,te),J.trim().replace(C[V],"")}(ye,G),g("stars",ye),ye}(ge,Se)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(ge){return!!ge.match(Ue)})),he=he.map(function(ge){return new Ce(ge,Se)})},Re.prototype.intersects=function(ne,Se){if(!(ne instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(Ue){return ne.set.some(function(he){return he.every(function(ge){return Ue.intersects(ge,Se)})})})})},e.toComparators=function(ne,Se){return new Re(ne,Se).set.map(function(Ee){return Ee.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(ne){if(!ne)return!1;typeof ne=="string"&&(ne=new fe(ne,this.loose));for(var Se=0;Se<this.set.length;Se++)if(He(this.set[Se],ne))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ne,Se,Ee){var Ue=null,he=null;try{var ge=new Re(Se,Ee)}catch(ye){return null}return ne.forEach(function(ye){ge.test(ye)&&(Ue&&he.compare(ye)!==-1||(he=new fe(Ue=ye,Ee)))}),Ue},e.minSatisfying=function(ne,Se,Ee){var Ue=null,he=null;try{var ge=new Re(Se,Ee)}catch(ye){return null}return ne.forEach(function(ye){ge.test(ye)&&(Ue&&he.compare(ye)!==1||(he=new fe(Ue=ye,Ee)))}),Ue},e.validRange=function(ne,Se){try{return new Re(ne,Se).range||"*"}catch(Ee){return null}},e.ltr=function(ne,Se,Ee){return tt(ne,Se,"<",Ee)},e.gtr=function(ne,Se,Ee){return tt(ne,Se,">",Ee)},e.outside=tt,e.prerelease=function(ne,Se){var Ee=ae(ne,Se);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(ne,Se,Ee){return ne=new Re(ne,Ee),Se=new Re(Se,Ee),ne.intersects(Se)},e.coerce=function(ne){if(ne instanceof fe)return ne;if(typeof ne!="string")return null;var Se=ne.match(C[k]);return Se==null?null:ae((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,E(1))},function(X,e){var E,P,g=X.exports={};function D(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function C(S){if(E===setTimeout)return setTimeout(S,0);if((E===D||!E)&&setTimeout)return E=setTimeout,setTimeout(S,0);try{return E(S,0)}catch(d){try{return E.call(null,S,0)}catch(_){return E.call(this,S,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:D}catch(S){E=D}try{P=typeof clearTimeout=="function"?clearTimeout:I}catch(S){P=I}})();var p,w=[],n=!1,A=-1;function b(){n&&p&&(n=!1,p.length?w=p.concat(w):A=-1,w.length&&m())}function m(){if(!n){var S=C(b);n=!0;for(var d=w.length;d;){for(p=w,w=[];++A<d;)p&&p[A].run();A=-1,d=w.length}p=null,n=!1,function(_){if(P===clearTimeout)return clearTimeout(_);if((P===I||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(_);try{P(_)}catch(f){try{return P.call(null,_)}catch(l){return P.call(this,_)}}}(S)}}function u(S,d){this.fun=S,this.array=d}function h(){}g.nextTick=function(S){var d=new Array(arguments.length-1);if(arguments.length>1)for(var _=1;_<arguments.length;_++)d[_-1]=arguments[_];w.push(new u(S,d)),w.length!==1||n||C(m)},u.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=h,g.addListener=h,g.once=h,g.off=h,g.removeListener=h,g.removeAllListeners=h,g.emit=h,g.prependListener=h,g.prependOnceListener=h,g.listeners=function(S){return[]},g.binding=function(S){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(S){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(ce[117],ue([0,1,4]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=E.globals.performance&&typeof E.globals.performance.now=="function";class g{constructor(I){this._highResolution=P&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new g(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=g}),define(ce[7],ue([0,1,11,72,2,114,117]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(f){f.None=()=>g.Disposable.None;function l(re){return(N,W=null,U)=>{let j=!1,H;return H=re(M=>{if(!j)return H?H.dispose():j=!0,N.call(W,M)},null,U),j&&H.dispose(),H}}f.once=l;function a(re,N){return v((W,U=null,j)=>re(H=>W.call(U,N(H)),null,j))}f.map=a;function t(re,N){return v((W,U=null,j)=>re(H=>{N(H),W.call(U,H)},null,j))}f.forEach=t;function r(re,N){return v((W,U=null,j)=>re(H=>N(H)&&W.call(U,H),null,j))}f.filter=r;function i(re){return re}f.signal=i;function s(...re){return(N,W=null,U)=>(0,g.combinedDisposable)(...re.map(j=>j(H=>N.call(W,H),null,U)))}f.any=s;function c(re,N,W){let U=W;return a(re,j=>(U=N(U,j),U))}f.reduce=c;function v(re){let N;const W=new b({onFirstListenerAdd(){N=re(W.fire,W)},onLastListenerRemove(){N.dispose()}});return W.event}function y(re,N,W=100,U=!1,j){let H,M,q,z=0;const V=new b({leakWarningThreshold:j,onFirstListenerAdd(){H=re(K=>{z++,M=N(M,K),U&&!q&&(V.fire(M),M=void 0),clearTimeout(q),q=setTimeout(()=>{const ae=M;M=void 0,q=void 0,(!U||z>1)&&V.fire(ae),z=0},W)})},onLastListenerRemove(){H.dispose()}});return V.event}f.debounce=y;function T(re,N=(W,U)=>W===U){let W=!0,U;return r(re,j=>{const H=W||!N(j,U);return W=!1,U=j,H})}f.latch=T;function R(re,N){return[f.filter(re,N),f.filter(re,W=>!N(W))]}f.split=R;function o(re,N=!1,W=[]){let U=W.slice(),j=re(q=>{U?U.push(q):M.fire(q)});const H=()=>{U&&U.forEach(q=>M.fire(q)),U=null},M=new b({onFirstListenerAdd(){j||(j=re(q=>M.fire(q)))},onFirstListenerDidAdd(){U&&(N?setTimeout(H):H())},onLastListenerRemove(){j&&j.dispose(),j=null}});return M.event}f.buffer=o;class k{constructor(N){this.event=N}map(N){return new k(a(this.event,N))}forEach(N){return new k(t(this.event,N))}filter(N){return new k(r(this.event,N))}reduce(N,W){return new k(c(this.event,N,W))}latch(){return new k(T(this.event))}debounce(N,W=100,U=!1,j){return new k(y(this.event,N,W,U,j))}on(N,W,U){return this.event(N,W,U)}once(N,W,U){return l(this.event)(N,W,U)}}function O(re){return new k(re)}f.chain=O;function Y(re,N,W=U=>U){const U=(...q)=>M.fire(W(...q)),j=()=>re.on(N,U),H=()=>re.removeListener(N,U),M=new b({onFirstListenerAdd:j,onLastListenerRemove:H});return M.event}f.fromNodeEventEmitter=Y;function Q(re,N,W=U=>U){const U=(...q)=>M.fire(W(...q)),j=()=>re.addEventListener(N,U),H=()=>re.removeEventListener(N,U),M=new b({onFirstListenerAdd:j,onLastListenerRemove:H});return M.event}f.fromDOMEventEmitter=Q;function me(re){return new Promise(N=>l(re)(N))}f.toPromise=me})(C=e.Event||(e.Event={}));class p{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${p._idPool++}`}start(l){this._stopWatch=new I.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let w=-1;function n(f){const l=w;return w=f,{dispose(){w=l}}}e.setGlobalLeakWarningThreshold=n;class A{constructor(l,a=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let a=w;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||l<a)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let i,s=0;for(const[c,v]of this._stacks)(!i||s<v)&&(i=c,s=v);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class b{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=w>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(l,a,t)=>{this._listeners||(this._listeners=new D.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(a?[l,a]:l);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,a);const s=this._leakageMon?.check(this._listeners.size),c=(0,g.toDisposable)(()=>{s&&s(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof g.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(r){(0,E.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=b;class m extends b{async fireAsync(l,a,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,l]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),s=[],c={...i,waitUntil:v=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");t&&(v=t(v,typeof r=="function"?r:r[0])),s.push(v)}};try{typeof r=="function"?r.call(void 0,c):r[0].call(r[1],c)}catch(v){(0,E.onUnexpectedError)(v);continue}Object.freeze(s),await Promise.allSettled(s).then(v=>{for(const y of v)y.status==="rejected"&&(0,E.onUnexpectedError)(y.reason)})}}}}e.AsyncEmitter=m;class u extends b{constructor(l){super(l);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=u;class h extends u{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=h;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const a={event:l,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const t=()=>{this.hasListeners&&this.unhook(a);const r=this.events.indexOf(a);this.events.splice(r,1)};return(0,g.toDisposable)((0,P.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(a=>this.emitter.fire(a))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class d{constructor(){this.buffers=[]}wrapEvent(l){return(a,t,r)=>l(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>a.call(t,i)):a.call(t,i)},void 0,r)}bufferEvents(l){const a=[];this.buffers.push(a);const t=l();return this.buffers.pop(),a.forEach(r=>r()),t}}e.EventBufferer=d;class _{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=g.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_}),define(ce[25],ue([0,1,7]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const P=Object.freeze(function(C,p){const w=setTimeout(C.bind(p),0);return{dispose(){clearTimeout(w)}}});var g;(function(C){function p(w){return w===C.None||w===C.Cancelled||w instanceof D?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}C.isCancellationToken=p,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(g=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?P:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=g.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=g.None}}e.CancellationTokenSource=I}),define(ce[39],ue([0,1,7]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class P{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(A){const b=this._icons.get(A.id);b?A.description?b.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const g=new P;e.iconRegistry=g;function D(n,A){return new C(n,A)}e.registerCodicon=D;function I(n){return n?n.replace(/\$\((.*?)\)/g,(A,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=I;class C{constructor(A,b,m){this.id=A,this.definition=b,this.description=m,g.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function p(n,A){const b=["codicon","codicon-"+n];return A&&b.push("codicon-modifier-"+A),b}e.getClassNamesArray=p;var w;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function b(h){if(h instanceof C)return["codicon","codicon-"+h.id];const S=A.exec(h.id);if(!S)return b(C.error);let[,d,_]=S;const f=["codicon","codicon-"+d];return _&&f.push("codicon-modifier-"+_.substr(1)),f}n.asClassNameArray=b;function m(h){return b(h).join(" ")}n.asClassName=m;function u(h){return"."+b(h).join(".")}n.asCSSSelector=u})(w=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(ce[42],ue([0,1,11,2]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function g(f){const l=f;return l?[l.on,l.pause,l.resume,l.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=g;function D(f){const l=f;return l?g(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=D;function I(f,l){return new C(f,l)}e.newWriteableStream=I;class C{constructor(l,a){this.reducer=l,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(a=>a(l))}emitError(l){this.listeners.error.length===0?(0,E.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(a=>a(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,a){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(l,a){if(this.state.destroyed)return;let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(f,l){const a=[];let t;for(;(t=f.read())!==null;)a.push(t);return l(a)}e.consumeReadable=p;function w(f,l,a){const t=[];let r;for(;(r=f.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return f.read()}}}e.peekReadable=w;function n(f,l){return new Promise((a,t)=>{const r=[];A(f,{onData:i=>{l&&r.push(i)},onError:i=>{l?t(i):a(void 0)},onEnd:()=>{a(l?l(r):void 0)}})})}e.consumeStream=n;function A(f,l){f.on("error",a=>l.onError(a)),f.on("end",()=>l.onEnd()),f.on("data",a=>l.onData(a))}e.listenStream=A;function b(f,l){return new Promise((a,t)=>{const r=new P.DisposableStore,i=[],s=y=>{if(i.push(y),i.length>l)return r.dispose(),f.pause(),a({stream:f,buffer:i,ended:!1})},c=y=>t(y),v=()=>a({stream:f,buffer:i,ended:!0});r.add((0,P.toDisposable)(()=>f.removeListener("error",c))),f.on("error",c),r.add((0,P.toDisposable)(()=>f.removeListener("end",v))),f.on("end",v),r.add((0,P.toDisposable)(()=>f.removeListener("data",s))),f.on("data",s)})}e.peekStream=b;function m(f,l){const a=I(l);return a.end(f),a}e.toStream=m;function u(){const f=I(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=u;function h(f){let l=!1;return{read:()=>l?null:(l=!0,f)}}e.toReadable=h;function S(f,l,a){const t=I(a);return A(f,{onData:r=>t.write(l.data(r)),onError:r=>t.error(l.error?l.error(r):r),onEnd:()=>t.end()}),t}e.transform=S;function d(f,l,a){let t=!1;return{read:()=>{const r=l.read();return t?r:(t=!0,r!==null?a([f,r]):f)}}}e.prefixedReadable=d;function _(f,l,a){let t=!1;const r=I(a);return A(l,{onData:i=>t?r.write(i):(t=!0,r.write(a([f,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(f)),r.end()}}),r}e.prefixedStream=_}),define(ce[13],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function E(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=E;const P=/{(\d+)}/g;function g(B,...ie){return ie.length===0?B:B.replace(P,function(se,ve){const ee=parseInt(ve,10);return isNaN(ee)||ee<0||ee>=ie.length?se:ie[ee]})}e.format=g;const D=/{([^}]+)}/g;function I(B,ie){return B.replace(D,(se,ve)=>ie[ve]??se)}e.format2=I;function C(B){return B.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=C;function p(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function w(B,ie){let se=0;const ve=ie.charCodeAt(0);for(let ee=B.length-1;ee>=0;ee--)B.charCodeAt(ee)===ve&&se++;return se}e.count=w;function n(B,ie,se="\u2026"){return B.length<=ie?B:`${B.substr(0,ie)}${se}`}e.truncate=n;function A(B,ie=" "){const se=b(B,ie);return m(se,ie)}e.trim=A;function b(B,ie){if(!B||!ie)return B;const se=ie.length;if(se===0||B.length===0)return B;let ve=0;for(;B.indexOf(ie,ve)===ve;)ve=ve+se;return B.substring(ve)}e.ltrim=b;function m(B,ie){if(!B||!ie)return B;const se=ie.length,ve=B.length;if(se===0||ve===0)return B;let ee=ve,we=-1;for(;we=B.lastIndexOf(ie,ee-1),!(we===-1||we+se!==ee);){if(we===0)return"";ee=we}return B.substring(0,ee)}e.rtrim=m;function u(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function h(B){return B.replace(/\*/g,"")}e.stripWildcards=h;function S(B,ie,se={}){if(!B)throw new Error("Cannot create regex from empty string");ie||(B=p(B)),se.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let ve="";return se.global&&(ve+="g"),se.matchCase||(ve+="i"),se.multiline&&(ve+="m"),se.unicode&&(ve+="u"),new RegExp(B,ve)}e.createRegExp=S;function d(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function _(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function f(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=f;function l(B){return B.split(/\r\n|\r|\n/)}e.splitLines=l;function a(B){for(let ie=0,se=B.length;ie<se;ie++){const ve=B.charCodeAt(ie);if(ve!==32&&ve!==9)return ie}return-1}e.firstNonWhitespaceIndex=a;function t(B,ie=0,se=B.length){for(let ve=ie;ve<se;ve++){const ee=B.charCodeAt(ve);if(ee!==32&&ee!==9)return B.substring(ie,ve)}return B.substring(ie,se)}e.getLeadingWhitespace=t;function r(B,ie=B.length-1){for(let se=ie;se>=0;se--){const ve=B.charCodeAt(se);if(ve!==32&&ve!==9)return se}return-1}e.lastNonWhitespaceIndex=r;function i(B,ie){return B<ie?-1:B>ie?1:0}e.compare=i;function s(B,ie,se=0,ve=B.length,ee=0,we=ie.length){for(;se<ve&&ee<we;se++,ee++){let Oe=B.charCodeAt(se),je=ie.charCodeAt(ee);if(Oe<je)return-1;if(Oe>je)return 1}const _e=ve-se,Te=we-ee;return _e<Te?-1:_e>Te?1:0}e.compareSubstring=s;function c(B,ie){return v(B,ie,0,B.length,0,ie.length)}e.compareIgnoreCase=c;function v(B,ie,se=0,ve=B.length,ee=0,we=ie.length){for(;se<ve&&ee<we;se++,ee++){let Oe=B.charCodeAt(se),je=ie.charCodeAt(ee);if(Oe===je)continue;const qe=Oe-je;if(!(qe===32&&T(je))&&!(qe===-32&&T(Oe)))return y(Oe)&&y(je)?qe:s(B.toLowerCase(),ie.toLowerCase(),se,ve,ee,we)}const _e=ve-se,Te=we-ee;return _e<Te?-1:_e>Te?1:0}e.compareSubstringIgnoreCase=v;function y(B){return B>=97&&B<=122}e.isLowerAsciiLetter=y;function T(B){return B>=65&&B<=90}e.isUpperAsciiLetter=T;function R(B){return y(B)||T(B)}function o(B,ie){return B.length===ie.length&&k(B,ie)}e.equalsIgnoreCase=o;function k(B,ie,se=B.length){for(let ve=0;ve<se;ve++){const ee=B.charCodeAt(ve),we=ie.charCodeAt(ve);if(ee!==we){if(R(ee)&&R(we)){const _e=Math.abs(ee-we);if(_e!==0&&_e!==32)return!1}else if(String.fromCharCode(ee).toLowerCase()!==String.fromCharCode(we).toLowerCase())return!1}}return!0}function O(B,ie){const se=ie.length;return ie.length>B.length?!1:k(B,ie,se)}e.startsWithIgnoreCase=O;function Y(B,ie){let se,ve=Math.min(B.length,ie.length);for(se=0;se<ve;se++)if(B.charCodeAt(se)!==ie.charCodeAt(se))return se;return ve}e.commonPrefixLength=Y;function Q(B,ie){let se,ve=Math.min(B.length,ie.length);const ee=B.length-1,we=ie.length-1;for(se=0;se<ve;se++)if(B.charCodeAt(ee-se)!==ie.charCodeAt(we-se))return se;return ve}e.commonSuffixLength=Q;function me(B){return 55296<=B&&B<=56319}e.isHighSurrogate=me;function re(B){return 56320<=B&&B<=57343}e.isLowSurrogate=re;function N(B,ie){return(B-55296<<10)+(ie-56320)+65536}e.computeCodePoint=N;function W(B,ie,se){const ve=B.charCodeAt(se);if(me(ve)&&se+1<ie){const ee=B.charCodeAt(se+1);if(re(ee))return N(ve,ee)}return ve}e.getNextCodePoint=W;function U(B,ie){const se=B.charCodeAt(ie-1);if(re(se)&&ie>1){const ve=B.charCodeAt(ie-2);if(me(ve))return N(ve,se)}return se}function j(B,ie){const se=he.getInstance(),ve=ie,ee=B.length,we=W(B,ee,ie);ie+=we>=65536?2:1;let _e=se.getGraphemeBreakType(we);for(;ie<ee;){const Te=W(B,ee,ie),Oe=se.getGraphemeBreakType(Te);if(Ee(_e,Oe))break;ie+=Te>=65536?2:1,_e=Oe}return ie-ve}e.nextCharLength=j;function H(B,ie){const se=he.getInstance(),ve=ie,ee=U(B,ie);ie-=ee>=65536?2:1;let we=se.getGraphemeBreakType(ee);for(;ie>0;){const _e=U(B,ie),Te=se.getGraphemeBreakType(_e);if(Ee(Te,we))break;ie-=_e>=65536?2:1,we=Te}return ve-ie}e.prevCharLength=H;function M(B,ie){const se=he.getInstance(),ve=B.length,ee=ie,we=W(B,ve,ie),_e=se.getGraphemeBreakType(we);ie+=we>=65536?2:1;let Te=_e;for(;ie<ve;){const je=W(B,ve,ie),qe=se.getGraphemeBreakType(je);if(Ee(Te,qe))break;ie+=je>=65536?2:1,Te=qe}const Oe=ie;for(ie=ee,Te=_e;ie>0;){const je=U(B,ie),qe=se.getGraphemeBreakType(je);if(Ee(qe,Te))break;ie-=je>=65536?2:1,Te=qe}return[ie,Oe]}function q(B,ie){return ie>0&&re(B.charCodeAt(ie))?M(B,ie-1):M(B,ie)}e.getCharContainingOffset=q;function z(B){const ie=B.length;let se=0,ve=0;for(;ve<ie;){const _e=W(B,ie,ve);ve+=_e>=65536?2:1,_e<128?se+=1:_e<2048?se+=2:_e<65536?se+=3:se+=4}const ee=new Uint8Array(se);ve=0;let we=0;for(;ve<ie;){const _e=W(B,ie,ve);ve+=_e>=65536?2:1,_e<128?ee[we++]=_e:_e<2048?(ee[we++]=192|(_e&1984)>>>6,ee[we++]=128|(_e&63)>>>0):_e<65536?(ee[we++]=224|(_e&61440)>>>12,ee[we++]=128|(_e&4032)>>>6,ee[we++]=128|(_e&63)>>>0):(ee[we++]=240|(_e&1835008)>>>18,ee[we++]=128|(_e&258048)>>>12,ee[we++]=128|(_e&4032)>>>6,ee[we++]=128|(_e&63)>>>0)}return ee}e.encodeUTF8=z;function V(B){const ie=B.byteLength,se=[];let ve=0;for(;ve<ie;){const ee=B[ve];let we;if(ee>=240&&ve+3<ie?we=(B[ve++]&7)<<18>>>0|(B[ve++]&63)<<12>>>0|(B[ve++]&63)<<6>>>0|(B[ve++]&63)<<0>>>0:ee>=224&&ve+2<ie?we=(B[ve++]&15)<<12>>>0|(B[ve++]&63)<<6>>>0|(B[ve++]&63)<<0>>>0:ee>=192&&ve+1<ie?we=(B[ve++]&31)<<6>>>0|(B[ve++]&63)<<0>>>0:we=B[ve++],we>=0&&we<=55295||we>=57344&&we<=65535)se.push(String.fromCharCode(we));else if(we>=65536&&we<=1114111){const _e=we-65536,Te=55296+((_e&1047552)>>>10),Oe=56320+((_e&1023)>>>0);se.push(String.fromCharCode(Te)),se.push(String.fromCharCode(Oe))}else se.push(String.fromCharCode(65533))}return se.join("")}e.decodeUTF8=V;const K=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ae(B){return K.test(B)}e.containsRTL=ae;const fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function De(B){return fe.test(B)}e.containsEmoji=De;const Pe=/^[\t\n\r\x20-\x7E]*$/;function Fe(B){return Pe.test(B)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ne(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=Ne;function ze(B){for(let ie=0,se=B.length;ie<se;ie++)if(Xe(B.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=ze;function Xe(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=Xe;function nt(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=nt;function it(B,ie){if(B.length<ie)return B;const se=/\b/g;let ve=0;for(;se.test(B)&&!(B.length-se.lastIndex<ie);)ve=se.lastIndex,se.lastIndex+=1;return B.substring(ve).replace(/^\s/,"")}e.lcut=it;const rt=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,Ce=/\x1b\[0?m/g;function Ae(B){return B&&(B=B.replace(rt,""),B=B.replace(pe,""),B=B.replace(Ce,"")),B}e.removeAnsiEscapeCodes=Ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function Me(B){return Re(B)?B.substr(1):B}e.stripUTF8BOM=Me;function $e(B,ie){if(!B||!ie||B.length<ie.length)return!1;const se=ie.length,ve=B.toLowerCase();let ee=0,we=-1;for(;ee<se;){const _e=ve.indexOf(ie[ee],we+1);if(_e<0)return!1;we=_e,ee++}return!0}e.fuzzyContains=$e;function He(B,ie=!1){return B?(ie&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=He;function Ye(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=Ye;function tt(B,ie=1){if(ie===0)return"";let se=-1;do se=B.indexOf(`
`,se+1),ie--;while(ie>0&&se>=0);return se===-1?B:(B[se-1]==="\r"&&se--,B.substr(0,se))}e.getNLines=tt;function ne(B){const ie=90-65+1;return B=B%(2*ie),B<ie?String.fromCharCode(97+B):String.fromCharCode(65+B-ie)}e.singleLetterHash=ne;function Se(B){return he.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=Se;function Ee(B,ie){return B===0?ie!==5&&ie!==7:B===2&&ie===3?!1:B===4||B===2||B===3||ie===4||ie===2||ie===3?!0:!(B===8&&(ie===8||ie===9||ie===11||ie===12)||(B===11||B===9)&&(ie===9||ie===10)||(B===12||B===10)&&ie===10||ie===5||ie===13||ie===7||B===1||B===13&&ie===14||B===6&&ie===6)}e.breakBetweenGraphemeBreakType=Ee;var Ue;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(Ue=e.GraphemeBreakType||(e.GraphemeBreakType={}));class he{constructor(){this._data=ge()}static getInstance(){return he._INSTANCE||(he._INSTANCE=new he),he._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const se=this._data,ve=se.length/3;let ee=1;for(;ee<=ve;)if(ie<se[3*ee])ee=2*ee;else if(ie>se[3*ee+1])ee=2*ee+1;else return se[3*ee+2];return 0}}he._INSTANCE=null;function ge(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ye(B,ie){if(B===0)return 0;const se=G(B,ie);if(se!==void 0)return se;const ve=U(ie,B);return B-=J(ve),B}e.getLeftDeleteOffset=ye;function G(B,ie){let se=U(ie,B);for(B-=J(se);te(se)||se===65039||se===8419;){if(B===0)return;se=U(ie,B),B-=J(se)}if(!!nt(se)){if(B>=0){const ve=U(ie,B);ve===8205&&(B-=J(ve))}return B}}function J(B){return B>=65536?2:1}function te(B){return 127995<=B&&B<=127999}var oe;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(oe||(oe={}))}),define(ce[17],ue([0,1,13,42]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const g=typeof Buffer!="undefined",D=typeof TextEncoder!="undefined",I=typeof TextDecoder!="undefined";let C,p;class w{constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}static alloc(y){return g?new w(Buffer.allocUnsafe(y)):new w(new Uint8Array(y))}static wrap(y){return g&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new w(y)}static fromString(y,T){return!(T?.dontUseNodeBuffer||!1)&&g?new w(Buffer.from(y)):D?(C||(C=new TextEncoder),new w(C.encode(y))):new w(E.encodeUTF8(y))}static concat(y,T){if(typeof T=="undefined"){T=0;for(let k=0,O=y.length;k<O;k++)T+=y[k].byteLength}const R=w.alloc(T);let o=0;for(let k=0,O=y.length;k<O;k++){const Y=y[k];R.set(Y,o),o+=Y.byteLength}return R}toString(){return g?this.buffer.toString():I?(p||(p=new TextDecoder),p.decode(this.buffer)):E.decodeUTF8(this.buffer)}slice(y,T){return new w(this.buffer.subarray(y,T))}set(y,T){y instanceof w?this.buffer.set(y.buffer,T):this.buffer.set(y,T)}readUInt32BE(y){return b(this.buffer,y)}writeUInt32BE(y,T){m(this.buffer,y,T)}readUInt32LE(y){return u(this.buffer,y)}writeUInt32LE(y,T){h(this.buffer,y,T)}readUInt8(y){return S(this.buffer,y)}writeUInt8(y,T){d(this.buffer,y,T)}}e.VSBuffer=w;function n(v,y){return v[y+0]<<0>>>0|v[y+1]<<8>>>0}e.readUInt16LE=n;function A(v,y,T){v[T+0]=y&255,y=y>>>8,v[T+1]=y&255}e.writeUInt16LE=A;function b(v,y){return v[y]*2**24+v[y+1]*2**16+v[y+2]*2**8+v[y+3]}e.readUInt32BE=b;function m(v,y,T){v[T+3]=y,y=y>>>8,v[T+2]=y,y=y>>>8,v[T+1]=y,y=y>>>8,v[T]=y}e.writeUInt32BE=m;function u(v,y){return v[y+0]<<0>>>0|v[y+1]<<8>>>0|v[y+2]<<16>>>0|v[y+3]<<24>>>0}e.readUInt32LE=u;function h(v,y,T){v[T+0]=y&255,y=y>>>8,v[T+1]=y&255,y=y>>>8,v[T+2]=y&255,y=y>>>8,v[T+3]=y&255}e.writeUInt32LE=h;function S(v,y){return v[y]}e.readUInt8=S;function d(v,y,T){v[T]=y}e.writeUInt8=d;function _(v){return P.consumeReadable(v,y=>w.concat(y))}e.readableToBuffer=_;function f(v){return P.toReadable(v)}e.bufferToReadable=f;function l(v){return P.consumeStream(v,y=>w.concat(y))}e.streamToBuffer=l;async function a(v){return v.ended?w.concat(v.buffer):w.concat([...v.buffer,await l(v.stream)])}e.bufferedStreamToBuffer=a;function t(v){return P.toStream(v,y=>w.concat(y))}e.bufferToStream=t;function r(v){return P.transform(v,{data:y=>typeof y=="string"?w.fromString(y):w.wrap(y)},y=>w.concat(y))}e.streamToBufferReadableStream=r;function i(v){return P.newWriteableStream(y=>w.concat(y),v)}e.newWriteableBufferStream=i;function s(v,y){return P.prefixedReadable(v,y,T=>w.concat(T))}e.prefixedBufferReadable=s;function c(v,y){return P.prefixedStream(v,y,T=>w.concat(T))}e.prefixedBufferStream=c}),define(ce[118],ue([0,1,13]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function P(d){return g(d,0)}e.hash=P;function g(d,_){switch(typeof d){case"object":return d===null?D(349,_):Array.isArray(d)?p(d,_):w(d,_);case"string":return C(d,_);case"boolean":return I(d,_);case"number":return D(d,_);case"undefined":return D(937,_);default:return D(617,_)}}e.doHash=g;function D(d,_){return(_<<5)-_+d|0}function I(d,_){return D(d?433:863,_)}function C(d,_){_=D(149417,_);for(let f=0,l=d.length;f<l;f++)_=D(d.charCodeAt(f),_);return _}e.stringHash=C;function p(d,_){return _=D(104579,_),d.reduce((f,l)=>g(l,f),_)}function w(d,_){return _=D(181387,_),Object.keys(d).sort().reduce((f,l)=>(f=C(l,f),g(d[l],f)),_)}class n{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=g(_,this._value),this._value}}e.Hasher=n;var A;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function b(d,_,f=32){const l=f-_,a=~((1<<l)-1);return(d<<_|(a&d)>>>l)>>>0}function m(d,_=0,f=d.byteLength,l=0){for(let a=0;a<f;a++)d[_+a]=l}function u(d,_,f="0"){for(;d.length<_;)d=f+d;return d}function h(d,_=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(f=>f.toString(16).padStart(2,"0")).join(""):u((d>>>0).toString(16),_/4)}e.toHexString=h;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const f=_.length;if(f===0)return;const l=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,r,i;for(t!==0?(r=t,i=-1,t=0):(r=_.charCodeAt(0),i=0);;){let s=r;if(E.isHighSurrogate(r))if(i+1<f){const c=_.charCodeAt(i+1);E.isLowSurrogate(c)?(i++,s=E.computeCodePoint(r,c)):s=65533}else{t=r;break}else E.isLowSurrogate(r)&&(s=65533);if(a=this._push(l,a,s),i++,i<f)r=_.charCodeAt(i);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(_,f,l){return l<128?_[f++]=l:l<2048?(_[f++]=192|(l&1984)>>>6,_[f++]=128|(l&63)>>>0):l<65536?(_[f++]=224|(l&61440)>>>12,_[f++]=128|(l&4032)>>>6,_[f++]=128|(l&63)>>>0):(_[f++]=240|(l&1835008)>>>18,_[f++]=128|(l&258048)>>>12,_[f++]=128|(l&4032)>>>6,_[f++]=128|(l&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=S._bigBlock32,f=this._buffDV;for(let y=0;y<64;y+=4)_.setUint32(y,f.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)_.setUint32(y,b(_.getUint32(y-12,!1)^_.getUint32(y-32,!1)^_.getUint32(y-56,!1)^_.getUint32(y-64,!1),1),!1);let l=this._h0,a=this._h1,t=this._h2,r=this._h3,i=this._h4,s,c,v;for(let y=0;y<80;y++)y<20?(s=a&t|~a&r,c=1518500249):y<40?(s=a^t^r,c=1859775393):y<60?(s=a&t|a&r|t&r,c=2400959708):(s=a^t^r,c=3395469782),v=b(l,5)+s+i+c+_.getUint32(y*4,!1)&4294967295,i=r,r=t,t=b(a,30),a=l,l=v;this._h0=this._h0+l&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ce[73],ue([0,1,13]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(P||(P={})),function(g){const D="error",I="warning",C="warn",p="info",w="ignore";function n(b){return b?E.equalsIgnoreCase(D,b)?g.Error:E.equalsIgnoreCase(I,b)||E.equalsIgnoreCase(C,b)?g.Warning:E.equalsIgnoreCase(p,b)?g.Info:g.Ignore:g.Ignore}g.fromValue=n;function A(b){switch(b){case g.Error:return D;case g.Warning:return I;case g.Info:return p;default:return w}}g.toString=A}(P||(P={})),e.default=P}),define(ce[12],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(y){return Array.isArray(y)}e.isArray=E;function P(y){return typeof y=="string"}e.isString=P;function g(y){return Array.isArray(y)&&y.every(T=>P(T))}e.isStringArray=g;function D(y){return typeof y=="object"&&y!==null&&!Array.isArray(y)&&!(y instanceof RegExp)&&!(y instanceof Date)}e.isObject=D;function I(y){return typeof y=="number"&&!isNaN(y)}e.isNumber=I;function C(y){return!!y&&typeof y[Symbol.iterator]=="function"}e.isIterable=C;function p(y){return y===!0||y===!1}e.isBoolean=p;function w(y){return typeof y=="undefined"}e.isUndefined=w;function n(y){return!A(y)}e.isDefined=n;function A(y){return w(y)||y===null}e.isUndefinedOrNull=A;function b(y,T){if(!y)throw new Error(T?`Unexpected type, expected '${T}'`:"Unexpected type")}e.assertType=b;function m(y){if(A(y))throw new Error("Assertion Failed: argument is undefined or null");return y}e.assertIsDefined=m;function u(...y){const T=[];for(let R=0;R<y.length;R++){const o=y[R];if(A(o))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);T.push(o)}return T}e.assertAllDefined=u;const h=Object.prototype.hasOwnProperty;function S(y){if(!D(y))return!1;for(let T in y)if(h.call(y,T))return!1;return!0}e.isEmptyObject=S;function d(y){return typeof y=="function"}e.isFunction=d;function _(...y){return y.length>0&&y.every(d)}e.areFunctions=_;function f(y,T){const R=Math.min(y.length,T.length);for(let o=0;o<R;o++)l(y[o],T[o])}e.validateConstraints=f;function l(y,T){if(P(T)){if(typeof y!==T)throw new Error(`argument does not match constraint: typeof ${T}`)}else if(d(T)){try{if(y instanceof T)return}catch{}if(!A(y)&&y.constructor===T||T.length===1&&T.call(void 0,y)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function a(y){let T=[],R=Object.getPrototypeOf(y);for(;Object.prototype!==R;)T=T.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return T}e.getAllPropertyNames=a;function t(y){const T=[];for(const R of a(y))typeof y[R]=="function"&&T.push(R);return T}e.getAllMethodNames=t;function r(y,T){const R=k=>function(){const O=Array.prototype.slice.call(arguments,0);return T(k,O)};let o={};for(const k of y)o[k]=R(k);return o}e.createProxyObject=r;function i(y){return y===null?void 0:y}e.withNullAsUndefined=i;function s(y){return typeof y=="undefined"?null:y}e.withUndefinedAsNull=s;function c(y){return class{constructor(){return new Proxy({},{get(T,R){if(T[R])return T[R];throw new Error(`Not Implemented: ${y}->${String(R)}`)}})}}}e.NotImplementedProxy=c;function v(y,T="Unreachable"){throw new Error(T)}e.assertNever=v}),define(ce[31],ue([0,1,4,13,5,12]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(i){return i===47||i===92}e.isPathSeparator=I;function C(i){return i.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=C;function p(i){return i.indexOf("/")===-1&&(i=C(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=p;function w(i,s=g.posix.sep){if(!i)return"";const c=i.length,v=i.charCodeAt(0);if(I(v)){if(I(i.charCodeAt(1))&&!I(i.charCodeAt(2))){let T=3;const R=T;for(;T<c&&!I(i.charCodeAt(T));T++);if(R!==T&&!I(i.charCodeAt(T+1))){for(T+=1;T<c;T++)if(I(i.charCodeAt(T)))return i.slice(0,T+1).replace(/[\\/]/g,s)}}return s}else if(d(v)&&i.charCodeAt(1)===58)return I(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let y=i.indexOf("://");if(y!==-1){for(y+=3;y<c;y++)if(I(i.charCodeAt(y)))return i.slice(0,y+1)}return""}e.getRoot=w;function n(i){if(!E.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let c=2;const v=c;for(;c<i.length&&(s=i.charCodeAt(c),s!==92);c++);return!(v===c||(s=i.charCodeAt(c+1),isNaN(s)||s===92))}e.isUNC=n;const A=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(i,s=E.isWindows){const c=s?A:b;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||s&&m.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=u;function h(i,s,c){const v=i===s;return!c||v?v:!i||!s?!1:(0,P.equalsIgnoreCase)(i,s)}e.isEqual=h;function S(i,s,c,v=g.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(c){if(!(0,P.startsWithIgnoreCase)(i,s))return!1;if(s.length===i.length)return!0;let T=s.length;return s.charAt(s.length-1)===v&&T--,i.charAt(T)===v}return s.charAt(s.length-1)!==v&&(s+=v),i.indexOf(s)===0}e.isEqualOrParent=S;function d(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=d;function _(i,s){return E.isWindows&&i.endsWith(":")&&(i+=g.sep),(0,g.isAbsolute)(i)||(i=(0,g.join)(s,i)),i=(0,g.normalize)(i),E.isWindows?(i=(0,P.rtrim)(i,g.sep),i.endsWith(":")&&(i+=g.sep)):(i=(0,P.rtrim)(i,g.sep),i||(i=g.sep)),i}e.sanitizeFilePath=_;function f(i){const s=(0,g.normalize)(i);return E.isWindows?i.length>3?!1:l(s)&&(i.length===2||s.charCodeAt(2)===92):s===g.posix.sep}e.isRootOrDriveLetter=f;function l(i){return E.isWindows?d(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function a(i){return l(i)?i[0]:void 0}e.getDriveLetter=a;function t(i,s,c){return s.length>i.length?-1:i===s?0:(c&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=t;function r(i){const s=i.split(":");let c,v,y;if(s.forEach(T=>{const R=Number(T);(0,D.isNumber)(R)?v===void 0?v=R:y===void 0&&(y=R):c=c?[c,T].join(":"):T}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:v!==void 0?v:void 0,column:y!==void 0?y:v!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(ce[18],ue([0,1,12]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function P(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const S=Array.isArray(h)?[]:{};return Object.keys(h).forEach(d=>{h[d]&&typeof h[d]=="object"?S[d]=P(h[d]):S[d]=h[d]}),S}e.deepClone=P;function g(h){if(!h||typeof h!="object")return h;const S=[h];for(;S.length>0;){const d=S.shift();Object.freeze(d);for(const _ in d)if(D.call(d,_)){const f=d[_];typeof f=="object"&&!Object.isFrozen(f)&&S.push(f)}}return h}e.deepFreeze=g;const D=Object.prototype.hasOwnProperty;function I(h,S){return C(h,S,new Set)}e.cloneAndChange=I;function C(h,S,d){if((0,E.isUndefinedOrNull)(h))return h;const _=S(h);if(typeof _!="undefined")return _;if((0,E.isArray)(h)){const f=[];for(const l of h)f.push(C(l,S,d));return f}if((0,E.isObject)(h)){if(d.has(h))throw new Error("Cannot clone recursive data-structure");d.add(h);const f={};for(let l in h)D.call(h,l)&&(f[l]=C(h[l],S,d));return d.delete(h),f}return h}function p(h,S,d=!0){return(0,E.isObject)(h)?((0,E.isObject)(S)&&Object.keys(S).forEach(_=>{_ in h?d&&((0,E.isObject)(h[_])&&(0,E.isObject)(S[_])?p(h[_],S[_],d):h[_]=S[_]):h[_]=S[_]}),h):S}e.mixin=p;function w(h,S){if(h===S)return!0;if(h==null||S===null||S===void 0||typeof h!=typeof S||typeof h!="object"||Array.isArray(h)!==Array.isArray(S))return!1;let d,_;if(Array.isArray(h)){if(h.length!==S.length)return!1;for(d=0;d<h.length;d++)if(!w(h[d],S[d]))return!1}else{const f=[];for(_ in h)f.push(_);f.sort();const l=[];for(_ in S)l.push(_);if(l.sort(),!w(f,l))return!1;for(d=0;d<f.length;d++)if(!w(h[f[d]],S[f[d]]))return!1}return!0}e.equals=w;function n(h){const S=new Set;return JSON.stringify(h,(d,_)=>{if((0,E.isObject)(_)||Array.isArray(_)){if(S.has(_))return"[Circular]";S.add(_)}return _})}e.safeStringify=n;function A(h,S,d){const _=S(h);return typeof _=="undefined"?d:_}e.getOrDefault=A;function b(h,S){const d=Object.create(null);return!h||!S||Object.keys(S).forEach(f=>{const l=h[f],a=S[f];w(l,a)||(d[f]=a)}),d}e.distinct=b;function m(h,S){const d=S.toLowerCase(),_=Object.keys(h).find(f=>f.toLowerCase()===d);return _?h[_]:h[S]}e.getCaseInsensitive=m;function u(h,S){const d=Object.create(null);for(const _ of Object.keys(h))S(_,h[_])&&(d[_]=h[_]);return d}e.filter=u}),define(ce[3],ue([0,1,4,5]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,D=/^\//,I=/^\/\//;function C(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!g.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!D.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(i,s){return!i&&!s?"file":i}function w(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==A&&(s=A+s):s=A;break}return s}const n="",A="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(s,c,v,y,T,R=!1){typeof s=="object"?(this.scheme=s.scheme||n,this.authority=s.authority||n,this.path=s.path||n,this.query=s.query||n,this.fragment=s.fragment||n):(this.scheme=p(s,R),this.authority=c||n,this.path=w(this.scheme,v||n),this.query=y||n,this.fragment=T||n,C(this,R))}static isUri(s){return s instanceof m?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return f(this,!1)}with(s){if(!s)return this;let{scheme:c,authority:v,path:y,query:T,fragment:R}=s;return c===void 0?c=this.scheme:c===null&&(c=n),v===void 0?v=this.authority:v===null&&(v=n),y===void 0?y=this.path:y===null&&(y=n),T===void 0?T=this.query:T===null&&(T=n),R===void 0?R=this.fragment:R===null&&(R=n),c===this.scheme&&v===this.authority&&y===this.path&&T===this.query&&R===this.fragment?this:new h(c,v,y,T,R)}static parse(s,c=!1){const v=b.exec(s);return v?new h(v[2]||n,r(v[4]||n),r(v[5]||n),r(v[7]||n),r(v[9]||n),c):new h(n,n,n,n,n)}static file(s){let c=n;if(E.isWindows&&(s=s.replace(/\\/g,A)),s[0]===A&&s[1]===A){const v=s.indexOf(A,2);v===-1?(c=s.substring(2),s=A):(c=s.substring(2,v),s=s.substring(v)||A)}return new h("file",c,s,n,n)}static from(s){const c=new h(s.scheme,s.authority,s.path,s.query,s.fragment);return C(c,!0),c}static joinPath(s,...c){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return E.isWindows&&s.scheme==="file"?v=m.file(P.win32.join(f(s,!0),...c)).path:v=P.posix.join(s.path,...c),s.with({path:v})}toString(s=!1){return l(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof m)return s;{const c=new h(s);return c._formatted=s.external,c._fsPath=s._sep===u?s.fsPath:null,c}}else return s}}e.URI=m;const u=E.isWindows?1:void 0;class h extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(s=!1){return s?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=u),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(i,s){let c,v=-1;for(let y=0;y<i.length;y++){const T=i.charCodeAt(y);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||s&&T===47)v!==-1&&(c+=encodeURIComponent(i.substring(v,y)),v=-1),c!==void 0&&(c+=i.charAt(y));else{c===void 0&&(c=i.substr(0,y));const R=S[T];R!==void 0?(v!==-1&&(c+=encodeURIComponent(i.substring(v,y)),v=-1),c+=R):v===-1&&(v=y)}}return v!==-1&&(c+=encodeURIComponent(i.substring(v))),c!==void 0?c:i}function _(i){let s;for(let c=0;c<i.length;c++){const v=i.charCodeAt(c);v===35||v===63?(s===void 0&&(s=i.substr(0,c)),s+=S[v]):s!==void 0&&(s+=i[c])}return s!==void 0?s:i}function f(i,s){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,E.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=f;function l(i,s){const c=s?_:d;let v="",{scheme:y,authority:T,path:R,query:o,fragment:k}=i;if(y&&(v+=y,v+=":"),(T||y==="file")&&(v+=A,v+=A),T){let O=T.indexOf("@");if(O!==-1){const Y=T.substr(0,O);T=T.substr(O+1),O=Y.indexOf(":"),O===-1?v+=c(Y,!1):(v+=c(Y.substr(0,O),!1),v+=":",v+=c(Y.substr(O+1),!1)),v+="@"}T=T.toLowerCase(),O=T.indexOf(":"),O===-1?v+=c(T,!1):(v+=c(T.substr(0,O),!1),v+=T.substr(O))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const O=R.charCodeAt(1);O>=65&&O<=90&&(R=`/${String.fromCharCode(O+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const O=R.charCodeAt(0);O>=65&&O<=90&&(R=`${String.fromCharCode(O+32)}:${R.substr(2)}`)}v+=c(R,!0)}return o&&(v+="?",v+=c(o,!1)),k&&(v+="#",v+=s?k:d(k,!1)),v}function a(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+a(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,s=>a(s)):i}}),define(ce[119],ue([0,1,3]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function P(w){const n=w;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=P;function g(w){const n=[];let A;try{const b=JSON.parse(w.arguments),m=b[b.length-1];m&&m.__$stack&&(b.pop(),A=m.__$stack),n.push(...b)}catch(b){n.push("Unable to log remote console arguments",w.arguments)}return{args:n,stack:A}}e.parse=g;function D(w){if(typeof w!="string")return D(g(w).stack);const n=w;if(n){const A=I(n),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(A||"");if(b&&b.length===4)return{uri:E.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=D;function I(w){if(!w)return w;const n=w.indexOf(`
`);return n===-1?w:w.substring(0,n)}function C(w,n){const{args:A,stack:b}=g(w),m=typeof A[0]=="string"&&A.length===1;let u=I(b);u&&(u=`(${u.trim()})`);let h=[];if(typeof A[0]=="string"?u&&m?h=[`%c[${n}] %c${A[0]} %c${u}`,p("blue"),p(""),p("grey")]:h=[`%c[${n}] %c${A[0]}`,p("blue"),p(""),...A.slice(1)]:h=[`%c[${n}]%`,p("blue"),...A],u&&!m&&h.push(u),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,h)}e.log=C;function p(w){return`color: ${w}`}});var Dt=this&&this.__classPrivateFieldSet||function(X,e,E,P,g){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!g:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?g.call(X,E):g?g.value=E:e.set(X,E),E},ot=this&&this.__classPrivateFieldGet||function(X,e,E,P){if(E==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!P:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?P:E==="a"?P.call(X):P?P.value:e.get(X)};define(ce[26],ue([0,1,3,13]),function(X,e,E,P){"use strict";var g,D,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,r,i){let s=t.get(r);return s===void 0&&(s=i,t.set(r,s)),s}e.getOrSet=C;function p(t){const r=[];return t.forEach((i,s)=>{r.push(`${s} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=p;function w(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=w;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return i-s}value(){return this._value[this._pos]}}e.StringIterator=n;class A{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,P.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class b{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,P.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=b;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class u{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,P.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,P.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,P.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,P.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class h{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(r){this._iter=r}static forUris(r=()=>!1){return new S(new u(r))}static forPaths(){return new S(new b)}static forStrings(){return new S(new n)}static forConfigKeys(){return new S(new A)}clear(){this._root=void 0}set(r,i){const s=this._iter.reset(r);let c;for(this._root||(this._root=new h,this._root.segment=s.value()),c=this._root;;){const y=s.cmp(c.segment);if(y>0)c.left||(c.left=new h,c.left.segment=s.value()),c=c.left;else if(y<0)c.right||(c.right=new h,c.right.segment=s.value()),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new h,c.mid.segment=s.value()),c=c.mid;else break}const v=c.value;return c.value=i,c.key=r,v}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const c=i.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else break}return s}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const s=this._iter.reset(r),c=[];let v=this._root;for(;v;){const y=s.cmp(v.segment);if(y>0)c.push([1,v]),v=v.left;else if(y<0)c.push([-1,v]),v=v.right;else if(s.hasNext())s.next(),c.push([0,v]),v=v.mid;else{for(i?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;c.length>0&&v.isEmpty();){let[T,R]=c.pop();switch(T){case 1:R.left=void 0;break;case 0:R.mid=void 0;break;case-1:R.right=void 0;break}v=R}break}}}findSubstr(r){const i=this._iter.reset(r);let s=this._root,c;for(;s;){const v=i.cmp(s.segment);if(v>0)s=s.left;else if(v<0)s=s.right;else if(i.hasNext())i.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const c=i.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[i,s]of this)r(s,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const s=i.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&i.push(s.left),s.mid&&i.push(s.mid),s.right&&i.push(s.right))}}}e.TernarySearchTree=S;class d{constructor(r,i){this[g]="ResourceMap",r instanceof d?(this.map=new Map(r.map),this.toKey=i??d.defaultToKey):(this.map=new Map,this.toKey=r??d.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[s,c]of this.map)r(c,E.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield E.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[E.URI.parse(r[0]),r[1]]}*[(g=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[E.URI.parse(r[0]),r[1]]}}e.ResourceMap=d,d.defaultToKey=t=>t.toString();var _;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(_=e.Touch||(e.Touch={}));class f{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const s=this._map.get(r);if(!!s)return i!==0&&this.touch(s,i),s.value}set(r,i,s=0){let c=this._map.get(r);if(c)c.value=i,s!==0&&this.touch(c,s);else{switch(c={key:r,value:i,next:void 0,previous:void 0},s){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const s=this._state;let c=this._head;for(;c;){if(i?r.bind(i)(c.value,c.key,this):r(c.value,c.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,i=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.key,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return c}values(){const r=this,i=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.value,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return c}entries(){const r=this,i=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:[s.key,s.value],done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return c}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>r;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,s=r.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const s=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(s.previous=c,c.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const s=r.next,c=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=c,c.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,s)=>{r.push([s,i])}),r}fromJSON(r){this.clear();for(const[i,s]of r)this.set(i,s)}}e.LinkedMap=f;class l extends f{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class a{constructor(r){I.set(this,void 0),Dt(this,I,r,"f")}get size(){return ot(this,I,"f").size}forEach(r,i){ot(this,I,"f").forEach(r,i)}get(r){return ot(this,I,"f").get(r)}has(r){return ot(this,I,"f").has(r)}entries(){return ot(this,I,"f").entries()}keys(){return ot(this,I,"f").keys()}values(){return ot(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return ot(this,I,"f").entries()}}e.ReadonlyMapView=a}),define(ce[120],ue([0,1,26,13]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function g(...pe){return function(Ce,Ae){for(let Re=0,Me=pe.length;Re<Me;Re++){const $e=pe[Re](Ce,Ae);if($e)return $e}return null}}e.or=g,e.matchesStrictPrefix=D.bind(void 0,!1),e.matchesPrefix=D.bind(void 0,!0);function D(pe,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let Re;return pe?Re=P.startsWithIgnoreCase(Ae,Ce):Re=Ae.indexOf(Ce)===0,Re?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function I(pe,Ce){const Ae=Ce.toLowerCase().indexOf(pe.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+pe.length}]}e.matchesContiguousSubString=I;function C(pe,Ce){return p(pe.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=C;function p(pe,Ce,Ae,Re){if(Ae===pe.length)return[];if(Re===Ce.length)return null;if(pe[Ae]===Ce[Re]){let Me=null;return(Me=p(pe,Ce,Ae+1,Re+1))?d({start:Re,end:Re+1},Me):null}return p(pe,Ce,Ae,Re+1)}function w(pe){return 97<=pe&&pe<=122}function n(pe){return 65<=pe&&pe<=90}e.isUpper=n;function A(pe){return 48<=pe&&pe<=57}function b(pe){return pe===32||pe===9||pe===10||pe===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(pe=>m.add(pe.charCodeAt(0)));function u(pe){return b(pe)||m.has(pe)}function h(pe,Ce){return pe===Ce||u(pe)&&u(Ce)}function S(pe){return w(pe)||n(pe)||A(pe)}function d(pe,Ce){return Ce.length===0?Ce=[pe]:pe.end===Ce[0].start?Ce[0].start=pe.start:Ce.unshift(pe),Ce}function _(pe,Ce){for(let Ae=Ce;Ae<pe.length;Ae++){const Re=pe.charCodeAt(Ae);if(n(Re)||A(Re)||Ae>0&&!S(pe.charCodeAt(Ae-1)))return Ae}return pe.length}function f(pe,Ce,Ae,Re){if(Ae===pe.length)return[];if(Re===Ce.length)return null;if(pe[Ae]!==Ce[Re].toLowerCase())return null;{let Me=null,$e=Re+1;for(Me=f(pe,Ce,Ae+1,Re+1);!Me&&($e=_(Ce,$e))<Ce.length;)Me=f(pe,Ce,Ae+1,$e),$e++;return Me===null?null:d({start:Re,end:Re+1},Me)}}function l(pe){let Ce=0,Ae=0,Re=0,Me=0,$e=0;for(let Se=0;Se<pe.length;Se++)$e=pe.charCodeAt(Se),n($e)&&Ce++,w($e)&&Ae++,S($e)&&Re++,A($e)&&Me++;const He=Ce/pe.length,Ye=Ae/pe.length,tt=Re/pe.length,ne=Me/pe.length;return{upperPercent:He,lowerPercent:Ye,alphaPercent:tt,numericPercent:ne}}function a(pe){const{upperPercent:Ce,lowerPercent:Ae}=pe;return Ae===0&&Ce>.6}function t(pe){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:Re,numericPercent:Me}=pe;return Ae>.2&&Ce<.8&&Re>.6&&Me<.2}function r(pe){let Ce=0,Ae=0,Re=0,Me=0;for(let $e=0;$e<pe.length;$e++)Re=pe.charCodeAt($e),n(Re)&&Ce++,w(Re)&&Ae++,b(Re)&&Me++;return(Ce===0||Ae===0)&&Me===0?pe.length<=30:Ce<=5}function i(pe,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!r(pe)||Ce.length>60)return null;const Ae=l(Ce);if(!t(Ae)){if(!a(Ae))return null;Ce=Ce.toLowerCase()}let Re=null,Me=0;for(pe=pe.toLowerCase();Me<Ce.length&&(Re=f(pe,Ce,0,Me))===null;)Me=_(Ce,Me+1);return Re}e.matchesCamelCase=i;function s(pe,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let Re=null,Me=0;for(pe=pe.toLowerCase(),Ce=Ce.toLowerCase();Me<Ce.length&&(Re=c(pe,Ce,0,Me,Ae))===null;)Me=v(Ce,Me+1);return Re}e.matchesWords=s;function c(pe,Ce,Ae,Re,Me){if(Ae===pe.length)return[];if(Re===Ce.length)return null;if(h(pe.charCodeAt(Ae),Ce.charCodeAt(Re))){let $e=null,He=Re+1;if($e=c(pe,Ce,Ae+1,Re+1,Me),!Me)for(;!$e&&(He=v(Ce,He))<Ce.length;)$e=c(pe,Ce,Ae+1,He,Me),He++;return $e===null?null:d({start:Re,end:Re+1},$e)}else return null}function v(pe,Ce){for(let Ae=Ce;Ae<pe.length;Ae++)if(u(pe.charCodeAt(Ae))||Ae>0&&u(pe.charCodeAt(Ae-1)))return Ae;return pe.length}const y=g(e.matchesPrefix,i,I),T=g(e.matchesPrefix,i,C),R=new E.LRUCache(1e4);function o(pe,Ce,Ae=!1){if(typeof pe!="string"||typeof Ce!="string")return null;let Re=R.get(pe);Re||(Re=new RegExp(P.convertSimple2RegExpPattern(pe),"i"),R.set(pe,Re));const Me=Re.exec(Ce);return Me?[{start:Me.index,end:Me.index+Me[0].length}]:Ae?T(pe,Ce):y(pe,Ce)}e.matchesFuzzy=o;function k(pe,Ce){const Ae=Fe(pe,pe.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Ae?Y(Ae):null}e.matchesFuzzy2=k;function O(pe,Ce,Ae,Re,Me,$e){const He=Math.min(13,pe.length);for(;Ae<He;Ae++){const Ye=Fe(pe,Ce,Ae,Re,Me,$e,!1);if(Ye)return Ye}return[0,$e]}e.anyScore=O;function Y(pe){if(typeof pe=="undefined")return[];const Ce=[],Ae=pe[1];for(let Re=pe.length-1;Re>1;Re--){const Me=pe[Re]+Ae,$e=Ce[Ce.length-1];$e&&$e.end===Me?$e.end=Me+1:Ce.push({start:Me,end:Me+1})}return Ce}e.createMatches=Y;const Q=128;function me(){const pe=[],Ce=[];for(let Ae=0;Ae<=Q;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=Q;Ae++)pe.push(Ce.slice(0));return pe}function re(pe){const Ce=[];for(let Ae=0;Ae<=pe;Ae++)Ce[Ae]=0;return Ce}const N=re(2*Q),W=re(2*Q),U=me(),j=me(),H=me(),M=!1;function q(pe,Ce,Ae,Re,Me){function $e(Ye,tt,ne=" "){for(;Ye.length<tt;)Ye=ne+Ye;return Ye}let He=` |   |${Re.split("").map(Ye=>$e(Ye,3)).join("|")}
`;for(let Ye=0;Ye<=Ae;Ye++)Ye===0?He+=" |":He+=`${Ce[Ye-1]}|`,He+=pe[Ye].slice(0,Me+1).map(tt=>$e(tt.toString(),3)).join("|")+`
`;return He}function z(pe,Ce,Ae,Re){pe=pe.substr(Ce),Ae=Ae.substr(Re),console.log(q(j,pe,pe.length,Ae,Ae.length)),console.log(q(H,pe,pe.length,Ae,Ae.length)),console.log(q(U,pe,pe.length,Ae,Ae.length))}function V(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;const Ae=pe.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(Ae)}}function K(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;switch(pe.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function ae(pe,Ce,Ae){return Ce[pe]!==Ae[pe]}function fe(pe,Ce,Ae,Re,Me,$e,He=!1){for(;Ce<Ae&&Me<$e;)pe[Ce]===Re[Me]&&(He&&(N[Ce]=Me),Ce+=1),Me+=1;return Ce===Ae}e.isPatternInWord=fe;var De;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(De||(De={}));var Pe;(function(pe){pe.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}pe.isDefault=Ce})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Fe(pe,Ce,Ae,Re,Me,$e,He){const Ye=pe.length>Q?Q:pe.length,tt=Re.length>Q?Q:Re.length;if(Ae>=Ye||$e>=tt||Ye-Ae>tt-$e||!fe(Ce,Ae,Ye,Me,$e,tt,!0))return;Ne(Ye,tt,Ae,$e,Ce,Me);let ne=1,Se=1,Ee=Ae,Ue=$e;const he=[!1];for(ne=1,Ee=Ae;Ee<Ye;ne++,Ee++){const te=N[Ee],oe=W[Ee],B=Ee+1<Ye?W[Ee+1]:tt;for(Se=te-$e+1,Ue=te;Ue<B;Se++,Ue++){let ie=Number.MIN_SAFE_INTEGER,se=!1;Ue<=oe&&(ie=ze(pe,Ce,Ee,Ae,Re,Me,Ue,tt,$e,U[ne-1][Se-1]===0,he));let ve=0;ie!==Number.MAX_SAFE_INTEGER&&(se=!0,ve=ie+j[ne-1][Se-1]);const ee=Ue>te,we=ee?j[ne][Se-1]+(U[ne][Se-1]>0?-5:0):0,_e=Ue>te+1&&U[ne][Se-1]>0,Te=_e?j[ne][Se-2]+(U[ne][Se-2]>0?-5:0):0;if(_e&&(!ee||Te>=we)&&(!se||Te>=ve))j[ne][Se]=Te,H[ne][Se]=3,U[ne][Se]=0;else if(ee&&(!se||we>=ve))j[ne][Se]=we,H[ne][Se]=2,U[ne][Se]=0;else if(se)j[ne][Se]=ve,H[ne][Se]=1,U[ne][Se]=U[ne-1][Se-1]+1;else throw new Error("not possible")}}if(M&&z(pe,Ae,Re,$e),!he[0]&&!He)return;ne--,Se--;const ge=[j[ne][Se],$e];let ye=0,G=0;for(;ne>=1;){let te=Se;do{const oe=H[ne][te];if(oe===3)te=te-2;else if(oe===2)te=te-1;else break}while(te>=1);ye>1&&Ce[Ae+ne-1]===Me[$e+Se-1]&&!ae(te+$e-1,Re,Me)&&ye+1>U[ne][te]&&(te=Se),te===Se?ye++:ye=1,G||(G=te),ne--,Se=te-1,ge.push(Se)}tt===Ye&&(ge[0]+=2);const J=G-Ye;return ge[0]-=J,ge}e.fuzzyScore=Fe;function Ne(pe,Ce,Ae,Re,Me,$e){let He=pe-1,Ye=Ce-1;for(;He>=Ae&&Ye>=Re;)Me[He]===$e[Ye]&&(W[He]=Ye,He--),Ye--}function ze(pe,Ce,Ae,Re,Me,$e,He,Ye,tt,ne,Se){if(Ce[Ae]!==$e[He])return Number.MIN_SAFE_INTEGER;let Ee=1,Ue=!1;return He===Ae-Re?Ee=pe[Ae]===Me[He]?7:5:ae(He,Me,$e)&&(He===0||!ae(He-1,Me,$e))?(Ee=pe[Ae]===Me[He]?7:5,Ue=!0):V($e,He)&&(He===0||!V($e,He-1))?Ee=5:(V($e,He-1)||K($e,He-1))&&(Ee=5,Ue=!0),Ee>1&&Ae===Re&&(Se[0]=!0),Ue||(Ue=ae(He,Me,$e)||V($e,He-1)||K($e,He-1)),Ae===Re?He>tt&&(Ee-=Ue?3:5):ne?Ee+=Ue?2:0:Ee+=Ue?0:1,He+1===Ye&&(Ee-=Ue?3:5),Ee}function Xe(pe,Ce,Ae,Re,Me,$e,He){return it(pe,Ce,Ae,Re,Me,$e,!0,He)}e.fuzzyScoreGracefulAggressive=Xe;function nt(pe,Ce,Ae,Re,Me,$e,He){return it(pe,Ce,Ae,Re,Me,$e,!1,He)}e.fuzzyScoreGraceful=nt;function it(pe,Ce,Ae,Re,Me,$e,He,Ye){let tt=Fe(pe,Ce,Ae,Re,Me,$e,Ye);if(tt&&!He)return tt;if(pe.length>=3){const ne=Math.min(7,pe.length-1);for(let Se=Ae+1;Se<ne;Se++){const Ee=rt(pe,Se);if(Ee){const Ue=Fe(Ee,Ee.toLowerCase(),Ae,Re,Me,$e,Ye);Ue&&(Ue[0]-=3,(!tt||Ue[0]>tt[0])&&(tt=Ue))}}}return tt}function rt(pe,Ce){if(Ce+1>=pe.length)return;const Ae=pe[Ce],Re=pe[Ce+1];if(Ae!==Re)return pe.slice(0,Ce)+Re+Ae+pe.slice(Ce+2)}}),define(ce[121],ue([0,1,39,120,13]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const D=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(`(\\\\)?${D.source}`,"g");function C(h){return h.replace(I,(S,d)=>d?S:`\\${S}`)}e.escapeIcons=C;const p=new RegExp(`\\\\${D.source}`,"g");function w(h){return h.replace(p,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=w;const n=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function A(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(n,(S,d,_,f)=>_?S:d||f||"")}e.stripIcons=A;function b(h){const S=h.indexOf(e.iconStartMarker);return S===-1?{text:h}:m(h,S)}e.parseLabelWithIcons=b;function m(h,S){const d=[];let _="";function f(v){if(v){_+=v;for(const y of v)d.push(t)}}let l=-1,a="",t=0,r,i,s=S;const c=h.length;for(f(h.substr(0,S));s<c;)r=h[s],i=h[s+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(l=s,f(a),a=e.iconStartMarker,s++):r===")"&&l!==-1?(t+=s-l+1,l=-1,a=""):l!==-1?/^[a-z0-9\-]$/i.test(r)?a+=r:(f(a),l=-1,a=""):f(r),s++;return f(a),{text:_,iconOffsets:d}}function u(h,S,d=!1){const{text:_,iconOffsets:f}=S;if(!f||f.length===0)return(0,P.matchesFuzzy)(h,_,d);const l=(0,g.ltrim)(_," "),a=_.length-l.length,t=(0,P.matchesFuzzy)(h,l,d);if(t)for(const r of t){const i=f[r.start+a]+a;r.start+=i,r.end+=i}return t}e.matchesFuzzyIconAware=u}),define(ce[74],ue([0,1,121,11]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(g=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(m="",u=!1){if(this.value=m,typeof this.value!="string")throw(0,P.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1)}appendText(m,u=0){return this.value+=w(this.supportThemeIcons?(0,E.escapeIcons)(m):m).replace(/([ \t]+)/g,(h,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,u){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=D;function I(b){return C(b)?!b.value:Array.isArray(b)?b.every(I):!0}e.isEmptyMarkdownString=I;function C(b){return b instanceof D?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function p(b,m){return b===m?!0:!b||!m?!1:b.value===m.value&&b.isTrusted===m.isTrusted&&b.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=p;function w(b){return b.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=w;function n(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function A(b){const m=[],u=b.split("|").map(S=>S.trim());b=u[0];const h=u[1];if(h){const S=/height=(\d+)/.exec(h),d=/width=(\d+)/.exec(h),_=S?S[1]:"",f=d?d[1]:"",l=isFinite(parseInt(f)),a=isFinite(parseInt(_));l&&m.push(`width="${f}"`),a&&m.push(`height="${_}"`)}return{href:b,dimensions:m}}e.parseHrefAndDimensions=A}),define(ce[46],ue([0,1,17,13,3]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function D(n){return JSON.stringify(n,p)}e.stringify=D;function I(n){let A=JSON.parse(n);return A=w(A),A}e.parse=I;var C;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function p(n,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,P.regExpFlags)(A)}:A}function w(n,A=0){if(!n||A>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return g.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof E.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let b=0;b<n.length;++b)n[b]=w(n[b],A+1);else for(const b in n)Object.hasOwnProperty.call(n,b)&&(n[b]=w(n[b],A+1))}return n}e.revive=w}),define(ce[8],ue([0,1,3,4]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var g;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(g=e.Schemas||(e.Schemas={}));class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,w,n){this._hosts[p]=w,this._ports[p]=n}setConnectionToken(p,w){this._connectionTokens[p]=w}rewrite(p){if(this._delegate)return this._delegate(p);const w=p.authority;let n=this._hosts[w];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const A=this._ports[w],b=this._connectionTokens[w];let m=`path=${encodeURIComponent(p.path)}`;return typeof b=="string"&&(m+=`&tkn=${encodeURIComponent(b)}`),E.URI.from({scheme:P.isWeb?this._preferredWebSchema:g.vscodeRemoteResource,authority:`${n}:${A}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new D;class I{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(p,w,n){const A=this.toUri(p,w);if(A.scheme===g.vscodeRemote)return e.RemoteAuthorities.rewrite(A);let b=!1;return P.isNative&&(n||P.isPreferringBrowserCodeLoad)&&A.scheme===g.file&&(b=!0),A.scheme===g.file&&typeof P.globals.importScripts=="function"&&P.globals.origin==="vscode-file://vscode-app"&&(b=!0),b?A.with({scheme:g.vscodeFileResource,authority:A.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):A}asFileUri(p,w){const n=this.toUri(p,w);return n.scheme===g.vscodeFileResource?n.with({scheme:g.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(p,w){return E.URI.isUri(p)?p:E.URI.parse(w.toUrl(p))}}e.FileAccess=new I}),define(ce[75],ue([0,1,26]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const P=new E.LRUCache(1e4);function g(w){return p(w,"NFC",P)}e.normalizeNFC=g;const D=new E.LRUCache(1e4);function I(w){return p(w,"NFD",D)}e.normalizeNFD=I;const C=/[^\u0000-\u0080]/;function p(w,n,A){if(!w)return w;const b=A.get(w);if(b)return b;let m;return C.test(w)?m=w.normalize(n):m=w,A.set(w,m),m}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(n){return I(n).replace(w,"")}}()}),define(ce[19],ue([0,1,31,5,3,13,8,4]),function(X,e,E,P,g,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(m){return(0,g.uriToFsPath)(m,!0)}e.originalFSPath=p;class w{constructor(u){this._ignorePathCasing=u}compare(u,h,S=!1){return u===h?0:(0,D.compare)(this.getComparisonKey(u,S),this.getComparisonKey(h,S))}isEqual(u,h,S=!1){return u===h?!0:!u||!h?!1:this.getComparisonKey(u,S)===this.getComparisonKey(h,S)}getComparisonKey(u,h=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,h,S=!1){if(u.scheme===h.scheme){if(u.scheme===I.Schemas.file)return E.isEqualOrParent(p(u),p(h),this._ignorePathCasing(u))&&u.query===h.query&&(S||u.fragment===h.fragment);if((0,e.isEqualAuthority)(u.authority,h.authority))return E.isEqualOrParent(u.path,h.path,this._ignorePathCasing(u),"/")&&u.query===h.query&&(S||u.fragment===h.fragment)}return!1}joinPath(u,...h){return g.URI.joinPath(u,...h)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return P.posix.basename(u.path)}extname(u){return P.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let h;return u.scheme===I.Schemas.file?h=g.URI.file(P.dirname(p(u))).path:(h=P.posix.dirname(u.path),u.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),h="/")),u.with({path:h})}normalizePath(u){if(!u.path.length)return u;let h;return u.scheme===I.Schemas.file?h=g.URI.file(P.normalize(p(u))).path:h=P.posix.normalize(u.path),u.with({path:h})}relativePath(u,h){if(u.scheme!==h.scheme||!(0,e.isEqualAuthority)(u.authority,h.authority))return;if(u.scheme===I.Schemas.file){const _=P.relative(p(u),p(h));return C.isWindows?E.toSlashes(_):_}let S=u.path||"/",d=h.path||"/";if(this._ignorePathCasing(u)){let _=0;for(const f=Math.min(S.length,d.length);_<f&&!(S.charCodeAt(_)!==d.charCodeAt(_)&&S.charAt(_).toLowerCase()!==d.charAt(_).toLowerCase());_++);S=d.substr(0,_)+S.substr(_)}return P.posix.relative(S,d)}resolvePath(u,h){if(u.scheme===I.Schemas.file){const S=g.URI.file(P.resolve(p(u),h));return u.with({authority:S.authority,path:S.path})}return h=E.toPosixPath(h),u.with({path:P.posix.resolve(u.path,h)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,h){return u===h||(0,D.equalsIgnoreCase)(u,h)}hasTrailingPathSeparator(u,h=P.sep){if(u.scheme===I.Schemas.file){const S=p(u);return S.length>E.getRoot(S).length&&S[S.length-1]===h}else{const S=u.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,h=P.sep){return(0,e.hasTrailingPathSeparator)(u,h)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,h=P.sep){let S=!1;if(u.scheme===I.Schemas.file){const d=p(u);S=d!==void 0&&d.length===E.getRoot(d).length&&d[d.length-1]===h}else{h="/";const d=u.path;S=d.length===1&&d.charCodeAt(d.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(u,h)?u.with({path:u.path+"/"}):u}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(m=>m.scheme===I.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new w(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(m,u){const h=[];for(let S=0;S<m.length;S++){const d=u(m[S]);m.some((_,f)=>f===S?!1:(0,e.isEqualOrParent)(d,u(_)))||h.push(m[S])}return h}e.distinctParents=n;var A;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function u(h){const S=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(f=>{const[l,a]=f.split(":");l&&a&&S.set(l,a)});const _=h.path.substring(0,h.path.indexOf(";"));return _&&S.set(m.META_DATA_MIME,_),S}m.parseMetaData=u})(A=e.DataUri||(e.DataUri={}));function b(m,u,h){if(u){let S=m.path;return S&&S[0]!==P.posix.sep&&(S=P.posix.sep+S),m.with({scheme:h,authority:u,path:S})}return m.with({scheme:h})}e.toLocalResource=b}),define(ce[14],ue([0,1,25,11,7,2,19]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(W){return!!W&&typeof W.then=="function"}e.isThenable=C;function p(W){const U=new E.CancellationTokenSource,j=W(U.token),H=new Promise((M,q)=>{const z=U.token.onCancellationRequested(()=>{z.dispose(),U.dispose(),q((0,P.canceled)())});Promise.resolve(j).then(V=>{z.dispose(),U.dispose(),M(V)},V=>{z.dispose(),U.dispose(),q(V)})});return new class{cancel(){U.cancel()}then(M,q){return H.then(M,q)}catch(M){return this.then(void 0,M)}finally(M){return H.finally(M)}}}e.createCancelablePromise=p;function w(W,U,j){return Promise.race([W,new Promise(H=>U.onCancellationRequested(()=>H(j)))])}e.raceCancellation=w;async function n(W){let U=-1;const j=W.map((M,q)=>M.then(z=>(U=q,z))),H=await Promise.race(j);return W.forEach((M,q)=>{q!==U&&M.cancel()}),H}e.raceCancellablePromises=n;function A(W,U,j){let H;const M=setTimeout(()=>{H?.(void 0),j?.()},U);return Promise.race([W.finally(()=>clearTimeout(M)),new Promise(q=>H=q)])}e.raceTimeout=A;function b(W){return new Promise((U,j)=>{const H=W();C(H)?H.then(U,j):U(H)})}e.asPromise=b;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const H=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,H};this.queuedPromise=new Promise(H=>{this.activePromise.then(j,j).then(H)})}return new Promise((j,H)=>{this.queuedPromise.then(j,H)})}return this.activePromise=U(),new Promise((j,H)=>{this.activePromise.then(M=>{this.activePromise=null,j(M)},M=>{this.activePromise=null,H(M)})})}}e.Throttler=m;class u{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=u;class h{constructor(){this.promiseMap=new Map}queue(U,j){const M=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(U)===M&&this.promiseMap.delete(U)});return this.promiseMap.set(U,M),M}}e.SequencerByKey=h;class S{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,j=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,M)=>{this.doResolve=H,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,P.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class d{constructor(U){this.delayer=new S(U),this.throttler=new m}trigger(U,j){return this.delayer.trigger(()=>this.throttler.queue(U),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=d;class _{constructor(){this._isOpen=!1,this._promise=new Promise((U,j)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=_;class f extends _{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function l(W,U){return U?new Promise((j,H)=>{const M=setTimeout(()=>{q.dispose(),j()},W),q=U.onCancellationRequested(()=>{clearTimeout(M),q.dispose(),H((0,P.canceled)())})}):p(j=>l(W,j))}e.timeout=l;function a(W,U=0){const j=setTimeout(W,U);return(0,D.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=a;function t(W){const U=[];let j=0;const H=W.length;function M(){return j<H?W[j++]():null}function q(z){z!=null&&U.push(z);const V=M();return V?V.then(q):Promise.resolve(U)}return Promise.resolve(null).then(q)}e.sequence=t;function r(W,U=H=>!!H,j=null){let H=0;const M=W.length,q=()=>{if(H>=M)return Promise.resolve(j);const z=W[H++];return Promise.resolve(z()).then(K=>U(K)?Promise.resolve(K):q())};return q()}e.first=r;function i(W,U=H=>!!H,j=null){if(W.length===0)return Promise.resolve(j);let H=W.length;const M=()=>{H=-1;for(const q of W)q.cancel?.()};return new Promise((q,z)=>{for(const V of W)V.then(K=>{--H>=0&&U(K)?(M(),q(K)):H===0&&q(j)}).catch(K=>{--H>=0&&(M(),z(K))})})}e.firstParallel=i;class s{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new g.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((j,H)=>{this.outstandingPromises.push({factory:U,c:j,e:H}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const j=U.factory();j.then(U.c,U.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class c extends s{constructor(){super(1)}}e.Queue=c;class v{constructor(){this.queues=new Map}queueFor(U,j=I.extUri){const H=j.getComparisonKey(U);let M=this.queues.get(H);return M||(M=new c,g.Event.once(M.onFinished)(()=>{M?.dispose(),this.queues.delete(H)}),this.queues.set(H,M)),M}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=v;class y{constructor(U,j){this._token=-1,typeof U=="function"&&typeof j=="number"&&this.setIfNotSet(U,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},j)}setIfNotSet(U,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},j))}}e.TimeoutTimer=y;class T{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,j){this.cancel(),this._token=setInterval(()=>{U()},j)}}e.IntervalTimer=T;class R{constructor(U,j){this.timeoutToken=-1,this.runner=U,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class o extends R{constructor(U,j){super(U,j);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class k extends D.Disposable{constructor(U,j,H,M){super();this.maxWorkChunkSize=U,this.maxPendingWork=j,this.throttleDelay=H,this.handler=M,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=k,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const j=setTimeout(()=>U(W));let H=!1;return{dispose(){H||(H=!0,clearTimeout(j))}}}}else e.runWhenIdle=(W,U)=>{const j=requestIdleCallback(W,typeof U=="number"?{timeout:U}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(j))}}}}();class O{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=O;async function Y(W,U,j){let H;for(let M=0;M<j;M++)try{return await W()}catch(q){H=q,await l(U)}throw H}e.retry=Y;class Q{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,j,H){return this._pending={taskId:U,cancel:()=>H?.(),promise:j},j.then(()=>this.donePending(U),()=>this.donePending(U)),j}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let j,H;const M=new Promise((q,z)=>{j=q,H=z});this._next={run:U,promise:M,promiseResolve:j,promiseReject:H}}return this._next.promise}}e.TaskSequentializer=Q;class me{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=me;class re{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,j)=>{this.completeCallback=U,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(j=>{this.completeCallback(U),this.resolved=!0,j()})}error(U){return new Promise(j=>{this.errorCallback(U),this.rejected=!0,j()})}cancel(){new Promise(U=>{this.errorCallback((0,P.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=re;var N;(function(W){async function U(j){let H;const M=await Promise.all(j.map(q=>q.then(z=>z,z=>{H||(H=z)})));if(typeof H!="undefined")throw H;return M}W.settled=U})(N=e.Promises||(e.Promises={}))}),define(ce[47],ue([0,1,13,31,5,26,14]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const p="**",w="/",n="[/\\\\]",A="[^/\\\\]",b=/\//g;function m(M){switch(M){case 0:return"";case 1:return`${A}*?`;default:return`(?:${n}|${A}+${n}|${n}${A}+)*?`}}function u(M,q){if(!M)return[];const z=[];let V=!1,K=!1,ae="";for(const fe of M){switch(fe){case q:if(!V&&!K){z.push(ae),ae="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":K=!0;break;case"]":K=!1;break}ae+=fe}return ae&&z.push(ae),z}e.splitGlobAware=u;function h(M){if(!M)return"";let q="";const z=u(M,w);if(z.every(V=>V===p))q=".*";else{let V=!1;z.forEach((K,ae)=>{if(K===p){V||(q+=m(2),V=!0);return}let fe=!1,De="",Pe=!1,Fe="";for(const Ne of K){if(Ne!=="}"&&fe){De+=Ne;continue}if(Pe&&(Ne!=="]"||!Fe)){let ze;Ne==="-"?ze=Ne:(Ne==="^"||Ne==="!")&&!Fe?ze="^":Ne===w?ze="":ze=E.escapeRegExpCharacters(Ne),Fe+=ze;continue}switch(Ne){case"{":fe=!0;continue;case"[":Pe=!0;continue;case"}":q+=`(?:${u(De,",").map(nt=>h(nt)).join("|")})`,fe=!1,De="";break;case"]":q+="["+Fe+"]",Pe=!1,Fe="";break;case"?":q+=A;continue;case"*":q+=m(1);continue;default:q+=E.escapeRegExpCharacters(Ne)}}ae<z.length-1&&(z[ae+1]!==p||ae+2<z.length)&&(q+=n),V=!1})}return q}const S=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),r=function(){return!1},i=function(){return null};function s(M,q){if(!M)return i;let z;typeof M!="string"?z=M.pattern:z=M,z=z.trim();const V=`${z}_${!!q.trimForExclusions}`;let K=t.get(V);if(K)return c(K,M);let ae;if(S.test(z)){const fe=z.substr(4);K=function(De,Pe){return typeof De=="string"&&De.endsWith(fe)?z:null}}else(ae=d.exec(v(z,q)))?K=y(ae[1],z):(q.trimForExclusions?f:_).test(z)?K=T(z,q):(ae=l.exec(v(z,q)))?K=R(ae[1].substr(1),z,!0):(ae=a.exec(v(z,q)))?K=R(ae[1],z,!1):K=o(z);return t.set(V,K),c(K,M)}function c(M,q){return typeof q=="string"?M:function(z,V){return P.isEqualOrParent(z,q.base)?M(g.relative(q.base,z),V):null}}function v(M,q){return q.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function y(M,q){const z=`/${M}`,V=`\\${M}`,K=function(fe,De){return typeof fe!="string"?null:De?De===M?q:null:fe===M||fe.endsWith(z)||fe.endsWith(V)?q:null},ae=[M];return K.basenames=ae,K.patterns=[q],K.allBasenames=ae,K}function T(M,q){const z=H(M.slice(1,-1).split(",").map(De=>s(De,q)).filter(De=>De!==i),M),V=z.length;if(!V)return i;if(V===1)return z[0];const K=function(De,Pe){for(let Fe=0,Ne=z.length;Fe<Ne;Fe++)if(z[Fe](De,Pe))return M;return null},ae=z.find(De=>!!De.allBasenames);ae&&(K.allBasenames=ae.allBasenames);const fe=z.reduce((De,Pe)=>Pe.allPaths?De.concat(Pe.allPaths):De,[]);return fe.length&&(K.allPaths=fe),K}function R(M,q,z){const V=g.sep===g.posix.sep,K=V?M:M.replace(b,g.sep),ae=g.sep+K,fe=g.posix.sep+M,De=z?function(Pe,Fe){return typeof Pe=="string"&&(Pe===K||Pe.endsWith(ae)||!V&&(Pe===M||Pe.endsWith(fe)))?q:null}:function(Pe,Fe){return typeof Pe=="string"&&(Pe===K||!V&&Pe===M)?q:null};return De.allPaths=[(z?"*/":"./")+M],De}function o(M){try{const q=new RegExp(`^${h(M)}$`);return function(z){return q.lastIndex=0,typeof z=="string"&&q.test(z)?M:null}}catch(q){return i}}function k(M,q,z){return!M||typeof q!="string"?!1:O(M)(q,void 0,z)}e.match=k;function O(M,q={}){if(!M)return r;if(typeof M=="string"||re(M)){const z=s(M,q);if(z===i)return r;const V=function(K,ae){return!!z(K,ae)};return z.allBasenames&&(V.allBasenames=z.allBasenames),z.allPaths&&(V.allPaths=z.allPaths),V}return U(M,q)}e.parse=O;function Y(M){if(!M)return;let q;return z=>(q||(q=(M()||Promise.resolve([])).then(V=>V?me(V):{})),q.then(V=>!!V[z]))}e.hasSiblingPromiseFn=Y;function Q(M){if(!M)return;let q;return z=>{if(!q){const V=M();q=V?me(V):{}}return!!q[z]}}e.hasSiblingFn=Q;function me(M){const q={};for(const z of M)q[z]=!0;return q}function re(M){const q=M;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=re;function N(M){return M.allBasenames||[]}e.getBasenameTerms=N;function W(M){return M.allPaths||[]}e.getPathTerms=W;function U(M,q){const z=H(Object.getOwnPropertyNames(M).map(De=>j(De,M[De],q)).filter(De=>De!==i)),V=z.length;if(!V)return i;if(!z.some(De=>!!De.requiresSiblings)){if(V===1)return z[0];const De=function(Ne,ze){for(let Xe=0,nt=z.length;Xe<nt;Xe++){const it=z[Xe](Ne,ze);if(it)return it}return null},Pe=z.find(Ne=>!!Ne.allBasenames);Pe&&(De.allBasenames=Pe.allBasenames);const Fe=z.reduce((Ne,ze)=>ze.allPaths?Ne.concat(ze.allPaths):Ne,[]);return Fe.length&&(De.allPaths=Fe),De}const K=function(De,Pe,Fe){let Ne;for(let ze=0,Xe=z.length;ze<Xe;ze++){const nt=z[ze];nt.requiresSiblings&&Fe&&(Pe||(Pe=g.basename(De)),Ne||(Ne=Pe.substr(0,Pe.length-g.extname(De).length)));const it=nt(De,Pe,Ne,Fe);if(it)return it}return null},ae=z.find(De=>!!De.allBasenames);ae&&(K.allBasenames=ae.allBasenames);const fe=z.reduce((De,Pe)=>Pe.allPaths?De.concat(Pe.allPaths):De,[]);return fe.length&&(K.allPaths=fe),K}function j(M,q,z){if(q===!1)return i;const V=s(M,z);if(V===i)return i;if(typeof q=="boolean")return V;if(q){const K=q.when;if(typeof K=="string"){const ae=(fe,De,Pe,Fe)=>{if(!Fe||!V(fe,De))return null;const Ne=K.replace("$(basename)",Pe),ze=Fe(Ne);return(0,I.isThenable)(ze)?ze.then(Xe=>Xe?M:null):ze?M:null};return ae.requiresSiblings=!0,ae}}return V}function H(M,q){const z=M.filter(De=>!!De.basenames);if(z.length<2)return M;const V=z.reduce((De,Pe)=>{const Fe=Pe.basenames;return Fe?De.concat(Fe):De},[]);let K;if(q){K=[];for(let De=0,Pe=V.length;De<Pe;De++)K.push(q)}else K=z.reduce((De,Pe)=>{const Fe=Pe.patterns;return Fe?De.concat(Fe):De},[]);const ae=function(De,Pe){if(typeof De!="string")return null;if(!Pe){let Ne;for(Ne=De.length;Ne>0;Ne--){const ze=De.charCodeAt(Ne-1);if(ze===47||ze===92)break}Pe=De.substr(Ne)}const Fe=V.indexOf(Pe);return Fe!==-1?K[Fe]:null};ae.basenames=V,ae.patterns=K,ae.allBasenames=V;const fe=M.filter(De=>!De.basenames);return fe.push(ae),fe}}),define(ce[52],ue([0,1,3,5,13,8,4,19,31]),function(X,e,E,P,g,D,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(s,c,v){if(typeof s=="string"&&(s=E.URI.file(s)),v){const T=v.getWorkspaceFolder(s);if(T){const R=v.getWorkspace().folders.length>1;let o;if((0,C.isEqual)(T.uri,s)?o="":o=(0,C.relativePath)(T.uri,s),R){const k=T.name?T.name:(0,C.basename)(T.uri);o=o?k+" \u2022 "+o:k}return o}}if(s.scheme!==D.Schemas.file&&s.scheme!==D.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(s.fsPath))return(0,P.normalize)(A(s.fsPath));let y=(0,P.normalize)(s.fsPath);return!I.isWindows&&c?.userHome&&(y=m(y,c.userHome.fsPath)),y}e.getPathLabel=w;function n(s){if(!s)return;typeof s=="string"&&(s=E.URI.file(s));const c=(0,C.basename)(s)||(s.scheme===D.Schemas.file?s.fsPath:s.path);return I.isWindows&&(0,p.isRootOrDriveLetter)(c)?A(c):c}e.getBaseLabel=n;function A(s){return(0,p.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=A;let b=Object.create(null);function m(s,c){if(I.isWindows||!s||!c)return s;let v=b.original===c?b.normalized:void 0;return v||(v=`${(0,g.rtrim)(c,P.posix.sep)}${P.posix.sep}`,b={original:c,normalized:v}),(I.isLinux?s.startsWith(v):(0,g.startsWithIgnoreCase)(s,v))&&(s=`~/${s.substr(v.length)}`),s}e.tildify=m;function u(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=u;const h="\u2026",S="\\\\",d="~";function _(s,c=P.sep){const v=new Array(s.length);let y=!1;for(let T=0;T<s.length;T++){let R=s[T];if(R===""){v[T]=`.${c}`;continue}if(!R){v[T]=R;continue}y=!0;let o="";R.indexOf(S)===0?(o=R.substr(0,R.indexOf(S)+S.length),R=R.substr(R.indexOf(S)+S.length)):R.indexOf(c)===0?(o=R.substr(0,R.indexOf(c)+c.length),R=R.substr(R.indexOf(c)+c.length)):R.indexOf(d)===0&&(o=R.substr(0,R.indexOf(d)+d.length),R=R.substr(R.indexOf(d)+d.length));const k=R.split(c);for(let O=1;y&&O<=k.length;O++)for(let Y=k.length-O;y&&Y>=0;Y--){y=!1;let Q=k.slice(Y,Y+O).join(c);for(let me=0;!y&&me<s.length;me++)if(me!==T&&s[me]&&s[me].indexOf(Q)>-1){const re=Y+O===k.length,N=Y>0&&s[me].indexOf(c)>-1?c+Q:Q,W=s[me].endsWith(N);y=!re||W}if(!y){let me="";(k[0].endsWith(":")||o!=="")&&(Y===1&&(Y=0,O++,Q=k[0]+c+Q),Y>0&&(me=k[0]+c),me=o+me),Y>0&&(me=me+h+c),me=me+Q,Y+O<k.length&&(me=me+c+h),v[T]=me}}y&&(v[T]=R)}return v}e.shorten=_;var f;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function l(s,c=Object.create(null)){const v=[];let y=!1,T="";for(const R of s)if(R==="$"||y&&R==="{")T&&v.push({value:T,type:f.TEXT}),T="",y=!0;else if(R==="}"&&y){const o=c[T];if(typeof o=="string")o.length&&v.push({value:o,type:f.VARIABLE});else if(o){const k=v[v.length-1];(!k||k.type!==f.SEPARATOR)&&v.push({value:o.label,type:f.SEPARATOR})}T="",y=!1}else T+=R;return T&&!y&&v.push({value:T,type:f.TEXT}),v.filter((R,o)=>{if(R.type===f.SEPARATOR){const k=v[o-1],O=v[o+1];return[k,O].every(Y=>Y&&(Y.type===f.VARIABLE||Y.type===f.TEXT)&&Y.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=l;function a(s,c){return I.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):s.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function t(s,c){return I.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,""):I.isWindows?s.replace(/&&|&/g,v=>v==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=r;function i(s){const c=s.indexOf("/")!==-1?P.posix:P.win32,v=c.basename(s),y=c.dirname(s);return v.length?{name:v,parentPath:y}:{name:y,parentPath:""}}e.splitName=i}),define(ce[53],ue([0,1,5,13,47,8,19]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(C=e.Mimes||(e.Mimes={}));let p=[],w=[],n=[];function A(r,i=!1){const s=b(r);p.push(s),s.userConfigured?n.push(s):w.push(s),i&&!s.userConfigured&&p.forEach(c=>{c.mime===s.mime||c.userConfigured||(s.extension&&c.extension===s.extension&&console.warn(`Overwriting extension <<${s.extension}>> to now point to mime <<${s.mime}>>`),s.filename&&c.filename===s.filename&&console.warn(`Overwriting filename <<${s.filename}>> to now point to mime <<${s.mime}>>`),s.filepattern&&c.filepattern===s.filepattern&&console.warn(`Overwriting filepattern <<${s.filepattern}>> to now point to mime <<${s.mime}>>`),s.firstline&&c.firstline===s.firstline&&console.warn(`Overwriting firstline <<${s.firstline}>> to now point to mime <<${s.mime}>>`))})}e.registerTextMime=A;function b(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(E.posix.sep)>=0:!1}}function m(r){r?(p=p.filter(i=>!i.userConfigured),n=[]):(p=[],w=[],n=[])}e.clearTextMimes=m;function u(r,i){let s;if(r)switch(r.scheme){case D.Schemas.file:s=r.fsPath;break;case D.Schemas.data:s=I.DataUri.parseMetaData(r).get(I.DataUri.META_DATA_LABEL);break;default:s=r.path}if(!s)return[C.unknown];s=s.toLowerCase();const c=(0,E.basename)(s),v=h(s,c,n);if(v)return[v,C.text];const y=h(s,c,w);if(y)return[y,C.text];if(i){const T=S(i);if(T)return[T,C.text]}return[C.unknown]}e.guessMimeTypes=u;function h(r,i,s){let c=null,v=null,y=null;for(let T=s.length-1;T>=0;T--){const R=s[T];if(i===R.filenameLowercase){c=R;break}if(R.filepattern&&(!v||R.filepattern.length>v.filepattern.length)){const o=R.filepatternOnPath?r:i;(0,g.match)(R.filepatternLowercase,o)&&(v=R)}R.extension&&(!y||R.extension.length>y.extension.length)&&i.endsWith(R.extensionLowercase)&&(y=R)}return c?c.mime:v?v.mime:y?y.mime:null}function S(r){if((0,P.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let i=p.length-1;i>=0;i--){const s=p[i];if(!s.firstline)continue;const c=r.match(s.firstline);if(c&&c.length>0)return s.mime}return null}function d(r){return r?typeof r=="string"?r===C.binary||r===C.text||r===C.unknown:r.length===1&&d(r[0]):!0}e.isUnspecific=d;const _={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(r){const i=(0,E.extname)(r);return _[i.toLowerCase()]}e.getMediaMime=f;function l(r){for(const i in _)if(_[i]===r)return i}e.getExtensionForMimeType=l;const a=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){const s=a.exec(r);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:i?void 0:r}e.normalizeMimeType=t}),define(ce[54],ue([0,1,3]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function P(n){return n.toJSON()}class g{constructor(A){this._uriTransformer=A}transformIncoming(A){const b=this._uriTransformer.transformIncoming(A);return b===A?A:P(E.URI.from(b))}transformOutgoing(A){const b=this._uriTransformer.transformOutgoing(A);return b===A?A:P(E.URI.from(b))}transformOutgoingURI(A){const b=this._uriTransformer.transformOutgoing(A);return b===A?A:E.URI.from(b)}transformOutgoingScheme(A){return this._uriTransformer.transformOutgoingScheme(A)}}e.URITransformer=g,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function D(n,A,b){if(!n||b>200)return null;if(typeof n=="object"){if(n instanceof E.URI)return A.transformOutgoing(n);for(let m in n)if(Object.hasOwnProperty.call(n,m)){const u=D(n[m],A,b+1);u!==null&&(n[m]=u)}}return null}function I(n,A){const b=D(n,A,0);return b===null?n:b}e.transformOutgoingURIs=I;function C(n,A,b,m){if(!n||m>200)return null;if(typeof n=="object"){if(n.$mid===1)return b?E.URI.revive(A.transformIncoming(n)):A.transformIncoming(n);for(let u in n)if(Object.hasOwnProperty.call(n,u)){const h=C(n[u],A,b,m+1);h!==null&&(n[u]=h)}}return null}function p(n,A){const b=C(n,A,!1,0);return b===null?n:b}e.transformIncomingURIs=p;function w(n,A){const b=C(n,A,!0,0);return b===null?n:b}e.transformAndReviveIncomingURIs=w}),define(ce[22],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(p){return E.test(p)}e.isUUID=P;const g=new Uint8Array(16),D=[];for(let p=0;p<256;p++)D.push(p.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(p){for(let w=0;w<p.length;w++)p[w]=Math.floor(Math.random()*256);return p};function C(){I(g),g[6]=g[6]&15|64,g[8]=g[8]&63|128;let p=0,w="";return w+=D[g[p++]],w+=D[g[p++]],w+=D[g[p++]],w+=D[g[p++]],w+="-",w+=D[g[p++]],w+=D[g[p++]],w+="-",w+=D[g[p++]],w+=D[g[p++]],w+="-",w+=D[g[p++]],w+=D[g[p++]],w+="-",w+=D[g[p++]],w+=D[g[p++]],w+=D[g[p++]],w+=D[g[p++]],w+=D[g[p++]],w+=D[g[p++]],w}e.generateUuid=C}),define(ce[76],ue([0,1,242]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class P{constructor(D="utf8"){this.stringDecoder=new E.StringDecoder(D),this.remaining=null}write(D){const I=[],C=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(C.length<1)return I;let p=0,w,n=p;for(;n<C.length;)if(w=C.charCodeAt(n),w===13||w===10){if(I.push(C.substring(p,n)),n++,n<C.length){const A=w;w=C.charCodeAt(n),(A===13&&w===10||A===10&&w===13)&&n++}p=n}else n++;return this.remaining=p<C.length?C.substr(p):null,I}end(){return this.remaining}}e.LineDecoder=P}),function(){"use strict";function X(e,E,P,g){function D(u){return new Promise(h=>P.exists(u,h))}function I(u){return new Promise((h,S)=>{const d=new Date;P.utimes(u,d,d,_=>_?S(_):h())})}function C(u){return new Promise((h,S)=>P.mkdir(u,{recursive:!0},d=>d&&d.code!=="EEXIST"?S(d):h(u)))}function p(u){return new Promise((h,S)=>P.rmdir(u,{recursive:!0},d=>d&&d.code!=="ENOENT"?S(d):h()))}function w(u){return new Promise((h,S)=>P.readFile(u,"utf8",(d,_)=>d?S(d):h(_)))}function n(u,h){return new Promise((S,d)=>P.writeFile(u,h,"utf8",_=>_?d(_):S()))}function A(u){const h=E.join(u,"languagepacks.json");try{return e(h)}catch(S){}}function b(u,h){try{for(;h;){if(u[h])return h;{const S=h.lastIndexOf("-");if(S>0)h=h.substring(0,S);else return}}}catch(S){console.error("Resolving language pack configuration failed.",S)}}function m(u,h,S,d){if(d==="pseudo")return Promise.resolve({locale:d,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:d,availableLanguages:{}});if(d&&(d==="en"||d==="en-us"))return Promise.resolve({locale:d,availableLanguages:{}});const _=d;g.mark("code/willGenerateNls");const f=function(l){return g.mark("code/didGenerateNls"),Promise.resolve({locale:l,availableLanguages:{}})};try{if(!u)return f(_);const l=A(h);if(!l||(d=b(l,d),!d))return f(_);const a=l[d];let t;return!a||typeof a.hash!="string"||!a.translations||typeof(t=a.translations.vscode)!="string"?f(_):D(t).then(r=>{if(!r)return f(_);const i=a.hash+"."+d,s=E.join(h,"clp",i),c=E.join(s,u),v=E.join(s,"tcf.json"),y=E.join(s,"corrupted.info"),T={locale:_,availableLanguages:{"*":d},_languagePackId:i,_translationsConfigFile:v,_cacheRoot:s,_resolvedLanguagePackCoreLocation:c,_corruptedFile:y};return D(y).then(R=>{let o;return R?o=p(s):o=Promise.resolve(void 0),o.then(()=>D(c).then(k=>k?(I(c).catch(()=>{}),g.mark("code/didGenerateNls"),T):C(c).then(()=>Promise.all([w(S),w(t)])).then(O=>{const Y=JSON.parse(O[0]),Q=JSON.parse(O[1]).contents,me=Object.keys(Y.bundles),re=[];for(const N of me){const W=Y.bundles[N],U=Object.create(null);for(const j of W){const H=Y.keys[j],M=Y.messages[j],q=Q[j];let z;if(q){z=[];for(let V=0;V<H.length;V++){const K=H[V],ae=typeof K=="string"?K:K.key;let fe=q[ae];fe===void 0&&(fe=M[V]),z.push(fe)}}else z=M;U[j]=z}re.push(n(E.join(c,N.replace(/\//g,"!")+".nls.json"),JSON.stringify(U)))}return re.push(n(v,JSON.stringify(a.translations))),Promise.all(re)}).then(()=>(g.mark("code/didGenerateNls"),T)).catch(O=>(console.error("Generating translation files failed.",O),f(d)))))})})}catch(l){return console.error("Generating translation files failed.",l),f(d)}}return{getNLSConfiguration:m}}if(typeof define=="function")define(ce[122],ue([0,77,27,48]),function(e,E,P,g){return X(e.__$__nodeRequire,E,P,g)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("fs"),P=require("../common/performance");module.exports=X(require,e,E,P)}else throw new Error("Unknown context")}(),define(ce[123],ue([0,1,24]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const P=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function g(C){const p=C.replace(/\-/g,":").toLowerCase();return!P.has(p)}function D(){return new Promise(async(C,p)=>{const w=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{C(await I())}catch(n){p(n)}finally{clearTimeout(w)}})}e.getMac=D;function I(){return new Promise((C,p)=>{try{const w=(0,E.networkInterfaces)();for(let n in w){const A=w[n];if(A){for(const{mac:b}of A)if(g(b))return C(b)}}p("Unable to retrieve mac address (unexpected format)")}catch(w){p(w)}})}}),define(ce[78],ue([0,1,11,22,24,26,123]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,A=0;const b=(0,g.networkInterfaces)();for(let m in b){const u=b[m];if(u)for(const{mac:h,internal:S}of u)S||(A+=1,this._isVirtualMachineMacAdress(h.toUpperCase())&&(n+=1))}this._value=A>0?n/A:0}return this._value}};let C;async function p(){return C||(C=(async()=>await w()||P.generateUuid())()),C}e.getMachineId=p;async function w(){try{const n=await new Promise((b,m)=>{X(["crypto"],b,m)}),A=await(0,I.getMac)();return n.createHash("sha256").update(A,"utf8").digest("hex")}catch(n){E.onUnexpectedError(n);return}}}),define(ce[16],ue([0,1,27,24,124,5,14,4,31,22,75,19,3]),function(X,e,E,P,g,D,I,C,p,w,n,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function u(N,W=m.UNLINK){if((0,p.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return W===m.UNLINK?S(N):h(N)}async function h(N){try{const W=(0,D.join)((0,P.tmpdir)(),(0,w.generateUuid)());try{await e.Promises.rename(N,W)}catch(U){return S(N)}S(W).catch(U=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function S(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function d(N){if((0,p.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");E.rmdirSync(N,{recursive:!0})}e.rimrafSync=d;async function _(N,W){return a(await(W?f(N):(0,g.promisify)(E.readdir)(N)))}async function f(N){try{return await(0,g.promisify)(E.readdir)(N,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const W=[],U=await _(N);for(const j of U){let H=!1,M=!1,q=!1;try{const z=await e.Promises.lstat((0,D.join)(N,j));H=z.isFile(),M=z.isDirectory(),q=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}W.push({name:j,isFile:()=>H,isDirectory:()=>M,isSymbolicLink:()=>q})}return W}function l(N){return a(E.readdirSync(N))}e.readdirSync=l;function a(N){return N.map(W=>typeof W=="string"?C.isMacintosh?(0,n.normalizeNFC)(W):W:(W.name=C.isMacintosh?(0,n.normalizeNFC)(W.name):W.name,W))}async function t(N){const W=await _(N),U=[];for(const j of W)await i.existsDirectory((0,D.join)(N,j))&&U.push(j);return U}function r(N,W=1e3){return new Promise(U=>{let j=!1;const H=setInterval(()=>{j||(j=!0,E.access(N,M=>{j=!1,M&&(clearInterval(H),U(void 0))}))},W)})}e.whenDeleted=r;var i;(function(N){async function W(H){let M;try{if(M=await e.Promises.lstat(H),!M.isSymbolicLink())return{stat:M}}catch(q){}try{return{stat:await e.Promises.stat(H),symbolicLink:M?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(C.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw z}throw q}}N.stat=W;async function U(H){try{const{stat:M,symbolicLink:q}=await N.stat(H);return M.isFile()&&q?.dangling!==!0}catch(M){}return!1}N.existsFile=U;async function j(H){try{const{stat:M,symbolicLink:q}=await N.stat(H);return M.isDirectory()&&q?.dangling!==!0}catch(M){}return!1}N.existsDirectory=j})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new I.ResourceQueue;function c(N,W,U){return s.queueFor(b.URI.file(N),A.extUriBiasedIgnorePathCase).queue(()=>{const j=R(U);return new Promise((H,M)=>y(N,W,j,q=>q?M(q):H()))})}let v=!0;function y(N,W,U,j){if(!v)return E.writeFile(N,W,{mode:U.mode,flag:U.flag},j);E.open(N,U.flag,U.mode,(H,M)=>{if(H)return j(H);E.writeFile(M,W,q=>{if(q)return E.close(M,()=>j(q));E.fdatasync(M,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),v=!1),E.close(M,V=>j(V))))})})}function T(N,W,U){const j=R(U);if(!v)return E.writeFileSync(N,W,{mode:j.mode,flag:j.flag});const H=E.openSync(N,j.flag,j.mode);try{E.writeFileSync(H,W);try{E.fdatasyncSync(H)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),v=!1}}finally{E.closeSync(H)}}e.writeFileSync=T;function R(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function o(N,W){if(N===W)return;async function U(j){try{const H=await e.Promises.lstat(j);if(H.isDirectory()||H.isSymbolicLink())return;await e.Promises.utimes(j,H.atime,new Date)}catch(H){}}try{await e.Promises.rename(N,W),await U(W)}catch(j){if(N.toLowerCase()!==W.toLowerCase()&&j.code==="EXDEV"||N.endsWith("."))await k(N,W,{preserveSymlinks:!1}),await u(N,m.MOVE),await U(W);else throw j}}async function k(N,W,U){return Y(N,W,{root:{source:N,target:W},options:U,handledSourcePaths:new Set})}const O=511;async function Y(N,W,U){if(U.handledSourcePaths.has(N))return;U.handledSourcePaths.add(N);const{stat:j,symbolicLink:H}=await i.stat(N);if(H){if(U.options.preserveSymlinks)try{return await re(N,W,U)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(H.dangling)return}return j.isDirectory()?Q(N,W,j.mode&O,U):me(N,W,j.mode&O)}async function Q(N,W,U,j){await e.Promises.mkdir(W,{recursive:!0,mode:U});const H=await _(N);for(const M of H)await Y((0,D.join)(N,M),(0,D.join)(W,M),j)}async function me(N,W,U){await e.Promises.copyFile(N,W),await e.Promises.chmod(W,U)}async function re(N,W,U){let j=await e.Promises.readlink(N);(0,p.isEqualOrParent)(j,U.root.source,!C.isLinux)&&(j=(0,D.join)(U.root.target,j.substr(U.root.source.length+1))),await e.Promises.symlink(j,W)}e.Promises=new class{get access(){return(0,g.promisify)(E.access)}get stat(){return(0,g.promisify)(E.stat)}get lstat(){return(0,g.promisify)(E.lstat)}get utimes(){return(0,g.promisify)(E.utimes)}get read(){return(0,g.promisify)(E.read)}get readFile(){return(0,g.promisify)(E.readFile)}get write(){return(0,g.promisify)(E.write)}get appendFile(){return(0,g.promisify)(E.appendFile)}get fdatasync(){return(0,g.promisify)(E.fdatasync)}get truncate(){return(0,g.promisify)(E.truncate)}get rename(){return(0,g.promisify)(E.rename)}get copyFile(){return(0,g.promisify)(E.copyFile)}get open(){return(0,g.promisify)(E.open)}get close(){return(0,g.promisify)(E.close)}get symlink(){return(0,g.promisify)(E.symlink)}get readlink(){return(0,g.promisify)(E.readlink)}get chmod(){return(0,g.promisify)(E.chmod)}get mkdir(){return(0,g.promisify)(E.mkdir)}get unlink(){return(0,g.promisify)(E.unlink)}get rmdir(){return(0,g.promisify)(E.rmdir)}get realpath(){return(0,g.promisify)(E.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return _}get readDirsInDir(){return t}get writeFile(){return c}get rm(){return u}get move(){return o}get copy(){return k}}}),define(ce[125],ue([0,1,27,13,5,16]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function I(n){const A=(0,g.dirname)(n);if(n===A)return n;const b=((0,g.basename)(n)||n).toLowerCase();try{const u=(0,D.readdirSync)(A).filter(h=>h.toLowerCase()===b);if(u.length===1){const h=I(A);if(h)return(0,g.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(b);if(h>=0){const S=I(A);if(S)return(0,g.join)(S,u[h])}}}catch(m){}return null}e.realcaseSync=I;async function C(n){try{return await D.Promises.realpath(n)}catch(A){const b=w(n);return await D.Promises.access(b,E.constants.R_OK),b}}e.realpath=C;function p(n){try{return E.realpathSync(n)}catch(A){const b=w(n);return E.accessSync(b,E.constants.R_OK),b}}e.realpathSync=p;function w(n){return(0,P.rtrim)((0,g.normalize)(n),g.sep)}}),define(ce[126],ue([0,1,79]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function P(C,p,w){let n=!1;return new Promise(A=>{const b=setTimeout(()=>{if(!n)return n=!0,A(0)},w);g(C,p,m=>{if(!n)return n=!0,clearTimeout(b),A(m)})})}e.findFreePort=P;function g(C,p,w){if(p===0)return w(0);const n=new E.Socket;n.once("connect",()=>(I(n),g(C+1,p-1,w))),n.once("data",()=>{}),n.once("error",A=>(I(n),A.code!=="ECONNREFUSED"?g(C+1,p-1,w):w(C))),n.connect(C,"127.0.0.1")}function D(C,p,w){let n=!1,A,b=1;const m=E.createServer({pauseOnConnect:!0});function u(h,S){n||(n=!0,m.removeAllListeners(),m.close(),A&&clearTimeout(A),S(h))}return new Promise(h=>{A=setTimeout(()=>{u(0,h)},w),m.on("listening",()=>{u(C,h)}),m.on("error",S=>{S&&(S.code==="EADDRINUSE"||S.code==="EACCES")&&b<p?(C++,b++,m.listen(C,"127.0.0.1")):u(0,h)}),m.on("close",()=>{u(0,h)}),m.listen(C,"127.0.0.1")})}e.findFreePortFaster=D;function I(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(p){console.error(p)}}}),define(ce[80],ue([0,1,16,24,5]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,I=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var p;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(p||(p={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class A{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await E.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:l=!1}={}){return l?w===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:l=!1,findPreview:a=!1}={}){const t=b({useAlternateBitness:l});if(!t)return null;const r=g.join(t,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(r))return null;let i=-1,s=null;for(const y of await E.Promises.readdir(r)){let T=-1;if(a){const o=y.indexOf("-");if(o<0)continue;const k=y.substring(0,o);if(!D.test(k)||y.substring(o+1)!=="preview")continue;T=parseInt(k,10)}else{if(!D.test(y))continue;T=parseInt(y,10)}if(T<=i)continue;const R=g.join(r,y,"pwsh.exe");!await E.SymlinkSupport.existsFile(R)||(s=R,i=T)}if(!s)return null;const c=t.includes("x86")?" (x86)":"",v=a?" Preview":"";return new A(s,`PowerShell${v}${c}`,!0)}async function u({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const a=g.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=l?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const i of await E.Promises.readdir(a))if(t.test(i)){const s=g.join(a,i,"pwsh.exe");return new A(s,r)}return null}function h(){const l=g.join(P.homedir(),".dotnet","tools","pwsh.exe");return new A(l,".NET Core PowerShell Global Tool")}function S(){const l=g.join(process.env.windir,w===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new A(l,"Windows PowerShell",!0)}async function*d(){let l=await m();l&&(yield l),l=await m({useAlternateBitness:!0}),l&&(yield l),l=await u(),l&&(yield l),l=h(),l&&(yield l),l=await m({findPreview:!0}),l&&(yield l),l=await u({findPreview:!0}),l&&(yield l),l=await m({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=S(),l&&(yield l)}async function*_(){for await(const l of d())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=_;async function f(){for await(const l of _())return l;return null}e.getFirstAvailablePowerShellInstallation=f}),define(ce[81],ue([0,1,35,8]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function g(I){return new Promise((C,p)=>{let w;const n=new Map;function A(m,u,h,S,d){const _=n.get(u);if(m===I||_){const f={name:b(h),cmd:h,pid:m,ppid:u,load:S,mem:d};n.set(m,f),m===I&&(w=f),_&&(_.children||(_.children=[]),_.children.push(f),_.children.length>1&&(_.children=_.children.sort((l,a)=>l.pid-a.pid)))}}function b(m){const u=/--disable-blink-features=Auxclick/,h=/\\watcher\\win32\\CodeHelper\.exe/,S=/--crashes-directory/,d=/\\pipe\\winpty-control/,_=/conhost\.exe/,f=/--type=([a-zA-Z-]+)/;if(h.exec(m))return"watcherService ";if(S.exec(m))return"electron-crash-reporter";if(d.exec(m))return"winpty-process";if(_.exec(m))return"console-window-host (Windows internal process)";let l=f.exec(m);if(l&&l.length===2)return l[1]==="renderer"?u.exec(m)?"shared-process":"window":l[1];const a=/[a-zA-Z-]+\.js/g;let t="";do l=a.exec(m),l&&(t+=l+" ");while(l);return t&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${t}`:m}if(process.platform==="win32"){const m=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,h)=>{X(["windows-process-tree"],u,h)}).then(u=>{u.getProcessList(I,h=>{u.getProcessCpuUsage(h,S=>{const d=new Map;S.forEach(_=>{const f=m(_.commandLine||"");d.set(_.pid,{name:b(f),cmd:f,pid:_.pid,ppid:_.ppid,load:_.cpu||0,mem:_.memory||0})}),w=d.get(I),w?(d.forEach(_=>{const f=d.get(_.ppid);f&&(f.children||(f.children=[]),f.children.push(_))}),d.forEach(_=>{_.children&&(_.children=_.children.sort((f,l)=>f.pid-l.pid))}),C(w)):p(new Error(`Root process ${I} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let m=function(){let u=[w];const h=[];for(;u.length;){const d=u.shift();d&&(h.push(d.pid),d.children&&(u=u.concat(d.children)))}let S=JSON.stringify(P.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",X).fsPath);S+=" "+h.join(" "),(0,E.exec)(S,{},(d,_,f)=>{if(d||f)p(d||new Error(f.toString()));else{const l=_.toString().split(`
`);for(let a=0;a<h.length;a++){const t=n.get(h[a]);t.load=parseFloat(l[a])}if(!w){p(new Error(`Root process ${I} not found`));return}C(w)}})};(0,E.exec)("which ps",{},(u,h,S)=>{if(u||S)if(process.platform!=="linux")p(u||new Error(S.toString()));else{const d=JSON.stringify(P.FileAccess.asFileUri("vs/base/node/ps.sh",X).fsPath);(0,E.exec)(d,{},(_,f,l)=>{_||l?p(_||new Error(l.toString())):(D(f,A),m())})}else{const d=h.toString().trim(),_="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${d} ${_}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,l,a)=>{f||a&&!a.includes("screen size is bogus")?p(f||new Error(a.toString())):(D(l,A),process.platform==="linux"?m():w?C(w):p(new Error(`Root process ${I} not found`)))})}})}})}e.listProcesses=g;function D(I,C){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=I.toString().split(`
`);for(const n of w){const A=p.exec(n.trim());A&&A.length===6&&C(parseInt(A[1]),parseInt(A[2]),A[5],parseFloat(A[3]),parseFloat(A[4]))}}}),define(ce[127],ue([0,1,5,27,4,75,2,16]),function(X,e,E,P,g,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function p(A,b,m){return n({path:A,isDirectory:!1},b,m)}e.watchFile=p;function w(A,b,m){return n({path:A,isDirectory:!0},b,m)}e.watchFolder=w,e.CHANGE_BUFFER_DELAY=100;function n(A,b,m){const u=(0,E.basename)(A.path),h=new Map;let S=!1,d=[(0,I.toDisposable)(()=>{h.forEach(_=>(0,I.dispose)(_)),h.clear()})];try{const _=(0,P.watch)(A.path);d.push((0,I.toDisposable)(()=>{_.removeAllListeners(),_.close()}));const f=new Set;A.isDirectory&&C.Promises.readdir(A.path).then(l=>l.forEach(a=>f.add(a))),_.on("error",(l,a)=>{S||m(`Failed to watch ${A.path} for changes using fs.watch() (${l}, ${a})`)}),_.on("change",(l,a)=>{if(S)return;let t="";if(a&&(t=a.toString(),g.isMacintosh&&(t=(0,D.normalizeNFC)(t))),!t||l!=="change"&&l!=="rename")return;const r=A.isDirectory?(0,E.join)(A.path,t):A.path;if(A.isDirectory)if(l==="rename"){const i=h.get(r);i&&(0,I.dispose)(i);const s=setTimeout(async()=>{h.delete(r);const c=await C.Promises.exists(r);if(S)return;let v;c?f.has(t)?v="changed":(v="added",f.add(t)):(f.delete(t),v="deleted"),b(v,r)},e.CHANGE_BUFFER_DELAY);h.set(r,(0,I.toDisposable)(()=>clearTimeout(s)))}else{let i;f.has(t)?i="changed":(i="added",f.add(t)),b(i,r)}else if(l==="rename"||t!==u){const i=setTimeout(async()=>{const s=await C.Promises.exists(r);S||(s?(b("changed",r),d=[n(A,b,m)]):b("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,I.dispose)(d),d=[(0,I.toDisposable)(()=>clearTimeout(i))]}else b("changed",r)})}catch(_){C.Promises.exists(A.path).then(f=>{f&&!S&&m(`Failed to watch ${A.path} for changes using fs.watch() (${_.toString()})`)})}return(0,I.toDisposable)(()=>{S=!0,d=(0,I.dispose)(d)})}});var Le=this&&this.__decorate||function(X,e,E,P){var g=arguments.length,D=g<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,E):P,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(X,e,E,P);else for(var C=X.length-1;C>=0;C--)(I=X[C])&&(D=(g<3?I(D):g>3?I(e,E,D):I(e,E))||D);return g>3&&D&&Object.defineProperty(e,E,D),D};define(ce[36],ue([0,1,7,2,14,25,11,17,21,12,46,13,71]),function(X,e,E,P,g,D,I,C,p,w,n,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function u(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function S(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(d||(d={}));class _{constructor(M){this.buffer=M,this.pos=0}read(M){const q=this.buffer.slice(this.pos,this.pos+M);return this.pos+=q.byteLength,q}}class f{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var l;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(l||(l={}));function a(H){const M=C.VSBuffer.alloc(4);return M.writeUInt32BE(H,0),M}function t(H){return H.read(4).readUInt32BE(0)}function r(H){const M=C.VSBuffer.alloc(1);return M.writeUInt8(H,0),M}const i={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object)},s=typeof Buffer!="undefined";function c(H,M){if(typeof M=="undefined")H.write(i.Undefined);else if(typeof M=="string"){const q=C.VSBuffer.fromString(M);H.write(i.String),H.write(a(q.byteLength)),H.write(q)}else if(s&&Buffer.isBuffer(M)){const q=C.VSBuffer.wrap(M);H.write(i.Buffer),H.write(a(q.byteLength)),H.write(q)}else if(M instanceof C.VSBuffer)H.write(i.VSBuffer),H.write(a(M.byteLength)),H.write(M);else if(Array.isArray(M)){H.write(i.Array),H.write(a(M.length));for(const q of M)c(H,q)}else{const q=C.VSBuffer.fromString(JSON.stringify(M));H.write(i.Object),H.write(a(q.byteLength)),H.write(q)}}function v(H){switch(H.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return H.read(t(H)).toString();case l.Buffer:return H.read(t(H)).buffer;case l.VSBuffer:return H.read(t(H));case l.Array:{const q=t(H),z=[];for(let V=0;V<q;V++)z.push(v(H));return z}case l.Object:return JSON.parse(H.read(t(H)).toString())}}class y{constructor(M,q,z=null,V=1e3){this.protocol=M,this.ctx=q,this.logger=z,this.timeoutDelay=V,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(M,q){this.channels.set(M,q),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const q=this.send([M.type]);this.logger&&this.logger.logOutgoing(q,0,1,S(M.type));return}case 201:case 202:case 204:case 203:{const q=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(q,M.id,1,S(M.type),M.data);return}}}send(M,q=void 0){const z=new f;return c(z,M),c(z,q),this.sendBuffer(z.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(q){return 0}}onRawMessage(M){const q=new _(M),z=v(q),V=v(q),K=z[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,z[1],1,`${u(K)}: ${z[2]}.${z[3]}`,V),this.onPromise({type:K,id:z[1],channelName:z[2],name:z[3],arg:V});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,z[1],1,`${u(K)}: ${z[2]}.${z[3]}`,V),this.onEventListen({type:K,id:z[1],channelName:z[2],name:z[3],arg:V});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,z[1],1,`${u(K)}`),this.disposeActiveRequest({type:K,id:z[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,z[1],1,`${u(K)}`),this.disposeActiveRequest({type:K,id:z[1]})}}onPromise(M){const q=this.channels.get(M.channelName);if(!q){this.collectPendingRequest(M);return}const z=new D.CancellationTokenSource;let V;try{V=q.call(this.ctx,M.name,M.arg,z.token)}catch(fe){V=Promise.reject(fe)}const K=M.id;V.then(fe=>{this.sendResponse({id:K,data:fe,type:201}),this.activeRequests.delete(M.id)},fe=>{fe instanceof Error?this.sendResponse({id:K,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.sendResponse({id:K,data:fe,type:203}),this.activeRequests.delete(M.id)});const ae=(0,P.toDisposable)(()=>z.cancel());this.activeRequests.set(M.id,ae)}onEventListen(M){const q=this.channels.get(M.channelName);if(!q){this.collectPendingRequest(M);return}const z=M.id,K=q.listen(this.ctx,M.name,M.arg)(ae=>this.sendResponse({id:z,data:ae,type:204}));this.activeRequests.set(M.id,K)}disposeActiveRequest(M){const q=this.activeRequests.get(M.id);q&&(q.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let q=this.pendingRequests.get(M.channelName);q||(q=[],this.pendingRequests.set(M.channelName,q));const z=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:M,timeoutTimer:z})}flushPendingRequests(M){const q=this.pendingRequests.get(M);if(q){for(const z of q)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=y;var T;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(T=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(M,q=null){this.protocol=M,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=q}getChannel(M){const q=this;return{call(z,V,K){return q.isDisposed?Promise.reject(I.canceled()):q.requestPromise(M,z,V,K)},listen(z,V){return q.isDisposed?Promise.reject(I.canceled()):q.requestEvent(M,z,V)}}}requestPromise(M,q,z,V=D.CancellationToken.None){const K=this.lastRequestId++,fe={id:K,type:100,channelName:M,name:q,arg:z};if(V.isCancellationRequested)return Promise.reject(I.canceled());let De;return new Promise((Fe,Ne)=>{if(V.isCancellationRequested)return Ne(I.canceled());const ze=()=>{const rt=pe=>{switch(pe.type){case 201:this.handlers.delete(K),Fe(pe.data);break;case 202:this.handlers.delete(K);const Ce=new Error(pe.data.message);Ce.stack=pe.data.stack,Ce.name=pe.data.name,Ne(Ce);break;case 203:this.handlers.delete(K),Ne(pe.data);break}};this.handlers.set(K,rt),this.sendRequest(fe)};let Xe=null;this.state===d.Idle?ze():(Xe=(0,g.createCancelablePromise)(rt=>this.whenInitialized()),Xe.then(()=>{Xe=null,ze()}));const nt=()=>{Xe?(Xe.cancel(),Xe=null):this.sendRequest({id:K,type:101}),Ne(I.canceled())},it=V.onCancellationRequested(nt);De=(0,P.combinedDisposable)((0,P.toDisposable)(nt),it),this.activeRequests.add(De)}).finally(()=>{this.activeRequests.delete(De)})}requestEvent(M,q,z){const V=this.lastRequestId++,ae={id:V,type:102,channelName:M,name:q,arg:z};let fe=null;const De=new E.Emitter({onFirstListenerAdd:()=>{fe=(0,g.createCancelablePromise)(Fe=>this.whenInitialized()),fe.then(()=>{fe=null,this.activeRequests.add(De),this.sendRequest(ae)})},onLastListenerRemove:()=>{fe?(fe.cancel(),fe=null):(this.activeRequests.delete(De),this.sendRequest({id:V,type:103}))}}),Pe=Fe=>De.fire(Fe.data);return this.handlers.set(V,Pe),De.event}sendRequest(M){switch(M.type){case 100:case 102:{const q=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(q,M.id,0,`${u(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const q=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(q,M.id,0,u(M.type));return}}}send(M,q=void 0){const z=new f;return c(z,M),c(z,q),this.sendBuffer(z.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(q){return 0}}onBuffer(M){const q=new _(M),z=v(q),V=v(q),K=z[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,S(K)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,z[1],0,S(K),V),this.onResponse({type:z[0],id:z[1],data:V})}}onResponse(M){if(M.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(M.id);q&&q(M)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}Le([b.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class o{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:q,onDidClientDisconnect:z})=>{E.Event.once(q.onMessage)(K=>{const ae=new _(K),fe=v(ae),De=new y(q,fe),Pe=new R(q);this.channels.forEach((Ne,ze)=>De.registerChannel(ze,Ne));const Fe={channelServer:De,channelClient:Pe,ctx:fe};this._connections.add(Fe),this._onDidAddConnection.fire(Fe),z(()=>{De.dispose(),Pe.dispose(),this._connections.delete(Fe),this._onDidRemoveConnection.fire(Fe)})})})}get connections(){const M=[];return this._connections.forEach(q=>M.push(q)),M}getChannel(M,q){const z=this;return{call(V,K,ae){let fe;if((0,w.isFunction)(q)){let Pe=(0,p.getRandomElement)(z.connections.filter(q));fe=Pe?Promise.resolve(Pe):E.Event.toPromise(E.Event.filter(z.onDidAddConnection,q))}else fe=q.routeCall(z,V,K);const De=fe.then(Pe=>Pe.channelClient.getChannel(M));return O(De).call(V,K,ae)},listen(V,K){if((0,w.isFunction)(q))return z.getMulticastEvent(M,q,V,K);const ae=q.routeEvent(z,V,K).then(fe=>fe.channelClient.getChannel(M));return O(ae).listen(V,K)}}}getMulticastEvent(M,q,z,V){const K=this;let ae=new P.DisposableStore;const fe=new E.Emitter({onFirstListenerAdd:()=>{ae=new P.DisposableStore;const De=new E.EventMultiplexer,Pe=new Map,Fe=ze=>{const nt=ze.channelClient.getChannel(M).listen(z,V),it=De.add(nt);Pe.set(ze,it)},Ne=ze=>{const Xe=Pe.get(ze);!Xe||(Xe.dispose(),Pe.delete(ze))};K.connections.filter(q).forEach(Fe),E.Event.filter(K.onDidAddConnection,q)(Fe,void 0,ae),K.onDidRemoveConnection(Ne,void 0,ae),De.event(fe.fire,fe,ae),ae.add(De)},onLastListenerRemove:()=>{ae.dispose()}});return fe.event}registerChannel(M,q){this.channels.set(M,q),this._connections.forEach(z=>{z.channelServer.registerChannel(M,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=o;class k{constructor(M,q,z=null){const V=new f;c(V,q),M.send(V.buffer),this.channelClient=new R(M,z),this.channelServer=new y(M,q,z)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,q){this.channelServer.registerChannel(M,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=k;function O(H){return{call(M,q,z){return H.then(V=>V.call(M,q,z))},listen(M,q){const z=new E.Relay;return H.then(V=>z.input=V.listen(M,q)),z.event}}}e.getDelayedChannel=O;function Y(H){let M=!1;return{call(q,z,V){return M?H.call(q,z,V):(0,g.timeout)(0).then(()=>M=!0).then(()=>H.call(q,z,V))},listen(q,z){if(M)return H.listen(q,z);const V=new E.Relay;return(0,g.timeout)(0).then(()=>M=!0).then(()=>V.input=H.listen(q,z)),V.event}}}e.getNextTickChannel=Y;class Q{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const q of M.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await E.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=Q;var me;(function(H){function M(V,K){const ae=V,fe=K&&K.disableMarshalling,De=new Map;for(const Pe in ae)z(Pe)&&De.set(Pe,E.Event.buffer(ae[Pe],!0));return new class{listen(Pe,Fe){const Ne=De.get(Fe);if(Ne)return Ne;throw new Error(`Event not found: ${Fe}`)}call(Pe,Fe,Ne){const ze=ae[Fe];if(typeof ze=="function"){if(!fe&&Array.isArray(Ne))for(let Xe=0;Xe<Ne.length;Xe++)Ne[Xe]=(0,n.revive)(Ne[Xe]);return ze.apply(ae,Ne)}throw new Error(`Method not found: ${Fe}`)}}}H.fromService=M;function q(V,K){const ae=K&&K.disableMarshalling;return new Proxy({},{get(fe,De){if(typeof De=="string")return K?.properties?.has(De)?K.properties.get(De):z(De)?V.listen(De):async function(...Pe){let Fe;K&&!(0,w.isUndefinedOrNull)(K.context)?Fe=[K.context,...Pe]:Fe=Pe;const Ne=await V.call(De,Fe);return ae?Ne:(0,n.revive)(Ne)};throw new Error(`Property not found: ${String(De)}`)}})}H.toService=q;function z(V){return V[0]==="o"&&V[1]==="n"&&A.isUpperAsciiLetter(V.charCodeAt(2))}})(me=e.ProxyChannel||(e.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let M=H.toString();if(M!=="[object Object]")return M}return H}function W(H){return Array.isArray(H)?H.map(N):N(H)}function U(H,M,q,z,V,K,ae){ae=W(ae);const fe=re[V],De=fe[z%fe.length];let Pe=[`%c[${H}]%c[${String(M).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${De}`];/\($/.test(K)?(Pe=Pe.concat(ae),Pe.push(")")):Pe.push(ae),console.log.apply(console,Pe)}e.logWithColors=U;class j{constructor(M,q){this._outgoingPrefix=M,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,q,z,V,K){this._totalOutgoing+=M,U(this._outgoingPrefix,this._totalOutgoing,M,q,z,V,K)}logIncoming(M,q,z,V,K){this._totalIncoming+=M,U(this._incomingPrefix,this._totalIncoming,M,q,z,V,K)}}e.IPCLogger=j}),define(ce[82],ue([0,1,7,36,2,17,4,23]),function(X,e,E,P,g,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var p;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function n(){return w||(w=D.VSBuffer.alloc(0)),w}class A{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,c){if(s===0)return n();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const R=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=s),R}if(this._chunks[0].byteLength>s){const R=this._chunks[0].slice(0,s);return c&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),R}let v=D.VSBuffer.alloc(s),y=0,T=0;for(;s>0;){const R=this._chunks[T];if(R.byteLength>s){const o=R.slice(0,s);v.set(o,y),y+=s,c&&(this._chunks[T]=R.slice(s),this._totalLength-=s),s-=s}else v.set(R,y),y+=R.byteLength,c?(this._chunks.shift(),this._totalLength-=R.byteLength):T++,s-=R.byteLength}return v}}e.ChunkStream=A;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(b||(b={}));var m;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(s,c,v,y){this.type=s,this.id=c,this.ack=v,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends g.Disposable{constructor(s){super();this._onMessage=this._register(new E.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new A,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5);else{const v=this._state.messageType,y=this._state.id,T=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new u(v,y,T,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=D.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this._writeSoon(c,s.data)}_bufferAdd(s,c){const v=this._totalLength===0;return this._data.push(s,c),this._totalLength+=s.byteLength+c.byteLength,v}_bufferTake(){const s=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,c){this._bufferAdd(s,c)&&I.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class d extends g.Disposable{constructor(s){super();this._onMessage=new E.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new u(1,0,0,s))}}e.Protocol=d;class _ extends P.IPCClient{constructor(s,c,v=null){super(s,c,v);this.protocol=s}static fromSocket(s,c){return new _(new d(s),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=_;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new E.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,C.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class l{constructor(s){this.data=s,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],c=0,v=this._first;for(;v;)s[c++]=v.data,v=v.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const c=new l(s);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class t{constructor(){this.lastRuns=[];const s=Date.now();for(let c=0;c<t._HISTORY_LENGTH;c++)this.lastRuns[c]=s-1e3*c;setInterval(()=>{for(let c=t._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const s=Date.now(),c=(1+t._HISTORY_LENGTH)*1e3;let v=0;for(let y=0;y<t._HISTORY_LENGTH;y++)s-this.lastRuns[y]<=c&&v++;return 1-v/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(s,c=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),c&&this._socketReader.acceptChunk(c),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,g.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new u(5,0,0,n());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const c=new u(4,0,0,n());this._socketWriter.write(c),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,c){this._isReconnecting=!0,this._socketDisposables=(0,g.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let c=0,v=s.length;c<v;c++)this._socketWriter.write(s[c]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new u(6,0,0,n())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const c=this._outgoingUnackMsg.toArray();for(let v=0,y=c.length;v<y;v++)this._socketWriter.write(c[v]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const v=new u(1,c,this._incomingAckId,s);this._outgoingUnackMsg.push(v),this._isReconnecting||(this._socketWriter.write(v),this._recvAckCheck())}sendControl(s){const c=new u(2,0,0,s);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const s=this._outgoingUnackMsg.peek(),c=Date.now()-s.writtenTime;if(c>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-c,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new u(3,0,this._incomingAckId,n());this._socketWriter.write(s)}}e.PersistentProtocol=r}),define(ce[128],ue([0,1,2,7,14,12]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var I;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(I=e.StorageHint||(e.StorageHint={}));var C;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(C||(C={}));class p extends E.Disposable{constructor(A,b=Object.create(null)){super();this.database=A,this.options=b,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new g.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(A=>this.onDidChangeItemsExternal(A)))}onDidChangeItemsExternal(A){A.changed?.forEach((b,m)=>this.accept(m,b)),A.deleted?.forEach(b=>this.accept(b,void 0))}accept(A,b){if(this.state===C.Closed)return;let m=!1;(0,D.isUndefinedOrNull)(b)?m=this.cache.delete(A):this.cache.get(A)!==b&&(this.cache.set(A,b),m=!0),m&&this._onDidChangeStorage.fire(A)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(A,b){const m=this.cache.get(A);return(0,D.isUndefinedOrNull)(m)?b:m}getBoolean(A,b){const m=this.get(A);return(0,D.isUndefinedOrNull)(m)?b:m==="true"}getNumber(A,b){const m=this.get(A);return(0,D.isUndefinedOrNull)(m)?b:parseInt(m,10)}async set(A,b){if(this.state===C.Closed)return;if((0,D.isUndefinedOrNull)(b))return this.delete(A);const m=String(b);if(this.cache.get(A)!==m)return this.cache.set(A,m),this.pendingInserts.set(A,m),this.pendingDeletes.delete(A),this._onDidChangeStorage.fire(A),this.flushDelayer.trigger(()=>this.flushPending())}async delete(A){if(!(this.state===C.Closed||!this.cache.delete(A)))return this.pendingDeletes.has(A)||this.pendingDeletes.add(A),this.pendingInserts.delete(A),this._onDidChangeStorage.fire(A),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(A){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const A={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(A).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(A=>this.whenFlushedCallbacks.push(A))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class w{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(A){A.insert&&A.insert.forEach((b,m)=>this.items.set(m,b)),A.delete&&A.delete.forEach(b=>this.items.delete(b))}async close(){}}e.InMemoryStorageDatabase=w}),define(ce[83],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(g,D){this.lineNumber=g,this.column=D}with(g=this.lineNumber,D=this.column){return g===this.lineNumber&&D===this.column?this:new E(g,D)}delta(g=0,D=0){return this.with(this.lineNumber+g,this.column+D)}equals(g){return E.equals(this,g)}static equals(g,D){return!g&&!D?!0:!!g&&!!D&&g.lineNumber===D.lineNumber&&g.column===D.column}isBefore(g){return E.isBefore(this,g)}static isBefore(g,D){return g.lineNumber<D.lineNumber?!0:D.lineNumber<g.lineNumber?!1:g.column<D.column}isBeforeOrEqual(g){return E.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,D){return g.lineNumber<D.lineNumber?!0:D.lineNumber<g.lineNumber?!1:g.column<=D.column}static compare(g,D){let I=g.lineNumber|0,C=D.lineNumber|0;if(I===C){let p=g.column|0,w=D.column|0;return p-w}return I-C}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new E(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}}e.Position=E}),define(ce[55],ue([0,1,83]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class P{constructor(D,I,C,p){D>C||D===C&&I>p?(this.startLineNumber=C,this.startColumn=p,this.endLineNumber=D,this.endColumn=I):(this.startLineNumber=D,this.startColumn=I,this.endLineNumber=C,this.endColumn=p)}isEmpty(){return P.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return P.containsPosition(this,D)}static containsPosition(D,I){return!(I.lineNumber<D.startLineNumber||I.lineNumber>D.endLineNumber||I.lineNumber===D.startLineNumber&&I.column<D.startColumn||I.lineNumber===D.endLineNumber&&I.column>D.endColumn)}containsRange(D){return P.containsRange(this,D)}static containsRange(D,I){return!(I.startLineNumber<D.startLineNumber||I.endLineNumber<D.startLineNumber||I.startLineNumber>D.endLineNumber||I.endLineNumber>D.endLineNumber||I.startLineNumber===D.startLineNumber&&I.startColumn<D.startColumn||I.endLineNumber===D.endLineNumber&&I.endColumn>D.endColumn)}strictContainsRange(D){return P.strictContainsRange(this,D)}static strictContainsRange(D,I){return!(I.startLineNumber<D.startLineNumber||I.endLineNumber<D.startLineNumber||I.startLineNumber>D.endLineNumber||I.endLineNumber>D.endLineNumber||I.startLineNumber===D.startLineNumber&&I.startColumn<=D.startColumn||I.endLineNumber===D.endLineNumber&&I.endColumn>=D.endColumn)}plusRange(D){return P.plusRange(this,D)}static plusRange(D,I){let C,p,w,n;return I.startLineNumber<D.startLineNumber?(C=I.startLineNumber,p=I.startColumn):I.startLineNumber===D.startLineNumber?(C=I.startLineNumber,p=Math.min(I.startColumn,D.startColumn)):(C=D.startLineNumber,p=D.startColumn),I.endLineNumber>D.endLineNumber?(w=I.endLineNumber,n=I.endColumn):I.endLineNumber===D.endLineNumber?(w=I.endLineNumber,n=Math.max(I.endColumn,D.endColumn)):(w=D.endLineNumber,n=D.endColumn),new P(C,p,w,n)}intersectRanges(D){return P.intersectRanges(this,D)}static intersectRanges(D,I){let C=D.startLineNumber,p=D.startColumn,w=D.endLineNumber,n=D.endColumn,A=I.startLineNumber,b=I.startColumn,m=I.endLineNumber,u=I.endColumn;return C<A?(C=A,p=b):C===A&&(p=Math.max(p,b)),w>m?(w=m,n=u):w===m&&(n=Math.min(n,u)),C>w||C===w&&p>n?null:new P(C,p,w,n)}equalsRange(D){return P.equalsRange(this,D)}static equalsRange(D,I){return!!D&&!!I&&D.startLineNumber===I.startLineNumber&&D.startColumn===I.startColumn&&D.endLineNumber===I.endLineNumber&&D.endColumn===I.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(D){return new E.Position(D.endLineNumber,D.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(D){return new E.Position(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,I){return new P(this.startLineNumber,this.startColumn,D,I)}setStartPosition(D,I){return new P(D,I,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(D){return new P(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}static fromPositions(D,I=D){return new P(D.lineNumber,D.column,I.lineNumber,I.column)}static lift(D){return D?new P(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,I){return!(D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<I.startColumn||I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<D.startColumn)}static areIntersecting(D,I){return!(D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<=I.startColumn||I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,I){if(D&&I){const w=D.startLineNumber|0,n=I.startLineNumber|0;if(w===n){const A=D.startColumn|0,b=I.startColumn|0;if(A===b){const m=D.endLineNumber|0,u=I.endLineNumber|0;if(m===u){const h=D.endColumn|0,S=I.endColumn|0;return h-S}return m-u}return A-b}return w-n}return(D?1:0)-(I?1:0)}static compareRangesUsingEnds(D,I){return D.endLineNumber===I.endLineNumber?D.endColumn===I.endColumn?D.startLineNumber===I.startLineNumber?D.startColumn-I.startColumn:D.startLineNumber-I.startLineNumber:D.endColumn-I.endColumn:D.endLineNumber-I.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}}e.Range=P}),define(ce[129],ue([0,1,47,5]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function g(D,I,C,p){if(Array.isArray(D)){let w=0;for(const n of D){const A=g(n,I,C,p);if(A===10)return A;A>w&&(w=A)}return w}else{if(typeof D=="string")return p?D==="*"?5:D===C?10:0:0;if(D){const{language:w,pattern:n,scheme:A,hasAccessToAllModels:b}=D;if(!p&&!b)return 0;let m=0;if(A)if(A===I.scheme)m=10;else if(A==="*")m=5;else return 0;if(w)if(w===C)m=10;else if(w==="*")m=Math.max(m,5);else return 0;if(n){let u;if(typeof n=="string"?u=n:u={...n,base:(0,P.normalize)(n.base)},u===I.fsPath||(0,E.match)(u,I.fsPath))m=10;else return 0}return m}else return 0}}e.score=g}),define(ce[130],ue([0,1,7,2]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class g{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,C){return this._map.set(I,C),this.fire([I]),(0,P.toDisposable)(()=>{this._map.get(I)===C&&(this._map.delete(I),this.fire([I]))})}registerPromise(I,C){let p=null,w=!1;return this._promises.set(I,C.then(n=>{this._promises.delete(I),!(w||!n)&&(p=this.register(I,n))})),(0,P.toDisposable)(()=>{w=!0,p&&p.dispose()})}getPromise(I){const C=this.get(I);if(C)return Promise.resolve(C);const p=this._promises.get(I);return p?p.then(w=>this.get(I)):null}get(I){return this._map.get(I)||null}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=g}),define(ce[131],ue([9,10]),function(X,e){return X.create("vs/base/common/date",e)}),define(ce[132],ue([0,1,131]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const P=60,g=P*60,D=g*24,I=D*7,C=D*30,p=D*365;function w(A,b){typeof A!="number"&&(A=A.getTime());const m=Math.round((new Date().getTime()-A)/1e3);if(m<-30)return(0,E.localize)(0,null,w(new Date().getTime()+m*1e3,!1));if(m<30)return(0,E.localize)(1,null);let u;return m<P?(u=m,b?u===1?(0,E.localize)(2,null,u):(0,E.localize)(3,null,u):u===1?(0,E.localize)(4,null,u):(0,E.localize)(5,null,u)):m<g?(u=Math.floor(m/P),b?u===1?(0,E.localize)(6,null,u):(0,E.localize)(7,null,u):u===1?(0,E.localize)(8,null,u):(0,E.localize)(9,null,u)):m<D?(u=Math.floor(m/g),b?u===1?(0,E.localize)(10,null,u):(0,E.localize)(11,null,u):u===1?(0,E.localize)(12,null,u):(0,E.localize)(13,null,u)):m<I?(u=Math.floor(m/D),b?u===1?(0,E.localize)(14,null,u):(0,E.localize)(15,null,u):u===1?(0,E.localize)(16,null,u):(0,E.localize)(17,null,u)):m<C?(u=Math.floor(m/I),b?u===1?(0,E.localize)(18,null,u):(0,E.localize)(19,null,u):u===1?(0,E.localize)(20,null,u):(0,E.localize)(21,null,u)):m<p?(u=Math.floor(m/C),b?u===1?(0,E.localize)(22,null,u):(0,E.localize)(23,null,u):u===1?(0,E.localize)(24,null,u):(0,E.localize)(25,null,u)):(u=Math.floor(m/p),b?u===1?(0,E.localize)(26,null,u):(0,E.localize)(27,null,u):u===1?(0,E.localize)(28,null,u):(0,E.localize)(29,null,u))}e.fromNow=w;function n(A){return A.getFullYear()+"-"+String(A.getMonth()+1).padStart(2,"0")+"-"+String(A.getDate()).padStart(2,"0")+"T"+String(A.getHours()).padStart(2,"0")+":"+String(A.getMinutes()).padStart(2,"0")+":"+String(A.getSeconds()).padStart(2,"0")+"."+(A.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(ce[133],ue([9,10]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ce[43],ue([0,1,133,12,21]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function D(w,n){return n&&(w.stack||w.stacktrace)?E.localize(0,null,C(w),I(w.stack)||I(w.stacktrace)):C(w)}function I(w){return Array.isArray(w)?w.join(`
`):w}function C(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?E.localize(1,null,w.message):w.message||E.localize(2,null)}function p(w=null,n=!1){if(!w)return E.localize(3,null);if(Array.isArray(w)){const A=g.coalesce(w),b=p(A[0],n);return A.length>1?E.localize(4,null,b,A.length):b}if(P.isString(w))return w;if(w.detail){const A=w.detail;if(A.error)return D(A.error,n);if(A.exception)return D(A.exception,n)}return w.stack?D(w,n):w.message?w.message:E.localize(5,null)}e.toErrorMessage=p}),define(ce[134],ue([9,10]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(ce[135],ue([0,1,134]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function P(g){switch(g){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=P}),define(ce[136],ue([9,10]),function(X,e){return X.create("vs/base/node/processes",e)}),define(ce[84],ue([0,1,5,16,35,136,23,12,18,31,4,76,8]),function(X,e,E,P,g,D,I,C,p,w,n,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(l,a){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const r=g.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],t);return new Promise(i=>{r.once("error",s=>{i({success:!1,error:s})}),r.once("exit",(s,c)=>{i(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(r=>{g.execFile(t,[l.pid.toString()],{encoding:"utf8",shell:!0},(i,s,c)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function h(l=I.env){return l.comspec||"cmd.exe"}e.getWindowsShell=h;class S{constructor(a,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=a,this.args=t,this.shell=r,this.options=i;else{const s=a;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(I.env).forEach(c=>{s[c]=I.env[c]}),Object.keys(this.options.env).forEach(c=>{s[c]=this.options.env[c]}),this.options.env=s}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(E.sep);return t!==-1&&(a=a.substring(t+1)),S.WellKnowCommands[a]?a:"other"}start(a){return n.isWindows&&(this.options&&this.options.cwd&&w.isUNC(this.options.cwd)||!this.options&&w.isUNC(I.cwd()))?Promise.reject(new Error(D.localize(0,null))):this.useExec().then(t=>{let r,i;const s=new Promise((c,v)=>{r=c,i=v});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=g.exec(c,this.options,(v,y,T)=>{this.childProcess=null;const R=v;R&&R.killed?i({killed:this.terminateRequested,stdout:y.toString(),stderr:T.toString()}):this.handleExec(r,a,v,y,T)})}else{let c=null;const v=y=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(y,r,a,i);const T={terminated:this.terminateRequested};C.isNumber(y)&&(T.cmdCode=y),r(T)};if(this.shell&&n.isWindows){const y=p.deepClone(this.options);y.windowsVerbatimArguments=!0,y.detached=!1;let T=!1,R=!1;const o=[];let k=this.ensureQuotes(this.cmd);o.push(k.value),T=k.quoted,this.args&&this.args.forEach(Y=>{k=this.ensureQuotes(Y),o.push(k.value),R=R&&k.quoted});const O=["/s","/c"];T?R?O.push('"'+o.join(" ")+'"'):o.length>1?O.push('"'+o[0]+'" '+o.slice(1).join(" ")):O.push('"'+o[0]+'"'):O.push(o.join(" ")),c=g.spawn(h(),O,y)}else this.cmd&&(c=g.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(C.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",y=>{this.childProcess=null,i({terminated:this.terminateRequested,error:y})}),c.pid&&(this.childProcess.on("close",v),this.handleSpawn(c,r,a,i,!0)))}return s})}handleClose(a,t,r,i){}ensureQuotes(a){return S.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,u(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!n.isWindows)return a(!1);const t=g.spawn(h(),["/s","/c"]);t.on("error",r=>a(!0)),t.on("exit",r=>a(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class d extends S{constructor(a,t,r,i){super(a,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,r,i,s){[i,s].forEach((c,v)=>{const y=new A.LineDecoder;y.write(c).forEach(o=>{t({line:o,source:v===0?0:1})});const R=y.end();R&&t({line:R,source:v===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,t,r,i,s){const c=new A.LineDecoder,v=new A.LineDecoder;a.stdout.on("data",y=>{c.write(y).forEach(R=>r({line:R,source:0}))}),a.stderr.on("data",y=>{v.write(y).forEach(R=>r({line:R,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=v}handleClose(a,t,r,i){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=d;function _(l){let a=[],t=!1;const r=function(i){if(t){a.push(i);return}(!l.send(i,c=>{if(c&&console.error(c),t=!1,a.length>0){const v=a.slice(0);a=[],v.forEach(y=>r(y))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=_;var f;(function(l){async function a(t,r,i){if(E.isAbsolute(t))return t;if(r===void 0&&(r=I.cwd()),E.dirname(t)!=="."||(i===void 0&&C.isString(I.env.PATH)&&(i=I.env.PATH.split(E.delimiter)),i===void 0||i.length===0))return E.join(r,t);async function c(v){return await P.Promises.exists(v)?!(await P.Promises.stat(v)).isDirectory():!1}for(let v of i){let y;if(E.isAbsolute(v)?y=E.join(v,t):y=E.join(r,v,t),await c(y))return y;let T=y+".com";if(await c(T)||(T=y+".exe",await c(T)))return T}return E.join(r,t)}l.findExecutable=a})(f=e.win32||(e.win32={}))}),define(ce[137],ue([0,1,24,4,80,84]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function I(m,u){return m===1?P.isWindows?A():D.getWindowsShell(u):w(m,u)}e.getSystemShell=I;function C(m,u){return m===1?P.isWindows?b(u):D.getWindowsShell(u):w(m,u)}e.getSystemShellSync=C;let p=null;function w(m,u){if(P.isLinux&&m===2||P.isMacintosh&&m===3)return"/bin/bash";if(!p){let h;if(P.isWindows)h="/bin/bash";else{if(h=u.SHELL,!h)try{h=(0,E.userInfo)().shell}catch(S){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}p=h}return p}let n=null;async function A(){return n||(n=(await(0,g.getFirstAvailablePowerShellInstallation)()).exePath),n}function b(m){if(n)return n;const u=P.isWindows&&parseFloat((0,E.release)())>=10,h=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${m.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?S:D.getWindowsShell(m)}}),define(ce[56],ue([0,1,35,2,14,18,7,84,36,119,25,11,17,4]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends p.ChannelServer{constructor(d){super({send:_=>{try{process.send&&process.send(_.buffer.toString("base64"))}catch(f){}},onMessage:I.Event.fromNodeEventEmitter(process,"message",_=>b.VSBuffer.wrap(Buffer.from(_,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=u;class h{constructor(d,_){this.modulePath=d,this.options=_,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=_&&_.timeout?_.timeout:6e4;this.disposeDelayer=new g.Delayer(f),this.child=null,this._client=null}getChannel(d){const _=this;return{call(f,l,a){return _.requestPromise(d,f,l,a)},listen(f,l){return _.requestEvent(d,f,l)}}}requestPromise(d,_,f,l=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(A.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(d),t=(0,g.createCancelablePromise)(s=>a.call(_,f,s)),r=l.onCancellationRequested(()=>t.cancel()),i=(0,P.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(d,_,f){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let l;const a=new I.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(d).listen(_,f)(a.fire,a),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],_=Object.create(null);_.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(_.env={..._.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(_.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(_.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(_.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),_.execArgv===void 0&&(_.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),m.isMacintosh&&_.env&&delete _.env.DYLD_LIBRARY_PATH,this.child=(0,E.fork)(this.modulePath,d,_);const f=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,w.isRemoteConsoleLog)(c)){(0,w.log)(c,`IPC Library: ${this.options.serverName}`);return}f.fire(b.VSBuffer.wrap(Buffer.from(c,"base64")))});const a=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&a.send(c.buffer.toString("base64")),r=f.event,i={send:t,onMessage:r};this._client=new p.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,v)=>{process.removeListener("exit",s),this.activeRequests.forEach(y=>(0,P.dispose)(y)),this.activeRequests.clear(),c!==0&&v!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+v),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:v})})}return this._client}getCachedChannel(d){let _=this.channels.get(d);return _||(_=this.client.getChannel(d),this.channels.set(d,_)),_}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(ce[138],ue([9,10]),function(X,e){return X.create("vs/base/node/zip",e)}),define(ce[139],ue([9,10]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ce[140],ue([9,10]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(ce[141],ue([9,10]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(ce[142],ue([9,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ce[143],ue([9,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ce[144],ue([9,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(ce[145],ue([9,10]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ce[146],ue([9,10]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ce[147],ue([9,10]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ce[148],ue([9,10]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ce[149],ue([9,10]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(ce[150],ue([9,10]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ce[151],ue([9,10]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(ce[152],ue([9,10]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ce[153],ue([9,10]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(ce[154],ue([9,10]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(ce[155],ue([9,10]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(ce[156],ue([9,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ce[157],ue([9,10]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(ce[158],ue([9,10]),function(X,e){return X.create("vs/server/remoteAgentEnvironmentImpl",e)}),define(ce[159],ue([9,10]),function(X,e){return X.create("vs/server/serverEnvironmentService",e)}),define(ce[160],ue([9,10]),function(X,e){return X.create("vs/workbench/common/editor",e)}),define(ce[161],ue([9,10]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ce[162],ue([9,10]),function(X,e){return X.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(ce[163],ue([0,1,7,2]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class g{constructor(){this._onCloseEmitter=new E.Emitter,this._onReloadEmitter=new E.Emitter,this._onTerminateEmitter=new E.Emitter,this._onAttachEmitter=new E.Emitter}call(C,p,w){switch(p){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(C,p,w){switch(p){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=g,g.ChannelName="extensionhostdebugservice";class D extends P.Disposable{constructor(C){super();this.channel=C}reload(C){this.channel.call("reload",[C])}get onReload(){return this.channel.listen("reload")}close(C){this.channel.call("close",[C])}get onClose(){return this.channel.listen("close")}attachSession(C,p,w){this.channel.call("attach",[C,p,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(C,p){this.channel.call("terminate",[C,p])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(C,p,w){return this.channel.call("openExtensionDevelopmentHostWindow",[C,p||{},w])}}e.ExtensionHostDebugChannelClient=D}),define(ce[164],ue([0,1,3]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class P{constructor(I){this.service=I}listen(I,C,p){throw new Error("Invalid listen")}call(I,C,p){switch(C){case"download":return this.service.download(E.URI.revive(p[0]),E.URI.revive(p[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=P;class g{constructor(I,C){this.channel=I,this.getUriTransformer=C}async download(I,C){const p=this.getUriTransformer();p&&(I=p.transformOutgoingURI(I),C=p.transformOutgoingURI(C)),await this.channel.call("download",[I,C])}}e.DownloadServiceChannelClient=g}),define(ce[165],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var E;(function(I){I[I.ACTIVATE=1]="ACTIVATE",I[I.RESTORE=2]="RESTORE",I[I.PRESERVE=3]="PRESERVE"})(E=e.EditorActivation||(e.EditorActivation={}));var P;(function(I){I[I.PICK=0]="PICK",I[I.DISABLED=1]="DISABLED",I[I.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(P=e.EditorResolution||(e.EditorResolution={}));var g;(function(I){I[I.API=0]="API",I[I.USER=1]="USER"})(g=e.EditorOpenContext||(e.EditorOpenContext={}));var D;(function(I){I[I.Center=0]="Center",I[I.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",I[I.NearTop=2]="NearTop",I[I.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(D=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ce[166],ue([0,1,5,19,71,132,8,3,23]),function(X,e,E,P,g,D,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(u,h,S){this._args=u,this.paths=h,this.productService=S}get appRoot(){return(0,E.dirname)(I.FileAccess.asFileUri("",X).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file((0,E.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,E.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,E.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(C.URI.file((0,E.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return C.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return C.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=p.env.VSCODE_PORTABLE;return u?C.URI.file((0,E.join)(u,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,E.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,E.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,E.resolve)(u):(0,E.normalize)((0,E.join)(I.FileAccess.asFileUri("",X).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,E.resolve)(u):(0,E.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,E.resolve)(u);const h=p.env.VSCODE_EXTENSIONS;if(h)return h;const S=p.env.VSCODE_PORTABLE;return S?(0,E.join)(S,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(h=>/^[^:/?#]+?:\/\//.test(h)?C.URI.parse(h):C.URI.file((0,E.normalize)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?C.URI.parse(u):C.URI.file((0,E.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!p.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return C.URI.file((0,E.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}Le([g.memoize],w.prototype,"appRoot",null),Le([g.memoize],w.prototype,"userHome",null),Le([g.memoize],w.prototype,"userDataPath",null),Le([g.memoize],w.prototype,"appSettingsHome",null),Le([g.memoize],w.prototype,"tmpDir",null),Le([g.memoize],w.prototype,"userRoamingDataHome",null),Le([g.memoize],w.prototype,"settingsResource",null),Le([g.memoize],w.prototype,"userDataSyncHome",null),Le([g.memoize],w.prototype,"userDataSyncLogResource",null),Le([g.memoize],w.prototype,"sync",null),Le([g.memoize],w.prototype,"machineSettingsResource",null),Le([g.memoize],w.prototype,"globalStorageHome",null),Le([g.memoize],w.prototype,"workspaceStorageHome",null),Le([g.memoize],w.prototype,"keybindingsResource",null),Le([g.memoize],w.prototype,"keyboardLayoutResource",null),Le([g.memoize],w.prototype,"argvResource",null),Le([g.memoize],w.prototype,"snippetsHome",null),Le([g.memoize],w.prototype,"isExtensionDevelopment",null),Le([g.memoize],w.prototype,"untitledWorkspacesHome",null),Le([g.memoize],w.prototype,"installSourcePath",null),Le([g.memoize],w.prototype,"builtinExtensionsPath",null),Le([g.memoize],w.prototype,"extensionsPath",null),Le([g.memoize],w.prototype,"extensionDevelopmentLocationURI",null),Le([g.memoize],w.prototype,"extensionDevelopmentKind",null),Le([g.memoize],w.prototype,"extensionTestsLocationURI",null),Le([g.memoize],w.prototype,"debugExtensionHost",null),Le([g.memoize],w.prototype,"serviceMachineIdResource",null),Le([g.memoize],w.prototype,"telemetryLogResource",null),Le([g.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function n(m,u){return b(m["inspect-extensions"],m["inspect-brk-extensions"],5870,u,m.debugId)}e.parseExtensionHostPort=n;function A(m,u){return b(m["inspect-search"],m["inspect-brk-search"],5876,u)}e.parseSearchPort=A;function b(m,u,h,S,d){const f=Number(u||m)||(S?null:h),l=f?Boolean(!!u):!1;return{port:f,break:l,debugId:d}}}),define(ce[57],ue([0,1,243,140,4]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,P.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(14,null)},category:{type:"string",cat:"e",description:(0,P.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,P.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,P.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,P.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,P.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,P.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,P.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,P.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,P.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,P.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,P.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{}};function C(u,h,S=I){const d={},_=[],f=[];for(let r in h){const i=h[r];i.alias&&(d[r]=i.alias),i.type==="string"||i.type==="string[]"?(_.push(r),i.deprecates&&_.push(i.deprecates)):i.type==="boolean"&&(f.push(r),i.deprecates&&f.push(i.deprecates))}const l=E(u,{string:_,boolean:f,alias:d}),a={},t=l;a._=l._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in h){const i=h[r];i.alias&&delete t[i.alias];let s=t[r];i.deprecates&&t.hasOwnProperty(i.deprecates)&&(s||(s=t[i.deprecates]),delete t[i.deprecates]),typeof s!="undefined"&&(i.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):i.type==="string"&&Array.isArray(s)&&(s=s.pop(),S.onMultipleValues(r,s)),a[r]=s),delete t[r]}for(let r in t)S.onUnknownOption(r);return a}e.parseArgs=C;function p(u,h){let S="";return h.args&&(Array.isArray(h.args)?S=` <${h.args.join("> <")}>`:S=` <${h.args}>`),h.alias?`-${h.alias} --${u}${S}`:`--${u}${S}`}function w(u,h){let S=0,d=[];for(const a in u){const t=u[a],r=p(a,t);S=Math.max(S,r.length),d.push([r,t.description])}let _=S+2+1;if(h-_<25)return d.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let f=h-_-1,l=[];for(const a of d){let t=a[0],r=A(a[1],f),i=n(_-t.length-2);l.push("  "+t+i+r[0]);for(let s=1;s<r.length;s++)l.push(n(_)+r[s])}return l}e.formatOptions=w;function n(u){return" ".repeat(u)}function A(u,h){let S=[];for(;u.length;){let d=u.length<h?u.length:u.lastIndexOf(" ",h),_=u.slice(0,d).trim();u=u.slice(d),S.push(_)}return S}function b(u,h,S,d,_=!0){const f=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${u} ${S}`];l.push(""),l.push(`${(0,P.localize)(32,null)}: ${h} [${(0,P.localize)(33,null)}][${(0,P.localize)(34,null)}...]`),l.push(""),_&&(g.isWindows?l.push((0,P.localize)(35,null,h)):l.push((0,P.localize)(36,null,h)),l.push(""));const a={};for(const t in d){const r=d[t];if(r.description&&r.cat){let i=a[r.cat];i||(a[r.cat]=i={}),i[t]=r}}for(let t in a){const r=t;let i=a[r];i&&(l.push(D[r]),l.push(...w(i,f)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=b;function m(u,h){return`${u||(0,P.localize)(37,null)}
${h||(0,P.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=m}),function(){"use strict";function X(e,E,P,g){function D(C){const p=I(C),w=[p];return e.isAbsolute(p)||w.unshift(g),e.resolve(...w)}function I(C){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,P);const n=C["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const A=process.env.USERPROFILE;if(typeof A!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(A,"AppData","Roaming")}break;case"darwin":w=e.join(E.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,P)}return{getUserDataPath:D}}if(typeof define=="function")define(ce[167],ue([0,77,24,8,19,23]),function(e,E,P,g,D,I){const C=D.dirname(g.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(D.joinPath(C,"package.json").fsPath);return X(E,P,p.name,I.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),E=require("path"),P=require("os");module.exports=X(E,P,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[168],ue([0,1,24,167,166]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends g.AbstractNativeEnvironmentService{constructor(C,p){super(C,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,P.getUserDataPath)(C)},p)}}e.NativeEnvironmentService=D}),define(ce[169],ue([0,1,7,3,54,18,2]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(u,h){return P.URI.revive(h?h.transformIncoming(u):u)}function p(u,h){return h?h.transformOutgoingURI(u):u}function w(u,h){h=h||g.DefaultURITransformer;const S=u.manifest;return{...(0,g.transformAndReviveIncomingURIs)({...u,manifest:void 0},h),manifest:S}}function n(u,h){return h?(0,D.cloneAndChange)(u,S=>S instanceof P.URI?h.transformOutgoingURI(S):void 0):u}class A{constructor(h,S){this.service=h,this.getUriTransformer=S,this.onInstallExtension=E.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=E.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=E.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=E.Event.buffer(h.onDidUninstallExtension,!0)}listen(h,S){const d=this.getUriTransformer(h);switch(S){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return E.Event.map(this.onDidInstallExtensions,_=>_.map(f=>({...f,local:f.local?n(f.local,d):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(h,S,d){const _=this.getUriTransformer(h);switch(S){case"zip":return this.service.zip(w(d[0],_)).then(f=>p(f,_));case"unzip":return this.service.unzip(C(d[0],_));case"install":return this.service.install(C(d[0],_),d[1]);case"getManifest":return this.service.getManifest(C(d[0],_));case"canInstall":return this.service.canInstall(d[0]);case"installFromGallery":return this.service.installFromGallery(d[0],d[1]);case"uninstall":return this.service.uninstall(w(d[0],_),d[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(w(d[0],_));case"getInstalled":return this.service.getInstalled(d[0]).then(f=>f.map(l=>n(l,_)));case"updateMetadata":return this.service.updateMetadata(w(d[0],_),d[1]).then(f=>n(f,_));case"updateExtensionScope":return this.service.updateExtensionScope(w(d[0],_),d[1]).then(f=>n(f,_));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=A;class b extends I.Disposable{constructor(h){super();this.channel=h,this._onInstallExtension=this._register(new E.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new E.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new E.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new E.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(S=>this._onInstallExtension.fire({identifier:S.identifier,source:this.isUriComponents(S.source)?P.URI.revive(S.source):S.source}))),this._register(this.channel.listen("onDidInstallExtensions")(S=>this._onDidInstallExtensions.fire(S.map(d=>({...d,local:d.local?w(d.local,null):d.local,source:this.isUriComponents(d.source)?P.URI.revive(d.source):d.source}))))),this._register(this.channel.listen("onUninstallExtension")(S=>this._onUninstallExtension.fire(S))),this._register(this.channel.listen("onDidUninstallExtension")(S=>this._onDidUninstallExtension.fire(S)))}isUriComponents(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}zip(h){return Promise.resolve(this.channel.call("zip",[h]).then(S=>P.URI.revive(S)))}unzip(h){return Promise.resolve(this.channel.call("unzip",[h]))}install(h,S){return Promise.resolve(this.channel.call("install",[h,S])).then(d=>w(d,null))}getManifest(h){return Promise.resolve(this.channel.call("getManifest",[h]))}async canInstall(h){return!0}installFromGallery(h,S){return Promise.resolve(this.channel.call("installFromGallery",[h,S])).then(d=>w(d,null))}uninstall(h,S){return Promise.resolve(this.channel.call("uninstall",[h,S]))}reinstallFromGallery(h){return Promise.resolve(this.channel.call("reinstallFromGallery",[h]))}getInstalled(h=null){return Promise.resolve(this.channel.call("getInstalled",[h])).then(S=>S.map(d=>w(d,null)))}updateMetadata(h,S){return Promise.resolve(this.channel.call("updateMetadata",[h,S])).then(d=>w(d,null))}updateExtensionScope(h,S){return Promise.resolve(this.channel.call("updateExtensionScope",[h,S])).then(d=>w(d,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=b;class m{constructor(h){this.service=h}listen(h,S){throw new Error("Invalid listen")}call(h,S,d){switch(S){case"getConfigBasedTips":return this.service.getConfigBasedTips(P.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=m}),define(ce[170],ue([0,1,18]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function g(D,I){const C=p=>{if(typeof p!="string")return;const w=P.exec(p);if(!w)return;const n=I[w[1]]??p;return typeof n=="string"?n:typeof n.message=="string"?n.message:p};return(0,E.cloneAndChange)(D,C)}e.localizeManifest=g}),define(ce[58],ue([0,1,148]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function D(b){return b=b.trim(),b==="*"||P.test(b)}e.isValidVersionStr=D;function I(b){if(!D(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=b.match(P);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=I;function C(b){if(!b)return null;let m=b.majorBase,u=b.majorMustEqual,h=b.minorBase,S=b.minorMustEqual,d=b.patchBase,_=b.patchMustEqual;b.hasCaret&&(m===0||(S=!1),_=!1);let f=0;if(b.preRelease){const l=g.exec(b.preRelease);if(l){const[,a,t,r]=l;f=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:m,majorMustEqual:u,minorBase:h,minorMustEqual:S,patchBase:d,patchMustEqual:_,isMinimum:b.hasGreaterEquals,notBefore:f}}e.normalizeVersion=C;function p(b,m,u){let h;typeof b=="string"?h=C(I(b)):h=b;let S;m instanceof Date?S=m.getTime():typeof m=="string"&&(S=new Date(m).getTime());let d;if(typeof u=="string"?d=C(I(u)):d=u,!h||!d)return!1;let _=h.majorBase,f=h.minorBase,l=h.patchBase,a=d.majorBase,t=d.minorBase,r=d.patchBase,i=d.notBefore,s=d.majorMustEqual,c=d.minorMustEqual,v=d.patchMustEqual;return d.isMinimum?_>a?!0:_<a?!1:f>t?!0:f<t||S&&S<i?!1:l>=r:(_===1&&a===0&&(!s||!c||!v)&&(a=1,t=0,r=0,s=!0,c=!1,v=!1),_<a?!1:_>a?!s:f<t?!1:f>t?!c:l<r?!1:l>r?!v:!(S&&S<i))}e.isValidVersion=p;function w(b,m,u,h){return u.isBuiltin||typeof u.main=="undefined"?!0:A(b,m,u.engines.vscode,h)}e.isValidExtensionVersion=w;function n(b,m,u){return b==="*"||A(m,u,b)}e.isEngineValid=n;function A(b,m,u,h=[]){let S=C(I(u));if(!S)return h.push(E.localize(0,null,u)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return h.push(E.localize(1,null,u)),!1}else if(!S.majorMustEqual)return h.push(E.localize(2,null,u)),!1;return p(b,m,S)?!0:(h.push(E.localize(3,null,b,u)),!1)}}),define(ce[171],ue([0,1,7,2,3,22,17,42,11,43]),function(X,e,E,P,g,D,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCFileSystemProvider=void 0;class n extends P.Disposable{constructor(b){super();this.channel=b,this.session=(0,D.generateUuid)(),this._onDidChange=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new E.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new E.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event,this._capabilities=2|4|16|8|8192,this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(b=>{if(Array.isArray(b)){const m=b;this._onDidChange.fire(m.map(u=>({resource:g.URI.revive(u.resource),type:u.type})))}else{const m=b;this._onDidWatchErrorOccur.fire(m)}}))}setCaseSensitive(b){b?this._capabilities|=1024:this._capabilities&=~1024,this._onDidChangeCapabilities.fire(void 0)}stat(b){return this.channel.call("stat",[b])}open(b,m){return this.channel.call("open",[b,m])}close(b){return this.channel.call("close",[b])}async read(b,m,u,h,S){const[d,_]=await this.channel.call("read",[b,m,S]);return u.set(d.buffer.slice(0,_),h),_}async readFile(b){return(await this.channel.call("readFile",[b])).buffer}readFileStream(b,m,u){const h=(0,C.newWriteableStream)(d=>I.VSBuffer.concat(d.map(_=>I.VSBuffer.wrap(_))).buffer),S=this.channel.listen("readFileStream",[b,m])(d=>{if(d instanceof I.VSBuffer)h.write(d.buffer);else{if(d==="end")h.end();else{let _=d;_ instanceof Error||(_=new Error((0,w.toErrorMessage)(_))),h.error(_),h.end()}S.dispose()}});return u.onCancellationRequested(()=>{h.error((0,p.canceled)()),h.end(),S.dispose()}),h}write(b,m,u,h,S){return this.channel.call("write",[b,m,I.VSBuffer.wrap(u),h,S])}writeFile(b,m,u){return this.channel.call("writeFile",[b,I.VSBuffer.wrap(m),u])}delete(b,m){return this.channel.call("delete",[b,m])}mkdir(b){return this.channel.call("mkdir",[b])}readdir(b){return this.channel.call("readdir",[b])}rename(b,m,u){return this.channel.call("rename",[b,m,u])}copy(b,m,u){return this.channel.call("copy",[b,m,u])}watch(b,m){const u=Math.random();return this.channel.call("watch",[this.session,u,b,m]),(0,P.toDisposable)(()=>this.channel.call("unwatch",[this.session,u]))}}e.IPCFileSystemProvider=n}),define(ce[172],ue([0,1,36,56,2,8]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends g.Disposable{constructor(p,w,n,A){super();this.folders=p,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=A,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new P.Client(D.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=E.ProxyChannel.toService((0,E.getNextTickChannel)(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(ce[173],ue([0,1,36,56,2,8]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends g.Disposable{constructor(p,w,n,A,b={}){super();this.folders=p,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=A,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new P.Client(D.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=E.ProxyChannel.toService((0,E.getNextTickChannel)(p.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(ce[174],ue([0,1,35,76,47,8]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class I{constructor(p,w,n,A,b){this.watchedFolder=p,this.eventCallback=n,this.logCallback=A,this.verboseLogging=b,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(m=>(0,g.parse)(m)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=(0,E.spawn)(D.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",X).fsPath,p);const w=new P.LineDecoder;this.handle.stdout.on("data",n=>{const A=[];for(const b of w.write(n)){const m=b.split("|");if(m.length===2){const u=Number(m[0]),h=m[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(S=>S(h))){this.verboseLogging&&this.log(h);continue}A.push({type:I.changeTypeMap[u],path:h})}else this.log(m[1])}}A.length>0&&this.eventCallback(A)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,A)=>this.onExit(n,A))}onError(p){this.error("process error: "+p.toString())}onExit(p,w){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${w})`),this.restartCounter<=I.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=I,I.MAX_RESTARTS=5,I.changeTypeMap=[0,1,2]}),define(ce[175],ue([0,1,174,5,13]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class D{constructor(C,p,w,n){this.onDidFilesChange=p,this.onLogMessage=w,this.verboseLogging=n,this.service=void 0,this.folder=C[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(P.posix.sep)&&(this.folder.path=(0,g.rtrim)(this.folder.path,P.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new E.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,C=>this.onFileEvents(C),C=>this.onLogMessage(C),this.verboseLogging)}setVerboseLogging(C){this.verboseLogging=C,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(C){this.isDisposed||C.length>0&&this.onDidFilesChange(C)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=D}),define(ce[59],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(g,D=[],I=!1){this.ctor=g,this.staticArguments=D,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=E}),define(ce[176],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=E;class P{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let I of this._nodes.values())I.outgoing.size===0&&D.push(I);return D}insertEdge(D,I){const C=this.lookupOrInsertNode(D),p=this.lookupOrInsertNode(I);C.outgoing.set(this._hashFn(I),p),p.incoming.set(this._hashFn(D),C)}removeNode(D){const I=this._hashFn(D);this._nodes.delete(I);for(let C of this._nodes.values())C.outgoing.delete(I),C.incoming.delete(I)}lookupOrInsertNode(D){const I=this._hashFn(D);let C=this._nodes.get(I);return C||(C=new E(D),this._nodes.set(I,C)),C}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[I,C]of this._nodes)D.push(`${I}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,I]of this._nodes){const C=new Set([D]),p=this._findCycle(I,C);if(p)return p}}_findCycle(D,I){for(let[C,p]of D.outgoing){if(I.has(C))return[...I,C].join(" -> ");I.add(C);const w=this._findCycle(p,I);if(w)return w;I.delete(C)}}}e.Graph=P}),define(ce[6],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function p(w){return w[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=p})(E=e._util||(e._util={})),e.IInstantiationService=g("instantiationService");function P(C,p,w,n){p[E.DI_TARGET]===p?p[E.DI_DEPENDENCIES].push({id:C,index:w,optional:n}):(p[E.DI_DEPENDENCIES]=[{id:C,index:w,optional:n}],p[E.DI_TARGET]=p)}function g(C){if(E.serviceIds.has(C))return E.serviceIds.get(C);const p=function(w,n,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(p,w,A,!1)};return p.toString=()=>C,E.serviceIds.set(C,p),p}e.createDecorator=g;function D(C){return C}e.refineServiceDecorator=D;function I(C){return function(p,w,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");P(C,p,n,!0)}}e.optional=I}),define(ce[177],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,E.createDecorator)("modelService");function P(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}e.shouldSynchronizeModel=P}),define(ce[178],ue([0,1,7,118,2,26,115,129,177]),function(X,e,E,P,g,D,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function w(b){return typeof b=="string"?!1:Array.isArray(b)?b.every(w):!!b.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new E.Emitter}get onDidChange(){return this._onDidChange.event}register(m,u){let h={selector:m,provider:u,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,g.toDisposable)(()=>{if(h){let S=this._entries.indexOf(h);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const u=[];for(let h of this._entries)h._score>0&&u.push(h.provider);return u}ordered(m){const u=[];return this._orderedForEach(m,h=>u.push(h.provider)),u}orderedGroups(m){const u=[];let h,S;return this._orderedForEach(m,d=>{h&&S===d._score?h.push(d.provider):(S=d._score,h=[d.provider],u.push(h))}),u}_orderedForEach(m,u){if(!!m){this._updateScores(m);for(const h of this._entries)h._score>0&&u(h)}}_updateScores(m){let u={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===u.language&&this._lastCandidate.uri===u.uri)){this._lastCandidate=u;for(let h of this._entries)if(h._score=(0,C.score)(h.selector,m.uri,m.getLanguageIdentifier().language,(0,p.shouldSynchronizeModel)(m)),w(h.selector)&&h._score>0){for(let S of this._entries)S._score=0;h._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(m,u){return m._score<u._score?1:m._score>u._score?-1:m._time<u._time?1:m._time>u._time?-1:0}}e.LanguageFeatureRegistry=n;class A{constructor(m,u,h=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=u,this.max=h,this._cache=new D.LRUCache(50,.7)}_key(m){return m.id+(0,P.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const u=this._key(m),h=this._cache.get(u);return this._clamp(h?.value)}update(m,u){const h=this._key(m);let S=this._cache.get(h);return S||(S=new I.MovingAverage,this._cache.set(h,S)),S.update(u),this.get(m)}}e.LanguageFeatureRequestDelays=A}),define(ce[179],ue([0,1,3,55,178,130,39]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class p{constructor(k,O){this.language=k,this.id=O}}e.LanguageIdentifier=p;var w;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(w=e.FontStyle||(e.FontStyle={}));var n;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var A;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var b;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(b=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&1792)>>>8}static getFontStyle(k){return(k&14336)>>>11}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){let O=this.getForeground(k),Y="mtk"+O,Q=this.getFontStyle(k);return Q&1&&(Y+=" mtki"),Q&2&&(Y+=" mtkb"),Q&4&&(Y+=" mtku"),Y}static getInlineStyleFromMetadata(k,O){const Y=this.getForeground(k),Q=this.getFontStyle(k);let me=`color: ${O[Y]};`;return Q&1&&(me+="font-style: italic;"),Q&2&&(me+="font-weight: bold;"),Q&4&&(me+="text-decoration: underline;"),me}}e.TokenMetadata=m;var u;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(k){const O=o[k];let Y=O&&I.iconRegistry.get(O);return Y||(console.info("No codicon found for CompletionItemKind "+k),Y=I.Codicon.symbolProperty),Y.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(k,O){let Y=o[k];return typeof Y=="undefined"&&!O&&(Y=9),Y}}();var h;(function(o){o[o.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var d;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var a;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(a=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&E.URI.isUri(o.uri)&&P.Range.isIRange(o.range)&&(P.Range.isIRange(o.originSelectionRange)||P.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var r;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var i;(function(o){o[o.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var s;(function(o){const k=new Map;k.set("file",0),k.set("module",1),k.set("namespace",2),k.set("package",3),k.set("class",4),k.set("method",5),k.set("property",6),k.set("field",7),k.set("constructor",8),k.set("enum",9),k.set("interface",10),k.set("function",11),k.set("variable",12),k.set("constant",13),k.set("string",14),k.set("number",15),k.set("boolean",16),k.set("array",17),k.set("object",18),k.set("key",19),k.set("null",20),k.set("enum-member",21),k.set("struct",22),k.set("event",23),k.set("operator",24),k.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function Y(re){return k.get(re)}o.fromString=Y;function Q(re){return O.get(re)}o.toString=Q;function me(re,N){const W=O.get(re);let U=W&&I.iconRegistry.get("symbol-"+W);return U||(console.info("No codicon found for SymbolKind "+re),U=I.Codicon.symbolProperty),`${N?"inline":"block"} ${U.classNames}`}o.toCssClassName=me})(s=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(k){this.value=k}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var v;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var y;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(y=e.CommentMode||(e.CommentMode={}));var T;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(T=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new g.LanguageFeatureRegistry,e.RenameProviderRegistry=new g.LanguageFeatureRegistry,e.CompletionProviderRegistry=new g.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new g.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new g.LanguageFeatureRegistry,e.HoverProviderRegistry=new g.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new g.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new g.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new g.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new g.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new g.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new g.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new g.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new g.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new g.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new g.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new g.LanguageFeatureRegistry,e.LinkProviderRegistry=new g.LanguageFeatureRegistry,e.ColorProviderRegistry=new g.LanguageFeatureRegistry,e.SelectionRangeRegistry=new g.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new g.LanguageFeatureRegistry,e.TokenizationRegistry=new D.TokenizationRegistryImpl;var R;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(R=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ce[60],ue([0,1,13,6,4]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let D=g.userAgent||"";const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",g.isMacintosh),I.set("isLinux",g.isLinux),I.set("isWindows",g.isWindows),I.set("isWeb",g.isWeb),I.set("isMacNative",g.isMacintosh&&!g.isWeb),I.set("isEdge",D.indexOf("Edg/")>=0),I.set("isFirefox",D.indexOf("Firefox")>=0),I.set("isChrome",D.indexOf("Chrome")>=0),I.set("isSafari",D.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var p;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(p=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return A.INSTANCE}static true(){return b.INSTANCE}static has(o){return m.create(o)}static equals(o,k){return u.create(o,k)}static notEquals(o,k){return d.create(o,k)}static regex(o,k){return r.create(o,k)}static in(o,k){return h.create(o,k)}static not(o){return _.create(o)}static and(...o){return s.create(o)}static or(...o){return c.create(o)}static greater(o,k){return f.create(o,k)}static less(o,k){return a.create(o,k)}static deserialize(o,k=!1){if(!!o)return this._deserializeOrExpression(o,k)}static _deserializeOrExpression(o,k){let O=o.split("||");return c.create(O.map(Y=>this._deserializeAndExpression(Y,k)))}static _deserializeAndExpression(o,k){let O=o.split("&&");return s.create(O.map(Y=>this._deserializeOne(Y,k)))}static _deserializeOne(o,k){if(o=o.trim(),o.indexOf("!=")>=0){let O=o.split("!=");return d.create(O[0].trim(),this._deserializeValue(O[1],k))}if(o.indexOf("==")>=0){let O=o.split("==");return u.create(O[0].trim(),this._deserializeValue(O[1],k))}if(o.indexOf("=~")>=0){let O=o.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],k))}if(o.indexOf(" in ")>=0){let O=o.split(" in ");return h.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const O=o.split(">=");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const O=o.split(">");return f.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const O=o.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const O=o.split("<");return a.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(o)?_.create(o.substr(1).trim()):m.create(o)}static _deserializeValue(o,k){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let O=/^'([^']*)'$/.exec(o);return O?O[1].trim():o}static _deserializeRegexValue(o,k){if((0,E.isFalsyOrWhitespace)(o)){if(k)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=o.indexOf("/"),Y=o.lastIndexOf("/");if(O===Y||O<0){if(k)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let Q=o.slice(O+1,Y),me=o[Y+1]==="i"?"i":"";try{return new RegExp(Q,me)}catch(re){if(k)throw new Error(`bad regexp-value '${o}', parse error: ${re}`);return console.warn(`bad regexp-value '${o}', parse error: ${re}`),null}}}e.ContextKeyExpr=w;function n(R,o){return R.cmp(o)}class A{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=A,A.INSTANCE=new A;class b{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return A.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class m{constructor(o){this.key=o,this.type=2}static create(o){const k=I.get(o);return typeof k=="boolean"?k?b.INSTANCE:A.INSTANCE:new m(o)}cmp(o){return o.type!==this.type?this.type-o.type:y(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return _.create(this.key)}}e.ContextKeyDefinedExpr=m;class u{constructor(o,k){this.key=o,this.value=k,this.type=4}static create(o,k){if(typeof k=="boolean")return k?m.create(o):_.create(o);const O=I.get(o);return typeof O=="boolean"?k===(O?"true":"false")?b.INSTANCE:A.INSTANCE:new u(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class h{constructor(o,k){this.key=o,this.valueKey=k,this.type=10}static create(o,k){return new h(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const k=o.getValue(this.valueKey),O=o.getValue(this.key);return Array.isArray(k)?k.indexOf(O)>=0:typeof O=="string"&&typeof k=="object"&&k!==null?C.call(k,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=h;class S{constructor(o){this._actual=o,this.type=11}static create(o){return new S(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new S(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class d{constructor(o,k){this.key=o,this.value=k,this.type=5}static create(o,k){if(typeof k=="boolean")return k?_.create(o):m.create(o);const O=I.get(o);return typeof O=="boolean"?k===(O?"true":"false")?A.INSTANCE:b.INSTANCE:new d(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=d;class _{constructor(o){this.key=o,this.type=3}static create(o){const k=I.get(o);return typeof k=="boolean"?k?A.INSTANCE:b.INSTANCE:new _(o)}cmp(o){return o.type!==this.type?this.type-o.type:y(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=_;class f{constructor(o,k){this.key=o,this.value=k,this.type=12}static create(o,k){return new f(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class l{constructor(o,k){this.key=o,this.value=k,this.type=13}static create(o,k){return new l(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class a{constructor(o,k){this.key=o,this.value=k,this.type=14}static create(o,k){return new a(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=a;class t{constructor(o,k){this.key=o,this.value=k,this.type=15}static create(o,k){return new t(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(o,k){this.key=o,this.regexp=k,this.type=7}static create(o,k){return new r(o,k)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const k=this.regexp?this.regexp.source:"",O=o.regexp?o.regexp.source:"";return k<O?-1:k>O?1:0}equals(o){if(o.type===this.type){const k=this.regexp?this.regexp.source:"",O=o.regexp?o.regexp.source:"";return this.key===o.key&&k===O}return!1}evaluate(o){let k=o.getValue(this.key);return this.regexp?this.regexp.test(k):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(o){this._actual=o,this.type=8}static create(o){return new i(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new i(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class s{constructor(o){this.expr=o,this.type=6}static create(o){return s._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let k=0,O=this.expr.length;k<O;k++){const Y=n(this.expr[k],o.expr[k]);if(Y!==0)return Y}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].equals(o.expr[k]))return!1;return!0}return!1}evaluate(o){for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].evaluate(o))return!1;return!0}static _normalizeArr(o){const k=[];let O=!1;for(const Y of o)if(!!Y){if(Y.type===1){O=!0;continue}if(Y.type===0)return A.INSTANCE;if(Y.type===6){k.push(...Y.expr);continue}k.push(Y)}if(k.length===0&&O)return b.INSTANCE;if(k.length!==0){if(k.length===1)return k[0];for(k.sort(n);k.length>1;){const Y=k[k.length-1];if(Y.type!==9)break;k.pop();const Q=k.pop(),me=c.create(Y.expr.map(re=>s.create([re,Q])));me&&(k.push(me),k.sort(n))}return k.length===1?k[0]:new s(k)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let k of this.expr)o.push(...k.keys());return o}map(o){return new s(this.expr.map(k=>k.map(o)))}negate(){let o=[];for(let k of this.expr)o.push(k.negate());return c.create(o)}}e.ContextKeyAndExpr=s;class c{constructor(o){this.expr=o,this.type=9}static create(o){const k=c._normalizeArr(o);if(k.length!==0)return k.length===1?k[0]:new c(k)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let k=0,O=this.expr.length;k<O;k++){const Y=n(this.expr[k],o.expr[k]);if(Y!==0)return Y}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].equals(o.expr[k]))return!1;return!0}return!1}evaluate(o){for(let k=0,O=this.expr.length;k<O;k++)if(this.expr[k].evaluate(o))return!0;return!1}static _normalizeArr(o){let k=[],O=!1;if(o){for(let Y=0,Q=o.length;Y<Q;Y++){const me=o[Y];if(!!me){if(me.type===0){O=!0;continue}if(me.type===1)return[b.INSTANCE];if(me.type===9){k=k.concat(me.expr);continue}k.push(me)}}if(k.length===0&&O)return[A.INSTANCE];k.sort(n)}return k}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let k of this.expr)o.push(...k.keys());return o}map(o){return new c(this.expr.map(k=>k.map(o)))}negate(){let o=[];for(let O of this.expr)o.push(O.negate());const k=O=>O.type===9?O.expr:[O];for(;o.length>1;){const O=o.shift(),Y=o.shift(),Q=[];for(const me of k(O))for(const re of k(Y))Q.push(w.and(me,re));o.unshift(w.or(...Q))}return o[0]}}e.ContextKeyOrExpr=c;class v extends m{constructor(o,k,O){super(o);this._defaultValue=k,typeof O=="object"?v._info.push({...O,key:o}):O!==!0&&v._info.push({key:o,description:O,type:k!=null?typeof k:void 0})}static all(){return v._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return w.not(this.key)}isEqualTo(o){return w.equals(this.key,o)}notEqualsTo(o){return w.notEquals(this.key,o)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(R,o){return R<o?-1:R>o?1:0}function T(R,o,k,O){return R<k?-1:R>k?1:o<O?-1:o>O?1:0}}),define(ce[180],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function P(g){return!!g.hostName&&!!g.errorMessage}e.isRemoteDiagnosticError=P}),define(ce[85],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,E.createDecorator)("downloadService")}),define(ce[28],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ce[32],ue([0,1,143,6,8]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(A){return A&&typeof A=="object"&&typeof A.id=="string"&&(!A.uuid||typeof A.uuid=="string")}e.isIExtensionIdentifier=D;var I;(function(A){A[A.NoneOrRelevance=0]="NoneOrRelevance",A[A.LastUpdatedDate=1]="LastUpdatedDate",A[A.Title=2]="Title",A[A.PublisherName=3]="PublisherName",A[A.InstallCount=4]="InstallCount",A[A.PublishedDate=5]="PublishedDate",A[A.AverageRating=6]="AverageRating",A[A.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var C;(function(A){A[A.Default=0]="Default",A[A.Ascending=1]="Ascending",A[A.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var p;(function(A){A.Install="install",A.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var w;(function(A){A[A.None=0]="None",A[A.Install=1]="Install",A[A.Update=2]="Update"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(b,m){super(b);this.code=m,this.name=m}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,P.createDecorator)("IExtensionManagementCLIService")}),define(ce[44],ue([0,1,13,6]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function g(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=g;function D(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class C{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,b){if(typeof A=="undefined"||A===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof A=="string"||typeof b=="string"){let m=typeof A=="string"?A:A.value,u=typeof b=="string"?b:b.value;return E.equalsIgnoreCase(m,u)}return A._lower===b._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=C;function p(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function w(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(ce[33],ue([0,1,13,44]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function g(u,h){return u.uuid&&h.uuid?u.uuid===h.uuid:u.id===h.id?!0:(0,E.compareIgnoreCase)(u.id,h.id)===0}e.areSameExtensions=g;class D{constructor(h,S){this.version=S,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof D?g(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=D;function I(u,h){return`${u}.${h}`}e.getExtensionId=I;function C(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function p(u,h){return C(I(u,h))}e.getGalleryExtensionId=p;function w(u,h){const S=[],d=_=>{for(const f of S)if(f.some(l=>g(h(l),h(_))))return f;return null};for(const _ of u){const f=d(_);f?f.push(_):S.push([_])}return S}e.groupByExtension=w;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function A(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function b(u){const h=new Set;for(const S of u)S.malicious&&h.add(S.id.id);return h}e.getMaliciousExtensionsSet=b;function m(u,h){const S=[],d=h.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const _=d.shift();if(_&&S.every(f=>!g(f.identifier,{id:_}))){const f=u.filter(l=>g(l.identifier,{id:_}));f.length===1&&(S.push(f[0]),d.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=m});var xe=this&&this.__param||function(X,e){return function(E,P){e(E,P,X)}};define(ce[86],ue([0,1,144,11,3,49,32,33,44,52,25,8]),function(X,e,E,P,g,D,I,C,p,w,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=e.getIdAndVersion=void 0;const b=_=>(0,E.localize)(0,null,_),m=(0,E.localize)(1,null,"ms-dotnettools.csharp");function u(_,f){return f?`${_.publisher}.${_.name}@${_.version}`:`${_.publisher}.${_.name}`}const h=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function S(_){const f=h.exec(_);return f&&f[1]?[(0,C.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,C.adoptToGalleryExtensionId)(_),void 0]}e.getIdAndVersion=S;let d=class{constructor(f,l){this.extensionManagementService=f,this.extensionGalleryService=l}get location(){}async listExtensions(f,l,a=console){let t=await this.extensionManagementService.getInstalled(1);const r=p.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(l&&l!==""){if(r.indexOf(l.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}t=t.filter(s=>s.manifest.categories?s.manifest.categories.map(v=>v.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){a.log("Possible Categories: "),r.forEach(s=>{a.log(s)});return}this.location&&a.log((0,E.localize)(2,null,this.location)),t=t.sort((s,c)=>s.identifier.id.localeCompare(c.identifier.id));let i;for(let s of t)i!==s.identifier.id&&(i=s.identifier.id,a.log(u(s.manifest,f)))}async installExtensions(f,l,a,t,r=console){const i=[],s=[];f.length&&r.log(this.location?(0,E.localize)(3,null,this.location):(0,E.localize)(4,null));const c=await this.extensionManagementService.getInstalled(1),v=(R,o)=>{const k=c.find(O=>(0,C.areSameExtensions)(O.identifier,{id:R}));if(k){if(!o&&!t)return r.log((0,E.localize)(5,null,R,k.manifest.version,R)),!1;if(o&&k.manifest.version===o)return r.log((0,E.localize)(6,null,`${R}@${o}`)),!1}return!0},y=[],T=[];for(const R of f)if(R instanceof g.URI)y.push(R);else{const[o,k]=S(R);v(o,k)&&T.push({id:o,version:k,installOptions:{isBuiltin:!1,isMachineScoped:a}})}for(const R of l){const[o,k]=S(R);v(o,k)&&T.push({id:o,version:k,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(y.length&&await Promise.all(y.map(async R=>{try{const o=await this.installVSIX(R,{isBuiltin:!1,isMachineScoped:a},t,r);o&&s.push(o)}catch(o){r.error(o.message||o.stack||o),i.push(R.toString())}})),T.length){const R=await this.getGalleryExtensions(T);await Promise.all(T.map(async o=>{const k=R.get(o.id.toLowerCase());if(k)try{const O=await this.installFromGallery(o,k,c,t,r);O&&s.push(O)}catch(O){r.error(O.message||O.stack||O),i.push(o.id)}else r.error(`${b(o.version?`${o.id}@${o.version}`:o.id)}
${m}`),i.push(o.id)}))}if(i.length)throw new Error((0,E.localize)(7,null,i.join(", ")))}async installVSIX(f,l,a,t){const r=await this.extensionManagementService.getManifest(f);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,a,t))try{return await this.extensionManagementService.install(f,l),t.log((0,E.localize)(8,null,(0,w.getBaseLabel)(f))),r}catch(s){if((0,P.isPromiseCanceledError)(s))return t.log((0,E.localize)(9,null,(0,w.getBaseLabel)(f))),null;throw s}return null}async getGalleryExtensions(f){const l=f.filter(({version:r})=>r===void 0).map(({id:r})=>r),a=f.filter(({version:r})=>r!==void 0),t=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(l,n.CancellationToken.None)).forEach(i=>t.set(i.identifier.id.toLowerCase(),i))})(),Promise.all(a.map(async({id:r,version:i})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:r},i);s&&t.set(s.identifier.id.toLowerCase(),s)}))]),t}async installFromGallery({id:f,version:l,installOptions:a},t,r,i,s){const c=await this.extensionGalleryService.getManifest(t,n.CancellationToken.None);if(c&&!this.validateExtensionKind(c,s))return null;const v=r.find(y=>(0,C.areSameExtensions)(y.identifier,t.identifier));if(v){if(t.version===v.manifest.version)return s.log((0,E.localize)(10,null,l?`${f}@${l}`:f)),null;s.log((0,E.localize)(11,null,f,t.version))}try{return a.isBuiltin?s.log(l?(0,E.localize)(12,null,f,l):(0,E.localize)(13,null,f)):s.log(l?(0,E.localize)(14,null,f,l):(0,E.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(t,a),s.log((0,E.localize)(16,null,f,t.version)),c}catch(y){if((0,P.isPromiseCanceledError)(y))return s.log((0,E.localize)(17,null,f)),null;throw y}}validateExtensionKind(f,l){return!0}async validateVSIX(f,l,a){const t={id:(0,C.getGalleryExtensionId)(f.publisher,f.name)},i=(await this.extensionManagementService.getInstalled(1)).find(s=>(0,C.areSameExtensions)(t,s.identifier)&&(0,D.gt)(s.manifest.version,f.version));return i&&!l?(a.log((0,E.localize)(18,null,i.identifier.id,i.manifest.version,f.version)),!1):this.validateExtensionKind(f,a)}async uninstallExtensions(f,l,a=console){const t=async i=>{if(i instanceof g.URI){const s=await this.extensionManagementService.getManifest(i);return u(s)}return i},r=[];for(const i of f){const s=await t(i),v=(await this.extensionManagementService.getInstalled()).filter(y=>(0,C.areSameExtensions)(y.identifier,{id:s}));if(!v.length)throw new Error(`${this.notInstalled(s)}
${m}`);if(v.some(y=>y.type===0)){a.log((0,E.localize)(19,null,s));return}if(!l&&v.some(y=>y.isBuiltin)){a.log((0,E.localize)(20,null,s));return}a.log((0,E.localize)(21,null,s));for(const y of v)await this.extensionManagementService.uninstall(y),r.push(y);this.location?a.log((0,E.localize)(22,null,s,this.location)):a.log((0,E.localize)(23,null,s))}}async locateExtension(f,l=console){const a=await this.extensionManagementService.getInstalled();f.forEach(t=>{a.forEach(r=>{if(r.identifier.id===t&&r.location.scheme===A.Schemas.file){l.log(r.location.fsPath);return}})})}notInstalled(f){return this.location?(0,E.localize)(24,null,f,this.location):(0,E.localize)(25,null,f)}};d=Le([xe(0,I.IExtensionManagementService),xe(1,I.IExtensionGalleryService)],d),e.ExtensionManagementCLIService=d}),define(ce[181],ue([0,1,2,5,44,16]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class I extends E.Disposable{constructor(p,w){super();this.environmentService=p,this.extensionsManifestCache=(0,P.join)(this.environmentService.userDataPath,g.MANIFEST_CACHE_FOLDER,g.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(w.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(p){p.some(w=>!!w.local)&&this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=I}),define(ce[20],ue([0,1,150,5,3,6,13,12,26]),function(X,e,E,P,g,D,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function w(N){return N.create===!0}e.isFileOpenForWriteOptions=w;var n;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var A;(function(N){N[N.Readonly=1]="Readonly"})(A=e.FilePermission||(e.FilePermission={}));var b;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=m;function u(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=u;function h(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function S(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=S;var d;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(d=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(W,U){super(W);this.code=U}}e.FileSystemProviderError=_;function f(N,W){const U=new _(N.toString(),W);return a(U,W),U}e.createFileSystemProviderError=f;function l(N){return N||f((0,E.localize)(0,null),d.Unknown)}e.ensureFileSystemProviderError=l;function a(N,W){return N.name=W?`${W} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=a;function t(N){if(!N)return d.Unknown;if(N instanceof _)return N.code;const W=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!W)return d.Unknown;switch(W[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileExceedsMemoryLimit:return d.FileExceedsMemoryLimit;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}e.toFileSystemProviderErrorCode=t;function r(N){if(N instanceof T)return N.fileOperationResult;switch(t(N)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 10;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileExceedsMemoryLimit:return 9;case d.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(W,U,j){this.resource=W,this.operation=U,this.target=j}isOperation(W){return this.operation===W}}e.FileOperationEvent=s;var c;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class v{constructor(W,U){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const j of W)switch(j.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>U)),this.added.set(j.resource,j);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>U)),this.updated.set(j.resource,j);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>U)),this.deleted.set(j.resource,j);break}}contains(W,...U){return this.doContains(W,{includeChildren:!1},...U)}affects(W,...U){return this.doContains(W,{includeChildren:!0},...U)}doContains(W,U,...j){if(!W)return!1;const H=j.length>0;return!!((!H||j.includes(1))&&(this.added?.get(W)||U.includeChildren&&this.added?.findSuperstr(W))||(!H||j.includes(0))&&(this.updated?.get(W)||U.includeChildren&&this.updated?.findSuperstr(W))||(!H||j.includes(2))&&(this.deleted?.findSubstr(W)||U.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=v;function y(N,W,U){return!N||!W||N===W||W.length>N.length?!1:(W.charAt(W.length-1)!==P.sep&&(W+=P.sep),U?(0,I.startsWithIgnoreCase)(N,W):N.indexOf(W)===0)}e.isParent=y;class T extends Error{constructor(W,U,j){super(W);this.fileOperationResult=U,this.options=j}}e.FileOperationError=T;class R extends T{constructor(W,U,j){super(W,2,j);this.stat=U}}e.NotModifiedSinceFileOperationError=R;var o;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=O;async function Y(N,W){if(!W.canHandleResource(g.URI.from({scheme:N.scheme})))return new Promise(U=>{const j=W.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===N.scheme&&H.added&&(j.dispose(),U())})})}e.whenProviderRegistered=Y,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize(W){return(0,C.isNumber)(W)||(W=0),W<Q.KB?(0,E.localize)(1,null,W.toFixed(0)):W<Q.MB?(0,E.localize)(2,null,(W/Q.KB).toFixed(2)):W<Q.GB?(0,E.localize)(3,null,(W/Q.MB).toFixed(2)):W<Q.TB?(0,E.localize)(4,null,(W/Q.GB).toFixed(2)):(0,E.localize)(5,null,(W/Q.TB).toFixed(2))}}e.ByteSize=Q,Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB;var me;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(me=e.Arch||(e.Arch={}));function re(N){return{maxFileSize:N===0?300*Q.MB:16*Q.GB,maxHeapSize:N===0?700*Q.MB:2*700*Q.MB}}e.getPlatformLimits=re}),define(ce[182],ue([0,1,244,141,20,57]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function I(b,m){const u={onUnknownOption:S=>{console.warn((0,P.localize)(0,null,S))},onMultipleValues:(S,d)=>{console.warn((0,P.localize)(1,null,S,d))}},h=(0,D.parseArgs)(b,D.OPTIONS,m?u:void 0);return h.goto&&h._.forEach(S=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,P.localize)(2,null))),h["max-memory"]&&E(parseInt(h["max-memory"])>=g.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${g.MIN_MAX_MEMORY_SIZE_MB} MB.`),h}function C(b){const m=b.findIndex(u=>!/^-/.test(u));if(m>-1)return[...b.slice(0,m),...b.slice(m+1)]}function p(b){let[,...m]=b;process.env.VSCODE_DEV&&(m=C(m)||[]);const u=!A(process.env);return I(m,u)}e.parseMainProcessArgv=p;function w(b){const[,,...m]=b;return I(m,!0)}e.parseCLIProcessArgv=w;function n(b,...m){const u=b.indexOf("--");return u===-1?b.push(...m):b.splice(u,0,...m),b}e.addArg=n;function A(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=A}),define(ce[61],ue([0,1,77,35,22,4,182,43,137,25,11]),function(X,e,E,P,g,D,I,C,p,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function A(u,h,S){return h["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):D.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(S)&&!h["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(S)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=new Promise(async d=>{const _=new w.CancellationTokenSource,f=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),_.dispose(!0),d({})},1e4);try{const l=await m(u,_.token);d(l)}catch(l){(0,n.isPromiseCanceledError)(l)||u.error(`[resolve shell env] Unable to resolve shell environment (${l}). Proceeding without shell environment...`),d({})}finally{clearTimeout(f),_.dispose()}})),b)}e.resolveShellEnv=A;let b;async function m(u,h){const S=new Promise(async(d,_)=>{const f=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",f);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",l);const a=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const i=await(0,p.getSystemShell)(D.OS,r);if(u.trace("getUnixShellEnvironment#shell",i),h.isCancellationRequested)return _(n.canceled);const s=E.basename(i);let c,v;/^pwsh(-preview)?$/.test(s)?(c=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,v=["-Login","-Command"]):(c=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,v=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(v),c);const y=(0,P.spawn)(i,[...v,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});h.onCancellationRequested(()=>(y.kill(),_(n.canceled))),y.on("error",o=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(o)),d({})});const T=[];y.stdout.on("data",o=>T.push(o));const R=[];y.stderr.on("data",o=>R.push(o)),y.on("close",(o,k)=>{const O=Buffer.concat(T).toString("utf8");u.trace("getUnixShellEnvironment#raw",O);const Y=Buffer.concat(R).toString("utf8");if(Y.trim()&&u.trace("getUnixShellEnvironment#stderr",Y),o||k)return _(new Error(`Failed to get environment (code ${o}, signal ${k})`));const Q=t.exec(O),me=Q?Q[1]:"{}";try{const re=JSON.parse(me);f?re.ELECTRON_RUN_AS_NODE=f:delete re.ELECTRON_RUN_AS_NODE,l?re.ELECTRON_NO_ATTACH_CONSOLE=l:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",re),d(re)}catch(re){u.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(re)),_(re)}})});try{return await S}catch(d){return u.error("getUnixShellEnvironment#error",(0,C.toErrorMessage)(d)),{}}}}),define(ce[87],ue([0,1,3,20,4]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function D(p){return p.map(w=>({type:w.type,resource:E.URI.file(w.path)}))}e.toFileChanges=D;function I(p){const w=new C;for(const n of p)w.processEvent(n);return w.normalize()}e.normalizeFileChanges=I;class C{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const n=this.mapPathToChange.get(w.path);if(n){const A=n.type,b=w.type;A===1&&b===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(n),1)):A===2&&b===1?n.type=0:A===1&&b===0||(n.type=b)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],n=[];return this.normalized.filter(A=>A.type!==2?(w.push(A),!1):!0).sort((A,b)=>A.path.length-b.path.length).filter(A=>n.some(b=>(0,P.isParent)(A.path,b,!g.isLinux))?!1:(n.push(A.path),!0)).concat(w)}}}),define(ce[183],ue([0,1,87,2,16,125,127,14,5]),function(X,e,E,P,g,D,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends P.Disposable{constructor(A,b,m,u){super();this.path=A,this.onDidFilesChange=b,this.onLogMessage=m,this.verboseLogging=u,this.fileChangesDelayer=this._register(new C.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(A){this.verboseLogging=A}async startWatching(){try{const{stat:A,symbolicLink:b}=await g.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let m=this.path;if(b)try{m=await(0,D.realpath)(m)}catch(u){if(this.onError(u),b.dangling)return}A.isDirectory()?this._register((0,I.watchFolder)(m,(u,h)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,p.join)(this.path,(0,p.basename)(h))})},u=>this.onError(u))):this._register((0,I.watchFile)(m,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(A){A.code!=="ENOENT"&&this.onError(A)}}onFileChange(A){this.fileChangesBuffer.push(A),this.verboseLogging&&this.onVerbose(`${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,E.normalizeFileChanges)(b);if(this.verboseLogging)for(const u of m)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);m.length>0&&this.onDidFilesChange(m)})}onError(A){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${A}`})}onVerbose(A){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${A}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(ce[62],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...g){this._entries=new Map;for(let[D,I]of g)this.set(D,I)}set(g,D){const I=this._entries.get(g);return this._entries.set(g,D),I}has(g){return this._entries.has(g)}get(g){return this._entries.get(g)}}e.ServiceCollection=E}),define(ce[88],ue([0,1,11,176,59,6,62,14]),function(X,e,E,P,g,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class w extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class n{constructor(u=new I.ServiceCollection,h=!1,S){this._activeInstantiations=new Set,this._services=u,this._strict=h,this._parent=S,this._services.set(D.IInstantiationService,this)}createChild(u){return new n(u,this._strict,this)}invokeFunction(u,...h){let S=b.traceInvocation(u),d=!1;try{return u({get:(f,l)=>{if(d)throw(0,E.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(f,S);if(!a&&l!==D.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return a}},...h)}finally{d=!0,S.stop()}}createInstance(u,...h){let S,d;return u instanceof g.SyncDescriptor?(S=b.traceCreation(u.ctor),d=this._createInstance(u.ctor,u.staticArguments.concat(h),S)):(S=b.traceCreation(u),d=this._createInstance(u,h,S)),S.stop(),d}_createInstance(u,h=[],S){let d=D._util.getServiceDependencies(u).sort((l,a)=>l.index-a.index),_=[];for(const l of d){let a=this._getOrCreateServiceInstance(l.id,S);if(!a&&this._strict&&!l.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${l.id}.`);_.push(a)}let f=d.length>0?d[0].index:h.length;if(h.length!==f){console.warn(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${h.length} static arguments`);let l=f-h.length;l>0?h=h.concat(new Array(l)):h=h.slice(0,f)}return new u(...[...h,..._])}_setServiceInstance(u,h){if(this._services.get(u)instanceof g.SyncDescriptor)this._services.set(u,h);else if(this._parent)this._parent._setServiceInstance(u,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let h=this._services.get(u);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):h}_getOrCreateServiceInstance(u,h){let S=this._getServiceInstanceOrDescriptor(u);return S instanceof g.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,S,h.branch(u,!0)):(h.branch(u,!1),S)}_safeCreateAndCacheServiceInstance(u,h,S){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,h,S)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,h,S){const d=new P.Graph(l=>l.id.toString());let _=0;const f=[{id:u,desc:h,_trace:S}];for(;f.length;){const l=f.pop();if(d.lookupOrInsertNode(l),_++>1e3)throw new w(d);for(let a of D._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),t instanceof g.SyncDescriptor){const r={id:a.id,desc:t,_trace:l._trace.branch(a.id,!0)};d.insertEdge(l,r),f.push(r)}}}for(;;){const l=d.roots();if(l.length===0){if(!d.isEmpty())throw new w(d);break}for(const{data:a}of l){if(this._getServiceInstanceOrDescriptor(a.id)instanceof g.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}d.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,h,S=[],d,_){if(this._services.get(u)instanceof g.SyncDescriptor)return this._createServiceInstance(h,S,d,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,h,S,d,_);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(u,h=[],S,d){if(S){const _=new C.IdleValue(()=>this._createInstance(u,h,d));return new Proxy(Object.create(null),{get(f,l){if(l in f)return f[l];let a=_.value,t=a[l];return typeof t!="function"||(t=t.bind(a),f[l]=t),t},set(f,l,a){return _.value[l]=a,!0}})}else return this._createInstance(u,h,d)}}e.InstantiationService=n;var A;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(A||(A={}));class b{constructor(u,h){this.type=u,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return p?new b(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(u){return p?new b(0,u.name):b._None}branch(u,h){let S=new b(2,u.toString());return this._dep.push([u,h,S]),S}stop(){let u=Date.now()-this._start;b._totals+=u;let h=!1;function S(_,f){let l=[],a=new Array(_+1).join("	");for(const[t,r,i]of f._dep)if(r&&i){h=!0,l.push(`${a}CREATES -> ${t}`);let s=S(_+1,i);s&&l.push(s)}else l.push(`${a}uses -> ${t}`);return l.join(`
`)}let d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(u>2||h)&&console.log(d.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(ce[184],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,E.createDecorator)("labelService")}),define(ce[63],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,E.createDecorator)("localizationsService");function P(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const D of g.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}e.isValidLocalization=P}),define(ce[15],ue([0,1,6,2,4,7,43]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function C(){return new Date().toISOString()}var p;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class w extends P.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class n extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(p.Trace)&&this.log(p.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(p.Debug)&&this.log(p.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(p.Info)&&this.log(p.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(p.Warning)&&this.log(p.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(p.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(p.Error,this.format(i))}else this.log(p.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(p.Critical)&&this.log(p.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let s=t[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch(c){}r+=(i>0?" ":"")+s}return r}}e.AbstractMessageLogger=n;class A extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!g.isWindows}trace(t,...r){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}debug(t,...r){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}info(t,...r){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}warn(t,...r){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...r):console.warn(`[main ${C()}]`,t,...r))}error(t,...r){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}critical(t,...r){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=A;class b extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=b;class m extends w{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,I.toErrorMessage)(t,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class u extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class h extends P.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=h;class S extends P.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(i))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?p.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class d{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(t){}getLevel(){return p.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=d;function _(a){if(a.verbose)return p.Trace;if(typeof a.logLevel=="string"){const t=f(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function f(a){switch(a){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=f;function l(a){switch(a){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=l}),define(ce[185],ue([0,1,16,2,20,32,28,3,19,33,15,22,49,4,14,11]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let d=class extends P.Disposable{constructor(f,l,a,t){super();this.fileService=l,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=C.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,l){await this.cleanUpPromise;const a=this.getName(f),t=(0,p.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const r=(0,p.joinPath)(this.extensionsDownloadDir,`.${(0,A.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(f,r,l);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(s){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,h.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(f){}async rename(f,l,a){try{await E.Promises.rename(f.fsPath,l.fsPath)}catch(t){if(m.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${f} to ${l} with 'EPERM' error. Trying again...`),this.rename(f,l,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const l=[],a=[];for(const i of f.children){const s=this.parse(i.name);s&&a.push([s,i])}const t=(0,w.groupByExtension)(a,([i])=>i),r=[];for(const i of t)i.sort((s,c)=>b.rcompare(s[0].version,c[0].version)),l.push(...i.slice(1).map(s=>s[1].resource)),r.push(i[0][1]);r.sort((i,s)=>i.mtime-s.mtime),l.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await u.Promises.settled(l.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new w.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,A.generateUuid)()}parse(f){const l=S.exec(f);return l&&l[1]&&l[2]?new w.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};d=Le([xe(0,I.INativeEnvironmentService),xe(1,g.IFileService),xe(2,D.IExtensionGalleryService),xe(3,n.ILogService)],d),e.ExtensionsDownloader=d}),define(ce[186],ue([0,1,2,15,35,43,5,14,7,8,16,28]),function(X,e,E,P,g,D,I,C,p,w,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let b=class extends E.Disposable{constructor(u,h){super();this.environmentService=u,this.logService=h,this.processesLimiter=new C.Limiter(5)}async postUninstall(u){const h=this.parseScript(u,"uninstall");return h&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${S}`)))),n.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(u,h){const S=`vscode:${h}`;if(u.location.scheme===w.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[S]=="string"){const d=u.manifest.scripts[S].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${S} should be a node script`),null):{script:(0,I.join)(u.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(u,h,S,d,_){return new Promise((f,l)=>{const a=this.start(u,h,S,_);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?l(i):f(void 0)};a.on("error",i=>{r((0,D.toErrorMessage)(i)||"Unknown")}),a.on("exit",(i,s)=>{r(i?`post-${h} process exited with code ${i}`:void 0)}),d&&(t=setTimeout(()=>{t=null,a.kill(),l("timed out")},5e3))})}start(u,h,S,d){const _={silent:!0,execArgv:void 0},f=(0,g.fork)(u,[`--type=extension-post-${h}`,...S],_);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const l=p.Event.fromNodeEventEmitter(f.stdout,"data"),a=p.Event.fromNodeEventEmitter(f.stderr,"data");l(i=>this.logService.info(d.identifier.id,d.manifest.version,`post-${h}`,i)),a(i=>this.logService.error(d.identifier.id,d.manifest.version,`post-${h}`,i));const t=p.Event.any(p.Event.map(l,i=>({data:`%c${i}`,format:[""]})),p.Event.map(a,i=>({data:`%c${i}`,format:["color: red"]})));return p.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(d.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),f}getExtensionStoragePath(u){return(0,I.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};b=Le([xe(0,A.IEnvironmentService),xe(1,P.ILogService)],b),e.ExtensionsLifecycle=b}),define(ce[187],ue([0,1,2,28,7,20,3,33,19,15]),function(X,e,E,P,g,D,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends E.Disposable{constructor(b,m,u,h){super();this.extensionsManagementService=b,this.logService=h,this._onDidChangeExtensionsByAnotherSource=this._register(new g.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(_=>{this.installedExtensions=_.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(b.onInstallExtension(_=>this.onInstallExtension(_))),this._register(b.onDidInstallExtensions(_=>this.onDidInstallExtensions(_))),this._register(b.onDidUninstallExtension(_=>this.onDidUninstallExtension(_)));const S=I.URI.file(u.extensionsPath),d=new p.ExtUri(_=>!m.hasCapability(_,1024));this._register(m.watch(S)),this._register(g.Event.filter(m.onDidChangeFilesRaw,_=>_.changes.some(f=>this.doesChangeAffects(f,S,d)))(()=>this.onDidChange()))}doesChangeAffects(b,m,u){return u.isEqual(u.dirname(b.resource),m)?u.isEqual(b.resource,u.joinPath(m,".obsolete"))?!0:!(b.type!==1&&b.type!==2||u.basename(b.resource).startsWith(".")):!1}onInstallExtension(b){this.addInstallingExtension(b.identifier)}onDidInstallExtensions(b){for(const m of b)this.removeInstallingExtension(m.identifier),m.local&&this.addInstalledExtension(m.identifier)}onDidUninstallExtension(b){b.error||this.removeInstalledExtension(b.identifier)}addInstallingExtension(b){this.removeInstallingExtension(b),this.installingExtensions.push(b)}removeInstallingExtension(b){this.installingExtensions=this.installingExtensions.filter(m=>!(0,C.areSameExtensions)(m,b))}addInstalledExtension(b){this.installedExtensions&&(this.removeInstalledExtension(b),this.installedExtensions.push(b))}removeInstalledExtension(b){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(m=>!(0,C.areSameExtensions)(m,b)))}async onDidChange(){if(this.installedExtensions){const b=await this.extensionsManagementService.getInstalled(1),m=b.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(S=>(0,C.areSameExtensions)(S,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),u=this.installedExtensions.filter(h=>this.installingExtensions.some(S=>(0,C.areSameExtensions)(S,h))?!1:b.every(S=>!(0,C.areSameExtensions)(S.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=b.map(h=>h.identifier),(m.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:m,removed:u})}}};n=Le([xe(1,D.IFileService),xe(2,P.INativeEnvironmentService),xe(3,w.ILogService)],n),e.ExtensionsWatcher=n}),define(ce[89],ue([0,1,16,64,32,2,28,14,33,15,63,21,8,5]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends D.Disposable{constructor(d,_,f){super();this.extensionManagementService=d,this.logService=f,this.cache=this._register(new h(_,f)),this.extensionManagementService.registerParticipant({postInstall:async l=>this.postInstallExtension(l),postUninstall:async l=>this.postUninstallExtension(l)})}async getLanguageIds(){const d=await this.cache.getLanguagePacks(),_=["en",...Object.keys(d)];return(0,A.distinct)(_)}async postInstallExtension(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",d.identifier.id),await this.update())}async postUninstallExtension(d){const _=await this.cache.getLanguagePacks();Object.keys(_).some(f=>_[f]&&_[f].extensions.some(l=>(0,p.areSameExtensions)(l.extensionIdentifier,d.identifier)))&&(this.logService.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,_]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(_);return!(0,A.equals)(Object.keys(d),Object.keys(f))}};u=Le([xe(0,g.IExtensionManagementService),xe(1,I.INativeEnvironmentService),xe(2,w.ILogService)],u),e.LocalizationsService=u;let h=class extends D.Disposable{constructor(d,_){super();this.logService=_,this.languagePacks={},this.languagePacksFilePath=(0,m.join)(d.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new C.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(d){return this.withLanguagePacks(_=>{Object.keys(_).forEach(f=>delete _[f]),this.createLanguagePacksFromExtensions(_,...d)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(d,..._){for(const f of _)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(d,f);Object.keys(d).forEach(f=>this.updateHash(d[f]))}createLanguagePacksFromExtension(d,_){const f=_.identifier,l=_.manifest.contributes&&_.manifest.contributes.localizations?_.manifest.contributes.localizations:[];for(const a of l)if(_.location.scheme===b.Schemas.file&&(0,n.isValidLocalization)(a)){let t=d[a.languageId];t||(t={hash:"",extensions:[],translations:{}},d[a.languageId]=t);let r=t.extensions.filter(i=>(0,p.areSameExtensions)(i.extensionIdentifier,f))[0];r?r.version=_.manifest.version:t.extensions.push({extensionIdentifier:f,version:_.manifest.version});for(const i of a.translations)t.translations[i.id]=(0,m.join)(_.location.fsPath,i.path)}}updateHash(d){if(d){const _=(0,P.createHash)("md5");for(const f of d.extensions)_.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);d.hash=_.digest("hex")}}withLanguagePacks(d=()=>null){return this.languagePacksFileLimiter.queue(()=>{let _=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(l){return{}}}).then(f=>(_=d(f),f)).then(f=>{for(const a of Object.keys(f))f[a]||delete f[a];this.languagePacks=f,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),E.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>_,f=>this.logService.error(f))})}};h=Le([xe(0,I.INativeEnvironmentService),xe(1,w.ILogService)],h)}),define(ce[90],ue([0,1,15,7,3]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class D{constructor(b){this.service=b,this.onDidChangeLogLevel=P.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(b,m,u){switch(m){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=D;class I{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){I.setLevel(this.channel,b)}static setLevel(b,m){return b.call("setLevel",m)}}e.LogLevelChannelClient=I;class C{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,m){throw new Error(`Event not found: ${m}`)}async call(b,m,u){switch(m){case"createLogger":this.createLogger(g.URI.revive(u[0]),u[1]);return;case"log":return this.log(g.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${m}`)}createLogger(b,m){this.loggers.set(b.toString(),this.loggerService.createLogger(b,m))}consoleLog(b,m){let u=console.log;switch(b){case E.LogLevel.Error:u=console.error;break;case E.LogLevel.Warning:u=console.warn;break;case E.LogLevel.Info:u=console.info;break}u.call(console,...m)}log(b,m){const u=this.loggers.get(b.toString());if(!u)throw new Error("Create the logger before logging");for(const[h,S]of m)switch(h){case E.LogLevel.Trace:u.trace(S);break;case E.LogLevel.Debug:u.debug(S);break;case E.LogLevel.Info:u.info(S);break;case E.LogLevel.Warning:u.warn(S);break;case E.LogLevel.Error:u.error(S);break;case E.LogLevel.Critical:u.critical(S);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=C;class p extends E.AbstractLoggerService{constructor(b,m,u){super(b,m);this.channel=u}createConsoleMainLogger(){return new E.AdapterLogger({log:(b,m)=>{this.channel.call("consoleLog",[b,m])}})}doCreateLogger(b,m,u){return new w(this.channel,b,m,u)}}e.LoggerChannelClient=p;class w extends E.AbstractMessageLogger{constructor(b,m,u,h){super(h?.always);this.channel=b,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[m,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,m){const u=[[b,m]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(b){this.channel.call("log",[this.file,b])}}class n extends E.LogService{constructor(b,m){super(m);this.parent=b,this._register(b.onDidChangeLogLevel(u=>m.setLevel(u)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=n}),define(ce[91],ue([0,1,15,20]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function g(p,w,n,A){try{const b=await new Promise((m,u)=>{X(["spdlog"],m,u)});return b.setFlushOn(E.LogLevel.Trace),b.createAsyncRotatingLogger(p,w,n,A)}catch(b){console.error(b)}return null}function D(p,w,n,A){const b=X.__$__nodeRequire("spdlog");return b.setFlushOn(E.LogLevel.Trace),b.createRotatingLogger(p,w,n,A)}e.createRotatingLogger=D;function I(p,w,n){switch(w){case E.LogLevel.Trace:p.trace(n);break;case E.LogLevel.Debug:p.debug(n);break;case E.LogLevel.Info:p.info(n);break;case E.LogLevel.Warning:p.warn(n);break;case E.LogLevel.Error:p.error(n);break;case E.LogLevel.Critical:p.critical(n);break;default:throw new Error("Invalid log level")}}class C extends E.AbstractMessageLogger{constructor(w,n,A,b){super();this.name=w,this.filepath=n,this.rotating=A,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const w=this.rotating?6:1,n=30/w*P.ByteSize.MB;return g(this.name,this.filepath,n,w).then(A=>{if(A){this._logger=A,this._logger.setLevel(this.getLevel());for(const{level:b,message:m}of this.buffer)I(this._logger,b,m);this.buffer=[]}})}log(w,n){this._logger?I(this._logger,w,n):this.getLevel()<=w&&this.buffer.push({level:w,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(ce[188],ue([0,1,6,153,73]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(D=e.MarkerTag||(e.MarkerTag={}));var I;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(p){function w(u,h){return h-u}p.compare=w;const n=Object.create(null);n[p.Error]=(0,P.localize)(0,null),n[p.Warning]=(0,P.localize)(1,null),n[p.Info]=(0,P.localize)(2,null);function A(u){return n[u]||""}p.toString=A;function b(u){switch(u){case g.default.Error:return p.Error;case g.default.Warning:return p.Warning;case g.default.Info:return p.Info;case g.default.Ignore:return p.Hint}}p.fromSeverity=b;function m(u){switch(u){case p.Error:return g.default.Error;case p.Warning:return g.default.Warning;case p.Info:return g.default.Info;case p.Hint:return g.default.Ignore}}p.toSeverity=m}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(p){const w="";function n(b){return A(b,!0)}p.makeKey=n;function A(b,m){let u=[w];return b.source?u.push(b.source.replace("\xA6","\\\xA6")):u.push(w),b.code?typeof b.code=="string"?u.push(b.code.replace("\xA6","\\\xA6")):u.push(b.code.value.replace("\xA6","\\\xA6")):u.push(w),b.severity!==void 0&&b.severity!==null?u.push(I.toString(b.severity)):u.push(w),b.message&&m?u.push(b.message.replace("\xA6","\\\xA6")):u.push(w),b.startLineNumber!==void 0&&b.startLineNumber!==null?u.push(b.startLineNumber.toString()):u.push(w),b.startColumn!==void 0&&b.startColumn!==null?u.push(b.startColumn.toString()):u.push(w),b.endLineNumber!==void 0&&b.endLineNumber!==null?u.push(b.endLineNumber.toString()):u.push(w),b.endColumn!==void 0&&b.endColumn!==null?u.push(b.endColumn.toString()):u.push(w),u.push(w),u.join("\xA6")}p.makeKeyOptionalMessage=A})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(ce[189],ue([0,1,73,6,7]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=E.default,e.INotificationService=(0,P.createDecorator)("notificationService");var D;(function(w){w[w.WORKSPACE=0]="WORKSPACE",w[w.GLOBAL=1]="GLOBAL"})(D=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(w){w[w.OFF=0]="OFF",w[w.SILENT=1]="SILENT",w[w.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new p,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=C;class p{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=p}),define(ce[29],ue([0,1,8,4,23,19]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof P.globals.vscode!="undefined"&&typeof P.globals.vscode.context!="undefined"){const C=P.globals.vscode.context.configuration();if(C)I=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const C=(0,D.dirname)(E.FileAccess.asFileUri("",X));I=X.__$__nodeRequire((0,D.joinPath)(C,"product.json").fsPath);const p=X.__$__nodeRequire((0,D.joinPath)(C,"package.json").fsPath);g.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`}),Object.assign(I,{version:p.version})}else I={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://vscodeweb.azureedge.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-webview.net/{{quality}}/{{commit}}",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","msjsdiag.debugger-for-chrome":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","austin.code-gnu-global":"{**/*.c,**/*.cpp,**/*.h}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","dbaeumer.jshint":"{**/*.js,**/*.jsx,**/*.es6,**/.babelrc,**/jsconfig.json,**/.jshintrc,**/.jshintignore}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","felixfbecker.php-intellisense":"{**/*.php,**/php.ini}","felixfbecker.php-debug":"{**/*.php,**/php.ini}","ikappas.phpcs":"{**/*.php,**/php.ini}","rust-lang.rust":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc,**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.babelrc,**/jsconfig.json}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","shinnn.stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","bajdzis.vscode-database":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","octref.vetur":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"ms-toolsai.jupyter":{name:"Jupyter",pattern:"{**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"octref.vetur":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","hiro-sun.vscode-emacs","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","octref.vetur","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",telemetryOptOutUrl:"https://go.microsoft.com/fwlink/?linkid=870136",npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionAllowedProposedApi:["GitHub.codespaces","GitHub.copilot-nightly","GitHub.copilot","GitHub.vscode-pull-request-github-insiders","GitHub.vscode-pull-request-github","GitHub.remotehub","GitHub.remotehub-insiders","Microsoft.vscode-nmake-tools","ms-ai-tools.notebook-renderers","ms-dotnettools.dotnet-interactive-vscode","ms-python.gather","ms-python.python","ms-toolsai.jupyter","ms-toolsai.vscode-ai","ms-toolsai.vscode-ai-remote","ms-vscode-remote.remote-containers-nightly","ms-vscode-remote.remote-containers","ms-vscode-remote.remote-ssh-edit-nightly","ms-vscode-remote.remote-ssh-edit","ms-vscode-remote.remote-ssh-nightly","ms-vscode-remote.remote-ssh","ms-vscode-remote.remote-wsl-nightly","ms-vscode-remote.remote-wsl","ms-vscode-remote.remote-wsl-recommender","ms-vscode-remote.vscode-remote-extensionpack-nightly","ms-vscode-remote.vscode-remote-extensionpack","ms-vscode.anycode","ms-vscode.azure-account","ms-vscode.azure-sphere-tools-ui","ms-vscode.azure-sphere-tools","ms-vscode.remotehub","ms-vscode.remotehub-insiders","ms-vscode.js-debug-nightly","ms-vscode.js-debug","ms-vscode.lsif-browser","ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.vscode-selfhost-test-provider","ms-vscode.test-adapter-converter","ms-vsliveshare.cloudenv-explorer","ms-vsliveshare.cloudenv","ms-vsliveshare.vsliveshare","ms-vsonline.vsonline","dbaeumer.vscode-eslint","tanhakabir.rest-book","ms-playwright.playwright","VisualStudioExptTeam.vscodeintellicode","VisualStudioExptTeam.vscodeintellicode-insiders","vscode.vscode-web-playground","sandy081.999-test-github-issue-notebooks"],tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"manasxx.background-cover":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"liviuschera.noctis":["ui","workspace"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"redhat.vscode-yaml":{default:!1},"felixfbecker.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"felixfbecker.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"batisteo.vscode-django":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://vscode-auth.github.com","https://client-auth-staging-14a768b.herokuapp.com","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.node-debug",version:"1.44.32",repo:"https://github.com/microsoft/vscode-node-debug",metadata:{id:"b6ded8fb-a0a0-4c1c-acbd-ab2a3bc995a6",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.node-debug2",version:"1.42.10",repo:"https://github.com/microsoft/vscode-node-debug2",metadata:{id:"36d19e17-7569-4841-a001-947eb18602b2",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.references-view",version:"0.0.80",repo:"https://github.com/microsoft/vscode-references-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.14",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.59.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.18",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.11",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.59.0",commit:"379476f0e13988d90fab105c5c19e7abc8b1dea8",date:"2021-08-04T23:01:14.936Z"},Object.keys(I).length===0&&Object.assign(I,{version:"1.59.0-dev",nameShort:P.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:P.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=I}),define(ce[92],ue([0,1,151,17,20,11,29]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(A,b,m,u,h,S){let d;try{await p(A,b,m,u,h,S)}catch(_){d=_}finally{d&&h.errorTransformer&&(d=h.errorTransformer(d)),typeof d!="undefined"&&m.error(d),m.end()}}e.readFileIntoStream=C;async function p(A,b,m,u,h,S){w(S);const d=await A.open(b,{create:!1});try{w(S);let _=0,f=0,l=h&&typeof h.length=="number"?h.length:void 0,a=P.VSBuffer.alloc(Math.min(h.bufferSize,typeof l=="number"?l:h.bufferSize)),t=h&&typeof h.position=="number"?h.position:0,r=0;do f=await A.read(d,t,a.buffer,r,a.byteLength-r),t+=f,r+=f,_+=f,typeof l=="number"&&(l-=f),r===a.byteLength&&(await m.write(u(a)),a=P.VSBuffer.alloc(Math.min(h.bufferSize,typeof l=="number"?l:h.bufferSize)),r=0);while(f>0&&(typeof l!="number"||l>0)&&w(S)&&n(_,h));if(r>0){let i=r;typeof l=="number"&&(i=Math.min(r,l)),m.write(u(a.slice(0,i)))}}catch(_){throw(0,g.ensureFileSystemProviderError)(_)}finally{await A.close(d)}}function w(A){if(A.isCancellationRequested)throw(0,D.canceled)();return!0}function n(A,b){if(b?.limits){if(typeof b.limits.memory=="number"&&A>b.limits.memory)throw(0,g.createFileSystemProviderError)((0,E.localize)(0,null,I.default.nameShort),g.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&A>b.limits.size)throw(0,g.createFileSystemProviderError)((0,E.localize)(1,null),g.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ce[93],ue([0,1,149,48,2,20,7,19,26,21,15,17,42,14,25,8,92,51]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let _=class wt extends g.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new I.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new I.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new I.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new I.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new I.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new I.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new m.ThrottledWorker(wt.FILE_EVENTS_THROTTLING.maxChangesChunkSize,wt.FILE_EVENTS_THROTTLING.maxChangesBufferSize,wt.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new D.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new m.ThrottledWorker(wt.FILE_EVENTS_THROTTLING.maxChangesChunkSize,wt.FILE_EVENTS_THROTTLING.maxChangesBufferSize,wt.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new D.FileChangesEvent(a,!0)))),this.watchedResources=p.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new m.ResourceQueue)}registerProvider(l,a){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,P.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:a});const t=new g.DisposableStore;return t.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:l}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,g.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:a}),this.provider.delete(l),(0,g.dispose)(t)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){a.push(t)}}),!this.provider.has(l)&&await m.Promises.settled(a)}canHandleResource(l){return this.provider.has(l.scheme)}hasCapability(l,a){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return d.Iterable.map(this.provider,([l,a])=>({scheme:l,capabilities:a.capabilities}))}async withProvider(l){if(!(0,C.isAbsolutePath)(l))throw new D.FileOperationError((0,E.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const a=this.provider.get(l.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,E.localize)(1,null,l.toString()),t}return a}async withReadProvider(l){const a=await this.withProvider(l);if((0,D.hasOpenReadWriteCloseCapability)(a)||(0,D.hasReadWriteCapability)(a)||(0,D.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const a=await this.withProvider(l);if((0,D.hasOpenReadWriteCloseCapability)(a)||(0,D.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,a){try{return await this.doResolveFile(l,a)}catch(t){throw(0,D.toFileSystemProviderErrorCode)(t)===D.FileSystemProviderErrorCode.FileNotFound?new D.FileOperationError((0,E.localize)(2,null,this.resourceForError(l)),1):(0,D.ensureFileSystemProviderError)(t)}}async doResolveFile(l,a){const t=await this.withProvider(l),r=this.isPathCaseSensitive(t),i=a?.resolveTo,s=a?.resolveSingleChildDescendants,c=a?.resolveMetadata,v=await t.stat(l);let y;return this.toFileStat(t,l,v,void 0,!!c,(T,R)=>(y||(y=p.TernarySearchTree.forUris(()=>!r),y.set(l,!0),(0,w.isNonEmptyArray)(i)&&i.forEach(o=>y.set(o,!0))),Boolean(y.findSuperstr(T.resource)||y.get(T.resource))?!0:T.isDirectory&&s?R===1:!1))}async toFileStat(l,a,t,r,i,s){const{providerExtUri:c}=this.getExtUri(l),v={resource:a,name:c.basename(a),isFile:(t.type&D.FileType.File)!=0,isDirectory:(t.type&D.FileType.Directory)!=0,isSymbolicLink:(t.type&D.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&D.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,D.etag)({mtime:t.mtime,size:t.size})};if(v.isDirectory&&s(v,r)){try{const y=await l.readdir(a),T=await m.Promises.settled(y.map(async([R,o])=>{try{const k=c.joinPath(a,R),O=i?await l.stat(k):{type:o};return await this.toFileStat(l,k,O,y.length,i,s)}catch(k){return this.logService.trace(k),null}}));v.children=(0,w.coalesce)(T)}catch(y){this.logService.trace(y),v.children=[]}return v}return v}async resolveAll(l){return m.Promises.settled(l.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const a=await this.withProvider(l);try{return!!await a.stat(l)}catch(t){return!1}}async canCreateFile(l,a){try{await this.doValidateCreateFile(l,a)}catch(t){return t}return!0}async doValidateCreateFile(l,a){if(!a?.overwrite&&await this.exists(l))throw new D.FileOperationError((0,E.localize)(3,null,this.resourceForError(l)),3,a)}async createFile(l,a=A.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const r=await this.writeFile(l,a);return this._onDidRunOperation.fire(new D.FileOperationEvent(l,0,r)),r}async writeFile(l,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,l,t)||await this.mkdirp(r,i.dirname(l));let c;if((0,D.hasReadWriteCapability)(r)&&!(a instanceof A.VSBuffer))if((0,b.isReadableStream)(a)){const v=await(0,b.peekStream)(a,3);v.ended?c=A.VSBuffer.concat(v.buffer):c=v}else c=(0,b.peekReadable)(a,v=>A.VSBuffer.concat(v),3);else c=a;!(0,D.hasOpenReadWriteCloseCapability)(r)||(0,D.hasReadWriteCapability)(r)&&c instanceof A.VSBuffer?await this.doWriteUnbuffered(r,l,t,c):await this.doWriteBuffered(r,l,t,c instanceof A.VSBuffer?(0,A.bufferToReadable)(c):c)}catch(s){throw new D.FileOperationError((0,E.localize)(4,null,this.resourceForError(l),(0,D.ensureFileSystemProviderError)(s).toString()),(0,D.toFileOperationResult)(s),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,a,t){if(!!t?.unlock&&!(l.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(a)));let i;try{i=await l.stat(a)}catch(s){return}if((i.type&D.FileType.Directory)!=0)throw new D.FileOperationError((0,E.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==D.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,D.etag)({mtime:t.mtime,size:i.size}))throw new D.FileOperationError((0,E.localize)(7,null),3,t);return i}async readFile(l,a){const t=await this.withReadProvider(l);return a?.atomic?this.doReadFileAtomic(t,l,a):this.doReadFile(t,l,a)}async doReadFileAtomic(l,a,t){return new Promise((r,i)=>{this.writeQueue.queueFor(a,this.getExtUri(l).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(l,a,t);r(s)}catch(s){i(s)}})})}async doReadFile(l,a,t){const r=await this.doReadFileStream(l,a,{...t,preferUnbuffered:!0});return{...r,value:await(0,A.streamToBuffer)(r.value)}}async readFileStream(l,a){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,a)}async doReadFileStream(l,a,t){const r=new u.CancellationTokenSource,i=this.validateReadFile(a,t).then(c=>c,c=>{throw r.cancel(),c});let s;try{return t&&typeof t.etag=="string"&&t.etag!==D.ETAG_DISABLED&&await i,!((0,D.hasOpenReadWriteCloseCapability)(l)||(0,D.hasFileReadStreamCapability)(l))||(0,D.hasReadWriteCapability)(l)&&t?.preferUnbuffered?s=this.readFileUnbuffered(l,a,t):(0,D.hasFileReadStreamCapability)(l)?s=this.readFileStreamed(l,a,r.token,t):s=this.readFileBuffered(l,a,r.token,t),{...await i,value:s}}catch(c){s&&await(0,b.consumeStream)(s);const v=(0,E.localize)(8,null,this.resourceForError(a),(0,D.ensureFileSystemProviderError)(c).toString());throw c instanceof D.NotModifiedSinceFileOperationError?new D.NotModifiedSinceFileOperationError(v,c.stat,t):new D.FileOperationError(v,(0,D.toFileOperationResult)(c),t)}}readFileStreamed(l,a,t,r=Object.create(null)){const i=l.readFileStream(a,r,t);return(0,b.transform)(i,{data:s=>s instanceof A.VSBuffer?s:A.VSBuffer.wrap(s),error:s=>new D.FileOperationError((0,E.localize)(9,null,this.resourceForError(a),(0,D.ensureFileSystemProviderError)(s).toString()),(0,D.toFileOperationResult)(s),r)},s=>A.VSBuffer.concat(s))}readFileBuffered(l,a,t,r=Object.create(null)){const i=(0,A.newWriteableBufferStream)();return(0,S.readFileIntoStream)(l,a,i,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new D.FileOperationError((0,E.localize)(10,null,this.resourceForError(a),(0,D.ensureFileSystemProviderError)(s).toString()),(0,D.toFileOperationResult)(s),r)},t),i}readFileUnbuffered(l,a,t){const r=(0,b.newWriteableStream)(i=>A.VSBuffer.concat(i));return(async()=>{try{let i=await l.readFile(a);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(a,i.byteLength,t),r.end(A.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(l,a){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new D.FileOperationError((0,E.localize)(11,null,this.resourceForError(l)),0,a);if(a&&typeof a.etag=="string"&&a.etag!==D.ETAG_DISABLED&&a.etag===t.etag)throw new D.NotModifiedSinceFileOperationError((0,E.localize)(12,null),t,a);return this.validateReadFileLimits(l,t.size,a),t}validateReadFileLimits(l,a,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new D.FileOperationError((0,E.localize)(13,null,this.resourceForError(l)),r)}}async canMove(l,a,t){return this.doCanMoveCopy(l,a,"move",t)}async canCopy(l,a,t){return this.doCanMoveCopy(l,a,"copy",t)}async doCanMoveCopy(l,a,t,r){if(l.toString()!==a.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(i,l,s,a,t,r)}catch(i){return i}return!0}async move(l,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,l,i,a,"move",!!t),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new D.FileOperationEvent(l,s==="move"?2:3,c)),c}async copy(l,a,t){const r=await this.withReadProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,l,i,a,"copy",!!t),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new D.FileOperationEvent(l,s==="copy"?3:2,c)),c}async doMoveCopy(l,a,t,r,i,s){if(a.toString()===r.toString())return i;const{exists:c,isSameResourceWithDifferentPathCase:v}=await this.doValidateMoveCopy(l,a,t,r,i,s);if(c&&!v&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(l===t&&(0,D.hasFileFolderCopyCapability)(l))await l.copy(a,r,{overwrite:s});else{const y=await this.resolve(a);y.isDirectory?await this.doCopyFolder(l,y,t,r):await this.doCopyFile(l,a,t,r)}return i}else return l===t?(await l.rename(a,r,{overwrite:s}),i):(await this.doMoveCopy(l,a,t,r,"copy",s),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(l,a,t,r){if((0,D.hasOpenReadWriteCloseCapability)(l)&&(0,D.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(l,a,t,r);if((0,D.hasOpenReadWriteCloseCapability)(l)&&(0,D.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(l,a,t,r);if((0,D.hasReadWriteCapability)(l)&&(0,D.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(l,a,t,r);if((0,D.hasReadWriteCapability)(l)&&(0,D.hasReadWriteCapability)(t))return this.doPipeUnbuffered(l,a,t,r)}async doCopyFolder(l,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await m.Promises.settled(a.children.map(async i=>{const s=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(l,await this.resolve(i.resource),t,s):this.doCopyFile(l,i.resource,t,s)}))}async doValidateMoveCopy(l,a,t,r,i,s){let c=!1;if(l===t){const{providerExtUri:y,isPathCaseSensitive:T}=this.getExtUri(l);if(T||(c=y.isEqual(a,r)),c&&i==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!c&&y.isEqualOrParent(r,a))throw new Error((0,E.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const v=await this.exists(r);if(v&&!c){if(!s)throw new D.FileOperationError((0,E.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(l===t){const{providerExtUri:y}=this.getExtUri(l);if(y.isEqualOrParent(a,r))throw new Error((0,E.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:v,isSameResourceWithDifferentPathCase:c}}getExtUri(l){const a=this.isPathCaseSensitive(l);return{providerExtUri:a?C.extUri:C.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(a,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new D.FileOperationEvent(l,0,t)),t}async mkdirp(l,a){const t=[],{providerExtUri:r}=this.getExtUri(l);for(;!r.isEqual(a,r.dirname(a));)try{if(((await l.stat(a)).type&D.FileType.Directory)==0)throw new Error((0,E.localize)(18,null,this.resourceForError(a)));break}catch(i){if((0,D.toFileSystemProviderErrorCode)(i)!==D.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(a)),a=r.dirname(a)}for(let i=t.length-1;i>=0;i--){a=r.joinPath(a,t[i]);try{await l.mkdir(a)}catch(s){if((0,D.toFileSystemProviderErrorCode)(s)!==D.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,a){try{await this.doValidateDelete(l,a)}catch(t){return t}return!0}async doValidateDelete(l,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(l)));let i;try{i=await t.stat(l)}catch(c){}if(i)this.throwIfFileIsReadonly(l,i);else throw new D.FileOperationError((0,E.localize)(20,null,this.resourceForError(l)),1);if(!!!a?.recursive){const c=await this.resolve(l);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,E.localize)(21,null,this.resourceForError(l)))}return t}async del(l,a){const t=await this.doValidateDelete(l,a),r=!!a?.useTrash,i=!!a?.recursive;await t.delete(l,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new D.FileOperationEvent(l,1))}onDidChangeFile(l,a){this._onDidChangeFilesRaw.fire({changes:l});let t,r;{for(const i of l)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new D.FileChangesEvent(t,!a))}if(r){const i=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&wt.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(l,a={recursive:!1,excludes:[]}){const t=new g.DisposableStore;{let r=!1,i=()=>{r=!0};t.add((0,g.toDisposable)(()=>i())),this.doWatch(l,a).then(s=>{r?(0,g.dispose)(s):i=()=>(0,g.dispose)(s)},s=>this.logService.error(s))}return a.recursive||(this.watchedResources.set(l,(this.watchedResources.get(l)??0)+1),t.add((0,g.toDisposable)(()=>{const r=this.watchedResources.get(l);typeof r=="number"&&(r<=1?this.watchedResources.delete(l):this.watchedResources.set(l,r-1))}))),t}async doWatch(l,a){const t=await this.withProvider(l),r=this.toWatchKey(t,l,a),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(l,a)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,(0,g.toDisposable)(()=>{i.count--,i.count===0&&((0,g.dispose)(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(l,a,t){const{providerExtUri:r}=this.getExtUri(l);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(l=>(0,g.dispose)(l.disposable)),this.activeWatchers.clear()}async doWriteBuffered(l,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(l).providerExtUri).queue(async()=>{const i=await l.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,b.isReadableStream)(r)||(0,b.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(l,i,r):await this.doWriteReadableBufferedQueued(l,i,r)}catch(s){throw(0,D.ensureFileSystemProviderError)(s)}finally{await l.close(i)}})}async doWriteStreamBufferedQueued(l,a,t){let r=0,i;if((0,b.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=A.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,a,s,s.byteLength,r,0),r+=s.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(s,c)=>{(0,b.listenStream)(i,{onData:async v=>{i.pause();try{await this.doWriteBuffer(l,a,v,v.byteLength,r,0)}catch(y){return c(y)}r+=v.byteLength,setTimeout(()=>i.resume())},onError:v=>c(v),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,a,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(l,a,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(l,a,t,r,i,s){let c=0;for(;c<r;)c+=await l.write(a,i+c,t.buffer,s+c,r-c)}async doWriteUnbuffered(l,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,a,t,r))}async doWriteUnbufferedQueued(l,a,t,r){let i;r instanceof A.VSBuffer?i=r:(0,b.isReadableStream)(r)?i=await(0,A.streamToBuffer)(r):(0,b.isReadableBufferedStream)(r)?i=await(0,A.bufferedStreamToBuffer)(r):i=(0,A.readableToBuffer)(r),await l.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(l,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,a,t,r))}async doPipeBufferedQueued(l,a,t,r){let i,s;try{i=await l.open(a,{create:!1}),s=await t.open(r,{create:!0,unlock:!1});const c=A.VSBuffer.alloc(this.BUFFER_SIZE);let v=0,y=0,T=0;do T=await l.read(i,v,c.buffer,y,c.byteLength-y),await this.doWriteBuffer(t,s,c,T,v,y),v+=T,y+=T,y===c.byteLength&&(y=0);while(T>0)}catch(c){throw(0,D.ensureFileSystemProviderError)(c)}finally{await m.Promises.settled([typeof i=="number"?l.close(i):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,a,t,r))}async doPipeUnbufferedQueued(l,a,t,r){return t.writeFile(r,await l.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,a,t,r))}async doPipeUnbufferedToBufferedQueued(l,a,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const s=await l.readFile(a);await this.doWriteBuffer(t,i,A.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,D.ensureFileSystemProviderError)(s)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(l,a,t,r){const i=await(0,A.streamToBuffer)(this.readFileBuffered(l,a,u.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(l,a){if(l.capabilities&2048)throw new D.FileOperationError((0,E.localize)(22,null,this.resourceForError(a)),6);return l}throwIfFileIsReadonly(l,a){if((a.permissions??0)&D.FilePermission.Readonly)throw new D.FileOperationError((0,E.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===h.Schemas.file?l.fsPath:l.toString(!0)}};_.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},_=Le([xe(0,n.ILogService)],_),e.FileService=_}),define(ce[65],ue([0,1,2,20,7,4,16,5,19,31,14,15,152,87,173,175,172,183,42,92,21,17]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h,S,d,_,f,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends E.Disposable{constructor(i,s){super();this.logService=i,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=g.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new g.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new g.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,D.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:c}=await I.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,c),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await I.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),c=[];return await Promise.all(s.map(async v=>{try{let y;v.isSymbolicLink()?y=(await this.stat((0,p.joinPath)(i,v.name))).type:y=this.toType(v),c.push([v.name,y])}catch(y){this.logService.trace(y)}})),c}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let c;return s?.dangling?c=P.FileType.Unknown:i.isFile()?c=P.FileType.File:i.isDirectory()?c=P.FileType.Directory:c=P.FileType.Unknown,s&&(c|=P.FileType.SymbolicLink),c}async readFile(i){try{const s=this.toFilePath(i);return await I.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(i,s,c){const v=(0,_.newWriteableStream)(y=>a.VSBuffer.concat(y.map(T=>a.VSBuffer.wrap(T))).buffer);return(0,f.readFileIntoStream)(this,i,v,y=>y.buffer,{...s,bufferSize:this.BUFFER_SIZE},c),v}async writeFile(i,s,c){let v;try{const y=this.toFilePath(i);if(!c.create||!c.overwrite){if(await I.Promises.exists(y)){if(!c.overwrite)throw(0,P.createFileSystemProviderError)((0,b.localize)(0,null),P.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,P.createFileSystemProviderError)((0,b.localize)(1,null),P.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(i,{create:!0,unlock:c.unlock}),await this.write(v,0,s,0,s.byteLength)}catch(y){throw await this.toFileSystemProviderWriteError(i,y)}finally{typeof v=="number"&&await this.close(v)}}async open(i,s){try{const c=this.toFilePath(i);if((0,P.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:T}=await I.SymlinkSupport.stat(c);T.mode&128||await I.Promises.chmod(c,T.mode|128)}catch(T){this.logService.trace(T)}let v;if((0,P.isFileOpenForWriteOptions)(s)){if(D.isWindows)try{await I.Promises.truncate(c,0),v="r+"}catch(T){T.code!=="ENOENT"&&this.logService.trace(T)}v||(v="w")}else v="r";const y=await I.Promises.open(c,v);return this.mapHandleToPos.set(y,0),(0,P.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(y,i),y}catch(c){throw(0,P.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(i,c):this.toFileSystemProviderError(c)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await I.Promises.fdatasync(i)}catch(s){this.canFlush=!1,this.logService.error(s)}return await I.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}}async read(i,s,c,v,y){const T=this.normalizePos(i,s);let R=null;try{const o=await I.Promises.read(i,c,v,y,T);return typeof o=="number"?R=o:R=o.bytesRead,R}catch(o){throw this.toFileSystemProviderError(o)}finally{this.updatePos(i,T,R)}}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,c){const v=this.mapHandleToPos.get(i);typeof v=="number"&&(typeof s=="number"||(typeof c=="number"?this.mapHandleToPos.set(i,v+c):this.mapHandleToPos.delete(i)))}async write(i,s,c,v,y){return(0,n.retry)(()=>this.doWrite(i,s,c,v,y),100,3)}async doWrite(i,s,c,v,y){const T=this.normalizePos(i,s);let R=null;try{const o=await I.Promises.write(i,c,v,y,T);return typeof o=="number"?R=o:R=o.bytesWritten,R}catch(o){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),o)}finally{this.updatePos(i,T,R)}}async mkdir(i){try{await I.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const c=this.toFilePath(i);await this.doDelete(c,s)}catch(c){throw this.toFileSystemProviderError(c)}}async doDelete(i,s){s.recursive?await I.Promises.rm(i,I.RimRafMode.MOVE):await I.Promises.unlink(i)}async rename(i,s,c){const v=this.toFilePath(i),y=this.toFilePath(s);if(v!==y)try{await this.validateTargetDeleted(i,s,"move",c.overwrite),await I.Promises.move(v,y)}catch(T){throw(T.code==="EINVAL"||T.code==="EBUSY"||T.code==="ENAMETOOLONG")&&(T=new Error((0,b.localize)(2,null,(0,C.basename)(v),(0,C.basename)((0,C.dirname)(y)),T.toString()))),this.toFileSystemProviderError(T)}}async copy(i,s,c){const v=this.toFilePath(i),y=this.toFilePath(s);if(v!==y)try{await this.validateTargetDeleted(i,s,"copy",c.overwrite),await I.Promises.copy(v,y,{preserveSymlinks:!0})}catch(T){throw(T.code==="EINVAL"||T.code==="EBUSY"||T.code==="ENAMETOOLONG")&&(T=new Error((0,b.localize)(3,null,(0,C.basename)(v),(0,C.basename)((0,C.dirname)(y)),T.toString()))),this.toFileSystemProviderError(T)}}async validateTargetDeleted(i,s,c,v){const y=this.toFilePath(i),T=this.toFilePath(s);let R=!1;if(!!(this.capabilities&1024)||(R=(0,w.isEqual)(y,T,!0)),R&&c==="copy")throw(0,P.createFileSystemProviderError)((0,b.localize)(4,null),P.FileSystemProviderErrorCode.FileExists);if(!R&&await I.Promises.exists(T)){if(!v)throw(0,P.createFileSystemProviderError)((0,b.localize)(5,null),P.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(i,s){return s.recursive?this.watchRecursive(i,s.excludes):this.watchNonRecursive(i)}watchRecursive(i,s){const c={path:this.toFilePath(i),excludes:s},v=(0,l.insert)(this.recursiveFoldersToWatch,c);return this.refreshRecursiveWatchers(),(0,E.toDisposable)(()=>{v(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof S.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,E.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,s;this.options?.watcher?.usePolling?(i=u.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?D.isWindows?i=h.FileWatcher:i=u.FileWatcher:i=S.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,c=>this._onDidChangeFile.fire((0,m.toFileChanges)(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===A.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===A.LogLevel.Trace)}))}}watchNonRecursive(i){const s=new d.FileWatcher(this.toFilePath(i),v=>this._onDidChangeFile.fire((0,m.toFileChanges)(v)),v=>{v.type==="error"&&this._onDidWatchErrorOccur.fire(v.message),this.logService[v.type](v.message)},this.logService.getLevel()===A.LogLevel.Trace),c=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===A.LogLevel.Trace)});return(0,E.combinedDisposable)(s,c)}toFilePath(i){return(0,C.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof P.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=P.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=P.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=P.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=P.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=P.FileSystemProviderErrorCode.NoPermissions;break;default:s=P.FileSystemProviderErrorCode.Unknown}return(0,P.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(i,s){let c=this.toFileSystemProviderError(s);if(i&&c.code===P.FileSystemProviderErrorCode.NoPermissions)try{const{stat:v}=await I.SymlinkSupport.stat(this.toFilePath(i));v.mode&128||(c=(0,P.createFileSystemProviderError)(s,P.FileSystemProviderErrorCode.FileWriteLocked))}catch(v){this.logService.trace(v)}return c}dispose(){super.dispose(),(0,E.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,E.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(ce[45],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService")}),define(ce[30],ue([0,1,12,111]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class g{constructor(){this.data=new Map}add(I,C){P.ok(E.isString(I)),P.ok(E.isObject(C)),P.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,C)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new g}),define(ce[190],ue([0,1,30,7]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function g(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class D{constructor(){this._onDidChangeSchema=new P.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,w){this.schemasById[g(p)]=w,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new D;E.Registry.add(e.Extensions.JSONContribution,I)}),define(ce[40],ue([0,1,139,7,30,12,190]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=g.Registry.as(I.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(_,f=!0){this.registerConfigurations([_],f)}registerConfigurations(_,f=!0){const l=[];_.forEach(a=>{l.push(...this.validateAndRegisterProperties(a,f,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(_){const f=[],l=a=>{if(a.properties)for(const t in a.properties)f.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,a.properties[t]);a.allOf&&a.allOf.forEach(t=>l(t))};for(const a of _){l(a);const t=this.configurationContributors.indexOf(a);t!==-1&&this.configurationContributors.splice(t,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}registerDefaultConfigurations(_){const f=[],l=[];for(const a of _)for(const t in a)if(f.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...a[t]};const r={type:"object",default:this.defaultValues[t],description:E.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};l.push(b(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=a[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(_){const f=[];for(const l of _)for(const a in l)if(f.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(..._){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(_){for(const f of _)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(_,f=!0,l,a=3){a=D.isUndefinedOrNull(_.scope)?a:_.scope;let t=[],r=_.properties;if(r)for(let s in r){if(f&&h(s)){delete r[s];continue}const c=r[s];if(this.updatePropertyDefaultValue(s,c),e.OVERRIDE_PROPERTY_PATTERN.test(s)?c.scope=void 0:(c.scope=D.isUndefinedOrNull(c.scope)?a:c.scope,c.restricted=D.isUndefinedOrNull(c.restricted)?!!l?.restrictedConfigurations?.includes(s):c.restricted),r[s].hasOwnProperty("included")&&!r[s].included){this.excludedConfigurationProperties[s]=r[s],delete r[s];continue}else this.configurationProperties[s]=r[s];!r[s].deprecationMessage&&r[s].markdownDeprecationMessage&&(r[s].deprecationMessage=r[s].markdownDeprecationMessage),t.push(s)}let i=_.allOf;if(i)for(let s of i)t.push(...this.validateAndRegisterProperties(s,f,l,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(_){const f=l=>{let a=l.properties;if(a)for(const r in a)this.updateSchema(r,a[r]);let t=l.allOf;t&&t.forEach(f)};f(_)}updateSchema(_,f){switch(e.allSettings.properties[_]=f,f.scope){case 1:e.applicationSettings.properties[_]=f;break;case 2:e.machineSettings.properties[_]=f;break;case 6:e.machineOverridableSettings.properties[_]=f;break;case 3:e.windowSettings.properties[_]=f;break;case 4:e.resourceSettings.properties[_]=f;break;case 5:e.resourceSettings.properties[_]=f,this.resourceLanguageSettingsSchema.properties[_]=f;break}}removeFromSchema(_,f){switch(delete e.allSettings.properties[_],f.scope){case 1:delete e.applicationSettings.properties[_];break;case 2:delete e.machineSettings.properties[_];break;case 6:delete e.machineOverridableSettings.properties[_];break;case 3:delete e.windowSettings.properties[_];break;case 4:case 5:delete e.resourceSettings.properties[_];break}}updateOverridePropertyPatternKey(){for(const _ of this.overrideIdentifiers.values()){const f=`[${_}]`,l={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,l),e.allSettings.properties[f]=l,e.applicationSettings.properties[f]=l,e.machineSettings.properties[f]=l,e.machineOverridableSettings.properties[f]=l,e.windowSettings.properties[f]=l,e.resourceSettings.properties[f]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(_,f){let l=this.defaultValues[_];D.isUndefined(l)&&(l=f.default),D.isUndefined(l)&&(l=m(f.type)),f.default=l}}const A="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(A);function b(d){return d.substring(1,d.length-1)}e.overrideIdentifierFromKey=b;function m(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const u=new n;g.Registry.add(e.Extensions.Configuration,u);function h(d){return d.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(d)?E.localize(5,null,d):u.getConfigurationProperties()[d]!==void 0?E.localize(6,null,d):null:E.localize(4,null)}e.validateProperty=h;function S(){const d=[],_=u.getConfigurationProperties();for(const f of Object.keys(_))d.push([f,_[f].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.getScopes=S}),define(ce[34],ue([0,1,18,12,3,30,6,40]),function(X,e,E,P,g,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function p(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof g.URI)}e.isConfigurationOverrides=p;var w;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function A(r,i){const s=i?r?i.keys.filter(k=>r.keys.indexOf(k)===-1):[...i.keys]:[],c=r?i?r.keys.filter(k=>i.keys.indexOf(k)===-1):[...r.keys]:[],v=[];if(i&&r){for(const k of r.keys)if(i.keys.indexOf(k)!==-1){const O=d(r.contents,k),Y=d(i.contents,k);E.equals(O,Y)||v.push(k)}}const y=[],T=k=>{const O={};for(const Y of k)for(const Q of Y.identifiers)O[a(Q)]=Y;return O},R=i?T(i.overrides):{},o=r?T(r.overrides):{};if(Object.keys(R).length)for(const k of s){const O=R[k];O&&y.push([(0,C.overrideIdentifierFromKey)(k),O.keys])}if(Object.keys(o).length)for(const k of c){const O=o[k];O&&y.push([(0,C.overrideIdentifierFromKey)(k),O.keys])}if(Object.keys(R).length&&Object.keys(o).length)for(const k of v){const O=o[k],Y=R[k];if(O&&Y){const Q=A({contents:O.contents,keys:O.keys,overrides:[]},{contents:Y.contents,keys:Y.keys,overrides:[]});y.push([(0,C.overrideIdentifierFromKey)(k),[...Q.added,...Q.removed,...Q.updated]])}}return{added:s,removed:c,updated:v,overrides:y}}e.compare=A;function b(r,i){const s=[];for(const c of Object.keys(r))if(C.OVERRIDE_PROPERTY_PATTERN.test(c)){const v={};for(const y in r[c])v[y]=r[c][y];s.push({identifiers:[(0,C.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(v),contents:m(v,i)})}return s}e.toOverrides=b;function m(r,i){const s=Object.create(null);for(let c in r)u(s,c,r[c],i);return s}e.toValuesTree=m;function u(r,i,s,c){const v=i.split("."),y=v.pop();let T=r;for(let R=0;R<v.length;R++){let o=v[R],k=T[o];switch(typeof k){case"undefined":k=T[o]=Object.create(null);break;case"object":break;default:c(`Ignoring ${i} as ${v.slice(0,R+1).join(".")} is ${JSON.stringify(k)}`);return}T=k}if(typeof T=="object"&&T!==null)try{T[y]=s}catch(R){c(`Ignoring ${i} as ${v.join(".")} is ${JSON.stringify(T)}`)}else c(`Ignoring ${i} as ${v.join(".")} is ${JSON.stringify(T)}`)}e.addToValueTree=u;function h(r,i){const s=i.split(".");S(r,s)}e.removeFromValueTree=h;function S(r,i){const s=i.shift();if(i.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const c=r[s];typeof c=="object"&&!Array.isArray(c)&&(S(c,i),Object.keys(c).length===0&&delete r[s])}}function d(r,i,s){function c(T,R){let o=T;for(const k of R){if(typeof o!="object"||o===null)return;o=o[k]}return o}const v=i.split("."),y=c(r,v);return typeof y=="undefined"?s:y}e.getConfigurationValue=d;function _(r,i,s){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in r?P.isObject(r[c])&&P.isObject(i[c])?_(r[c],i[c],s):s&&(r[c]=i[c]):r[c]=i[c])})}e.merge=_;function f(){const r=D.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=f;function l(){const r=Object.create(null),i=D.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let s in i){let c=i[s].default;u(r,s,c,v=>console.error(`Conflict in default settings: ${v}`))}return r}e.getDefaultValues=l;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,i,s){const c=r.inspect(i),v=r.inspect(s);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:c.defaultValue}e.getMigratedSettingValue=t}),define(ce[191],ue([0,1,38,26,21,12,18,3,40,34,30,2,7]),function(X,e,E,P,g,D,I,C,p,w,n,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,w.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?(0,w.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const s of g.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[s],v=r[s];v&&(typeof c=="object"&&typeof v=="object"?(c=I.deepClone(c),this.mergeContents(c,v)):c=v),i[s]=c}return new m(i,this.keys,this.overrides)}merge(...t){const r=I.deepClone(this.contents),i=I.deepClone(this.overrides),s=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const v of c.overrides){const[y]=i.filter(T=>g.equals(T.identifiers,v.identifiers));y?this.mergeContents(y.contents,v.contents):i.push(I.deepClone(v))}for(const v of c.keys)s.indexOf(v)===-1&&s.push(v)}return new m(r,s,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&D.isObject(t[i])&&D.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=I.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?I.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,w.addToValueTree)(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,w.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class u extends m{constructor(){const t=(0,w.getDefaultValues)(),r=(0,w.getConfigurationKeys)(),i=[];for(const s of Object.keys(t))p.OVERRIDE_PROPERTY_PATTERN.test(s)&&i.push({identifiers:[(0,p.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,w.toValuesTree)(t[s],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,i)}}e.DefaultConfigurationModel=u;class h{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!D.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:s,overrides:c,restricted:v}=this.doParseRaw(t,r);this._configurationModel=new m(i,s,c),this._restrictedConfigurations=v||[]}doParseContent(t){let r={},i=null,s=[],c=[],v=[];function y(R){Array.isArray(s)?s.push(R):i!==null&&(s[i]=R)}let T={onObjectBegin:()=>{let R={};y(R),c.push(s),s=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{let R=[];y(R),c.push(s),s=R,i=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:y,onError:(R,o,k)=>{v.push({error:R,offset:o,length:k})}};if(t)try{E.visit(t,T),r=s[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return r}doParseRaw(t,r){const i=n.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,i,!0,r);t=s.raw;const c=(0,w.toValuesTree)(t,T=>console.error(`Conflict in settings file ${this._name}: ${T}`)),v=Object.keys(t),y=(0,w.toOverrides)(t,T=>console.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:c,keys:v,overrides:y,restricted:s.restricted}}filter(t,r,i,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const c={},v=[];for(let y in t)if(p.OVERRIDE_PROPERTY_PATTERN.test(y)&&i){const T=this.filter(t[y],r,!1,s);c[y]=T.raw,v.push(...T.restricted)}else{const T=r[y],R=T?typeof T.scope!="undefined"?T.scope:3:void 0;T?.restricted&&v.push(y),(R===void 0||s.scopes===void 0||s.scopes.includes(R))&&(s.skipRestricted&&T?.restricted||(c[y]=t[y]))}return{raw:c,restricted:v}}}e.ConfigurationModelParser=h;class S extends A.Disposable{constructor(t,r,i,s){super();this.userSettingsResource=t,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class d{constructor(t,r,i=new m,s=new m,c=new P.ResourceMap,v=new m,y=new P.ResourceMap,T=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=s,this._folderConfigurations=c,this._memoryConfiguration=v,this._memoryConfigurationByResource=y,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let s;i.resource?(s=this._memoryConfigurationByResource.get(i.resource),s||(s=new m,this._memoryConfigurationByResource.set(i.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(t):s.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const s=this.getConsolidateConfigurationModel(r,i),c=this.getFolderConfigurationModelForResource(r.resource,i),v=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,y=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),T=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),R=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),k=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,Y=r.overrideIdentifier?v.override(r.overrideIdentifier).getValue(t):v.getValue(t),Q=s.getValue(t),me=g.distinct(g.flatten(s.overrides.map(re=>re.identifiers))).filter(re=>s.getOverrideValue(t,re)!==void 0);return{defaultValue:y,userValue:T,userLocalValue:R,userRemoteValue:o,workspaceValue:k,workspaceFolderValue:O,memoryValue:Y,value:Q,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:c?.freeze().getValue(t),override:r.overrideIdentifier?c?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:v.getValue(t),override:r.overrideIdentifier?v.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:me.length?me:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(s=>p.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const c=(0,p.overrideIdentifierFromKey)(s),v=this._defaultConfiguration.getKeysForOverrideIdentifier(c),y=t.getKeysForOverrideIdentifier(c),T=[...y.filter(R=>v.indexOf(R)===-1),...v.filter(R=>y.indexOf(R)===-1),...v.filter(R=>!I.equals(this._defaultConfiguration.override(c).getValue(R),t.override(c).getValue(R)))];return[c,T]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:c}=(0,w.compare)(this.localUserConfiguration,t),v=[...r,...i,...s];return v.length&&this.updateLocalUserConfiguration(t),{keys:v,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:c}=(0,w.compare)(this.remoteUserConfiguration,t);let v=[...r,...i,...s];return v.length&&this.updateRemoteUserConfiguration(t),{keys:v,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:s,overrides:c}=(0,w.compare)(this.workspaceConfiguration,t);let v=[...r,...i,...s];return v.length&&this.updateWorkspaceConfiguration(t),{keys:v,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:s,updated:c,removed:v,overrides:y}=(0,w.compare)(i,r);let T=[...s,...c,...v];return(T.length||!i)&&this.updateFolderConfiguration(t,r),{keys:T,overrides:y}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:s,removed:c,overrides:v}=(0,w.compare)(r,void 0);return{keys:[...i,...s,...c],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const s=r.getFolder(t);s&&(i=this.getFolderConsolidatedConfiguration(s.uri)||i);const c=this._memoryConfigurationByResource.get(t);c&&(i=i.merge(c))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(r=i.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:s,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:s,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((v,y)=>(v.set(C.URI.revive(y[0]),this.parseConfigurationModel(y[1])),v),new P.ResourceMap);return new d(r,i,new m,s,c,new m,new P.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=d;function _(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const s of a)s.keys.forEach(c=>t.add(c)),s.overrides.forEach(([c,v])=>{const y=(0,P.getOrSet)(r,c,new Set);v.forEach(T=>y.add(T))});const i=[];return r.forEach((s,c)=>i.push([c,[...s.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=_;class f{constructor(t,r,i,s){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=s,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(y=>c.add(y)),t.overrides.forEach(([,y])=>y.forEach(T=>c.add(T))),this.affectedKeys=[...c.values()];const v=new m;this.affectedKeys.forEach(y=>v.setValue(y,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!I.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=(0,w.toValuesTree)({[r]:!0},()=>{}),s;for(;typeof i=="object"&&(s=Object.keys(i)[0]);){if(t=t[s],!t)return!1;i=i[s]}return!0}}e.ConfigurationChangeEvent=f;class l extends f{constructor(t,r,i,s){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=l}),define(ce[94],ue([0,1,30,40,2,34,191,7,14,19]),function(X,e,E,P,g,D,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends g.Disposable{constructor(b,m){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,w.extUriBiasedIgnorePathCase,m)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,m){const u=typeof b=="string"?b:void 0,h=(0,D.isConfigurationOverrides)(b)?b:(0,D.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(u,h,void 0)}updateValue(b,m,u,h){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const m=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(u,m,1)}onDidDefaultConfigurationChange(b){const m=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,b);this.trigger(u,m,6)}trigger(b,m,u){const h=new I.ConfigurationChangeEvent(b,{data:m},this.configuration);h.source=u,h.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(ce[95],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,E.createDecorator)("remoteAuthorityResolverService");var P;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class g extends Error{constructor(I,C=P.Unknown,p){super(I);this._message=I,this._code=C,this._detail=p,this.isHandled=C===P.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,g.prototype)}static isTemporarilyNotAvailable(I){return I instanceof g&&I._code===P.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof g&&I._code===P.NoResolverFound}static isHandled(I){return I instanceof g&&I.isHandled}}e.RemoteAuthorityResolverError=g}),define(ce[192],ue([0,1,8]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function P(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=P;function g(w){if(!w)return;const n=w.indexOf("+");return n<0?w:w.substr(0,n)}e.getRemoteName=g;function D(w){return w.scheme!==E.Schemas.file&&w.scheme!==E.Schemas.vscodeRemote}e.isVirtualResource=D;function I(w){if(w.folders.length)return w.folders.every(n=>D(n.uri))?w.folders[0].uri:void 0;if(w.configuration&&D(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=I;function C(w){return I(w)?.scheme}e.getVirtualWorkspaceScheme=C;function p(w){return I(w)!==void 0}e.isVirtualWorkspace=p}),define(ce[66],ue([0,1,154,6,40,30,17]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");function C(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=C;function p(u){return u.res.statusCode===204}async function w(u){if(!C(u))throw new Error("Server returned "+u.res.statusCode);return p(u)?null:(await(0,I.streamToBuffer)(u.stream)).toString()}e.asText=w;async function n(u){if(!C(u))throw new Error("Server returned "+u.res.statusCode);if(p(u))return null;const S=(await(0,I.streamToBuffer)(u.stream)).toString();try{return JSON.parse(S)}catch(d){throw d.message+=`:
`+S,d}}e.asJson=n;function A(u){m(u)}e.updateProxyConfigurationsScope=A;let b;function m(u){const h=D.Registry.as(g.Extensions.Configuration);b&&h.deregisterConfigurations([b]),b={id:"http",order:15,title:(0,E.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,E.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,E.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,E.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,E.localize)(4,null),(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],default:"override",description:(0,E.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,E.localize)(9,null),restricted:!0}}},h.registerConfiguration(b)}m(2)}),define(ce[193],ue([0,1,25,17]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class g{constructor(C){this.service=C}listen(C,p){throw new Error("Invalid listen")}call(C,p,w){switch(p){case"request":return this.service.request(w[0],E.CancellationToken.None).then(async({res:n,stream:A})=>{const b=await(0,P.streamToBuffer)(A);return[{statusCode:n.statusCode,headers:n.headers},b]})}throw new Error("Invalid call")}}e.RequestChannel=g;class D{constructor(C){this.channel=C}async request(C,p){return D.request(this.channel,C,p)}static async request(C,p,w){const[n,A]=await C.call("request",[p]);return{res:n,stream:(0,P.bufferToStream)(A)}}}e.RequestChannelClient=D}),define(ce[194],ue([0,1,67,12]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function g(I,C){return I.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:I.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function D(I,C,p={}){const w=(0,E.parse)(I),n=p.proxyUrl||g(w,C);if(!n)return null;const A=(0,E.parse)(n);if(!/^https?:$/.test(A.protocol||""))return null;const b={host:A.hostname||"",port:A.port||(A.protocol==="https"?"443":"80"),auth:A.auth,rejectUnauthorized:(0,P.isBoolean)(p.strictSSL)?p.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((m,u)=>{X(["http-proxy-agent"],m,u)}))(b):new(await new Promise((m,u)=>{X(["https-proxy-agent"],m,u)}))(b)}e.getProxyAgent=D}),define(ce[195],ue([0,1,22,17]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function g(D,I,C){let p=C&&C.get("storage.serviceMachineId",0)||null;if(p)return p;try{const n=(await I.readFile(D.serviceMachineIdResource)).value.toString();p=(0,E.isUUID)(n)?n:null}catch(w){p=null}if(!p){p=(0,E.generateUuid)();try{await I.writeFile(D.serviceMachineIdResource,P.VSBuffer.fromString(p))}catch(w){}}return C&&C.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=g}),define(ce[196],ue([0,1,6,7,2,12,128,14]),function(X,e,E,P,g,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";e.IStorageService=(0,E.createDecorator)("storageService");var w;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(h){h[h.GLOBAL=0]="GLOBAL",h[h.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var A;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(A=e.StorageTarget||(e.StorageTarget={}));class b extends g.Disposable{constructor(S={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new g.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,g.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,d){d===p?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:d,target:this.getKeyTargets(S)[d]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,d,_){return this.getStorage(d)?.get(S,_)}getBoolean(S,d,_){return this.getStorage(d)?.getBoolean(S,_)}getNumber(S,d,_){return this.getStorage(d)?.getNumber(S,_)}store(S,d,_,f){if((0,D.isUndefinedOrNull)(d)){this.remove(S,_);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,_,f),this.getStorage(_)?.set(S,d)})}remove(S,d){this.withPausedEmitters(()=>{this.updateKeyTarget(S,d,void 0),this.getStorage(d)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,d){const _=[],f=this.getKeyTargets(S);for(const l of Object.keys(f))f[l]===d&&_.push(l);return _}updateKeyTarget(S,d,_){const f=this.getKeyTargets(d);typeof _=="number"?f[S]!==_&&(f[S]=_,this.getStorage(d)?.set(p,JSON.stringify(f))):typeof f[S]=="number"&&(delete f[S],this.getStorage(d)?.set(p,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const d=this.get(p,S);if(d)try{return JSON.parse(d)}catch(_){}return Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(){this._onWillSaveState.fire({reason:w.NONE}),await C.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const S=this.getStorage(0)?.items??new Map,d=this.getStorage(1)?.items??new Map;return u(S,d,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class m extends b{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}e.InMemoryStorageService=m;async function u(h,S,d,_){const f=c=>{try{return JSON.parse(c)}catch(v){return c}},l=new Map,a=new Map;h.forEach((c,v)=>{l.set(v,c),a.set(v,f(c))});const t=new Map,r=new Map;S.forEach((c,v)=>{t.set(v,c),r.set(v,f(c))}),console.group(`Storage: Global (path: ${d})`);let i=[];l.forEach((c,v)=>{i.push({key:v,value:c})}),console.table(i),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${_})`);let s=[];t.forEach((c,v)=>{s.push({key:v,value:c})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=u}),define(ce[197],ue([0,1,4,23,22,3]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(w){if(E.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function C(w,n,A,b,m,u,h,S,d,_){const f=Object.create(null);f["common.machineId"]=h,f.sessionID=(0,g.generateUuid)()+Date.now(),f.commitHash=m,f.version=u,f["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,E.PlatformToString)(E.platform),f["common.nodePlatform"]=P.platform,f["common.nodeArch"]=b,f["common.product"]=_||"desktop";const l=p(S||[]);l&&(f["common.msftInternal"]=l);let a=0;const t=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),E.isLinuxSnap&&(f["common.snap"]="true");const r=I(A);r&&(f["common.platformDetail"]=r);try{const i=await w.readFile(D.URI.file(d));f["common.source"]=i.value.toString().slice(0,30)}catch(i){}return f}e.resolveCommonProperties=C;function p(w){const n=P.env.USERDNSDOMAIN;if(!n)return!1;const A=n.toLowerCase();return w.some(b=>A===b)}e.verifyMicrosoftInternalDomain=p}),define(ce[198],ue([0,1,21,11,2,18]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var I;(function(p){function w(n,A){return n.callstack<A.callstack?-1:n.callstack>A.callstack?1:0}p.compare=w})(I=e.ErrorEvent||(e.ErrorEvent={}));class C{constructor(w,n=C.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new g.DisposableStore,this._telemetryService=w,this._flushDelay=n;const A=P.errorHandler.addListener(b=>this._onErrorEvent(b));this._disposables.add((0,g.toDisposable)(A)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(w){if(!w)return;w.detail&&w.detail.stack&&(w=w.detail);let n=Array.isArray(w.stack)?w.stack.join(`
`):w.stack,A=w.message?w.message:(0,D.safeStringify)(w);!n||this._enqueue({msg:A,callstack:n})}_enqueue(w){const n=(0,E.binarySearch)(this._buffer,w,I.compare);n<0?(w.count=1,this._buffer.splice(~n,0,w)):(this._buffer[n].count||(this._buffer[n].count=0),this._buffer[n].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let w of this._buffer)this._telemetryService.publicLogError2("UnhandledError",w);this._buffer.length=0}}e.default=C,C.ERROR_FLUSH_TIMEOUT=5*1e3}),define(ce[37],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(ce[199],ue([0,1,24,78,180,5,38,81,45,4,3,37,51,8,20,16]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function S(a,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,s=new Map,c=2e4;function v(R,o,k,O){const Y=o.substring(R.length+1);return new Promise(async Q=>{let me;try{me=await h.Promises.readdir(o,{withFileTypes:!0})}catch(W){Q();return}if(O.count>=c){O.count+=me.length,O.maxReached=!0,Q();return}let re=me.length;if(re===0){Q();return}let N=me;O.count+me.length>c&&(O.maxReached=!0,re=c-O.count,N=me.slice(0,re)),O.count+=me.length;for(const W of N)if(W.isDirectory()){if(k.includes(W.name)||await v(R,(0,D.join)(o,W.name),k,O),--re==0){Q();return}}else{const U=W.name.lastIndexOf(".");if(U>=0){const j=W.name.substring(U+1);j&&i.set(j,(i.get(j)??0)+1)}for(const j of r)j.relativePathPattern?.test(Y)!==!1&&j.filePattern.test(W.name)&&s.set(j.tag,(s.get(j.tag)??0)+1);if(--re==0){Q();return}}})}const y={count:0,maxReached:!1};await v(a,a,t,y);const T=await f(a);return{configFiles:d(s),fileTypes:d(i),fileCount:y.count,maxFilesReached:y.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=S;function d(a){return[...b.Iterable.map(a.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function _(){const a={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},t=E.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=_;async function f(a){try{const t=new Map,r=(0,D.join)(a,".vscode","launch.json"),i=await h.Promises.readFile(r),s=[],c=(0,I.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,I.getNodeType)(c)==="object"&&c.configurations)for(const v of c.configurations){const y=v.type;y&&(t.has(y)?t.set(y,t.get(y)+1):t.set(y,1))}return d(t)}catch(t){return[]}}e.collectLaunchConfigs=f;let l=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const i=E.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||r.push(`Load (avg):       ${E.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,C.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[s,c]=i,v=this.formatProcessList(t,s);return r.forEach(y=>{if((0,g.isRemoteDiagnosticError)(y))v+=`
${y.errorMessage}`,c+=`
${y.errorMessage}`;else if(v+=`

Remote: ${y.hostName}`,y.processes&&(v+=`
${this.formatProcessList(t,y.processes)}`),y.workspaceMetadata){c+=`
|  Remote: ${y.hostName}`;for(const T of Object.keys(y.workspaceMetadata)){const R=y.workspaceMetadata[T];let o=`${R.fileCount} files`;R.maxFilesReached&&(o=`more than ${o}`),c+=`|    Folder (${T}): ${o}`,c+=this.formatWorkspaceStats(R)}}}),{processInfo:v,workspaceInfo:c}})}async getSystemInfo(t,r){const{memory:i,vmHint:s,os:c,cpus:v}=_(),y={os:c,memory:i,cpus:v,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return w.isWindows||(y.load=`${E.loadavg().map(T=>Math.round(T)).join(", ")}`),w.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(t,r){const i=[];return(0,C.listProcesses)(t.mainPID).then(async s=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,s)),t.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(c=>{if((0,g.isRemoteDiagnosticError)(c))i.push(`
${c.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${c.hostName}`),i.push(this.formatMachineInfo(c.machineInfo)),c.processes&&i.push(this.formatProcessList(t,c.processes)),c.workspaceMetadata)for(const v of Object.keys(c.workspaceMetadata)){const y=c.workspaceMetadata[v];let T=`${y.fileCount} files`;y.maxFilesReached&&(T=`more than ${T}`),i.push(`Folder (${v}): ${T}`),i.push(this.formatWorkspaceStats(y))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let s=0;const c=(R,o)=>{const k=` ${R}(${o})`;s+k.length>i?(r.push(v),v="|                 ",s=v.length):s+=k.length,v+=k};let v="|      File types:";const y=10;let T=t.fileTypes.length>y?y:t.fileTypes.length;for(let R=0;R<T;R++){const o=t.fileTypes[R];c(o.name,o.count)}if(r.push(v),t.configFiles.length>=0&&(v="|      Conf files:",s=0,t.configFiles.forEach(R=>{c(R.name,R.count)}),r.push(v)),t.launchConfigFiles.length>0){let R="|      Launch Configs:";t.launchConfigFiles.forEach(o=>{R+=o.count>1?` ${o.name}(${o.count})`:` ${o.name}`}),r.push(R)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(c=>{const v=n.URI.revive(c);if(v.scheme===m.Schemas.file){const y=v.fsPath;i.push(S(y,["node_modules",".git"]).then(T=>{let R=`${T.fileCount} files`;T.maxFilesReached&&(R=`more than ${R}`),r.push(`|    Folder (${(0,D.basename)(y)}): ${R}`),r.push(this.formatWorkspaceStats(T))}).catch(T=>{r.push(`|      Error: Unable to collect workspace stats for folder ${y} (${T.toString()})`)}))}else r.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(c=>i.set(c.pid,c.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,s,r,0),s.join(`
`)}formatProcessItem(t,r,i,s,c){const v=c===0;let y;v?y=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(y=`${"  ".repeat(c)} ${s.name}`,s.name==="window"&&(y=`${y} (${r.get(s.pid)})`));const T=process.platform==="win32"?s.mem:E.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(T/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(s.children)&&s.children.forEach(R=>this.formatProcessItem(t,r,i,R,c+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==m.Schemas.file)continue;const s=i.fsPath;try{const c=await S(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),c.fileTypes.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:v.name,count:v.count})}),c.launchConfigFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:v.name,count:v.count})}),c.configFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:v.name,count:v.count})})}catch{}}}};l=Le([xe(0,A.ITelemetryService),xe(1,p.IProductService)],l),e.DiagnosticsService=l}),define(ce[200],ue([0,1,142,2,32,33,7,29,15,37,25,11,3,14,4]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let h=class extends P.Disposable{constructor(l,a,t){super();this.galleryService=l,this.telemetryService=a,this.logService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new I.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new I.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new I.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new I.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(l,a={}){if(!this.galleryService.isEnabled())throw new Error(E.localize(0,null));try{l=await this.checkAndGetCompatibleVersion(l)}catch(r){throw this.logService.error((0,A.getErrorMessage)(r)),d(this.telemetryService,"extensionGallery:install",(0,D.getGalleryExtensionTelemetryData)(l),void 0,r),r}if(!await this.canInstall(l)){const r=new g.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",l.identifier.id,r.message),d(this.telemetryService,"extensionGallery:install",(0,D.getGalleryExtensionTelemetryData)(l),void 0,r),r}const t=await this.galleryService.getManifest(l,n.CancellationToken.None);if(t===null){const r=new g.ExtensionManagementError(`Missing manifest for extension ${l.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",l.identifier.id,r.message),d(this.telemetryService,"extensionGallery:install",(0,D.getGalleryExtensionTelemetryData)(l),void 0,r),r}return this.installExtension(t,l,a)}async uninstall(l,a={}){return this.logService.trace("ExtensionManagementService#uninstall",l.identifier.id),this.unininstallExtension(l,a)}async reinstallFromGallery(l){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",l.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const a=await this.findGalleryExtension(l);if(!a)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(l,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(a)}getExtensionsReport(){const l=new Date().getTime();return(!this.reportedExtensions||l-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=l),this.reportedExtensions}registerParticipant(l){this.participants.push(l)}async installExtension(l,a,t){if(!b.URI.isUri(a)){let v=this.installingExtensions.get(new D.ExtensionIdentifierWithVersion(a.identifier,a.version).key());if(v)return this.logService.info("Extensions is already requested to install",a.identifier.id),v.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],i=[],s=this.createInstallExtensionTask(l,a,t);b.URI.isUri(a)||this.installingExtensions.set(new D.ExtensionIdentifierWithVersion(s.identifier,l.version).key(),s),this._onInstallExtension.fire({identifier:s.identifier,source:a}),this.logService.info("Installing extension:",s.identifier.id),r.push({task:s,manifest:l});let c=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",s.identifier.id);else try{const y=await this.getAllDepsAndPackExtensionsToInstall(s.identifier,l,!!t.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:T,manifest:R}of y)if(c=c||!!R.extensionDependencies?.some(o=>(0,D.areSameExtensions)({id:o},s.identifier)),this.installingExtensions.has(new D.ExtensionIdentifierWithVersion(T.identifier,T.version).key()))this.logService.info("Extension is already requested to install",T.identifier.id);else{const o=this.createInstallExtensionTask(R,T,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new D.ExtensionIdentifierWithVersion(o.identifier,R.version).key(),o),this._onInstallExtension.fire({identifier:o.identifier,source:T}),this.logService.info("Installing extension:",o.identifier.id),r.push({task:o,manifest:R})}}catch(y){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",s.identifier.id),this.logService.error(y),y}const v=r.reduce((y,{task:T,manifest:R})=>(y.set(T.identifier.id.toLowerCase(),{task:T,manifest:R}),y),new Map);for(;v.size;){let y;const T=[...v.values()].filter(({manifest:R})=>!R.extensionDependencies?.some(o=>v.has(o.toLowerCase())));T.length?y=v.size===1?T:T.filter(({task:R})=>!(R===s&&!c)):(this.logService.info("Found extensions with circular dependencies",T.map(({task:R})=>R.identifier.id)),y=[...v.values()]),await this.joinAllSettled(y.map(async({task:R})=>{const o=new Date().getTime();try{const k=await R.run();if(await this.joinAllSettled(this.participants.map(O=>O.postInstall(k,R.source,t,n.CancellationToken.None))),!b.URI.isUri(R.source)&&(d(this.telemetryService,R.operation===2?"extensionGallery:update":"extensionGallery:install",(0,D.getGalleryExtensionTelemetryData)(R.source),new Date().getTime()-o,void 0),u.isWeb&&R.operation===1))try{await this.galleryService.reportStatistic(k.manifest.publisher,k.manifest.name,k.manifest.version,"install")}catch(O){}i.push({local:k,identifier:R.identifier,operation:R.operation,source:R.source})}catch(k){throw b.URI.isUri(R.source)||d(this.telemetryService,R.operation===2?"extensionGallery:update":"extensionGallery:install",(0,D.getGalleryExtensionTelemetryData)(R.source),new Date().getTime()-o,k),this.logService.error("Error while installing the extension:",R.identifier.id),this.logService.error(k),k}finally{v.delete(R.identifier.id.toLowerCase())}}))}return i.forEach(({identifier:y})=>this.logService.info("Extension installed successfully:",y.id)),this._onDidInstallExtensions.fire(i),i.filter(({identifier:y})=>(0,D.areSameExtensions)(y,s.identifier))[0].local}catch(v){if(r.forEach(({task:y})=>y.cancel()),i.length)try{const y=await Promise.allSettled(i.map(({local:T})=>this.createUninstallExtensionTask(T,{versionOnly:!0}).run()));for(let T=0;T<y.length;T++){const R=y[T],{identifier:o}=i[T];R.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",o.id):this.logService.warn("Rollback: Error while uninstalling extension",o.id,(0,A.getErrorMessage)(R.reason))}}catch(y){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(y),i.map(({identifier:T})=>T.id))}throw this.logService.error("Failed to install extension:",s.identifier.id,(0,A.getErrorMessage)(v)),this._onDidInstallExtensions.fire(r.map(({task:y})=>({identifier:y.identifier,operation:1,source:y.source}))),v instanceof Error&&(v.name=v&&v.code?v.code:e.ERROR_UNKNOWN),v}finally{for(const{task:v,manifest:y}of r)if(!b.URI.isUri(v.source)){const T=new D.ExtensionIdentifierWithVersion(v.identifier,y.version).key();this.installingExtensions.delete(T)||this.logService.warn("Installation task is not found in the cache",T)}}}async joinAllSettled(l){const a=[],t=[],r=await Promise.allSettled(l);for(const i of r)i.status==="fulfilled"?a.push(i.value):t.push(i.reason);if(t.length)throw S(t);return a}async getAllDepsAndPackExtensionsToInstall(l,a,t){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const i=[l,...r.map(v=>v.identifier)],s=[],c=async(v,y)=>{const T=y.extensionDependencies||[];if(y.extensionPack){const R=t?r.find(o=>(0,D.areSameExtensions)(o.identifier,v)):void 0;for(const o of y.extensionPack)R&&R.manifest.extensionPack&&R.manifest.extensionPack.some(k=>(0,D.areSameExtensions)({id:k},{id:o}))||T.every(k=>!(0,D.areSameExtensions)({id:k},{id:o}))&&T.push(o)}if(T.length){const R=[...i,...s.map(k=>k.gallery.identifier)],o=T.filter(k=>R.every(O=>!(0,D.areSameExtensions)(O,{id:k})));if(o.length){const k=await this.galleryService.query({names:o,pageSize:T.length},n.CancellationToken.None);for(const O of k.firstPage){if(R.find(me=>(0,D.areSameExtensions)(me,O.identifier)))continue;const Y=await this.checkAndGetCompatibleVersion(O);if(!await this.canInstall(Y)){this.logService.info("Skipping the extension as it cannot be installed",Y.identifier.id);continue}const Q=await this.galleryService.getManifest(Y,n.CancellationToken.None);if(Q===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${Y.identifier.id}`,e.INSTALL_ERROR_VALIDATING);s.push({gallery:Y,manifest:Q}),await c(Y.identifier,Q)}}}};return await c(l,a),r=await this.getInstalled(),s.filter(v=>!r.some(y=>(0,D.areSameExtensions)(y.identifier,v.gallery.identifier)))}async checkAndGetCompatibleVersion(l){if(await this.isMalicious(l))throw new g.ExtensionManagementError(E.localize(3,null,l.identifier.id),g.INSTALL_ERROR_MALICIOUS);const a=await this.galleryService.getCompatibleExtension(l);if(!a)throw new g.ExtensionManagementError(E.localize(4,null,l.identifier.id,C.default.version),g.INSTALL_ERROR_INCOMPATIBLE);return a}async isMalicious(l){const a=await this.getExtensionsReport();return(0,D.getMaliciousExtensionsSet)(a).has(l.identifier.id)}async unininstallExtension(l,a){const t=this.uninstallingExtensions.get(l.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",l.identifier.id),t.waitUntilTaskIsFinished();const r=(v,y)=>{const T=this.createUninstallExtensionTask(v,y);return this.uninstallingExtensions.set(T.extension.identifier.id.toLowerCase(),T),this.logService.info("Uninstalling extension:",v.identifier.id),this._onUninstallExtension.fire(v.identifier),T},i=(v,y)=>{y?this.logService.error("Failed to uninstall extension:",v.identifier.id,y.message):this.logService.info("Successfully uninstalled extension:",v.identifier.id),d(this.telemetryService,"extensionGallery:uninstall",(0,D.getLocalExtensionTelemetryData)(v),void 0,y),this._onDidUninstallExtension.fire({identifier:v.identifier,error:y?.code})},s=[],c=[];try{s.push(r(l,{}));const v=await this.getInstalled(1);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",l.identifier.id);else{const y=this.getAllPackExtensionsToUninstall(l,v);for(const T of y)this.uninstallingExtensions.has(T.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",T.identifier.id):s.push(r(T,{}))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",l.identifier.id):this.checkForDependents(s.map(y=>y.extension),v,l),await this.joinAllSettled(s.map(async y=>{try{if(await y.run(),await this.joinAllSettled(this.participants.map(T=>T.postUninstall(y.extension,a,n.CancellationToken.None))),y.extension.identifier.uuid)try{await this.galleryService.reportStatistic(y.extension.manifest.publisher,y.extension.manifest.name,y.extension.manifest.version,"uninstall")}catch(T){}i(y.extension)}catch(T){const R=T instanceof g.ExtensionManagementError?T:new g.ExtensionManagementError((0,A.getErrorMessage)(T),e.ERROR_UNKNOWN);throw i(y.extension,R),R}finally{c.push(y)}}))}catch(v){const y=v instanceof g.ExtensionManagementError?v:new g.ExtensionManagementError((0,A.getErrorMessage)(v),e.ERROR_UNKNOWN);for(const T of s){try{T.cancel()}catch(R){}c.includes(T)||i(T.extension,y)}throw y}finally{for(const v of s)this.uninstallingExtensions.delete(v.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",v.extension.identifier.id)}}checkForDependents(l,a,t){for(const r of l){const i=this.getDependents(r,a);if(i.length){const s=i.filter(c=>l.indexOf(c)===-1);if(s.length)throw new Error(this.getDependentsErrorMessage(r,s,t))}}}getDependentsErrorMessage(l,a,t){return t===l?a.length===1?E.localize(5,null,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(6,null,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(7,null,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?E.localize(8,null,t.manifest.displayName||t.manifest.name,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(9,null,t.manifest.displayName||t.manifest.name,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(10,null,t.manifest.displayName||t.manifest.name,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}getAllPackExtensionsToUninstall(l,a,t=[]){if(t.indexOf(l)!==-1)return[];t.push(l);const r=l.manifest.extensionPack?l.manifest.extensionPack:[];if(r.length){const i=a.filter(c=>!c.isBuiltin&&r.some(v=>(0,D.areSameExtensions)({id:v},c.identifier))),s=[];for(const c of i)s.push(...this.getAllPackExtensionsToUninstall(c,a,t));return[...i,...s]}return[]}getDependents(l,a){return a.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(r=>(0,D.areSameExtensions)({id:r},l.identifier)))}async findGalleryExtension(l){if(l.identifier.uuid){const a=await this.findGalleryExtensionById(l.identifier.uuid);return a||this.findGalleryExtensionByName(l.identifier.id)}return this.findGalleryExtensionByName(l.identifier.id)}async findGalleryExtensionById(l){return(await this.galleryService.query({ids:[l],pageSize:1},n.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(l){return(await this.galleryService.query({names:[l],pageSize:1},n.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const l=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${l.length} reported extensions from service`),l}catch(l){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};h=Le([xe(0,g.IExtensionGalleryService),xe(1,w.ITelemetryService),xe(2,p.ILogService)],h),e.AbstractExtensionManagementService=h;function S(f){const l=Array.isArray(f)?f:[f];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((a,t)=>new Error(`${a.message}${a.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=S;function d(f,l,a,t,r){const i=r?r instanceof g.ExtensionManagementError?r.code:e.ERROR_UNKNOWN:void 0;f.publicLogError(l,{...a,success:!r,duration:t,errorcode:i})}e.reportTelemetry=d;class _{constructor(){this.barrier=new m.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,m.createCancelablePromise)(l=>this.doRun(l))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,m.createCancelablePromise)(l=>new Promise((a,t)=>{const r=l.onCancellationRequested(()=>{r.dispose(),t((0,A.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=_}),define(ce[96],ue([0,1,11,32,33,18,37,66,58,28,25,15,20,3,45,196,195,6,4]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h,S,d,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var f;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(f||(f={}));function l(...U){return String(U.reduce((j,H)=>j|H,0))}var a;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:f.None,criteria:[],assetTypes:[]};class c{constructor(j=s){this.state=j}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(j,H=this.state.pageSize){return new c({...this.state,pageNumber:j,pageSize:H})}withFilter(j,...H){const M=[...this.state.criteria,...H.length?H.map(q=>({filterType:j,value:q})):[{filterType:j}]];return new c({...this.state,criteria:M})}withSortBy(j){return new c({...this.state,sortBy:j})}withSortOrder(j){return new c({...this.state,sortOrder:j})}withFlags(...j){return new c({...this.state,flags:j.reduce((H,M)=>H|M,0)})}withAssetTypes(...j){return new c({...this.state,assetTypes:j})}get raw(){const{criteria:j,pageNumber:H,pageSize:M,sortBy:q,sortOrder:z,flags:V,assetTypes:K}=this.state;return{filters:[{criteria:j,pageNumber:H,pageSize:M,sortBy:q,sortOrder:z}],assetTypes:K,flags:V}}get searchText(){const j=this.state.criteria.filter(H=>H.filterType===a.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(j=>String(j.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function v(U,j){const H=(U||[]).filter(M=>M.statisticName===j)[0];return H?H.value:0}function y(U){const j="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(M=>M.assetType.indexOf(j)===0).reduce((M,q)=>{const z=k(U,q.assetType);return z&&M.push([q.assetType.substring(j.length),z]),M},[])}function T(U){if(U.properties){const j=U.properties.filter(q=>q.key===t.Repository),H=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=j.filter(q=>H.test(q.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return k(U,t.Repository)}function R(U){return{uri:`${U.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${U.fallbackAssetUri}/${t.VSIX}`}}function o(U){const j=k(U,t.Icon);if(j)return j;const H=P.DefaultIconPath;return{uri:H,fallbackUri:H}}function k(U,j){return U.files.filter(M=>M.assetType===j)[0]?{uri:`${U.assetUri}/${j}`,fallbackUri:`${U.fallbackAssetUri}/${j}`}:null}function O(U,j){const H=U.properties?U.properties.filter(q=>q.key===j):[],M=H.length>0&&H[0].value;return M?M.split(",").map(q=>(0,g.adoptToGalleryExtensionId)(q)):[]}function Y(U){const j=U.properties?U.properties.filter(H=>H.key===r.Engine):[];return j.length>0&&j[0].value||""}function Q(U){const j=U.properties?U.properties.filter(M=>M.key===r.LocalizedLanguages):[],H=j.length>0&&j[0].value||"";return H?H.split(","):[]}function me(U){return U.indexOf("preview")!==-1}function re(U,j,H,M,q){const z={manifest:k(j,t.Manifest),readme:k(j,t.Details),changelog:k(j,t.Changelog),license:k(j,t.License),repository:T(j),download:R(j),icon:o(j),coreTranslations:y(j)};return{identifier:{id:(0,g.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:j.version,date:j.lastUpdated,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,description:U.shortDescription||"",installCount:v(U.statistics,"install"),rating:v(U.statistics,"averagerating"),ratingCount:v(U.statistics,"ratingcount"),assetUri:m.URI.parse(j.assetUri),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),webExtension:!!U.tags?.includes(P.WEB_EXTENSION_TAG),assetTypes:j.files.map(({assetType:V})=>V),assets:z,properties:{dependencies:O(j,r.Dependency),extensionPack:O(j,r.ExtensionPack),engine:Y(j),localizedLanguages:Q(j)},telemetryData:{index:(M.pageNumber-1)*M.pageSize+H,querySource:q},preview:me(U.flags)}}let N=class{constructor(j,H,M,q,z,V,K){this.requestService=j,this.logService=H,this.environmentService=M,this.telemetryService=q,this.fileService=z,this.productService=V;const ae=V.extensionsGallery;this.extensionsGalleryUrl=ae&&ae.serviceUrl,this.extensionsControlUrl=ae&&ae.controlUrl,this.commonHeadersPromise=W(V.version,this.environmentService,this.fileService,K)}api(j=""){return`${this.extensionsGalleryUrl}${j}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(j,H){const M=[];let{total:q,firstPage:z,getPage:V}=await this.query({names:j,pageSize:j.length},H);M.push(...z);for(let K=1;M.length<q&&(z=await V(K,H),z.length);K++)M.push(...z);return M}async getCompatibleExtension(j,H){return this.getCompatibleExtensionByEngine(j,H)}async getCompatibleExtensionByEngine(j,H){const M=(0,P.isIExtensionIdentifier)(j)?null:j;if(M&&M.properties.engine&&(0,p.isEngineValid)(M.properties.engine,this.productService.version,this.productService.date))return M;const{id:q,uuid:z}=M?M.identifier:j;let V=new c().withFlags(f.IncludeAssetUri,f.IncludeStatistics,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");z?V=V.withFilter(a.ExtensionId,z):V=V.withFilter(a.ExtensionName,q);const{galleryExtensions:K}=await this.queryGallery(V,n.CancellationToken.None),[ae]=K;if(!ae||!ae.versions.length)return null;if(H){const De=ae.versions.filter(Pe=>Pe.version===H)[0];if(De){const Pe=re(ae,De,0,V);if(Pe.properties.engine&&(0,p.isEngineValid)(Pe.properties.engine,this.productService.version,this.productService.date))return Pe}return null}const fe=await this.getLastValidExtensionVersion(ae,ae.versions);return fe?re(ae,fe,0,V):null}async query(j,H){const M=n.CancellationToken.isCancellationToken(j)?{}:j,q=n.CancellationToken.isCancellationToken(j)?j:H;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let z=M.text||"";const V=(0,D.getOrDefault)(M,Fe=>Fe.pageSize,50);let K=new c().withFlags(f.IncludeLatestVersionOnly,f.IncludeAssetUri,f.IncludeStatistics,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,V).withFilter(a.Target,"Microsoft.VisualStudio.Code");z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Fe,Ne,ze)=>(K=K.withFilter(a.Category,ze||Ne),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Fe,Ne,ze)=>(K=K.withFilter(a.Tag,ze||Ne),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(a.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),K=K.withFilter(a.SearchText,z)),K=K.withSortBy(0)):M.ids?K=K.withFilter(a.ExtensionId,...M.ids):M.names?K=K.withFilter(a.ExtensionName,...M.names):K=K.withSortBy(4),typeof M.sortBy=="number"&&(K=K.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(K=K.withSortOrder(M.sortOrder));const{galleryExtensions:ae,total:fe}=await this.queryGallery(K,q),De=ae.map((Fe,Ne)=>re(Fe,Fe.versions[0],Ne,K,M.source)),Pe=async(Fe,Ne)=>{if(Ne.isCancellationRequested)throw(0,E.canceled)();const ze=K.withPage(Fe+1),{galleryExtensions:Xe}=await this.queryGallery(ze,Ne);return Xe.map((nt,it)=>re(nt,nt.versions[0],it,ze,M.source))};return{firstPage:De,total:fe,pageSize:K.pageSize,getPage:Pe}}async queryGallery(j,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,f.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,l(f.Unpublished));const M=await this.commonHeadersPromise,q=JSON.stringify(j.raw),z={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},V=new Date().getTime();let K,ae,fe=0;try{if(K=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:q,headers:z},H),K.res.statusCode&&K.res.statusCode>=400&&K.res.statusCode<500)return{galleryExtensions:[],total:fe};const De=await(0,C.asJson)(K);if(De){const Pe=De.results[0],Fe=Pe.extensions,Ne=Pe.resultMetadata&&Pe.resultMetadata.filter(ze=>ze.metadataType==="ResultCount")[0];return fe=Ne&&Ne.metadataItems.filter(ze=>ze.name==="TotalCount")[0].count||0,{galleryExtensions:Fe,total:fe}}return{galleryExtensions:[],total:fe}}catch(De){throw ae=De,De}finally{this.telemetryService.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-V,success:!!K&&(0,C.isSuccess)(K),responseBodySize:K?.res.headers["Content-Length"],statusCode:K?String(K.res.statusCode):void 0,errorCode:ae?(0,E.isPromiseCanceledError)(ae)?"canceled":(0,E.getErrorMessage)(ae).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(j,H,M,q){if(!this.isEnabled())return;const z=_.isWeb?this.api(`/itemName/${j}.${H}/version/${M}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${j}/extensions/${H}/${M}/stats?statType=${q}`),V=_.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ae={...await this.commonHeadersPromise,Accept:V};try{await this.requestService.request({type:"POST",url:z,headers:ae},n.CancellationToken.None)}catch(fe){}}async download(j,H,M){this.logService.trace("ExtensionGalleryService#download",j.identifier.id);const q=(0,g.getGalleryExtensionTelemetryData)(j),z=new Date().getTime(),V=De=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:De}),K=M===1?"install":M===2?"update":"",ae=K?{uri:`${j.assets.download.uri}&${K}=true`,fallbackUri:`${j.assets.download.fallbackUri}?${K}=true`}:j.assets.download,fe=await this.getAsset(ae);await this.fileService.writeFile(H,fe.stream),V(new Date().getTime()-z)}async getReadme(j,H){if(j.assets.readme){const M=await this.getAsset(j.assets.readme,{},H);return await(0,C.asText)(M)||""}return""}async getManifest(j,H){if(j.assets.manifest){const M=await this.getAsset(j.assets.manifest,{},H),q=await(0,C.asText)(M);return q?JSON.parse(q):null}return null}async getCoreTranslation(j,H){const M=j.assets.coreTranslations.filter(q=>q[0]===H.toUpperCase())[0];if(M){const q=await this.getAsset(M[1]),z=await(0,C.asText)(q);return z?JSON.parse(z):null}return null}async getChangelog(j,H){if(j.assets.changelog){const M=await this.getAsset(j.assets.changelog,{},H);return await(0,C.asText)(M)||""}return""}async getAllVersions(j,H){let M=new c().withFlags(f.IncludeVersions,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");j.identifier.uuid?M=M.withFilter(a.ExtensionId,j.identifier.uuid):M=M.withFilter(a.ExtensionName,j.identifier.id);const q=[],{galleryExtensions:z}=await this.queryGallery(M,n.CancellationToken.None);return z.length&&(H?await Promise.all(z[0].versions.map(async V=>{let K;try{K=await this.getEngine(V)}catch(ae){}K&&(0,p.isEngineValid)(K,this.productService.version,this.productService.date)&&q.push({version:V.version,date:V.lastUpdated})})):q.push(...z[0].versions.map(V=>({version:V.version,date:V.lastUpdated})))),q}async getAsset(j,H={},M=n.CancellationToken.None){const q=await this.commonHeadersPromise,z={type:"GET"},V={...q,...H.headers||{}};H={...H,...z,headers:V};const K=j.uri,ae=j.fallbackUri,fe={...H,url:K};try{const De=await this.requestService.request(fe,M);if(De.res.statusCode===200)return De;const Pe=await(0,C.asText)(De);throw new Error(`Expected 200, got back ${De.res.statusCode} instead.

${Pe}`)}catch(De){if((0,E.isPromiseCanceledError)(De))throw De;const Pe=(0,E.getErrorMessage)(De);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:K,message:Pe});const Fe={...H,url:ae};return this.requestService.request(Fe,M)}}async getLastValidExtensionVersion(j,H){const M=this.getLastValidExtensionVersionFromProperties(j,H);return M||this.getLastValidExtensionVersionRecursively(j,H)}getLastValidExtensionVersionFromProperties(j,H){for(const M of H){const q=Y(M);if(!q)return null;if((0,p.isEngineValid)(q,this.productService.version,this.productService.date))return M}return null}async getEngine(j){const H=Y(j);if(H)return H;const M=k(j,t.Manifest);if(!M)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},z=await this.getAsset(M,{headers:q}),V=await(0,C.asJson)(z);if(V)return V.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(j,H){if(!H.length)return null;const M=H[0],q=await this.getEngine(M);return(0,p.isEngineValid)(q,this.productService.version,this.productService.date)?{...M,properties:[...M.properties||[],{key:r.Engine,value:q}]}:this.getLastValidExtensionVersionRecursively(j,H.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const j=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const H=await(0,C.asJson)(j),M=new Map;if(H)for(const q of H.malicious){const z=M.get(q)||{id:{id:q},malicious:!0,slow:!1};z.malicious=!0,M.set(q,z)}return[...M.values()]}};N=Le([xe(0,C.IRequestService),xe(1,A.ILogService),xe(2,w.IEnvironmentService),xe(3,I.ITelemetryService),xe(4,b.IFileService),xe(5,u.IProductService),xe(6,(0,d.optional)(h.IStorageService))],N),e.ExtensionGalleryService=N;async function W(U,j,H,M){const q={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},z=await(0,S.getServiceMachineId)(j,H,M);return q["X-Market-User-Id"]=z,q}e.resolveMarketplaceHeaders=W}),define(ce[201],ue([0,1,29,155,13,6,34,40,2,18,30]),function(X,e,E,P,g,D,I,C,p,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let A=class{constructor(u,h){this._configurationService=h,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,g.escapeRegExpCharacters)(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const d=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!d})}))}setExperimentProperty(u,h){this._experimentProperties[u]=h}setEnabled(u){this._enabled=u}_updateUserOptIn(){const u=this._configurationService?.getValue(b);this._userOptIn=u?u.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let h=u.sessionID,S=u["common.instanceId"],d=u["common.machineId"],_=u["common.firstSessionDate"],f=u["common.msftInternal"];return{sessionId:h,instanceId:S,machineId:d,firstSessionDate:_,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(u,h,S){return this.isOptedIn?this._commonProperties.then(d=>{h=(0,w.mixin)(h,d),h=(0,w.mixin)(h,this._experimentProperties),h=(0,w.cloneAndChange)(h,_=>{if(typeof _=="string")return this._cleanupInfo(_,S)}),this._appender.log(u,h)},d=>{console.error(d)}):Promise.resolve(void 0)}publicLog2(u,h,S){return this.publicLog(u,h,S)}publicLogError(u,h){return this.sendErrorTelemetry?this.publicLog(u,h,!0):Promise.resolve(void 0)}publicLogError2(u,h){return this.publicLogError(u,h)}_cleanupInfo(u,h){let S=u;if(h){const d=[];for(let a of this._cleanupPatterns)for(;;){const t=a.exec(u);if(!t)break;d.push([t.index,a.lastIndex])}const _=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(S="";;){const a=f.exec(u);if(!a)break;!_.test(a[0])&&d.every(([t,r])=>a.index<t||a.index>=r)&&(S+=u.substring(l,a.index)+"<REDACTED: user-file-path>",l=f.lastIndex)}l<u.length&&(S+=u.substr(l))}for(let d of this._cleanupPatterns)S=S.replace(d,"");return S}};A.IDLE_START_EVENT_NAME="UserIdleStart",A.IDLE_STOP_EVENT_NAME="UserIdleStop",A=Le([xe(1,(0,D.optional)(I.IConfigurationService))],A),e.TelemetryService=A;const b="telemetry";n.Registry.as(C.Extensions.Configuration).registerConfiguration({id:b,order:110,type:"object",title:(0,P.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,P.localize)(2,null,E.default.nameLong,E.default.privacyStatementUrl):(0,P.localize)(1,null,E.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[68],ue([0,1,34,18,12,14]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(u,h){return Promise.resolve(void 0)}publicLog2(u,h){return this.publicLog(u,h)}publicLogError(u,h){return Promise.resolve(void 0)}publicLogError2(u,h){return this.publicLogError(u,h)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class I{async publicLog(h,S,d){}async publicLogError(h,S,d){}}e.NullEndpointTelemetryService=I;function C(...u){return{log:(h,S)=>u.forEach(d=>d.log(h,S)),flush:()=>D.Promises.settled(u.map(h=>h.flush())),productIdentifier:u.find(h=>h.productIdentifier!==void 0)?.productIdentifier}}e.combinedAppender=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(u,h){return h.onDidChangeConfiguration(S=>{S.source!==6&&u.publicLog2("updateConfiguration",{configurationSource:(0,E.ConfigurationTargetToString)(S.source),configurationKeys:b(S.sourceConfig)})})}e.configurationTelemetry=p;function w(u){const h=Object.create(null),S=Object.create(null),d=Object.create(null);A(u,d);for(let _ in d){_=_.length>150?_.substr(_.length-149):_;const f=d[_];typeof f=="number"?S[_]=f:typeof f=="boolean"?S[_]=f?1:0:typeof f=="string"?h[_]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(h[_]=f)}return{properties:h,measurements:S}}e.validateTelemetryData=w;function n(u){if(!u)return"none";let h="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(d=>{u.indexOf(`${d}+`)===0&&(h=d)}),h}e.cleanRemoteAuthority=n;function A(u,h,S=0,d){if(!!u)for(let _ of Object.getOwnPropertyNames(u)){const f=u[_],l=d?d+_:_;Array.isArray(f)?h[l]=(0,P.safeStringify)(f):f instanceof Date?h[l]=f.toISOString():(0,g.isObject)(f)?S<2?A(f,h,S+1,l+"."):h[l]=(0,P.safeStringify)(f):h[l]=f}}function b(u){if(!u)return[];const h=[];return m(h,"",u),h}function m(u,h,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(d=>m(u,h?`${h}.${d}`:d,S[d])):u.push(h)}}),define(ce[202],ue([0,1,11,18,68]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function D(C){const p=await new Promise((n,A)=>{X(["applicationinsights"],n,A)});let w;return p.defaultClient?(w=new p.TelemetryClient(C),w.channel.setUseDiskRetryCaching(!0)):(p.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),w=p.defaultClient),C.indexOf("AIF-")===0&&(w.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),w}class I{constructor(p,w,n){this._eventPrefix=p,this._defaultData=w,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(p){if(!!this._aiClient){if(typeof this._aiClient!="string"){p(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=D(this._aiClient)),this._asyncAIClient.then(w=>{p(w)},w=>{(0,E.onUnexpectedError)(w),console.error(w)})}}log(p,w){!this._aiClient||(w=(0,P.mixin)(w,this._defaultData),w=(0,g.validateTelemetryData)(w),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+p,properties:w.properties,measurements:w.measurements})))}flush(){return this._aiClient?new Promise(p=>{this._withAIClient(w=>{w.flush({callback:()=>{this._aiClient=void 0,p(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=I}),define(ce[203],ue([0,1,11,198]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class g extends P.default{installErrorListeners(){(0,E.setUnexpectedErrorHandler)(C=>console.error(C));const I=[];process.on("unhandledRejection",(C,p)=>{I.push(p),setTimeout(()=>{const w=I.indexOf(p);w>=0&&p.catch(n=>{I.splice(w,1),(0,E.isPromiseCanceledError)(n)||(console.warn(`rejected promise not handled within 1 second: ${n}`),n.stack&&console.warn(`stack trace: ${n.stack}`),(0,E.onUnexpectedError)(C))})},1e3)}),process.on("rejectionHandled",C=>{const p=I.indexOf(C);p>=0&&I.splice(p,1)}),process.on("uncaughtException",C=>{(0,E.onUnexpectedError)(C)})}}e.default=g}),define(ce[204],ue([0,1,14,25,7,2,15]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let C=class extends D.Disposable{constructor(w,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new g.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=w===void 0?15e3:w}createRequest(w){return new Promise((n,A)=>{const b=++this._lastRequestId;this._pendingRequests.set(b,n),this._onCreateRequest.fire({requestId:b,...w});const m=new P.CancellationTokenSource;(0,E.timeout)(this._timeout,m.token).then(()=>A(`Request ${b} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(b,[(0,D.toDisposable)(()=>m.cancel())])})}acceptReply(w,n){const A=this._pendingRequests.get(w);A?(this._pendingRequests.delete(w),(0,D.dispose)(this._pendingRequestDisposables.get(w)||[]),this._pendingRequestDisposables.delete(w),A(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};C=Le([xe(1,I.ILogService)],C),e.RequestStore=C}),define(ce[97],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var P;(function(m){m.Shell="terminal.integrated.shell.",m.ShellArgs="terminal.integrated.shellArgs.",m.DefaultProfile="terminal.integrated.defaultProfile.",m.Profiles="terminal.integrated.profiles."})(P=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var g;(function(m){m.ShellLinux="terminal.integrated.shell.linux",m.ShellMacOs="terminal.integrated.shell.osx",m.ShellWindows="terminal.integrated.shell.windows",m.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",m.AutomationShellLinux="terminal.integrated.automationShell.linux",m.AutomationShellMacOs="terminal.integrated.automationShell.osx",m.AutomationShellWindows="terminal.integrated.automationShell.windows",m.ShellArgsLinux="terminal.integrated.shellArgs.linux",m.ShellArgsMacOs="terminal.integrated.shellArgs.osx",m.ShellArgsWindows="terminal.integrated.shellArgs.windows",m.ProfilesWindows="terminal.integrated.profiles.windows",m.ProfilesMacOs="terminal.integrated.profiles.osx",m.ProfilesLinux="terminal.integrated.profiles.linux",m.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",m.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",m.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",m.UseWslProfiles="terminal.integrated.useWslProfiles",m.TabsEnabled="terminal.integrated.tabs.enabled",m.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",m.TabsHideCondition="terminal.integrated.tabs.hideCondition",m.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",m.TabsShowActions="terminal.integrated.tabs.showActions",m.TabsLocation="terminal.integrated.tabs.location",m.TabsFocusMode="terminal.integrated.tabs.focusMode",m.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",m.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",m.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",m.CopyOnSelection="terminal.integrated.copyOnSelection",m.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",m.FontFamily="terminal.integrated.fontFamily",m.FontSize="terminal.integrated.fontSize",m.LetterSpacing="terminal.integrated.letterSpacing",m.LineHeight="terminal.integrated.lineHeight",m.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",m.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",m.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",m.BellDuration="terminal.integrated.bellDuration",m.FontWeight="terminal.integrated.fontWeight",m.FontWeightBold="terminal.integrated.fontWeightBold",m.CursorBlinking="terminal.integrated.cursorBlinking",m.CursorStyle="terminal.integrated.cursorStyle",m.CursorWidth="terminal.integrated.cursorWidth",m.Scrollback="terminal.integrated.scrollback",m.DetectLocale="terminal.integrated.detectLocale",m.DefaultLocation="terminal.integrated.defaultLocation",m.GpuAcceleration="terminal.integrated.gpuAcceleration",m.RightClickBehavior="terminal.integrated.rightClickBehavior",m.Cwd="terminal.integrated.cwd",m.ConfirmOnExit="terminal.integrated.confirmOnExit",m.ConfirmOnKill="terminal.integrated.confirmOnKill",m.EnableBell="terminal.integrated.enableBell",m.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",m.AllowChords="terminal.integrated.allowChords",m.AllowMnemonics="terminal.integrated.allowMnemonics",m.EnvMacOs="terminal.integrated.env.osx",m.EnvLinux="terminal.integrated.env.linux",m.EnvWindows="terminal.integrated.env.windows",m.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",m.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",m.ShowExitAlert="terminal.integrated.showExitAlert",m.SplitCwd="terminal.integrated.splitCwd",m.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",m.WordSeparators="terminal.integrated.wordSeparators",m.TitleMode="terminal.integrated.titleMode",m.EnableFileLinks="terminal.integrated.enableFileLinks",m.UnicodeVersion="terminal.integrated.unicodeVersion",m.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",m.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",m.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",m.LocalEchoStyle="terminal.integrated.localEchoStyle",m.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",m.InheritEnv="terminal.integrated.inheritEnv",m.ShowLinkHover="terminal.integrated.showLinkHover"})(g=e.TerminalSettingId||(e.TerminalSettingId={}));var D;(function(m){m.CommandPrompt="cmd",m.PowerShell="pwsh",m.Wsl="wsl",m.GitBash="gitbash"})(D=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(m){m[m.Api=0]="Api",m[m.Process=1]="Process",m[m.Sequence=2]="Sequence"})(I=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(m){m.LocalPty="localPty",m.PtyHost="ptyHost",m.Log="log",m.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,E.createDecorator)("ptyService");var p;(function(m){m[m.BeatInterval=5e3]="BeatInterval",m[m.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",m[m.SecondWaitMultiplier=1]="SecondWaitMultiplier",m[m.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(m){m.TerminalView="view",m.Editor="editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(m){m[m.GraceTime=6e4]="GraceTime",m[m.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var A;(function(m){m[m.HighWatermarkChars=1e5]="HighWatermarkChars",m[m.LowWatermarkChars=5e3]="LowWatermarkChars",m[m.CharCountAckSize=5e3]="CharCountAckSize"})(A=e.FlowControlConstants||(e.FlowControlConstants={}));var b;(function(m){m.GitBash="Git Bash",m.Pwsh="PowerShell"})(b=e.ProfileSource||(e.ProfileSource={}))}),define(ce[205],ue([0,1,24,5,23,16,12,18,4]),function(X,e,E,P,g,D,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const A=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let b=0;return A&&A.length===4&&(b=parseInt(A[3])),b}e.getWindowsBuildNumber=w;async function n(A,b,m,u=g.env,h=D.Promises.exists){if(P.isAbsolute(A))return await h(A)?A:void 0;if(b===void 0&&(b=g.cwd()),P.dirname(A)!=="."){const f=P.join(b,A);return await h(f)?f:void 0}const d=(0,C.getCaseInsensitive)(u,"PATH");if(m===void 0&&(0,I.isString)(d)&&(m=d.split(P.delimiter)),m===void 0||m.length===0){const f=P.join(b,A);return await h(f)?f:void 0}for(let f of m){let l;if(P.isAbsolute(f)?l=P.join(f,A):l=P.join(b,f,A),await h(l))return l;if(p.isWindows){let a=l+".com";if(await h(a)||(a=l+".exe",await h(a)))return a}}const _=P.join(b,A);return await h(_)?_:void 0}e.findExecutable=n}),define(ce[206],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var E;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST="hc"})(E=e.ColorScheme||(e.ColorScheme={}))}),define(ce[98],ue([0,1,6,2,30,7,206,39]),function(X,e,E,P,g,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,E.createDecorator)("themeService");var p;(function(S){function d(_){return _&&typeof _=="object"&&typeof _.id=="string"}S.isThemeColor=d})(p=e.ThemeColor||(e.ThemeColor={}));function w(S){return{id:S}}e.themeColorFromId=w;var n;(function(S){function d(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||p.isThemeColor(r.color))}S.isThemeIcon=d;const _=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function f(r){const i=_.exec(r);if(!i)return;let[,s]=i;return{id:s}}S.fromString=f;function l(r,i){let s=r.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),i&&(s=`${s}~${i}`),{id:s}}S.modify=l;function a(r,i){return r.id===i.id&&r.color?.id===i.color?.id}S.isEqual=a;function t(r,i){return{id:r.id,color:i?w(i):void 0}}S.asThemeIcon=t,S.asClassNameArray=C.CSSIcon.asClassNameArray,S.asClassName=C.CSSIcon.asClassName,S.asCSSSelector=C.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function A(S){switch(S){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=A,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new D.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,P.toDisposable)(()=>{const _=this.themingParticipants.indexOf(d);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new b;g.Registry.add(e.Extensions.ThemingContribution,m);function u(S){return m.onColorThemeChange(S)}e.registerThemingParticipant=u;class h extends P.Disposable{constructor(d){super();this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,_){let f=this.theme.getColor(d);return f&&_&&(f=_(f,this.theme)),f?f.toString():null}}e.Themable=h}),define(ce[207],ue([0,1,39,98]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function g(C,p){const w=C.map(n=>({name:n.profileName,description:D(n)}));return p&&w.push(...p.map(n=>({name:n.title,description:I(n)}))),{values:w.map(n=>n.name),markdownDescriptions:w.map(n=>n.description)}}e.createProfileSchemaEnums=g;function D(C){let p=`$(${P.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:E.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?p+=`
- args: "${C.args}"`:p+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(p+=`
- overrideName: ${C.overrideName}`),C.color&&(p+=`
- color: ${C.color}`),C.env&&(p+=`
- env: ${JSON.stringify(C.env)}`),p}function I(C){return`$(${P.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:E.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}}),define(ce[208],ue([0,1,39,156,40,30,207]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const C={args:{description:(0,P.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(1,null),type:"boolean"},icon:{description:(0,P.localize)(2,null),type:"string",enum:Array.from(E.iconRegistry.all,S=>S.id),markdownEnumDescriptions:Array.from(E.iconRegistry.all,S=>`$(${S.id})`)},color:{description:(0,P.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,P.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(5,null),type:["string","array"],items:{type:"string"}},...C}},w=(0,P.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,P.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),A=(0,P.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),b={id:"terminal",order:100,title:(0,P.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,P.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,P.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,P.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,P.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,P.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,P.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:A},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,P.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,P.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,P.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,P.localize)(19,null)}},{type:"string",markdownDescription:(0,P.localize)(20,null)}],default:[],markdownDeprecationMessage:A},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,P.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(22,null),enum:["PowerShell","Git Bash"]},...C}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(23,null),type:"string"},id:{description:(0,P.localize)(24,null),type:"string"},title:{description:(0,P.localize)(25,null),type:"string"},...C}},{type:"null"},p]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,P.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(27,null),type:"string"},id:{description:(0,P.localize)(28,null),type:"string"},title:{description:(0,P.localize)(29,null),type:"string"},...C}},{type:"null"},p]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,P.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(31,null),type:"string"},id:{description:(0,P.localize)(32,null),type:"string"},title:{description:(0,P.localize)(33,null),type:"string"},...C}},{type:"null"},p]}},["terminal.integrated.useWslProfiles"]:{description:(0,P.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,P.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,P.localize)(36,null),type:"boolean",default:!0}}};function m(){D.Registry.as(g.Extensions.Configuration).registerConfiguration(b),h()}e.registerTerminalPlatformConfiguration=m;let u;function h(S,d){const _=D.Registry.as(g.Extensions.Configuration);u&&_.deregisterConfigurations([u]);let f;S&&(f=(0,I.createProfileSchemaEnums)(S?.profiles,d)),u={id:"terminal",order:100,title:(0,P.localize)(37,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,P.localize)(38,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:S?.os===3?f?.values:void 0,markdownEnumDescriptions:S?.os===3?f?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,P.localize)(39,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:S?.os===2?f?.values:void 0,markdownEnumDescriptions:S?.os===2?f?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,P.localize)(40,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:S?.os===1?f?.values:void 0,markdownEnumDescriptions:S?.os===1?f?.markdownDescriptions:void 0}}},_.registerConfiguration(u)}e.registerTerminalDefaultProfileConfiguration=h}),define(ce[209],ue([0,1,5,80,205,35,16,39,4,98]),function(X,e,E,P,g,D,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function A(t,r,i,s,c=process.env,v,y,T,R){return v=v||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},p.isWindows?b(i,v,c,y,s.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:s.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:s.getValue("terminal.integrated.defaultProfile.windows"),R,T):f(v,y,i,t&&typeof t=="object"?{...t}:s.getValue(p.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:s.getValue(p.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),R,T,c)}e.detectAvailableProfiles=A;async function b(t,r,i,s,c,v,y,T,R){const o=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),k=`${process.env.windir}\\${o?"Sysnative":"System32"}`;let O=!1;(0,g.getWindowsBuildNumber)()>=16299&&(O=!0),await h(T);const Y=new Map;t&&(Y.set("PowerShell",{source:"PowerShell",icon:C.Codicon.terminalPowershell,isAutoDetected:!0}),Y.set("Windows PowerShell",{path:`${k}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.Codicon.terminalPowershell,isAutoDetected:!0}),Y.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),Y.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),Y.set("Command Prompt",{path:`${k}\\cmd.exe`,icon:C.Codicon.terminalCmd,isAutoDetected:!0})),l(v,Y);const Q=await m(Y.entries(),y,r,i,s,R);if(t||!t&&c)try{const me=await d(`${k}\\${O?"wsl":"bash"}.exe`,y);for(const re of me)(!v||!(re.profileName in v))&&Q.push(re)}catch(me){s?.info("WSL is not installed, so could not detect WSL profiles")}return Q}async function m(t,r,i,s=process.env,c,v){const y=[];for(const[T,R]of t){if(R===null)continue;let o,k,O;if("source"in R){const me=n?.get(R.source);if(!me)continue;o=me.paths,k=R.args||me.args,R.icon?O=u(R.icon):me.icon&&(O=me.icon)}else o=Array.isArray(R.path)?R.path:[R.path],k=p.isWindows||Array.isArray(R.args)?R.args:void 0,O=u(R.icon)||void 0;const Y=await v?.(o)||o.slice(),Q=await a(T,r,Y,i,s,k,R.env,R.overrideName,R.isAutoDetected,c);Q?(Q.isAutoDetected=R.isAutoDetected,Q.icon=O,Q.color=R.color,y.push(Q)):c?.trace("profile not validated",T,o)}return y}function u(t){return typeof t=="string"?{id:t}:t}async function h(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await S(),icon:w.ThemeIcon.asThemeIcon(C.Codicon.terminalPowershell)}))}async function S(){const t=[];for await(const r of(0,P.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function d(t,r){const i=[],s=await new Promise((y,T)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(R,o)=>{if(R)return T("Problem occurred when getting wsl distros");y(o)})});if(!s)return[];const c=new RegExp(/[\r?\n]/),v=s.split(c).filter(y=>y.trim().length>0&&y!=="");for(const y of v){if(y===""||y.startsWith("docker-desktop"))continue;const T=`${y} (WSL)`,R={profileName:T,path:t,args:["-d",`${y}`],isDefault:T===r,icon:_(y)};i.push(R)}return i}function _(t){return t.includes("Ubuntu")?w.ThemeIcon.asThemeIcon(C.Codicon.terminalUbuntu):t.includes("Debian")?w.ThemeIcon.asThemeIcon(C.Codicon.terminalDebian):w.ThemeIcon.asThemeIcon(C.Codicon.terminalLinux)}async function f(t,r,i,s,c,v,y,T){const R=new Map;if(i){const o=(await t.readFile("/etc/shells")).toString(),k=v||o.split(`
`).filter(Y=>Y.trim().indexOf("#")!==0&&Y.trim().length>0),O=new Map;for(const Y of k){let Q=(0,E.basename)(Y),me=O.get(Q)||0;me++,me>1&&(Q=`${Q} (${me})`),O.set(Q,me),R.set(Q,{path:Y,isAutoDetected:!0})}}return l(s,R),await m(R.entries(),c,t,T,r,y)}function l(t,r){if(!!t)for(const[i,s]of Object.entries(t))s===null||!("path"in s)&&!("source"in s)?r.delete(i):r.set(i,s)}async function a(t,r,i,s,c,v,y,T,R,o){if(i.length===0)return Promise.resolve(void 0);const k=i.shift();if(k==="")return a(t,r,i,s,c,v,y,T,R);const O={profileName:t,path:k,args:v,env:y,overrideName:T,isAutoDetected:R,isDefault:t===r};if((0,E.basename)(k)===k){const Q=c.PATH?c.PATH.split(E.delimiter):void 0;return await(0,g.findExecutable)(k,void 0,Q,void 0,s.existsFile)?O:a(t,r,i,s,c,v)}return await s.existsFile((0,E.normalize)(k))?O:a(t,r,i,s,c,v,y,T,R)}}),define(ce[210],ue([0,1,2,15,97,56,8,36,4,7,90,37,209,34,208,204,61]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let _=0,f=class extends E.Disposable{constructor(a,t,r,i){super();this._reconnectConstants=a,this._configurationService=t,this._logService=r,this._telemetryService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new w.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new w.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new w.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new w.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new w.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new w.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new w.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new w.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new w.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new w.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new w.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new w.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new w.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new w.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new w.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new w.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,(0,u.registerTerminalPlatformConfiguration)(),this._shellEnv=p.isWindows?Promise.resolve(process.env):(0,S.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,E.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new D.Client(I.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:_,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),C.ProxyChannel.toService(a.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(a.onDidProcessExit(s=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(s.code),this._isDisposed||(this._restartCount<=d.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const r=a.getChannel(g.TerminalIpcChannels.Log);n.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{n.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const i=C.ProxyChannel.toService(a.getChannel(g.TerminalIpcChannels.PtyHost));return this._register(i.onProcessData(s=>this._onProcessData.fire(s))),this._register(i.onProcessExit(s=>this._onProcessExit.fire(s))),this._register(i.onProcessReady(s=>this._onProcessReady.fire(s))),this._register(i.onProcessTitleChanged(s=>this._onProcessTitleChanged.fire(s))),this._register(i.onProcessShellTypeChanged(s=>this._onProcessShellTypeChanged.fire(s))),this._register(i.onProcessOverrideDimensions(s=>this._onProcessOverrideDimensions.fire(s))),this._register(i.onProcessResolvedShellLaunchConfig(s=>this._onProcessResolvedShellLaunchConfig.fire(s))),this._register(i.onProcessDidChangeHasChildProcesses(s=>this._onProcessDidChangeHasChildProcesses.fire(s))),this._register(i.onProcessReplay(s=>this._onProcessReplay.fire(s))),this._register(i.onProcessOrphanQuestion(s=>this._onProcessOrphanQuestion.fire(s))),this._register(i.onDidRequestDetach(s=>this._onDidRequestDetach.fire(s))),[a,i]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,t,r,i,s,c,v,y,T,R){const o=setTimeout(()=>this._handleUnresponsiveCreateProcess(),g.HeartbeatConstants.CreateProcessTimeout),k=await this._proxy.createProcess(a,t,r,i,s,c,v,y,T,R);return clearTimeout(o),_=Math.max(_,k),k}updateTitle(a,t,r){return this._proxy.updateTitle(a,t,r)}updateIcon(a,t,r){return this._proxy.updateIcon(a,t,r)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,t){return this._proxy.shutdown(a,t)}input(a,t){return this._proxy.input(a,t)}processBinary(a,t){return this._proxy.processBinary(a,t)}resize(a,t,r){return this._proxy.resize(a,t,r)}acknowledgeDataEvent(a,t){return this._proxy.acknowledgeDataEvent(a,t)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,t,r,i=!1){const s=await this._shellEnv;return(0,b.detectAvailableProfiles)(t,r,i,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,t){return this._proxy.requestDetachInstance(a,t)}async acceptDetachInstanceReply(a,t){return this._proxy.acceptDetachInstanceReply(a,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,t){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:t})}async acceptPtyHostResolvedVariables(a,t){this._resolveVariablesRequestStore.acceptReply(a,t)}};f=Le([xe(1,m.IConfigurationService),xe(2,P.ILogService),xe(3,A.ITelemetryService)],f),e.PtyHostService=f}),define(ce[99],ue([0,1,3,19,6,26]),function(X,e,E,P,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,g.createDecorator)("contextService");var I;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function C(b){const m=b;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=C;function p(b){const m=b;return!!(m&&typeof m=="object"&&E.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=p;class w{constructor(m,u,h,S){this._id=m,this._configuration=h,this._ignorePathCasing=S,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=w;class n{constructor(m,u){this.raw=u,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,P.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function A(b){return new n({uri:b,index:0,name:(0,P.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=A}),define(ce[211],ue([0,1,6,157,99,3,4,5,19,113,38,8,52,31,192]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(N){return(typeof N=="string"?(0,C.extname)(N):(0,p.extname)(N))===h}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function d(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function _(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=_;function f(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=f;function l(N){const W=N;return typeof W?.id=="string"&&D.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=l;function a(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=a;function t(N){const W=N;return typeof W?.id=="string"&&D.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=t;function r(N){const W=N;if(W?.uri)return{id:W.id,uri:D.URI.revive(W.uri)};const U=N;if(U?.configPath)return{id:U.id,configPath:D.URI.revive(U.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=r;function i(N,W){return p.extUriBiasedIgnorePathCase.isEqualOrParent(N,W.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function s(N){return c(N)||v(N)}e.isStoredWorkspaceFolder=s;function c(N){const W=N;return typeof W?.path=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=c;function v(N){const W=N;return typeof W?.uri=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=v;function y(N,W,U,j,H=!I.isWindows,M){if(N.scheme!==j.scheme)return{name:U,uri:N.toString(!0)};let q=W?void 0:M.relativePath(j,N);if(q!==void 0)q.length===0?q=".":I.isWindows&&N.scheme===A.Schemas.file&&!H&&(q=q.replace(/\//g,"\\"));else if(N.scheme===A.Schemas.file)q=N.fsPath,I.isWindows&&(q=(0,b.normalizeDriveLetter)(q),H&&(q=(0,m.toSlashes)(q)));else{if(!M.isEqualAuthority(N.authority,j.authority))return{name:U,uri:N.toString(!0)};q=N.path}return{name:U,path:q}}e.getStoredWorkspaceFolder=y;function T(N,W,U){let j=[],H=new Set;const M=U.dirname(W);for(let q of N){let z;if(c(q))q.path&&(z=U.resolvePath(M,q.path));else if(v(q))try{z=D.URI.parse(q.uri),z.path[0]!=="/"&&(z=z.with({path:"/"+z.path}))}catch(V){console.warn(V)}if(z){let V=U.getComparisonKey(z);if(!H.has(V)){H.add(V);const K=q.name||U.basenameOrAuthority(z);j.push(new g.WorkspaceFolder({uri:z,name:K,index:j.length},q))}}}return j}e.toWorkspaceFolders=T;function R(N,W,U,j,H){let M=o(W,N);const q=H.dirname(W),z=H.dirname(j),V=[],K=k(M.folders);for(const Pe of M.folders){const Fe=c(Pe)?H.resolvePath(q,Pe.path):D.URI.parse(Pe.uri);let Ne;U?Ne=!1:Ne=!c(Pe)||(0,C.isAbsolute)(Pe.path),V.push(y(Fe,Ne,Pe.name,z,K,H))}const ae={insertSpaces:!1,tabSize:4,eol:I.isLinux||I.isMacintosh?`
`:`\r
`},fe=w.setProperty(N,["folders"],V,ae);let De=w.applyEdits(N,fe);return M.remoteAuthority===(0,u.getRemoteAuthority)(j)&&(De=w.applyEdits(De,w.removeProperty(De,["remoteAuthority"],ae))),De}e.rewriteWorkspaceFileForNewLocation=R;function o(N,W){let U=n.parse(W);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(j=>s(j));else throw new Error(`${N} looks like an invalid workspace file.`);return U}function k(N){return I.isWindows?N.some(W=>c(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=k;function O(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function Y(N){return typeof N.folderUri=="string"}function Q(N){return typeof N.fileUri=="string"}function me(N,W){const U={workspaces:[],files:[]};if(N){const j=function(M,q){for(let z=0;z<M.length;z++)try{q(M[z],z)}catch(V){W.warn(`Error restoring recent entry ${JSON.stringify(M[z])}: ${V.toString()}. Skip entry.`)}},H=N;if(Array.isArray(H.entries))j(H.entries,M=>{const q=M.label,z=M.remoteAuthority;O(M)?U.workspaces.push({label:q,remoteAuthority:z,workspace:{id:M.workspace.id,configPath:D.URI.parse(M.workspace.configPath)}}):Y(M)?U.workspaces.push({label:q,remoteAuthority:z,folderUri:D.URI.parse(M.folderUri)}):Q(M)&&U.files.push({label:q,remoteAuthority:z,fileUri:D.URI.parse(M.fileUri)})});else{const M=N;Array.isArray(M.workspaces3)&&j(M.workspaces3,(q,z)=>{const V=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[z]||void 0;typeof q=="object"&&typeof q.id=="string"&&typeof q.configURIPath=="string"?U.workspaces.push({label:V,workspace:{id:q.id,configPath:D.URI.parse(q.configURIPath)}}):typeof q=="string"&&U.workspaces.push({label:V,folderUri:D.URI.parse(q)})}),Array.isArray(M.files2)&&j(M.files2,(q,z)=>{const V=Array.isArray(M.fileLabels)&&M.fileLabels[z]||void 0;typeof q=="string"&&U.files.push({label:V,fileUri:D.URI.parse(q)})})}}return U}e.restoreRecentlyOpened=me;function re(N){const W={entries:[]};for(const U of N.workspaces)_(U)?W.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):W.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of N.files)W.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return W}e.toStoreData=re}),define(ce[212],ue([0,1,7,14]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function g(I){let C=0,p=0,w=0;I>=1e3&&(w=Math.floor(I/1e3),I-=w*1e3),w>=60&&(p=Math.floor(w/60),w-=p*60),p>=60&&(C=Math.floor(p/60),p-=C*60);const n=C?`${C}h`:"",A=p?`${p}m`:"",b=w?`${w}s`:"",m=I?`${I}ms`:"";return`${n}${A}${b}${m}`}e.printTime=g;class D{constructor(C,p,w,n){this._logService=C,this._reconnectionToken=p,this._onClose=new E.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=w,this.protocol=n,this._disposed=!1,this._disconnectRunner1=new P.RunOnceScheduler(()=>{this._log(`The reconnection grace time of ${g(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new P.RunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${g(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${g(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(C){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${C}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${g(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const C=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),C.end(),this._onClose.fire(void 0)}acceptReconnection(C,p,w){this._remoteAddress=C,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(p,w),this.protocol.endAcceptReconnection()}}e.ManagementConnection=D}),define(ce[100],ue([0,1,27,8,5,122,29]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const C=g.join(P.FileAccess.asFileUri("",X).fsPath,"nls.metadata.json"),p=new Map;function w(b){return new Promise(m=>E.exists(b,m))}function n(b,m){return w(C).then(u=>{if(!u||!I.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let h=`${b}||${m}`,S=p.get(h);return S||(S=D.getNLSConfiguration(I.default.commit,m,C,b).then(d=>(A.is(d)&&(d._languagePackSupport=!0),d)),p.set(h,S)),S})}e.getNLSConfiguration=n;var A;(function(b){function m(u){let h=u;return h&&typeof h._languagePackId=="string"}b.is=m})(A=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(ce[41],ue([0,1,54,8]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createRemoteURITransformer=e.uriTransformerPath=void 0,e.uriTransformerPath=P.FileAccess.asFileUri("vs/server/uriTransformer.js",X).fsPath;function g(D){const C=X.__$__nodeRequire(e.uriTransformerPath)(D);return new E.URITransformer(C)}e.createRemoteURITransformer=g}),define(ce[213],ue([0,1,7,2,3,41,65,17,5,42,25]),function(X,e,E,P,g,D,I,C,p,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemChannel=void 0;class A extends P.Disposable{constructor(u,h,S,d){super();this.logService=u,this.environmentService=h,this.uriTransformer=S,this.watcherRequests=new Map,this.fileWatcher=this._register(new I.DiskFileSystemProvider(this.logService,{watcher:this.getWatcherOptions()})),this.registerListeners(d)}registerListeners(u){const h=this._register(new E.Emitter);this._register(h.event(S=>{u.fire(S.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(S=>h.fire(S))),this._register(this.fileWatcher.onDidErrorOccur(S=>u.fire(S)))}getWatcherOptions(){const u=this.environmentService.args.fileWatcherPolling;if(u){const h=u.split(p.delimiter),S=Number(h[0]);if(S>0)return{usePolling:h.length>1?h.slice(1):!0,pollingInterval:S}}}watch(u,h,S){const d=g.URI.revive(this.uriTransformer.transformIncoming(h));return this.environmentService.extensionsPath&&(S.excludes=[...S.excludes||[],p.posix.join(this.environmentService.extensionsPath,"**")]),this.watcherRequests.set(u,this.fileWatcher.watch(d,S)),(0,P.toDisposable)(()=>{(0,P.dispose)(this.watcherRequests.get(u)),this.watcherRequests.delete(u)})}dispose(){super.dispose(),this.watcherRequests.forEach(u=>(0,P.dispose)(u)),this.watcherRequests.clear()}}class b extends P.Disposable{constructor(u,h){super();this.logService=u,this.environmentService=h,this.BUFFER_SIZE=256*1024,this.uriTransformerCache=new Map,this.fileWatchers=new Map,this.fsProvider=this._register(new I.DiskFileSystemProvider(this.logService,{bufferSize:this.BUFFER_SIZE})),this.watchRequests=new Map}call(u,h,S){const d=this.getUriTransformer(u.remoteAuthority);switch(h){case"stat":return this.stat(d,S[0]);case"readdir":return this.readdir(d,S[0]);case"open":return this.open(d,S[0],S[1]);case"close":return this.close(S[0]);case"read":return this.read(S[0],S[1],S[2]);case"readFile":return this.readFile(d,S[0]);case"write":return this.write(S[0],S[1],S[2],S[3],S[4]);case"writeFile":return this.writeFile(d,S[0],S[1],S[2]);case"rename":return this.rename(d,S[0],S[1],S[2]);case"copy":return this.copy(d,S[0],S[1],S[2]);case"mkdir":return this.mkdir(d,S[0]);case"delete":return this.delete(d,S[0],S[1]);case"watch":return Promise.resolve(this.watch(S[0],S[1],S[2],S[3]));case"unwatch":return Promise.resolve(this.unwatch(S[0],S[1]))}throw new Error(`IPC Command ${h} not found`)}listen(u,h,S){const d=this.getUriTransformer(u.remoteAuthority);switch(h){case"filechange":return this.onFileChange(d,S[0]);case"readFileStream":return this.onReadFileStream(d,S[0],S[1])}throw new Error(`Unknown event ${h}`)}onFileChange(u,h){const S=new E.Emitter({onFirstListenerAdd:()=>{this.fileWatchers.set(h,new A(this.logService,this.environmentService,u,S))},onLastListenerRemove:()=>{(0,P.dispose)(this.fileWatchers.get(h)),this.fileWatchers.delete(h)}});return S.event}onReadFileStream(u,h,S){const d=this.transformIncoming(u,h,!0),_=new n.CancellationTokenSource,f=new E.Emitter({onLastListenerRemove:()=>{_.cancel()}}),l=this.fsProvider.readFileStream(d,S,_.token);return(0,w.listenStream)(l,{onData:a=>f.fire(C.VSBuffer.wrap(a)),onError:a=>f.fire(a),onEnd:()=>{f.fire("end"),f.dispose(),_.dispose()}}),f.event}getUriTransformer(u){let h=this.uriTransformerCache.get(u);return h||(h=(0,D.createRemoteURITransformer)(u),this.uriTransformerCache.set(u,h)),h}stat(u,h){const S=this.transformIncoming(u,h,!0);return this.fsProvider.stat(S)}readdir(u,h){const S=this.transformIncoming(u,h);return this.fsProvider.readdir(S)}open(u,h,S){const d=this.transformIncoming(u,h,!0);return this.fsProvider.open(d,S)}close(u){return this.fsProvider.close(u)}async read(u,h,S){const d=C.VSBuffer.alloc(S),_=0,f=await this.fsProvider.read(u,h,d.buffer,_,S);return[d,f]}async readFile(u,h){const S=this.transformIncoming(u,h,!0),d=await this.fsProvider.readFile(S);return C.VSBuffer.wrap(d)}write(u,h,S,d,_){return this.fsProvider.write(u,h,S.buffer,d,_)}writeFile(u,h,S,d){const _=this.transformIncoming(u,h);return this.fsProvider.writeFile(_,S.buffer,d)}rename(u,h,S,d){const _=g.URI.revive(u.transformIncoming(h)),f=g.URI.revive(u.transformIncoming(S));return this.fsProvider.rename(_,f,d)}copy(u,h,S,d){const _=this.transformIncoming(u,h),f=this.transformIncoming(u,S);return this.fsProvider.copy(_,f,d)}mkdir(u,h){const S=this.transformIncoming(u,h);return this.fsProvider.mkdir(S)}delete(u,h,S){const d=this.transformIncoming(u,h);return this.fsProvider.delete(d,S)}transformIncoming(u,h,S=!1){if(S&&h.path==="/vscode-resource"&&h.query){const d=JSON.parse(h.query).requestResourcePath;return g.URI.from({scheme:"file",path:d})}return g.URI.revive(u.transformIncoming(h))}watch(u,h,S,d){const _=u+h,f=this.fileWatchers.get(u);if(f){const l=f.watch(h,S,d);this.watchRequests.set(_,l)}}unwatch(u,h){const S=u+h,d=this.watchRequests.get(S);d&&((0,P.dispose)(d),this.watchRequests.delete(S))}dispose(){super.dispose(),this.watchRequests.forEach(u=>(0,P.dispose)(u)),this.watchRequests.clear(),this.fileWatchers.forEach(u=>(0,P.dispose)(u)),this.fileWatchers.clear()}}e.RemoteAgentFileSystemChannel=b}),define(ce[69],ue([0,1,159,168,57,6,28]),function(X,e,E,P,g,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={port:{type:"string"},connectionToken:{type:"string"},"connection-secret":{type:"string",description:E.localize(0,null)},host:{type:"string"},"socket-path":{type:"string"},driver:{type:"string"},"start-server":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"disable-websocket-compression":{type:"boolean"},fileWatcherPolling:{type:"string"},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"without-browser-env-var":{type:"boolean"},"disable-telemetry":g.OPTIONS["disable-telemetry"],"extensions-dir":g.OPTIONS["extensions-dir"],"extensions-download-dir":g.OPTIONS["extensions-download-dir"],"install-extension":g.OPTIONS["install-extension"],"install-builtin-extension":g.OPTIONS["install-builtin-extension"],"uninstall-extension":g.OPTIONS["uninstall-extension"],"locate-extension":g.OPTIONS["locate-extension"],"list-extensions":g.OPTIONS["list-extensions"],force:g.OPTIONS.force,"show-versions":g.OPTIONS["show-versions"],category:g.OPTIONS.category,"do-not-sync":g.OPTIONS["do-not-sync"],"force-disable-user-env":g.OPTIONS["force-disable-user-env"],folder:{type:"string"},workspace:{type:"string"},"web-user-data-dir":{type:"string"},"use-host-proxy":{type:"string"},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},log:{type:"string"},logsPath:{type:"string"},_:g.OPTIONS._},e.IServerEnvironmentService=(0,D.refineServiceDecorator)(I.IEnvironmentService);class C extends P.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=C}),define(ce[214],ue([0,1,27,67,124,245,64,31,53,4,3,41,29,5,8,22,23]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.serveError=void 0;const d={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function _(t,r,i,s){r.writeHead(i,{"Content-Type":"text/plain"}),r.end(s)}e.serveError=_;async function f(t,r,i,s,c=Object.create(null)){try{const v=await g.promisify(E.stat)(s),y=`W/"${[v.ino,v.size,v.mtime.getTime()].join("-")}"`;if(r.headers["if-none-match"]===y)return i.writeHead(304),i.end();c["Content-Type"]=d[(0,m.extname)(s)]||(0,p.getMediaMime)(s)||"text/plain",c.Etag=y,i.writeHead(200,c),E.createReadStream(s).pipe(i)}catch(v){return v.code!=="ENOENT"&&(t.error(v),console.error(v.toString())),i.writeHead(404,{"Content-Type":"text/plain"}),i.end("Not found")}}e.serveFile=f;const l=(0,m.dirname)(u.FileAccess.asFileUri("",X).fsPath);class a{constructor(r,i,s){this._connectionToken=r,this._environmentService=i,this._logService=s,this._webviewEndpoint="https://{{uuid}}.vscode-webview-test.com/{{commit}}",this._mapCallbackUriToRequestId=new Map}async handle(r,i,s){try{const c=s.pathname;return c==="/favicon.ico"||c==="/manifest.json"||c==="/code-192.png"||c==="/code-512.png"?f(this._logService,r,i,(0,m.join)(l,"resources","server",c.substr(1))):/^\/static\//.test(c)?this._handleStatic(r,i,s):c==="/"?this._handleRoot(r,i,s):c==="/callback"?this._handleCallback(r,i,s):c==="/fetch-callback"?this._handleFetchCallback(r,i,s):_(r,i,404,"Not found.")}catch(c){return this._logService.error(c),console.error(c.toString()),_(r,i,500,"Internal Server Error.")}}_hasCorrectTokenCookie(r){return D.parse(r.headers.cookie||"")["vscode-tkn"]===this._connectionToken}async _handleStatic(r,i,s){const c=Object.create(null),v=decodeURIComponent(s.pathname),y=(0,m.normalize)(v.substr("/static/".length)),T=(0,m.join)(l,y);return(0,C.isEqualOrParent)(T,l,!w.isLinux)?f(this._logService,r,i,T,c):_(r,i,400,"Bad request.")}async _handleRoot(r,i,s){if(!r.headers.host)return _(r,i,400,"Bad request.");const c=s.query.tkn;if(typeof c=="string"){const re=Object.create(null);re["Set-Cookie"]=D.serialize("vscode-tkn",c,{sameSite:"strict",maxAge:60*60*24*7});const N=Object.create(null);for(let U in s.query)U!=="tkn"&&(N[U]=s.query[U]);const W=P.format({pathname:"/",query:N});return re.Location=W,i.writeHead(302,re),i.end()}if(this._environmentService.isBuilt&&!this._hasCorrectTokenCookie(r))return _(r,i,403,"Forbidden.");const v=r.headers.host,y=(0,A.createRemoteURITransformer)(v),{workspacePath:T,isFolder:R}=await this._getWorkspaceFromCLI();function o(re){return re.replace(/"/g,"&quot;")}let k;this._environmentService.driverHandle&&(k=!1);const O=u.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",X).fsPath,Y=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,h.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,Q=(await g.promisify(E.readFile)(O)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",o(JSON.stringify({folderUri:T&&R?y.transformOutgoing(n.URI.file(T)):void 0,workspaceUri:T&&!R?y.transformOutgoing(n.URI.file(T)):void 0,remoteAuthority:v,webviewEndpoint:this._webviewEndpoint,_wrapWebWorkerExtHostInIframe:k,developmentOptions:{enableSmokeTestDriver:this._environmentService.driverHandle==="web"?!0:void 0},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>Y?o(JSON.stringify(Y)):""),me=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' 'unsafe-eval' https://az416426.vo.msecnd.net ${this._getScriptCspHashes(Q).join(" ")} 'sha256-O98pkmgtvUCQGVoddaGy891K52PVRnySDRxRszVLPNQ=' http://${v};`,"child-src 'self';","frame-src 'self' https://*.vscode-webview-test.com https://vscodeweb.azureedge.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ");return i.writeHead(200,{"Content-Type":"text/html","Set-Cookie":D.serialize("vscode-tkn",this._connectionToken,{sameSite:"strict",maxAge:60*60*24*7}),"Content-Security-Policy":me}),i.end(Q)}_getScriptCspHashes(r){const i=/<script>([\s\S]+?)<\/script>/img,s=[];let c;for(;c=i.exec(r);){const v=I.createHash("sha256"),y=c[1].replace(/\r\n/g,`
`),T=v.update(Buffer.from(y)).digest().toString("base64");s.push(`'sha256-${T}'`)}return s}async _getWorkspaceFromCLI(){const r=this._environmentService.args.workspace;if(r&&r.length>0){const s=(0,C.sanitizeFilePath)(r,(0,S.cwd)());if(await g.promisify(E.exists)(s))return{workspacePath:s}}const i=this._environmentService.args.folder;if(i&&i.length>0){const s=(0,C.sanitizeFilePath)(i,(0,S.cwd)());if(await g.promisify(E.exists)(s))return{workspacePath:s,isFolder:!0}}return{}}_getFirstQueryValue(r,i){const s=r.query[i];return Array.isArray(s)?s[0]:s}_getFirstQueryValues(r,i){const s=new Map;for(const c in r.query){if(i&&i.indexOf(c)>=0)continue;const v=this._getFirstQueryValue(r,c);typeof v=="string"&&s.set(c,v)}return s}async _handleCallback(r,i,s){const c=["vscode-requestId","vscode-scheme","vscode-authority","vscode-path","vscode-query","vscode-fragment"],[v,y,T,R,o,k]=c.map(Q=>{const me=this._getFirstQueryValue(s,Q);return me&&decodeURIComponent(me)});if(!v)return i.writeHead(400,{"Content-Type":"text/plain"}),i.end("Bad request.");let O=o,Y=0;return this._getFirstQueryValues(s,c).forEach((Q,me)=>{O||(O=""),O+=`${Y++==0?"":"&"}${me}=${Q}`}),this._mapCallbackUriToRequestId.set(v,n.URI.from({scheme:y||b.default.urlProtocol,authority:T,path:R,query:O,fragment:k}).toJSON()),f(this._logService,r,i,u.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",X).fsPath,{"Content-Type":"text/html"})}async _handleFetchCallback(r,i,s){const c=this._getFirstQueryValue(s,"vscode-requestId");if(!c)return i.writeHead(400,{"Content-Type":"text/plain"}),i.end("Bad request.");const v=this._mapCallbackUriToRequestId.get(c);return v&&this._mapCallbackUriToRequestId.delete(c),i.writeHead(200,{"Content-Type":"text/json"}),i.end(JSON.stringify(v))}}e.WebClientServer=a}),define(ce[215],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class P{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.ExtHostRpcService=P}),define(ce[216],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var E;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(E=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const P=new WeakMap,g=(_,f)=>{const l={controllerId:f};return P.set(_,l),l};e.createPrivateApiFor=g;const D=_=>P.get(_);e.getPrivateApiFor=D;const I=(_,f,l,a)=>{let t=l;return{enumerable:!0,configurable:!1,get(){return t},set(r){a(t,r)||(t=r,_.listener?.({op:3,key:f,value:r}))}}},C=(_,f)=>_===f,p={range:(_,f)=>_===f?!0:!_||!f?!1:_.isEqual(f),label:C,description:C,busy:C,error:C,canResolveChildren:C},w=Object.keys(p),n=(_,f)=>({range:I(_,"range",void 0,p.range),label:I(_,"label",f,p.label),description:I(_,"description",void 0,p.description),canResolveChildren:I(_,"canResolveChildren",!1,p.canResolveChildren),busy:I(_,"busy",!1,p.busy),error:I(_,"error",void 0,p.error)}),A=(_,f)=>{const l=new Map;for(const a of w)p[a](_[a],f[a])||l.set(a,f[a]);return l};e.diffTestItems=A;class b extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=b;class m extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class u extends Error{constructor(f,l,a){super(`TestItem with ID "${f}" is from controller "${l}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=u;const h=_=>{const f=(0,e.getPrivateApiFor)(_);let l=new Map;return{get size(){return l.size},forEach(a,t){for(const r of l.values())a.call(t,r,this)},replace(a){const t=new Map,r=new Set(l.keys()),i={op:4,ops:[]};for(const s of a){if(!(s instanceof S))throw new m(s.id);const c=(0,e.getPrivateApiFor)(s).controllerId;if(c!==f.controllerId)throw new u(s.id,c,f.controllerId);if(t.has(s.id))throw new b(s.id);t.set(s.id,s),r.delete(s.id),i.ops.push({op:0,item:s})}for(const s of r.keys())i.ops.push({op:1,id:s});f.listener?.(i),l=t},add(a){if(!(a instanceof S))throw new m(a.id);l.set(a.id,a),f.listener?.({op:0,item:a})},delete(a){l.delete(a)&&f.listener?.({op:1,id:a})},get(a){return l.get(a)},toJSON(){return Array.from(l.values())},[Symbol.iterator](){return l.values()}}};class S{constructor(f,l,a,t){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const r=(0,e.createPrivateApiFor)(this,f);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof d?void 0:r.parent}},children:{value:h(this),enumerable:!0,writable:!1},...n(r,a)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=S;class d extends S{constructor(f,l){super(f,f,l,void 0)}}e.TestItemRootImpl=d});var Dt=this&&this.__classPrivateFieldSet||function(X,e,E,P,g){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!g:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?g.call(X,E):g?g.value=E:e.set(X,E),E},ot=this&&this.__classPrivateFieldGet||function(X,e,E,P){if(E==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!P:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?P:E==="a"?P.call(X):P?P.value:e.get(X)};define(ce[101],ue([0,1,21,11,74,26,53,12,3,22,20,95]),function(X,e,E,P,g,D,I,C,p,w,n,A){"use strict";var b,m,u,h,S,d,_,f,l,a,t,r,i,s,c,v,y,T,R,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(F){function L(){return Reflect.construct(F,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(F,"name")),Object.setPrototypeOf(L,F),Object.setPrototypeOf(L.prototype,F.prototype),L}let O=S=class{constructor(L){b.set(this,void 0),Dt(this,b,L,"f")}static from(...L){let x=L;return new S(function(){if(x){for(const be of x)be&&typeof be.dispose=="function"&&be.dispose();x=void 0}})}dispose(){typeof ot(this,b,"f")=="function"&&(ot(this,b,"f").call(this),Dt(this,b,void 0,"f"))}};b=new WeakMap,O=S=Le([k],O),e.Disposable=O;let Y=d=class{constructor(L,x){if(L<0)throw(0,P.illegalArgument)("line must be non-negative");if(x<0)throw(0,P.illegalArgument)("character must be non-negative");this._line=L,this._character=x}static Min(...L){if(L.length===0)throw new TypeError;let x=L[0];for(let be=1;be<L.length;be++){const Be=L[be];Be.isBefore(x)&&(x=Be)}return x}static Max(...L){if(L.length===0)throw new TypeError;let x=L[0];for(let be=1;be<L.length;be++){const Be=L[be];Be.isAfter(x)&&(x=Be)}return x}static isPosition(L){if(!L)return!1;if(L instanceof d)return!0;let{line:x,character:be}=L;return typeof x=="number"&&typeof be=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,x=0){if(L===null||x===null)throw(0,P.illegalArgument)();let be;return typeof L=="undefined"?be=0:typeof L=="number"?be=L:(be=typeof L.lineDelta=="number"?L.lineDelta:0,x=typeof L.characterDelta=="number"?L.characterDelta:0),be===0&&x===0?this:new d(this.line+be,this.character+x)}with(L,x=this.character){if(L===null||x===null)throw(0,P.illegalArgument)();let be;return typeof L=="undefined"?be=this.line:typeof L=="number"?be=L:(be=typeof L.line=="number"?L.line:this.line,x=typeof L.character=="number"?L.character:this.character),be===this.line&&x===this.character?this:new d(be,x)}toJSON(){return{line:this.line,character:this.character}}};Y=d=Le([k],Y),e.Position=Y;let Q=_=class{constructor(L,x,be,Be){let Ke,Qe;if(typeof L=="number"&&typeof x=="number"&&typeof be=="number"&&typeof Be=="number"?(Ke=new Y(L,x),Qe=new Y(be,Be)):L instanceof Y&&x instanceof Y&&(Ke=L,Qe=x),!Ke||!Qe)throw new Error("Invalid arguments");Ke.isBefore(Qe)?(this._start=Ke,this._end=Qe):(this._start=Qe,this._end=Ke)}static isRange(L){return L instanceof _?!0:L?Y.isPosition(L.start)&&Y.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof _?this.contains(L._start)&&this.contains(L._end):L instanceof Y?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const x=Y.Max(L.start,this._start),be=Y.Min(L.end,this._end);if(!x.isAfter(be))return new _(x,be)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const x=Y.Min(L.start,this._start),be=Y.Max(L.end,this.end);return new _(x,be)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,x=this.end){if(L===null||x===null)throw(0,P.illegalArgument)();let be;return L?Y.isPosition(L)?be=L:(be=L.start||this.start,x=L.end||this.end):be=this.start,be.isEqual(this._start)&&x.isEqual(this.end)?this:new _(be,x)}toJSON(){return[this.start,this.end]}};Q=_=Le([k],Q),e.Range=Q;let me=f=class extends Q{constructor(L,x,be,Be){let Ke,Qe;if(typeof L=="number"&&typeof x=="number"&&typeof be=="number"&&typeof Be=="number"?(Ke=new Y(L,x),Qe=new Y(be,Be)):L instanceof Y&&x instanceof Y&&(Ke=L,Qe=x),!Ke||!Qe)throw new Error("Invalid arguments");super(Ke,Qe);this._anchor=Ke,this._active=Qe}static isSelection(L){return L instanceof f?!0:L?Q.isRange(L)&&Y.isPosition(L.anchor)&&Y.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};me=f=Le([k],me),e.Selection=me;class re{constructor(L,x,be){if(typeof L!="string"||L.length===0)throw(0,P.illegalArgument)("host");if(typeof x!="number"||x===0||Math.round(x)!==x)throw(0,P.illegalArgument)("port");if(typeof be!="undefined"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z\-]+$/.test(be)))throw(0,P.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(x),this.connectionToken=be}}e.ResolvedAuthority=re;class N extends Error{constructor(L,x=A.RemoteAuthorityResolverErrorCode.Unknown,be){super(L);this._message=L,this._code=x,this._detail=be,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable(L,x){return new N(L,A.RemoteAuthorityResolverErrorCode.NotAvailable,x)}static TemporarilyNotAvailable(L){return new N(L,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var W;(function(F){F[F.LF=1]="LF",F[F.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var U;(function(F){F[F.Replace=1]="Replace",F[F.Append=2]="Append",F[F.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=l=class{constructor(L,x){this._range=L,this._newText=x}static isTextEdit(L){return L instanceof l?!0:L?Q.isRange(L)&&typeof L.newText=="string":!1}static replace(L,x){return new l(L,x)}static insert(L,x){return l.replace(new Q(L,L),x)}static delete(L){return l.replace(L,"")}static setEndOfLine(L){const x=new l(new Q(new Y(0,0),new Y(0,0)),"");return x.newEol=L,x}get range(){return this._range}set range(L){if(L&&!Q.isRange(L))throw(0,P.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,P.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,P.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=l=Le([k],j),e.TextEdit=j;var H;(function(F){F[F.File=1]="File",F[F.Text=2]="Text",F[F.Cell=3]="Cell",F[F.CellReplace=5]="CellReplace"})(H=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,x,be,Be){this._edits.push({_type:1,from:L,to:x,options:be,metadata:Be})}createFile(L,x,be){this._edits.push({_type:1,from:void 0,to:L,options:x,metadata:be})}deleteFile(L,x,be){this._edits.push({_type:1,from:L,to:void 0,options:x,metadata:be})}replaceNotebookMetadata(L,x,be){this._edits.push({_type:3,metadata:be,uri:L,edit:{editType:5,metadata:x},notebookMetadata:x})}replaceNotebookCells(L,x,be,Be,Ke){let Qe,et,at=[],ct;if(Ct.isNotebookRange(x)&&Et.isNotebookCellDataArray(be)&&!Et.isNotebookCellDataArray(Be)?(Qe=x.start,et=x.end,at=be,ct=Be):typeof x=="number"&&typeof be=="number"&&Et.isNotebookCellDataArray(Be)&&(Qe=x,et=be,at=Be,ct=Ke),Qe===void 0||et===void 0)throw new Error("Invalid arguments");(Qe!==et||at.length>0)&&this._edits.push({_type:5,uri:L,index:Qe,count:et-Qe,cells:at,metadata:ct})}replaceNotebookCellMetadata(L,x,be,Be){this._edits.push({_type:3,metadata:Be,uri:L,edit:{editType:8,index:x,metadata:be}})}replace(L,x,be,Be){this._edits.push({_type:2,uri:L,edit:new j(x,be),metadata:Be})}insert(L,x,be,Be){this.replace(L,new Q(x,x),be,Be)}delete(L,x,be){this.replace(L,x,"",be)}has(L){return this._edits.some(x=>x._type===2&&x.uri.toString()===L.toString())}set(L,x){if(x)for(const be of x)be&&this._edits.push({_type:2,uri:L,edit:be});else{for(let be=0;be<this._edits.length;be++){const Be=this._edits[be];Be._type===2&&Be.uri.toString()===L.toString()&&(this._edits[be]=void 0)}(0,E.coalesceInPlace)(this._edits)}}get(L){const x=[];for(let be of this._edits)be._type===2&&be.uri.toString()===L.toString()&&x.push(be.edit);return x}entries(){const L=new D.ResourceMap;for(let x of this._edits)if(x._type===2){let be=L.get(x.uri);be||(be=[x.uri,[]],L.set(x.uri,be)),be[1].push(x.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=Le([k],M),e.WorkspaceEdit=M;let q=a=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof a?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=a._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,x=this._tabstop++){if(typeof L=="function"){const be=new a;be._tabstop=this._tabstop,L(be),this._tabstop=be._tabstop,L=be.value}else L=a._escape(L);return this.value+="${",this.value+=x,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,x=this._tabstop++){const be=L.map(Be=>Be.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=x,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(L,x){if(typeof x=="function"){const be=new a;be._tabstop=this._tabstop,x(be),this._tabstop=be._tabstop,x=be.value}else typeof x=="string"&&(x=x.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,x&&(this.value+=":",this.value+=x),this.value+="}",this}};q=a=Le([k],q),e.SnippetString=q;var z;(function(F){F[F.Unnecessary=1]="Unnecessary",F[F.Deprecated=2]="Deprecated"})(z=e.DiagnosticTag||(e.DiagnosticTag={}));var V;(function(F){F[F.Hint=3]="Hint",F[F.Information=2]="Information",F[F.Warning=1]="Warning",F[F.Error=0]="Error"})(V=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let K=t=class{constructor(L,x){if(this.uri=L,x)if(x instanceof Q)this.range=x;else if(x instanceof Y)this.range=new Q(x,x);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof t?!0:L?Q.isRange(L.range)&&p.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};K=t=Le([k],K),e.Location=K;let ae=class{constructor(L,x){this.location=L,this.message=x}static is(L){return L?typeof L.message=="string"&&L.location&&Q.isRange(L.location.range)&&p.URI.isUri(L.location.uri):!1}static isEqual(L,x){return L===x?!0:!L||!x?!1:L.message===x.message&&L.location.range.isEqual(x.location.range)&&L.location.uri.toString()===x.location.uri.toString()}};ae=Le([k],ae),e.DiagnosticRelatedInformation=ae;let fe=class{constructor(L,x,be=V.Error){if(!Q.isRange(L))throw new TypeError("range must be set");if(!x)throw new TypeError("message must be set");this.range=L,this.message=x,this.severity=be}toJSON(){return{severity:V[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,x){return L===x?!0:!L||!x?!1:L.message===x.message&&L.severity===x.severity&&L.code===x.code&&L.severity===x.severity&&L.source===x.source&&L.range.isEqual(x.range)&&(0,E.equals)(L.tags,x.tags)&&(0,E.equals)(L.relatedInformation,x.relatedInformation,ae.isEqual)}};fe=Le([k],fe),e.Diagnostic=fe;let De=class{constructor(L,x){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=x}};De=Le([k],De),e.Hover=De;var Pe;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(Pe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Fe=class{constructor(L,x=Pe.Text){this.range=L,this.kind=x}toJSON(){return{range:this.range,kind:Pe[this.kind]}}};Fe=Le([k],Fe),e.DocumentHighlight=Fe;var Ne;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(Ne=e.SymbolKind||(e.SymbolKind={}));var ze;(function(F){F[F.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let Xe=r=class{constructor(L,x,be,Be,Ke){this.name=L,this.kind=x,this.containerName=Ke,typeof be=="string"&&(this.containerName=be),Be instanceof K?this.location=Be:be instanceof Q&&(this.location=new K(Be,be)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};Xe=r=Le([k],Xe),e.SymbolInformation=Xe;let nt=i=class{constructor(L,x,be,Be,Ke){this.name=L,this.detail=x,this.kind=be,this.range=Be,this.selectionRange=Ke,this.children=[],i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(i.validate)}};nt=i=Le([k],nt),e.DocumentSymbol=nt;var it;(function(F){F[F.Invoke=1]="Invoke",F[F.Automatic=2]="Automatic"})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let rt=class{constructor(L,x){this.title=L,this.kind=x}};rt=Le([k],rt),e.CodeAction=rt;let pe=s=class{constructor(L){this.value=L}append(L){return new s(this.value?this.value+s.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+s.sep)}};pe.sep=".",pe=s=Le([k],pe),e.CodeActionKind=pe,pe.Empty=new pe(""),pe.QuickFix=pe.Empty.append("quickfix"),pe.Refactor=pe.Empty.append("refactor"),pe.RefactorExtract=pe.Refactor.append("extract"),pe.RefactorInline=pe.Refactor.append("inline"),pe.RefactorRewrite=pe.Refactor.append("rewrite"),pe.Source=pe.Empty.append("source"),pe.SourceOrganizeImports=pe.Source.append("organizeImports"),pe.SourceFixAll=pe.Source.append("fixAll");let Ce=class{constructor(L,x){if(this.range=L,this.parent=x,x&&!x.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ce=Le([k],Ce),e.SelectionRange=Ce;class Ae{constructor(L,x,be,Be,Ke,Qe){this.kind=L,this.name=x,this.detail=be,this.uri=Be,this.range=Ke,this.selectionRange=Qe}}e.CallHierarchyItem=Ae;class Re{constructor(L,x){this.fromRanges=x,this.from=L}}e.CallHierarchyIncomingCall=Re;class Me{constructor(L,x){this.fromRanges=x,this.to=L}}e.CallHierarchyOutgoingCall=Me;var $e;(function(F){F[F.Information=0]="Information",F[F.Warning=1]="Warning",F[F.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let He=class{constructor(L,x){this.range=L,this.command=x}get isResolved(){return!!this.command}};He=Le([k],He),e.CodeLens=He;let Ye=c=class{constructor(L,x=!1){m.set(this,void 0),Dt(this,m,new g.MarkdownString(L,{supportThemeIcons:x}),"f")}static isMarkdownString(L){return L instanceof c?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return ot(this,m,"f").value}set value(L){ot(this,m,"f").value=L}get isTrusted(){return ot(this,m,"f").isTrusted}set isTrusted(L){ot(this,m,"f").isTrusted=L}get supportThemeIcons(){return ot(this,m,"f").supportThemeIcons}set supportThemeIcons(L){ot(this,m,"f").supportThemeIcons=L}appendText(L){return ot(this,m,"f").appendText(L),this}appendMarkdown(L){return ot(this,m,"f").appendMarkdown(L),this}appendCodeblock(L,x){return ot(this,m,"f").appendCodeblock(x??"",L),this}};m=new WeakMap,Ye=c=Le([k],Ye),e.MarkdownString=Ye;let tt=class{constructor(L,x){this.label=L,this.documentation=x}};tt=Le([k],tt),e.ParameterInformation=tt;let ne=class{constructor(L,x){this.label=L,this.documentation=x,this.parameters=[]}};ne=Le([k],ne),e.SignatureInformation=ne;let Se=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Se=Le([k],Se),e.SignatureHelp=Se;var Ee;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(Ee=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ue;(function(F){F[F.Other=0]="Other",F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(Ue=e.InlayHintKind||(e.InlayHintKind={}));let he=class{constructor(L,x,be){this.text=L,this.position=x,this.kind=be}};he=Le([k],he),e.InlayHint=he;var ge;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ye;(function(F){F[F.Text=0]="Text",F[F.Method=1]="Method",F[F.Function=2]="Function",F[F.Constructor=3]="Constructor",F[F.Field=4]="Field",F[F.Variable=5]="Variable",F[F.Class=6]="Class",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Unit=10]="Unit",F[F.Value=11]="Value",F[F.Enum=12]="Enum",F[F.Keyword=13]="Keyword",F[F.Snippet=14]="Snippet",F[F.Color=15]="Color",F[F.File=16]="File",F[F.Reference=17]="Reference",F[F.Folder=18]="Folder",F[F.EnumMember=19]="EnumMember",F[F.Constant=20]="Constant",F[F.Struct=21]="Struct",F[F.Event=22]="Event",F[F.Operator=23]="Operator",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue"})(ye=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(F){F[F.Deprecated=1]="Deprecated"})(G=e.CompletionItemTag||(e.CompletionItemTag={}));let J=class{constructor(L,x){this.label=L,this.kind=x}toJSON(){return{label:this.label,kind:this.kind&&ye[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};J=Le([k],J),e.CompletionItem=J;let te=class{constructor(L=[],x=!1){this.items=L,this.isIncomplete=x}};te=Le([k],te),e.CompletionList=te;let oe=class{constructor(L,x,be){this.text=L,this.range=x,this.command=be}};oe=Le([k],oe),e.InlineSuggestion=oe;let B=class{constructor(L){this.items=L}};B=Le([k],B),e.InlineSuggestions=B;var ie;(function(F){F[F.Active=-1]="Active",F[F.Beside=-2]="Beside",F[F.One=1]="One",F[F.Two=2]="Two",F[F.Three=3]="Three",F[F.Four=4]="Four",F[F.Five=5]="Five",F[F.Six=6]="Six",F[F.Seven=7]="Seven",F[F.Eight=8]="Eight",F[F.Nine=9]="Nine"})(ie=e.ViewColumn||(e.ViewColumn={}));var se;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(se=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ve;(function(F){F[F.Off=0]="Off",F[F.On=1]="On",F[F.Relative=2]="Relative"})(ve=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ee;(function(F){F[F.Manual=1]="Manual",F[F.AfterDelay=2]="AfterDelay",F[F.FocusOut=3]="FocusOut"})(ee=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var we;(function(F){F[F.Default=0]="Default",F[F.InCenter=1]="InCenter",F[F.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",F[F.AtTop=3]="AtTop"})(we=e.TextEditorRevealType||(e.TextEditorRevealType={}));var _e;(function(F){F[F.Keyboard=1]="Keyboard",F[F.Mouse=2]="Mouse",F[F.Command=3]="Command"})(_e=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Te;(function(F){F[F.Undo=1]="Undo",F[F.Redo=2]="Redo"})(Te=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Oe;(function(F){F[F.OpenOpen=0]="OpenOpen",F[F.ClosedClosed=1]="ClosedClosed",F[F.OpenClosed=2]="OpenClosed",F[F.ClosedOpen=3]="ClosedOpen"})(Oe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(F){function L(x){switch(x){case"keyboard":return F.Keyboard;case"mouse":return F.Mouse;case"api":return F.Command}}F.fromValue=L}(_e=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let je=class{constructor(L,x){if(x&&!p.URI.isUri(x))throw(0,P.illegalArgument)("target");if(!Q.isRange(L)||L.isEmpty)throw(0,P.illegalArgument)("range");this.range=L,this.target=x}};je=Le([k],je),e.DocumentLink=je;let qe=class{constructor(L,x,be,Be){this.red=L,this.green=x,this.blue=be,this.alpha=Be}};qe=Le([k],qe),e.Color=qe;let Ze=class{constructor(L,x){if(x&&!(x instanceof qe))throw(0,P.illegalArgument)("color");if(!Q.isRange(L)||L.isEmpty)throw(0,P.illegalArgument)("range");this.range=L,this.color=x}};Ze=Le([k],Ze),e.ColorInformation=Ze;let Je=class{constructor(L){if(!L||typeof L!="string")throw(0,P.illegalArgument)("label");this.label=L}};Je=Le([k],Je),e.ColorPresentation=Je;var Ve;(function(F){F[F.RGB=0]="RGB",F[F.HEX=1]="HEX",F[F.HSL=2]="HSL"})(Ve=e.ColorFormat||(e.ColorFormat={}));var le;(function(F){F[F.Error=0]="Error",F[F.Warning=1]="Warning",F[F.Information=2]="Information"})(le=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class de{constructor(L,x,be){if(this.startIndex=L,this.length=x,this.tooltip=be,typeof L!="number"||L<0)throw(0,P.illegalArgument)("startIndex");if(typeof x!="number"||x<1)throw(0,P.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,P.illegalArgument)("tooltip")}}e.TerminalLink=de;class Z{constructor(L){this.options=L,typeof L!="object"&&(0,P.illegalArgument)("options")}}e.TerminalProfile=Z;var $;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})($=e.TaskRevealKind||(e.TaskRevealKind={}));var ke;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(ke=e.TaskPanelKind||(e.TaskPanelKind={}));let Ie=v=class{constructor(L,x){if(typeof L!="string"||typeof x!="string")throw(0,P.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}get id(){return this._id}};Ie.Clean=new v("clean","Clean"),Ie.Build=new v("build","Build"),Ie.Rebuild=new v("rebuild","Rebuild"),Ie.Test=new v("test","Test"),Ie=v=Le([k],Ie),e.TaskGroup=Ie;function Ge(F){let L="";for(let x=0;x<F.length;x++)L+=F[x].replace(/,/g,",,")+",";return L}let We=class{constructor(L,x,be){if(typeof L!="string")throw(0,P.illegalArgument)("process");this._args=[],this._process=L,x!==void 0&&(Array.isArray(x)?(this._args=x,this._options=be):this._options=x)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,P.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let x of this._args)L.push(x);return Ge(L)}};We=Le([k],We),e.ProcessExecution=We;let st=class{constructor(L,x,be){if(this._args=[],Array.isArray(x)){if(!L)throw(0,P.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,P.illegalArgument)("command");this._command=L,this._args=x,this._options=be}else{if(typeof L!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=L,this._options=x}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,P.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let x of this._args)L.push(typeof x=="string"?x:x.value);return Ge(L)}};st=Le([k],st),e.ShellExecution=st;var ut;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var gt;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace"})(gt=e.TaskScope||(e.TaskScope={}));class dt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,w.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=dt;let lt=y=class{constructor(L,x,be,Be,Ke,Qe){this.__deprecated=!1,this._definition=this.definition=L;let et;typeof x=="string"?(this._name=this.name=x,this._source=this.source=be,this.execution=Be,et=Ke,this.__deprecated=!0):x===gt.Global||x===gt.Workspace?(this.target=x,this._name=this.name=be,this._source=this.source=Be,this.execution=Ke,et=Qe):(this.target=x,this._name=this.name=be,this._source=this.source=Be,this.execution=Ke,et=Qe),typeof et=="string"?(this._problemMatchers=[et],this._hasDefinedMatchers=!0):Array.isArray(et)?(this._problemMatchers=et,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof We?this._definition={type:y.ProcessType,id:this._execution.computeId()}:this._execution instanceof st?this._definition={type:y.ShellType,id:this._execution.computeId()}:this._execution instanceof dt?this._definition={type:y.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:y.EmptyType,id:(0,w.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,P.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,P.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const x=this._definition.type;(y.EmptyType===x||y.ProcessType===x||y.ShellType===x||y.ExtensionCallbackType===x)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,P.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=y=Le([k],lt),e.Task=lt;var vt;(function(F){F[F.SourceControl=1]="SourceControl",F[F.Window=10]="Window",F[F.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));let At=class{constructor(L,x=nn.None){this.collapsibleState=x,p.URI.isUri(L)?this.resourceUri=L:this.label=L}};At=Le([k],At),e.TreeItem=At;var nn;(function(F){F[F.None=0]="None",F[F.Collapsed=1]="Collapsed",F[F.Expanded=2]="Expanded"})(nn=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor(L,x){this.id=L,this.color=x}};yt=Le([k],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let Rt=class{constructor(L){this.id=L}};Rt=Le([k],Rt),e.ThemeColor=Rt;var sn;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.WorkspaceFolder=3]="WorkspaceFolder"})(sn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Tt=class{constructor(L,x){if(typeof L!="string"&&(!L||!p.URI.isUri(L)&&!p.URI.isUri(L.uri)))throw(0,P.illegalArgument)("base");if(typeof x!="string")throw(0,P.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=p.URI.file(L),this.base=L):p.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=x}};Tt=Le([k],Tt),e.RelativePattern=Tt;let bt=class{constructor(L,x,be,Be){this.enabled=typeof L=="boolean"?L:!0,typeof x=="string"&&(this.condition=x),typeof be=="string"&&(this.hitCondition=be),typeof Be=="string"&&(this.logMessage=Be)}get id(){return this._id||(this._id=(0,w.generateUuid)()),this._id}};bt=Le([k],bt),e.Breakpoint=bt;let Lt=class extends bt{constructor(L,x,be,Be,Ke){super(x,be,Be,Ke);if(L===null)throw(0,P.illegalArgument)("location");this.location=L}};Lt=Le([k],Lt),e.SourceBreakpoint=Lt;let Ft=class extends bt{constructor(L,x,be,Be,Ke){super(x,be,Be,Ke);this.functionName=L}};Ft=Le([k],Ft),e.FunctionBreakpoint=Ft;let Ot=class extends bt{constructor(L,x,be,Be,Ke,Qe,et){super(Be,Ke,Qe,et);if(!x)throw(0,P.illegalArgument)("dataId");this.label=L,this.dataId=x,this.canPersist=be}};Ot=Le([k],Ot),e.DataBreakpoint=Ot;let Nt=class{constructor(L,x,be){this.command=L,this.args=x||[],this.options=be}};Nt=Le([k],Nt),e.DebugAdapterExecutable=Nt;let Mt=class{constructor(L,x){this.port=L,this.host=x}};Mt=Le([k],Mt),e.DebugAdapterServer=Mt;let Ut=class{constructor(L){this.path=L}};Ut=Le([k],Ut),e.DebugAdapterNamedPipeServer=Ut;let Bt=class{constructor(L){this.implementation=L}};Bt=Le([k],Bt),e.DebugAdapterInlineImplementation=Bt;let zt=class{constructor(L,x){this.range=L,this.expression=x}};zt=Le([k],zt),e.EvaluatableExpression=zt;var on;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(on=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let $t=class{constructor(L,x){this.range=L,this.text=x}};$t=Le([k],$t),e.InlineValueText=$t;let Wt=class{constructor(L,x,be=!0){this.range=L,this.variableName=x,this.caseSensitiveLookup=be}};Wt=Le([k],Wt),e.InlineValueVariableLookup=Wt;let jt=class{constructor(L,x){this.range=L,this.expression=x}};jt=Le([k],jt),e.InlineValueEvaluatableExpression=jt;let Ht=class{constructor(L,x){this.frameId=L,this.stoppedLocation=x}};Ht=Le([k],Ht),e.InlineValueContext=Ht;var an;(function(F){F[F.Changed=1]="Changed",F[F.Created=2]="Created",F[F.Deleted=3]="Deleted"})(an=e.FileChangeType||(e.FileChangeType={}));let qt=T=class extends Error{constructor(L,x=n.FileSystemProviderErrorCode.Unknown,be){super(p.URI.isUri(L)?L.toString(!0):L);this.code=be?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,x),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}static FileExists(L){return new T(L,n.FileSystemProviderErrorCode.FileExists,T.FileExists)}static FileNotFound(L){return new T(L,n.FileSystemProviderErrorCode.FileNotFound,T.FileNotFound)}static FileNotADirectory(L){return new T(L,n.FileSystemProviderErrorCode.FileNotADirectory,T.FileNotADirectory)}static FileIsADirectory(L){return new T(L,n.FileSystemProviderErrorCode.FileIsADirectory,T.FileIsADirectory)}static NoPermissions(L){return new T(L,n.FileSystemProviderErrorCode.NoPermissions,T.NoPermissions)}static Unavailable(L){return new T(L,n.FileSystemProviderErrorCode.Unavailable,T.Unavailable)}};qt=T=Le([k],qt),e.FileSystemError=qt;let Vt=class{constructor(L,x,be){this.start=L,this.end=x,this.kind=be}};Vt=Le([k],Vt),e.FoldingRange=Vt;var ln;(function(F){F[F.Comment=1]="Comment",F[F.Imports=2]="Imports",F[F.Region=3]="Region"})(ln=e.FoldingRangeKind||(e.FoldingRangeKind={}));var cn;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(cn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var un;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(un=e.CommentMode||(e.CommentMode={}));class fn{constructor(L,x=[]){this.tokenTypes=L,this.tokenModifiers=x}}e.SemanticTokensLegend=fn;function hn(F){return typeof F=="undefined"||(0,C.isStringArray)(F)}class xt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let x=0,be=L.tokenTypes.length;x<be;x++)this._tokenTypeStrToInt.set(L.tokenTypes[x],x);for(let x=0,be=L.tokenModifiers.length;x<be;x++)this._tokenModifierStrToInt.set(L.tokenModifiers[x],x)}}push(L,x,be,Be,Ke){if(typeof L=="number"&&typeof x=="number"&&typeof be=="number"&&typeof Be=="number"&&(typeof Ke=="number"||typeof Ke=="undefined"))return typeof Ke=="undefined"&&(Ke=0),this._pushEncoded(L,x,be,Be,Ke);if(Q.isRange(L)&&typeof x=="string"&&hn(be))return this._push(L,x,be);throw(0,P.illegalArgument)()}_push(L,x,be){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(x))throw new Error("`tokenType` is not in the provided legend");const Be=L.start.line,Ke=L.start.character,Qe=L.end.character-L.start.character,et=this._tokenTypeStrToInt.get(x);let at=0;if(be)for(const ct of be){if(!this._tokenModifierStrToInt.has(ct))throw new Error("`tokenModifier` is not in the provided legend");const ht=this._tokenModifierStrToInt.get(ct);at|=1<<ht>>>0}this._pushEncoded(Be,Ke,Qe,et,at)}_pushEncoded(L,x,be,Be,Ke){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&x<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const at=this._data.length/5|0;let ct=0,ht=0;for(let mt=0;mt<at;mt++){let pt=this._data[5*mt],It=this._data[5*mt+1];pt===0?(pt=ct,It+=ht):pt+=ct,this._data[5*mt]=pt,this._data[5*mt+1]=It,ct=pt,ht=It}}let Qe=L,et=x;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Qe-=this._prevLine,Qe===0&&(et-=this._prevChar)),this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=et,this._data[this._dataLen++]=be,this._data[this._dataLen++]=Be,this._data[this._dataLen++]=Ke,this._prevLine=L,this._prevChar=x}static _sortAndDeltaEncode(L){let x=[];const be=L.length/5|0;for(let et=0;et<be;et++)x[et]=et;x.sort((et,at)=>{const ct=L[5*et],ht=L[5*at];if(ct===ht){const mt=L[5*et+1],pt=L[5*at+1];return mt-pt}return ct-ht});const Be=new Uint32Array(L.length);let Ke=0,Qe=0;for(let et=0;et<be;et++){const at=5*x[et],ct=L[at+0],ht=L[at+1],mt=L[at+2],pt=L[at+3],It=L[at+4],rn=ct-Ke,$n=rn===0?ht-Qe:ht,Pt=5*et;Be[Pt+0]=rn,Be[Pt+1]=$n,Be[Pt+2]=mt,Be[Pt+3]=pt,Be[Pt+4]=It,Ke=ct,Qe=ht}return Be}build(L){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),L):new Gt(xt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=xt;class Gt{constructor(L,x){this.resultId=x,this.data=L}}e.SemanticTokens=Gt;class dn{constructor(L,x,be){this.start=L,this.deleteCount=x,this.data=be}}e.SemanticTokensEdit=dn;class mn{constructor(L,x){this.resultId=x,this.edits=L}}e.SemanticTokensEdits=mn;var gn;(function(F){F[F.Separate=0]="Separate",F[F.MergeWithParent=1]="MergeWithParent"})(gn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var vn;(function(F){F[F.Initial=1]="Initial",F[F.Dynamic=2]="Dynamic"})(vn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let kt=class{constructor(){}};kt.Back={iconPath:new yt("arrow-left")},kt=Le([k],kt),e.QuickInputButtons=kt;var pn;(function(F){F[F.UI=1]="UI",F[F.Workspace=2]="Workspace"})(pn=e.ExtensionKind||(e.ExtensionKind={}));class yn{constructor(L,x,be){this.badge=L,this.tooltip=x,this.color=be}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=yn;let Kt=class{constructor(L){this.kind=L}};Kt=Le([k],Kt),e.ColorTheme=Kt;var wn;(function(F){F[F.Light=1]="Light",F[F.Dark=2]="Dark",F[F.HighContrast=3]="HighContrast"})(wn=e.ColorThemeKind||(e.ColorThemeKind={}));class Ct{constructor(L,x){if(L<0)throw(0,P.illegalArgument)("start must be positive");if(x<0)throw(0,P.illegalArgument)("end must be positive");L<=x?(this._start=L,this._end=x):(this._start=x,this._end=L)}static isNotebookRange(L){return L instanceof Ct?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let x=this._start,be=this._end;return L.start!==void 0&&(x=L.start),L.end!==void 0&&(be=L.end),x===this._start&&be===this._end?this:new Ct(x,be)}}e.NotebookRange=Ct;class Et{constructor(L,x,be,Be,Ke,Qe,et){this.kind=L,this.value=x,this.languageId=be,this.mime=Be,this.outputs=Ke??[],this.metadata=Qe,this.executionSummary=et,Et.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(x=>Et.isNotebookCellData(x))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Et;class En{constructor(L){this.cells=L}}e.NotebookData=En;class ft{constructor(L,x){this.data=L,this.mime=x;const be=(0,I.normalizeMimeType)(x,!0);if(!be)throw new Error("INVALID mime type, must not be empty or falsy: "+x);this.mime=be}static isNotebookCellOutputItem(L){return L instanceof ft?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const x={name:L.name,message:L.message,stack:L.stack};return ft.json(x,"application/vnd.code.notebook.error")}static stdout(L){return ft.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return ft.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,x="application/octet-stream"){return new ft(L,x)}static text(L,x=I.Mimes.text){const be=ot(ft,u,"f",h).encode(String(L));return new ft(be,x)}static json(L,x="application/json"){const be=JSON.stringify(L,void 0,"	");return ft.text(be,x)}}e.NotebookCellOutputItem=ft,u=ft,h={value:new TextEncoder};class _t{constructor(L,x,be){this.items=_t.ensureUniqueMimeTypes(L,!0),typeof x=="string"?(this.id=x,this.metadata=be):(this.id=(0,w.generateUuid)(),this.metadata=x??be)}static isNotebookCellOutput(L){return L instanceof _t?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,C.isArray)(L.items)}static ensureUniqueMimeTypes(L,x=!1){const be=new Set,Be=new Set;for(let Ke=0;Ke<L.length;Ke++){const Qe=L[Ke],et=(0,I.normalizeMimeType)(Qe.mime);if(!be.has(et)){be.add(et);continue}Be.add(Ke),x&&console.warn(`DUPLICATED mime type '${Qe.mime}' will be dropped`)}return Be.size===0?L:L.filter((Ke,Qe)=>!Be.has(Qe))}}e.NotebookCellOutput=_t;var bn;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(bn=e.NotebookCellKind||(e.NotebookCellKind={}));var Sn;(function(F){F[F.Idle=1]="Idle",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(Sn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Dn;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(Dn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Cn;(function(F){F[F.Default=0]="Default",F[F.InCenter=1]="InCenter",F[F.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",F[F.AtTop=3]="AtTop"})(Cn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class In{constructor(L,x){this.text=L,this.alignment=x}}e.NotebookCellStatusBarItem=In;var Pn;(function(F){F[F.Default=1]="Default",F[F.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class kn{constructor(L,x=[]){this.uri=L,this.provides=(0,E.asArray)(x)}}e.NotebookRendererScript=kn;let Xt=class{constructor(L,x){this.label=L,this.timestamp=x}};Xt=Le([k],Xt),e.TimelineItem=Xt;var _n;(function(F){F[F.Production=1]="Production",F[F.Development=2]="Development",F[F.Test=3]="Test"})(_n=e.ExtensionMode||(e.ExtensionMode={}));var An;(function(F){F[F.Node=1]="Node",F[F.Webworker=2]="Webworker"})(An=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(F){F[F.Other=0]="Other",F[F.Comment=1]="Comment",F[F.String=2]="String",F[F.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Tn{constructor(L,x){this.ranges=L,this.wordPattern=x}}e.LinkedEditingRanges=Tn;class Ln{constructor(L,x){this._port=L,this._autoForwardAction=x}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var Fn;(function(F){F[F.Queued=1]="Queued",F[F.Running=2]="Running",F[F.Passed=3]="Passed",F[F.Failed=4]="Failed",F[F.Skipped=5]="Skipped",F[F.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var On;(function(F){F[F.Error=0]="Error",F[F.Warning=1]="Warning",F[F.Information=2]="Information",F[F.Hint=3]="Hint"})(On=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Nn;(function(F){F[F.Run=1]="Run",F[F.Debug=2]="Debug",F[F.Coverage=3]="Coverage"})(Nn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Yt=class{constructor(L,x,be){this.include=L,this.exclude=x,this.profile=be}};Yt=Le([k],Yt),e.TestRunRequest=Yt;let Jt=R=class{constructor(L){this.message=L}static diff(L,x,be){const Be=new R(L);return Be.expectedOutput=x,Be.actualOutput=be,Be}};Jt=R=Le([k],Jt),e.TestMessage=Jt;let St=class{constructor(L,x){this.covered=L,this.total=x}};St=Le([k],St),e.CoveredCount=St;let Qt=o=class{constructor(L,x,be,Be){this.uri=L,this.statementCoverage=x,this.branchCoverage=be,this.functionCoverage=Be}static fromDetails(L,x){const be=new St(0,0),Be=new St(0,0),Ke=new St(0,0);for(const et of x)if("branches"in et){be.total+=1,be.covered+=et.executionCount>0?1:0;for(const at of et.branches)Be.total+=1,Be.covered+=at.executionCount>0?1:0}else Ke.total+=1,Ke.covered+=et.executionCount>0?1:0;const Qe=new o(L,be,Be.total>0?Be:void 0,Ke.total>0?Ke:void 0);return Qe.detailedCoverage=x,Qe}};Qt=o=Le([k],Qt),e.FileCoverage=Qt;let Zt=class{constructor(L,x,be=[]){this.executionCount=L,this.location=x,this.branches=be}};Zt=Le([k],Zt),e.StatementCoverage=Zt;let en=class{constructor(L,x){this.executionCount=L,this.location=x}};en=Le([k],en),e.BranchCoverage=en;let tn=class{constructor(L,x){this.executionCount=L,this.location=x}};tn=Le([k],tn),e.FunctionCoverage=tn;var Mn;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(Mn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Un;(function(F){F[F.Untrusted=0]="Untrusted",F[F.Trusted=1]="Trusted",F[F.Unspecified=2]="Unspecified"})(Un=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Bn;(function(F){F[F.Notify=1]="Notify",F[F.OpenBrowser=2]="OpenBrowser",F[F.OpenPreview=3]="OpenPreview",F[F.Silent=4]="Silent",F[F.Ignore=5]="Ignore",F[F.OpenBrowserOnce=6]="OpenBrowserOnce"})(Bn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class zn{constructor(L,x,be,Be,Ke,Qe){this.kind=L,this.name=x,this.detail=be,this.uri=Be,this.range=Ke,this.selectionRange=Qe}}e.TypeHierarchyItem=zn}),define(ce[102],ue([0,1,160,12,3,2,6,60,30,21,8]),function(X,e,E,P,g,D,I,C,p,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,E.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,E.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,E.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,E.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,E.localize)(6,null)),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,E.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,E.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,E.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,E.localize)(10,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,E.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,E.localize)(12,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,E.localize)(13,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,E.localize)(14,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,E.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,E.localize)(16,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,E.localize)(17,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,E.localize)(18,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,E.localize)(19,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,E.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function A(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=A;function b(o){if(f(o))return!1;const k=o;return g.URI.isUri(k?.resource)}e.isResourceEditorInput=b;function m(o){if(f(o))return!1;const k=o;return k?.original!==void 0&&k.modified!==void 0}e.isResourceDiffEditorInput=m;function u(o){if(f(o))return!1;const k=o;return k?k?.resource===void 0||k.resource.scheme===n.Schemas.untitled||k.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var h;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(h=e.Verbosity||(e.Verbosity={}));var S;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var d;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(d=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class _ extends D.Disposable{}e.AbstractEditorInput=_;function f(o){return o instanceof _}e.isEditorInput=f;function l(o){const k=o;return g.URI.isUri(k?.preferredResource)}function a(o){const k=o;return f(k?.primary)&&f(k?.secondary)}e.isSideBySideEditorInput=a;function t(o){return f(o?.editor)}e.isEditorInputWithOptions=t;function r(o){const k=o;return t(o)&&k?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function i(o){const k=o;return typeof k?.groupId=="number"&&f(k.editor)}e.isEditorIdentifier=i;var s;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(s=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(k,O){if(!k)return;const Y=a(k)?k.primary:m(k)?k.modified:void 0,Q=a(k)?k.secondary:m(k)?k.original:void 0;if(O?.supportSideBySide&&Y&&Q){if(O?.supportSideBySide===s.BOTH)return{primary:this.getOriginalUri(Y,{filterByScheme:O.filterByScheme}),secondary:this.getOriginalUri(Q,{filterByScheme:O.filterByScheme})};k=O.supportSideBySide===s.PRIMARY?Y:Q}if(m(k))return;const me=l(k)?k.preferredResource:k.resource;return!me||!O||!O.filterByScheme?me:this.filterUri(me,O.filterByScheme)}getCanonicalUri(k,O){if(!k)return;const Y=a(k)?k.primary:m(k)?k.modified:void 0,Q=a(k)?k.secondary:m(k)?k.original:void 0;if(O?.supportSideBySide&&Y&&Q){if(O?.supportSideBySide===s.BOTH)return{primary:this.getCanonicalUri(Y,{filterByScheme:O.filterByScheme}),secondary:this.getCanonicalUri(Q,{filterByScheme:O.filterByScheme})};k=O.supportSideBySide===s.PRIMARY?Y:Q}if(m(k))return;const me=k.resource;return!me||!O||!O.filterByScheme?me:this.filterUri(me,O.filterByScheme)}filterUri(k,O){if(Array.isArray(O)){if(O.some(Y=>k.scheme===Y))return k}else if(O===k.scheme)return k}}e.EditorResourceAccessor=new c;var v;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class y{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(k){const O=this.instantiationService=k.get(I.IInstantiationService);for(const[Y,Q]of this.editorSerializerConstructors)this.createEditorSerializer(Y,Q,O);this.editorSerializerConstructors.clear()}createEditorSerializer(k,O,Y){const Q=Y.createInstance(O);this.editorSerializerInstances.set(k,Q)}registerFileEditorFactory(k){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=k}getFileEditorFactory(){return(0,P.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(k,O){if(this.editorSerializerConstructors.has(k)||this.editorSerializerInstances.has(k))throw new Error(`A editor serializer with type ID '${k}' was already registered.`);return this.instantiationService?this.createEditorSerializer(k,O,this.instantiationService):this.editorSerializerConstructors.set(k,O),(0,D.toDisposable)(()=>{this.editorSerializerConstructors.delete(k),this.editorSerializerInstances.delete(k)})}getEditorSerializer(k){return this.editorSerializerInstances.get(typeof k=="string"?k:k.typeId)}}p.Registry.add(e.EditorExtensions.EditorFactory,new y);async function T(o,k){if(!o||!o.length)return[];const O=await Promise.all(o.map(async Y=>{const Q=g.URI.revive(Y.fileUri);if(!Q||(await k.activateProvider(Q.scheme),!k.canHandleResource(Q)))return;const me=typeof Y.exists=="boolean"?Y.exists:await k.exists(Q);if(!me&&Y.openOnlyIfExists)return;const re=me&&!(0,P.isUndefined)(Y.selection)?{selection:Y.selection,pinned:!0,override:Y.editorOverrideId}:{pinned:!0,override:Y.editorOverrideId};let N;return me?N={resource:Q,options:re,forceFile:!0}:N={resource:Q,options:re,forceUntitled:!0},N}));return(0,w.coalesce)(O)}e.pathsToEditors=T;var R;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(R=e.EditorsOrder||(e.EditorsOrder={}))}),define(ce[217],ue([0,1,47,53,8,5,4,60]),function(X,e,E,P,g,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var p;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(p=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var A;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(A=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var S;(function(o){o.scheme=g.Schemas.vscodeNotebookCell;const k=/^ch(\d{7,})/;function O(N,W){return N.with({scheme:o.scheme,fragment:`ch${W.toString().padStart(7,"0")}${N.scheme!==g.Schemas.file?N.scheme:""}`})}o.generate=O;function Y(N){if(N.scheme!==o.scheme)return;const W=k.exec(N.fragment);return W?{handle:Number(W[1]),notebook:N.with({scheme:N.fragment.substr(W[0].length)||g.Schemas.file,fragment:null})}:void 0}o.parse=Y;function Q(N){if(N.scheme!==g.Schemas.vscodeNotebookCellMetadata)return;const W=k.exec(N.fragment);return W?{handle:Number(W[1]),notebook:N.with({scheme:N.fragment.substr(W[0].length)||g.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=Q;function me(N,W,U){return N.with({scheme:U,fragment:`ch${W.toString().padStart(7,"0")}${N.scheme!==g.Schemas.file?N.scheme:""}`})}o.generateCellUri=me;function re(N,W){if(N.scheme!==W)return;const U=k.exec(N.fragment);return U?{handle:Number(U[1]),notebook:N.with({scheme:N.fragment.substr(U[0].length)||g.Schemas.file,fragment:null})}:void 0}o.parseCellUri=re})(S=e.CellUri||(e.CellUri={}));const d=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[P.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[P.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function _(o){return d.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=_;function f(o){return d.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=f;function l(o){return d.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=l;function a(o,k){return I.isWindows&&(o=o.replace(/\//g,"\\"),k=k.replace(/\//g,"\\")),E.match(o,k)}function t(o,k,O){let Y=0;for(let Q=0;Q<k.length;Q++){if(a(k[Q],o))return Y;Y++}for(let Q=0;Q<O.length;Q++){if(a(O[Q],o))return Y;Y++}return Y}function r(o,k,O){return o.sort((Y,Q)=>t(Y,k,O)-t(Q,k,O))}e.sortMimeTypes=r;function i(o,k,O,Y=(Q,me)=>Q===me){const Q=[];function me(W,U,j){if(U===0&&j.length===0)return;const H=Q[Q.length-1];H&&H.start+H.deleteCount===W?(H.deleteCount+=U,H.toInsert.push(...j)):Q.push({start:W,deleteCount:U,toInsert:j})}let re=0,N=0;for(;;){if(re===o.length){me(re,0,k.slice(N));break}if(N===k.length){me(re,o.length-re,[]);break}const W=o[re],U=k[N];if(Y(W,U)){re+=1,N+=1;continue}O(U)?(me(re,1,[]),re+=1):(me(re,0,[U]),N+=1)}return Q}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(o){o.default="default",o.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(o){const k=o;return!!((typeof k.include=="string"||E.isRelativePattern(k.include))&&(typeof k.exclude=="string"||E.isRelativePattern(k.exclude)))}e.isDocumentExcludePattern=c;function v(o,k,O){if(Array.isArray(o.viewType)&&o.viewType.indexOf(k)>=0||o.viewType===k)return!0;if(o.filenamePattern){let Y=c(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,Q=c(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(E.match(Y,(0,D.basename)(O.fsPath).toLowerCase()))return!(Q&&E.match(Q,(0,D.basename)(O.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=v;class y{constructor(k){this.textModel=k}getElements(){const k=new Int32Array(this.textModel.cells.length);for(let O=0;O<this.textModel.cells.length;O++)k[O]=this.textModel.cells[O].getHashValue();return k}}e.CellSequence=y,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var T;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(T=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class R{static create(k){return`${R._prefix}${k}`}static parse(k){if(k.startsWith(R._prefix))return k.substr(R._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=R,R._prefix="notebook/"}),define(ce[103],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,E.createDecorator)("environmentVariableService");var P;(function(g){g[g.Replace=1]="Replace",g[g.Append=2]="Append",g[g.Prepend=3]="Prepend"})(P=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ce[218],ue([0,1,4,103]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class g{constructor(p){this.map=new Map,p.forEach((w,n)=>{const A=w.map.entries();let b=A.next();for(;!b.done;){const m=b.value[0];let u=this.map.get(m);if(u||(u=[],this.map.set(m,u)),u.length>0&&u[0].type===P.EnvironmentVariableMutatorType.Replace){b=A.next();continue}const h=b.value[1];u.unshift({extensionIdentifier:n,value:h.value,type:h.type}),b=A.next()}})}applyToProcessEnvironment(p,w){let n;E.isWindows&&(n={},Object.keys(p).forEach(A=>n[A.toLowerCase()]=A)),this.map.forEach((A,b)=>{const m=E.isWindows&&n[b.toLowerCase()]||b;A.forEach(u=>{const h=w?w(u.value):u.value;switch(u.type){case P.EnvironmentVariableMutatorType.Append:p[m]=(p[m]||"")+h;break;case P.EnvironmentVariableMutatorType.Prepend:p[m]=h+(p[m]||"");break;case P.EnvironmentVariableMutatorType.Replace:p[m]=h;break}})})}diff(p){const w=new Map,n=new Map,A=new Map;if(p.map.forEach((b,m)=>{const u=this.map.get(m),h=D(b,u);h&&w.set(m,h)}),this.map.forEach((b,m)=>{const u=p.map.get(m),h=D(b,u);h&&A.set(m,h)}),this.map.forEach((b,m)=>{const u=p.map.get(m),h=I(b,u);h&&n.set(m,h)}),!(w.size===0&&n.size===0&&A.size===0))return{added:w,changed:n,removed:A}}}e.MergedEnvironmentVariableCollection=g;function D(C,p){if(!p)return C;const w=new Set;p.forEach(A=>w.add(A.extensionIdentifier));const n=[];return C.forEach(A=>{w.has(A.extensionIdentifier)||n.push(A)}),n.length===0?void 0:n}function I(C,p){if(!p)return;const w=new Map;p.forEach(A=>w.set(A.extensionIdentifier,A));const n=[];return C.forEach(A=>{const b=w.get(A.extensionIdentifier);b&&(A.type!==b.type||A.value!==b.value)&&n.push(b)}),n.length===0?void 0:n}}),define(ce[104],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(g){return[...g.entries()]}e.serializeEnvironmentVariableCollection=E;function P(g){return new Map(g)}e.deserializeEnvironmentVariableCollection=P}),define(ce[219],ue([0,1,5,116,4]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function D(l,a){if(!!a)if(g.isWindows)for(const t in a){let r=t;for(const s in l)if(t.toLowerCase()===s.toLowerCase()){r=s;break}const i=a[t];i!==void 0&&I(l,r,i)}else Object.keys(a).forEach(t=>{const r=a[t];r!==void 0&&I(l,t,r)})}e.mergeEnvironments=D;function I(l,a,t){typeof t=="string"?l[a]=t:delete l[a]}function C(l,a,t,r){l.TERM_PROGRAM="vscode",a&&(l.TERM_PROGRAM_VERSION=a),n(l,r)&&(l.LANG=A(t)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=C;function p(l,a){if(!!a)for(const t of Object.keys(a)){const r=a[t];r&&(l[t]=r)}}function w(l,a){return Object.keys(a).forEach(t=>{const r=a[t];if(typeof r=="string")try{a[t]=l(r)}catch(i){a[t]=r}}),a}function n(l,a){if(a==="on")return!0;if(a==="auto"){const t=l.LANG;return!t||t.search(/\.UTF\-8$/)===-1&&t.search(/\.utf8$/)===-1&&t.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=n;function A(l){const a=l?l.split("-"):[],t=a.length;if(t===0)return"en_US.UTF-8";if(t===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};a[0]in r&&a.push(r[a[0]])}else a[1]=a[1].toUpperCase();return a.join("_")+".UTF-8"}e.getLangEnvVariable=A;function b(l,a,t,r,i,s){if(l.cwd){const v=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,y=m(v,t);return u(y||v)}let c;return!l.ignoreConfigurationCwd&&i&&(t&&(i=m(i,t,s)),i&&(E.isAbsolute(i)?c=i:r&&(c=E.join(r.fsPath,i)))),c||(c=r?r.fsPath:a||""),u(c)}e.getCwd=b;function m(l,a,t){if(a)try{return a(l)}catch(r){t?.error("Could not resolve terminal cwd",r);return}return l}function u(l){return g.OS===1&&l&&l[1]===":"?l[0].toUpperCase()+l.substr(1):l}function h(l,a,t){if(!!t)return r=>t.resolveWithEnvironment(a,l,r)}e.createVariableResolver=h;function S(l,a,t,r,i,s,c,v=g.platform){let y;c&&(y=_(l,"automationShell",v)),y||(y=_(l,"shell",v));let T=y||a;if(v===3&&!t&&r){const R=E.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();T&&T.toLowerCase().indexOf(R)===0&&(T=E.join(r,"System32",T.substr(R.length+1)))}if(T&&v===3&&(T=T.replace(/\//g,"\\")),i)try{T=i(T)}catch(R){s.error("Could not resolve shell",R)}return T}e.getDefaultShell=S;function d(l,a,t,r,i=g.platform){if(a&&_(l,"automationShell",i))return[];const s=i===3?"windows":i===1?"osx":"linux";let c=l(`terminal.integrated.shellArgs.${s}`);if(!c)return[];if(typeof c=="string"&&i===3)return t?t(c):c;if(t){const v=[];for(const y of c)try{v.push(t(y))}catch(T){r.error(`Could not resolve terminal.integrated.shellArgs.${s}`,T),v.push(y)}c=v}return c}e.getDefaultShellArgs=d;function _(l,a,t=g.platform){return l(`terminal.integrated.${a}.${t===3?"windows":t===1?"osx":"linux"}`)}function f(l,a,t,r,i,s){const c={};if(l.strictEnv)p(c,l.env);else{p(c,s);const v={...a};t&&(v&&w(t,v),l.env&&w(t,l.env)),(0,P.sanitizeProcessEnvironment)(c,"VSCODE_IPC_HOOK_CLI"),D(c,v),D(c,l.env),C(c,r,g.locale,i)}return c}e.createTerminalEnvironment=f}),define(ce[220],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(D){D.Delimiter="\0"})(E=e.TestIdPathParts||(e.TestIdPathParts={}));var P;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(P=e.TestPosition||(e.TestPosition={}));class g{constructor(I,C=I.length){if(this.path=I,this.viewEnd=C,I.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(I,C,p=I.parent){if(I.id===C)return new g([C]);let w=[I.id];for(let n=p;n&&n.id!==C;n=n.parent)w.push(n.id);return w.push(C),new g(w.reverse())}static fromString(I){return new g(I.split("\0"))}static join(I,C){return new g([...I.path,C])}static joinToString(I,C){return I.toString()+"\0"+C}static compare(I,C){return I===C?0:C.startsWith(I+"\0")?2:I.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new g(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let I=1;I<=this.viewEnd;I++)yield new g(this.path,I)}compare(I){if(typeof I=="string")return g.compare(this.toString(),I);for(let C=0;C<I.viewEnd&&C<this.viewEnd;C++)if(I.path[C]!==this.path[C])return 1;return I.viewEnd>this.viewEnd?2:I.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let I=1;I<this.viewEnd;I++)this.stringifed+="\0",this.stringifed+=this.path[I]}return this.stringifed}}e.TestId=g}),define(ce[221],ue([0,1,34,6]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,P.refineServiceDecorator)(E.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(ce[222],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,E.createDecorator)("configurationResolverService")}),define(ce[223],ue([0,1,5,23,12,18,4,52,161]),function(X,e,E,P,g,D,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(A,b,m){this._contributedVariables=new Map,this._context=A,this._labelService=b,m&&(this._envVariablesPromise=m.then(u=>this.prepareEnv(u)))}prepareEnv(A){if(I.isWindows){const b=Object.create(null);return Object.keys(A).forEach(m=>{b[m.toLowerCase()]=A[m]}),b}return A}resolveWithEnvironment(A,b,m){return this.recursiveResolve(this.prepareEnv(A),b?b.uri:void 0,m)}async resolveAsync(A,b){return this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,b)}async resolveAnyBase(A,b,m,u){const h=D.deepClone(b);return I.isWindows&&h.windows?Object.keys(h.windows).forEach(S=>h[S]=h.windows[S]):I.isMacintosh&&h.osx?Object.keys(h.osx).forEach(S=>h[S]=h.osx[S]):I.isLinux&&h.linux&&Object.keys(h.linux).forEach(S=>h[S]=h.linux[S]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,h,m,u)}async resolveAnyAsync(A,b,m){return this.resolveAnyBase(A,b,m)}async resolveAnyMap(A,b,m){const u=new Map;return{newConfig:await this.resolveAnyBase(A,b,m,u),resolvedVariables:u}}resolveWithInteractionReplace(A,b,m,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(A,b,m,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(A,b){if(this._contributedVariables.has(A))throw new Error("Variable "+A+" is contributed twice.");this._contributedVariables.set(A,b)}recursiveResolve(A,b,m,u,h){if(g.isString(m))return this.resolveString(A,b,m,u,h);if(g.isArray(m))return m.map(S=>this.recursiveResolve(A,b,S,u,h));if(g.isObject(m)){let S=Object.create(null);return Object.keys(m).forEach(d=>{const _=this.resolveString(A,b,d,u,h);S[_]=this.recursiveResolve(A,b,m[d],u,h)}),S}return m}resolveString(A,b,m,u,h){return m.replace(w.VARIABLE_REGEXP,(d,_)=>{if(_.includes(w.VARIABLE_LHS))return d;let f=this.evaluateSingleVariable(A,d,_,b,u);return h&&h.set(_,f),f!==d&&g.isString(f)&&f.match(w.VARIABLE_REGEXP)&&(f=this.resolveString(A,b,f,u,h)),f})}fsPath(A){return this._labelService?this._labelService.getUriLabel(A,{noPrefix:!0}):A.fsPath}evaluateSingleVariable(A,b,m,u,h){let S;const d=m.split(":");d.length>1&&(m=d[0],S=d[1]);const _=()=>{const a=this._context.getFilePath();if(a)return a;throw new Error((0,p.localize)(0,null,b))},f=()=>{const a=_();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,p.localize)(1,null,b,E.basename(a)))},l=()=>{if(S){const a=this._context.getFolderUri(S);if(a)return a;throw new Error((0,p.localize)(2,null,b,S))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,p.localize)(3,null,b)):new Error((0,p.localize)(4,null,b))};switch(m){case"env":if(S){if(A){const a=A[I.isWindows?S.toLowerCase():S];if(g.isString(a))return a}return""}throw new Error((0,p.localize)(5,null,b));case"config":if(S){const a=this._context.getConfigurationValue(u,S);if(g.isUndefinedOrNull(a))throw new Error((0,p.localize)(6,null,b,S));if(g.isObject(a))throw new Error((0,p.localize)(7,null,b,S));return a}throw new Error((0,p.localize)(8,null,b));case"command":return this.resolveFromMap(b,S,h,"command");case"input":return this.resolveFromMap(b,S,h,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return u||S?(0,C.normalizeDriveLetter)(this.fsPath(l())):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return E.basename(this.fsPath(l()));case"lineNumber":const a=this._context.getLineNumber();if(a)return a;throw new Error((0,p.localize)(9,null,b));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,p.localize)(10,null,b));case"file":return _();case"fileWorkspaceFolder":return f();case"relativeFile":return u||S?E.relative(this.fsPath(l()),_()):_();case"relativeFileDirname":const r=E.dirname(_());if(u||S){const v=E.relative(this.fsPath(l()),r);return v.length===0?".":v}return r;case"fileDirname":return E.dirname(_());case"fileExtname":return E.extname(_());case"fileBasename":return E.basename(_());case"fileBasenameNoExtension":const i=E.basename(_());return i.slice(0,i.length-E.extname(i).length);case"fileDirnameBasename":return E.basename(E.dirname(_()));case"execPath":const s=this._context.getExecPath();return s||b;case"execInstallFolder":const c=this._context.getAppRoot();return c||b;case"pathSeparator":return E.sep;default:try{const v=S?`${m}:${S}`:m;return this.resolveFromMap(b,v,h,void 0)}catch(v){return b}}}}resolveFromMap(A,b,m,u){if(b&&m){const h=u===void 0?m[b]:m[u+":"+b];if(typeof h=="string")return h;throw new Error((0,p.localize)(11,null,A))}return A}}e.AbstractVariableResolverService=w,w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ce[224],ue([0,1,6,102]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var g;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(g=e.GroupDirection||(e.GroupDirection={}));var D;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var C;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var p;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(p=e.MergeGroupMode||(e.MergeGroupMode={}));function w(h){const S=h;return(0,P.isEditorInput)(S?.editor)&&(0,P.isEditorInput)(S?.replacement)}e.isEditorReplacement=w;var n;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var A;(function(h){h[h.GROUP_ACTIVE=0]="GROUP_ACTIVE",h[h.GROUP_INDEX=1]="GROUP_INDEX",h[h.EDITOR_OPEN=2]="EDITOR_OPEN",h[h.EDITOR_CLOSE=3]="EDITOR_CLOSE",h[h.EDITOR_MOVE=4]="EDITOR_MOVE",h[h.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",h[h.EDITOR_LABEL=6]="EDITOR_LABEL",h[h.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",h[h.EDITOR_PIN=8]="EDITOR_PIN",h[h.EDITOR_STICKY=9]="EDITOR_STICKY",h[h.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(A=e.GroupChangeKind||(e.GroupChangeKind={}));var b;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(b=e.OpenEditorContext||(e.OpenEditorContext={}));function m(h){const S=h;return!!S&&typeof S.id=="number"&&Array.isArray(S.editors)}e.isEditorGroup=m;function u(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=u}),define(ce[105],ue([0,1,6,224]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function g(D){const I=D;return typeof D=="number"||(0,P.isEditorGroup)(I)}e.isPreferredGroup=g}),define(ce[225],ue([0,1,21,74,246,46,18,12,3,55,179,165,188,216,217,220,105,101]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(le){function de($){const{selectionStartLineNumber:ke,selectionStartColumn:Ie,positionLineNumber:Ge,positionColumn:We}=$,st=new d.Position(ke-1,Ie-1),ut=new d.Position(Ge-1,We-1);return new d.Selection(st,ut)}le.to=de;function Z($){const{anchor:ke,active:Ie}=$;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}le.from=Z})(_=e.Selection||(e.Selection={}));var f;(function(le){function de($){if(!$)return;const{start:ke,end:Ie}=$;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}le.from=de;function Z($){if(!$)return;const{startLineNumber:ke,startColumn:Ie,endLineNumber:Ge,endColumn:We}=$;return new d.Range(ke-1,Ie-1,Ge-1,We-1)}le.to=Z})(f=e.Range||(e.Range={}));var l;(function(le){function de(Z){switch(Z){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}le.to=de})(l=e.TokenType||(e.TokenType={}));var a;(function(le){function de($){return new d.Position($.lineNumber-1,$.column-1)}le.to=de;function Z($){return{lineNumber:$.line+1,column:$.character+1}}le.from=Z})(a=e.Position||(e.Position={}));var t;(function(le){function de($){switch($){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}le.from=de;function Z($){switch($){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}le.to=Z})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(le){function de($){let ke;return $.code&&((0,C.isString)($.code)||(0,C.isNumber)($.code)?ke=String($.code):ke={value:String($.code.value),target:$.code.target}),{...f.from($.range),message:$.message,source:$.source,code:ke,severity:s.from($.severity),relatedInformation:$.relatedInformation&&$.relatedInformation.map(i.from),tags:Array.isArray($.tags)?(0,E.coalesce)($.tags.map(t.from)):void 0}}le.from=de;function Z($){const ke=new d.Diagnostic(f.to($),$.message,s.to($.severity));return ke.source=$.source,ke.code=(0,C.isString)($.code)?$.code:$.code?.value,ke.relatedInformation=$.relatedInformation&&$.relatedInformation.map(i.to),ke.tags=$.tags&&(0,E.coalesce)($.tags.map(t.to)),ke}le.to=Z})(r=e.Diagnostic||(e.Diagnostic={}));var i;(function(le){function de($){return{...f.from($.location.range),message:$.message,resource:$.location.uri}}le.from=de;function Z($){return new d.DiagnosticRelatedInformation(new d.Location($.resource,f.to($)),$.message)}le.to=Z})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var s;(function(le){function de($){switch($){case d.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}le.from=de;function Z($){switch($){case b.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}le.to=Z})(s=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(le){function de($){return typeof $=="number"&&$>=d.ViewColumn.One?$-1:$===d.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}le.from=de;function Z($){if(typeof $=="number"&&$>=0)return $+1;throw new Error("invalid 'EditorGroupColumn'")}le.to=Z})(c=e.ViewColumn||(e.ViewColumn={}));function v(le){return typeof le.range!="undefined"}function y(le){return le.length===0?!0:!!v(le[0])}e.isDecorationOptionsArr=y;var T;(function(le){function de(We){return We.map(le.from)}le.fromMany=de;function Z(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function $(We){let st;if(Z(We)){const{language:lt,value:vt}=We;st={value:"```"+lt+`
`+vt+"\n```\n"}}else d.MarkdownString.isMarkdownString(We)?st={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons}:typeof We=="string"?st={value:We}:st={value:""};const ut=Object.create(null);st.uris=ut;const gt=lt=>{try{let vt=p.URI.parse(lt,!0);vt=vt.with({query:ke(vt.query,ut)}),ut[lt]=vt}catch(vt){}return""},dt=new g.Renderer;return dt.link=gt,dt.image=lt=>gt(P.parseHrefAndDimensions(lt).href),g(st.value,{renderer:dt}),st}le.from=$;function ke(We,st){if(!We)return We;let ut;try{ut=(0,D.parse)(We)}catch(dt){}if(!ut)return We;let gt=!1;return ut=(0,I.cloneAndChange)(ut,dt=>{if(p.URI.isUri(dt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[lt]=dt,gt=!0,lt}else return}),gt?JSON.stringify(ut):We}function Ie(We){const st=new d.MarkdownString(We.value,We.supportThemeIcons);return st.isTrusted=We.isTrusted,st}le.to=Ie;function Ge(We){if(!!We)return typeof We=="string"?We:le.from(We)}le.fromStrict=Ge})(T=e.MarkdownString||(e.MarkdownString={}));function R(le){return y(le)?le.map(de=>({range:f.from(de.range),hoverMessage:Array.isArray(de.hoverMessage)?T.fromMany(de.hoverMessage):de.hoverMessage?T.from(de.hoverMessage):void 0,renderOptions:de.renderOptions})):le.map(de=>({range:f.from(de)}))}e.fromRangeOrRangeWithMessage=R;function o(le){return typeof le=="undefined"?le:typeof le=="string"?p.URI.file(le):le}e.pathOrURIToURI=o;var k;(function(le){function de(Z){return typeof Z=="undefined"?Z:{contentText:Z.contentText,contentIconPath:Z.contentIconPath?o(Z.contentIconPath):void 0,border:Z.border,borderColor:Z.borderColor,fontStyle:Z.fontStyle,fontWeight:Z.fontWeight,textDecoration:Z.textDecoration,color:Z.color,backgroundColor:Z.backgroundColor,margin:Z.margin,width:Z.width,height:Z.height}}le.from=de})(k=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(le){function de(Z){return typeof Z=="undefined"?Z:{backgroundColor:Z.backgroundColor,outline:Z.outline,outlineColor:Z.outlineColor,outlineStyle:Z.outlineStyle,outlineWidth:Z.outlineWidth,border:Z.border,borderColor:Z.borderColor,borderRadius:Z.borderRadius,borderSpacing:Z.borderSpacing,borderStyle:Z.borderStyle,borderWidth:Z.borderWidth,fontStyle:Z.fontStyle,fontWeight:Z.fontWeight,textDecoration:Z.textDecoration,cursor:Z.cursor,color:Z.color,opacity:Z.opacity,letterSpacing:Z.letterSpacing,gutterIconPath:Z.gutterIconPath?o(Z.gutterIconPath):void 0,gutterIconSize:Z.gutterIconSize,overviewRulerColor:Z.overviewRulerColor,before:Z.before?k.from(Z.before):void 0,after:Z.after?k.from(Z.after):void 0}}le.from=de})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var Y;(function(le){function de(Z){if(typeof Z=="undefined")return Z;switch(Z){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}le.from=de})(Y=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var Q;(function(le){function de(Z){return{isWholeLine:Z.isWholeLine,rangeBehavior:Z.rangeBehavior?Y.from(Z.rangeBehavior):void 0,overviewRulerLane:Z.overviewRulerLane,light:Z.light?O.from(Z.light):void 0,dark:Z.dark?O.from(Z.dark):void 0,backgroundColor:Z.backgroundColor,outline:Z.outline,outlineColor:Z.outlineColor,outlineStyle:Z.outlineStyle,outlineWidth:Z.outlineWidth,border:Z.border,borderColor:Z.borderColor,borderRadius:Z.borderRadius,borderSpacing:Z.borderSpacing,borderStyle:Z.borderStyle,borderWidth:Z.borderWidth,fontStyle:Z.fontStyle,fontWeight:Z.fontWeight,textDecoration:Z.textDecoration,cursor:Z.cursor,color:Z.color,opacity:Z.opacity,letterSpacing:Z.letterSpacing,gutterIconPath:Z.gutterIconPath?o(Z.gutterIconPath):void 0,gutterIconSize:Z.gutterIconSize,overviewRulerColor:Z.overviewRulerColor,before:Z.before?k.from(Z.before):void 0,after:Z.after?k.from(Z.after):void 0}}le.from=de})(Q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var me;(function(le){function de($){return{text:$.newText,eol:$.newEol&&ne.from($.newEol),range:f.from($.range)}}le.from=de;function Z($){const ke=new d.TextEdit(f.to($.range),$.text);return ke.newEol=typeof $.eol=="undefined"?void 0:ne.to($.eol),ke}le.to=Z})(me=e.TextEdit||(e.TextEdit={}));var re;(function(le){function de($,ke,Ie){const Ge={edits:[]};if($ instanceof d.WorkspaceEdit)for(let We of $._allEntries())if(We._type===1)Ge.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata});else if(We._type===2){const st=ke?.getDocument(We.uri);Ge.edits.push({_type:2,resource:We.uri,edit:me.from(We.edit),modelVersionId:st?.version,metadata:We.metadata})}else We._type===3?Ge.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Ie?.getNotebookDocument(We.uri,!0)?.apiNotebook.version}):We._type===5&&Ge.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Ie?.getNotebookDocument(We.uri,!0)?.apiNotebook.version,edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(B.from)}});return Ge}le.from=de;function Z($){const ke=new d.WorkspaceEdit;for(const Ie of $.edits)Ie.edit?ke.replace(p.URI.revive(Ie.resource),f.to(Ie.edit.range),Ie.edit.text):ke.renameFile(p.URI.revive(Ie.oldUri),p.URI.revive(Ie.newUri),Ie.options);return ke}le.to=Z})(re=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(le){const de=Object.create(null);de[d.SymbolKind.File]=0,de[d.SymbolKind.Module]=1,de[d.SymbolKind.Namespace]=2,de[d.SymbolKind.Package]=3,de[d.SymbolKind.Class]=4,de[d.SymbolKind.Method]=5,de[d.SymbolKind.Property]=6,de[d.SymbolKind.Field]=7,de[d.SymbolKind.Constructor]=8,de[d.SymbolKind.Enum]=9,de[d.SymbolKind.Interface]=10,de[d.SymbolKind.Function]=11,de[d.SymbolKind.Variable]=12,de[d.SymbolKind.Constant]=13,de[d.SymbolKind.String]=14,de[d.SymbolKind.Number]=15,de[d.SymbolKind.Boolean]=16,de[d.SymbolKind.Array]=17,de[d.SymbolKind.Object]=18,de[d.SymbolKind.Key]=19,de[d.SymbolKind.Null]=20,de[d.SymbolKind.EnumMember]=21,de[d.SymbolKind.Struct]=22,de[d.SymbolKind.Event]=23,de[d.SymbolKind.Operator]=24,de[d.SymbolKind.TypeParameter]=25;function Z(ke){return typeof de[ke]=="number"?de[ke]:6}le.from=Z;function $(ke){for(const Ie in de)if(de[Ie]===ke)return Number(Ie);return d.SymbolKind.Property}le.to=$})(N=e.SymbolKind||(e.SymbolKind={}));var W;(function(le){function de($){switch($){case d.SymbolTag.Deprecated:return 1}}le.from=de;function Z($){switch($){case 1:return d.SymbolTag.Deprecated}}le.to=Z})(W=e.SymbolTag||(e.SymbolTag={}));var U;(function(le){function de($){return{name:$.name,kind:N.from($.kind),tags:$.tags&&$.tags.map(W.from),containerName:$.containerName,location:z.from($.location)}}le.from=de;function Z($){const ke=new d.SymbolInformation($.name,N.to($.kind),$.containerName,z.to($.location));return ke.tags=$.tags&&$.tags.map(W.to),ke}le.to=Z})(U=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var j;(function(le){function de($){const ke={name:$.name||"!!MISSING: name!!",detail:$.detail,range:f.from($.range),selectionRange:f.from($.selectionRange),kind:N.from($.kind),tags:$.tags?.map(W.from)??[]};return $.children&&(ke.children=$.children.map(de)),ke}le.from=de;function Z($){const ke=new d.DocumentSymbol($.name,$.detail,N.to($.kind),f.to($.range),f.to($.selectionRange));return(0,E.isNonEmptyArray)($.tags)&&(ke.tags=$.tags.map(W.to)),$.children&&(ke.children=$.children.map(Z)),ke}le.to=Z})(j=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(le){function de($){const ke=new d.CallHierarchyItem(N.to($.kind),$.name,$.detail||"",p.URI.revive($.uri),f.to($.range),f.to($.selectionRange));return ke._sessionId=$._sessionId,ke._itemId=$._itemId,ke}le.to=de;function Z($,ke,Ie){if(ke=ke??$._sessionId,Ie=Ie??$._itemId,ke===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ie,name:$.name,detail:$.detail,kind:N.from($.kind),uri:$.uri,range:f.from($.range),selectionRange:f.from($.selectionRange),tags:$.tags?.map(W.from)}}le.from=Z})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(le){function de(Z){return new d.CallHierarchyIncomingCall(H.to(Z.from),Z.fromRanges.map($=>f.to($)))}le.to=de})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var q;(function(le){function de(Z){return new d.CallHierarchyOutgoingCall(H.to(Z.to),Z.fromRanges.map($=>f.to($)))}le.to=de})(q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var z;(function(le){function de($){return{range:$.range&&f.from($.range),uri:$.uri}}le.from=de;function Z($){return new d.Location(p.URI.revive($.uri),f.to($.range))}le.to=Z})(z=e.location||(e.location={}));var V;(function(le){function de($){const ke=$,Ie=$;return{originSelectionRange:ke.originSelectionRange?f.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Ie.uri,range:f.from(ke.targetRange?ke.targetRange:Ie.range),targetSelectionRange:ke.targetSelectionRange?f.from(ke.targetSelectionRange):void 0}}le.from=de;function Z($){return{targetUri:p.URI.revive($.uri),targetRange:f.to($.range),targetSelectionRange:$.targetSelectionRange?f.to($.targetSelectionRange):void 0,originSelectionRange:$.originSelectionRange?f.to($.originSelectionRange):void 0}}le.to=Z})(V=e.DefinitionLink||(e.DefinitionLink={}));var K;(function(le){function de($){return{range:f.from($.range),contents:T.fromMany($.contents)}}le.from=de;function Z($){return new d.Hover($.contents.map(T.to),f.to($.range))}le.to=Z})(K=e.Hover||(e.Hover={}));var ae;(function(le){function de($){return{range:f.from($.range),expression:$.expression}}le.from=de;function Z($){return new d.EvaluatableExpression(f.to($.range),$.expression)}le.to=Z})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var fe;(function(le){function de($){if($ instanceof d.InlineValueText)return{type:"text",range:f.from($.range),text:$.text};if($ instanceof d.InlineValueVariableLookup)return{type:"variable",range:f.from($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};if($ instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:f.from($.range),expression:$.expression};throw new Error("Unknown 'InlineValue' type")}le.from=de;function Z($){switch($.type){case"text":return{range:f.to($.range),text:$.text};case"variable":return{range:f.to($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};case"expression":return{range:f.to($.range),expression:$.expression}}}le.to=Z})(fe=e.InlineValue||(e.InlineValue={}));var De;(function(le){function de($){return{frameId:$.frameId,stoppedLocation:f.from($.stoppedLocation)}}le.from=de;function Z($){return new d.InlineValueContext($.frameId,f.to($.stoppedLocation))}le.to=Z})(De=e.InlineValueContext||(e.InlineValueContext={}));var Pe;(function(le){function de($){return{range:f.from($.range),kind:$.kind}}le.from=de;function Z($){return new d.DocumentHighlight(f.to($.range),$.kind)}le.to=Z})(Pe=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(le){function de(Z){switch(Z){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}le.to=de})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ne;(function(le){function de(Z){return{triggerKind:Fe.to(Z.triggerKind),triggerCharacter:Z.triggerCharacter}}le.to=de})(Ne=e.CompletionContext||(e.CompletionContext={}));var ze;(function(le){function de($){switch($){case d.CompletionItemTag.Deprecated:return 1}}le.from=de;function Z($){switch($){case 1:return d.CompletionItemTag.Deprecated}}le.to=Z})(ze=e.CompletionItemTag||(e.CompletionItemTag={}));var Xe;(function(le){const de=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function Z(Ie){return de.get(Ie)??9}le.from=Z;const $=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function ke(Ie){return $.get(Ie)??d.CompletionItemKind.Property}le.to=ke})(Xe=e.CompletionItemKind||(e.CompletionItemKind={}));var nt;(function(le){function de(Z,$){const ke=new d.CompletionItem(Z.label);return ke.insertText=Z.insertText,ke.kind=Xe.to(Z.kind),ke.tags=Z.tags?.map(ze.to),ke.detail=Z.detail,ke.documentation=P.isMarkdownString(Z.documentation)?T.to(Z.documentation):Z.documentation,ke.sortText=Z.sortText,ke.filterText=Z.filterText,ke.preselect=Z.preselect,ke.commitCharacters=Z.commitCharacters,w.Range.isIRange(Z.range)?ke.range=f.to(Z.range):typeof Z.range=="object"&&(ke.range={inserting:f.to(Z.range.insert),replacing:f.to(Z.range.replace)}),ke.keepWhitespace=typeof Z.insertTextRules=="undefined"?!1:Boolean(Z.insertTextRules&1),typeof Z.insertTextRules!="undefined"&&Z.insertTextRules&4?ke.insertText=new d.SnippetString(Z.insertText):(ke.insertText=Z.insertText,ke.textEdit=ke.range instanceof d.Range?new d.TextEdit(ke.range,ke.insertText):void 0),Z.additionalTextEdits&&Z.additionalTextEdits.length>0&&(ke.additionalTextEdits=Z.additionalTextEdits.map(Ie=>me.to(Ie))),ke.command=$&&Z.command?$.fromInternal(Z.command):void 0,ke}le.to=de})(nt=e.CompletionItem||(e.CompletionItem={}));var it;(function(le){function de($){return{label:$.label,documentation:$.documentation?T.fromStrict($.documentation):void 0}}le.from=de;function Z($){return{label:$.label,documentation:P.isMarkdownString($.documentation)?T.to($.documentation):$.documentation}}le.to=Z})(it=e.ParameterInformation||(e.ParameterInformation={}));var rt;(function(le){function de($){return{label:$.label,documentation:$.documentation?T.fromStrict($.documentation):void 0,parameters:Array.isArray($.parameters)?$.parameters.map(it.from):[],activeParameter:$.activeParameter}}le.from=de;function Z($){return{label:$.label,documentation:P.isMarkdownString($.documentation)?T.to($.documentation):$.documentation,parameters:Array.isArray($.parameters)?$.parameters.map(it.to):[],activeParameter:$.activeParameter}}le.to=Z})(rt=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(le){function de($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(rt.from):[]}}le.from=de;function Z($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(rt.to):[]}}le.to=Z})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Ce;(function(le){function de($){return{text:$.text,position:a.from($.position),kind:Ae.from($.kind??d.InlayHintKind.Other),whitespaceBefore:$.whitespaceBefore,whitespaceAfter:$.whitespaceAfter}}le.from=de;function Z($){const ke=new d.InlayHint($.text,a.to($.position),Ae.to($.kind));return ke.whitespaceAfter=$.whitespaceAfter,ke.whitespaceBefore=$.whitespaceBefore,ke}le.to=Z})(Ce=e.InlayHint||(e.InlayHint={}));var Ae;(function(le){function de($){return $}le.from=de;function Z($){return $}le.to=Z})(Ae=e.InlayHintKind||(e.InlayHintKind={}));var Re;(function(le){function de($){return{range:f.from($.range),url:$.target,tooltip:$.tooltip}}le.from=de;function Z($){let ke;if($.url)try{ke=typeof $.url=="string"?p.URI.parse($.url,!0):p.URI.revive($.url)}catch(Ie){}return new d.DocumentLink(f.to($.range),ke)}le.to=Z})(Re=e.DocumentLink||(e.DocumentLink={}));var Me;(function(le){function de($){const ke=new d.ColorPresentation($.label);return $.textEdit&&(ke.textEdit=me.to($.textEdit)),$.additionalTextEdits&&(ke.additionalTextEdits=$.additionalTextEdits.map(Ie=>me.to(Ie))),ke}le.to=de;function Z($){return{label:$.label,textEdit:$.textEdit?me.from($.textEdit):void 0,additionalTextEdits:$.additionalTextEdits?$.additionalTextEdits.map(ke=>me.from(ke)):void 0}}le.from=Z})(Me=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(le){function de($){return new d.Color($[0],$[1],$[2],$[3])}le.to=de;function Z($){return[$.red,$.green,$.blue,$.alpha]}le.from=Z})($e=e.Color||(e.Color={}));var He;(function(le){function de($){return{range:f.from($.range)}}le.from=de;function Z($){return new d.SelectionRange(f.to($.range))}le.to=Z})(He=e.SelectionRange||(e.SelectionRange={}));var Ye;(function(le){function de(Z){switch(Z){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}le.to=de})(Ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(le){function de($){switch($){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}le.from=de;function Z($){switch($){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}le.to=Z})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ne;(function(le){function de($){if($===d.EndOfLine.CRLF)return 1;if($===d.EndOfLine.LF)return 0}le.from=de;function Z($){if($===1)return d.EndOfLine.CRLF;if($===0)return d.EndOfLine.LF}le.to=Z})(ne=e.EndOfLine||(e.EndOfLine={}));var Se;(function(le){function de(Z){if(typeof Z=="object")return Z.viewId;switch(Z){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}le.from=de})(Se=e.ProgressLocation||(e.ProgressLocation={}));var Ee;(function(le){function de(Z){const $={start:Z.start+1,end:Z.end+1};return Z.kind&&($.kind=Ue.from(Z.kind)),$}le.from=de})(Ee=e.FoldingRange||(e.FoldingRange={}));var Ue;(function(le){function de(Z){if(Z)switch(Z){case d.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}le.from=de})(Ue=e.FoldingRangeKind||(e.FoldingRangeKind={}));var he;(function(le){function de(Z){if(Z)return{pinned:typeof Z.preview=="boolean"?!Z.preview:void 0,inactive:Z.background,preserveFocus:Z.preserveFocus,selection:typeof Z.selection=="object"?f.from(Z.selection):void 0,override:typeof Z.override=="boolean"?A.EditorResolution.DISABLED:void 0}}le.from=de})(he=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ge;(function(le){function de($){return $ instanceof d.RelativePattern||typeof $=="string"?$:Z($)?new d.RelativePattern($.base,$.pattern):$}le.from=de;function Z($){const ke=$;return ke&&typeof ke.base=="string"&&typeof ke.pattern=="string"}})(ge=e.GlobPattern||(e.GlobPattern={}));var ye;(function(le){function de(Z){if(Z){if(Array.isArray(Z))return Z.map(de);if(typeof Z=="string")return Z;{const $=Z;return{language:$.language,scheme:$.scheme,pattern:typeof $.pattern=="undefined"?void 0:ge.from($.pattern),exclusive:$.exclusive}}}else return}le.from=de})(ye=e.LanguageSelector||(e.LanguageSelector={}));var G;(function(le){function de($){return{start:$.start,end:$.end}}le.from=de;function Z($){return new d.NotebookRange($.start,$.end)}le.to=Z})(G=e.NotebookRange||(e.NotebookRange={}));var J;(function(le){function de($){return{timing:typeof $.runStartTime=="number"&&typeof $.runEndTime=="number"?{startTime:$.runStartTime,endTime:$.runEndTime}:void 0,executionOrder:$.executionOrder,success:$.lastRunSuccess}}le.to=de;function Z($){return{lastRunSuccess:$.success,runStartTime:$.timing?.startTime,runEndTime:$.timing?.endTime,executionOrder:$.executionOrder}}le.from=Z})(J=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var te;(function(le){function de($){switch($){case d.NotebookCellKind.Markup:return u.CellKind.Markup;case d.NotebookCellKind.Code:default:return u.CellKind.Code}}le.from=de;function Z($){switch($){case u.CellKind.Markup:return d.NotebookCellKind.Markup;case u.CellKind.Code:default:return d.NotebookCellKind.Code}}le.to=Z})(te=e.NotebookCellKind||(e.NotebookCellKind={}));var oe;(function(le){function de($){const ke={metadata:$.metadata??Object.create(null),cells:[]};for(let Ie of $.cells)d.NotebookCellData.validate(Ie),ke.cells.push(B.from(Ie));return ke}le.from=de;function Z($){const ke=new d.NotebookData($.cells.map(B.to));return(0,C.isEmptyObject)($.metadata)||(ke.metadata=$.metadata),ke}le.to=Z})(oe=e.NotebookData||(e.NotebookData={}));var B;(function(le){function de($){return{cellKind:te.from($.kind),language:$.languageId,mime:$.mime,source:$.value,metadata:$.metadata,internalMetadata:J.from($.executionSummary??{}),outputs:$.outputs?$.outputs.map(se.from):[]}}le.from=de;function Z($){return new d.NotebookCellData(te.to($.cellKind),$.source,$.language,$.mime,$.outputs?$.outputs.map(se.to):void 0,$.metadata,$.internalMetadata?J.to($.internalMetadata):void 0)}le.to=Z})(B=e.NotebookCellData||(e.NotebookCellData={}));var ie;(function(le){function de($){return{mime:$.mime,valueBytes:Array.from($.data)}}le.from=de;function Z($){return new d.NotebookCellOutputItem(new Uint8Array($.valueBytes),$.mime)}le.to=Z})(ie=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var se;(function(le){function de($){return{outputId:$.id,items:$.items.map(ie.from),metadata:$.metadata}}le.from=de;function Z($){const ke=$.items.map(ie.to);return new d.NotebookCellOutput(ke,$.outputId,$.metadata)}le.to=Z})(se=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ve;(function(le){function de(Ie){if(Ie!=null){if(Ie instanceof d.RelativePattern||typeof Ie=="string")return Ie;if(ke(Ie))return new d.RelativePattern(Ie.base,Ie.pattern);if($(Ie))return{include:ge.from(Ie.include)||void 0,exclude:ge.from(Ie.exclude)||void 0}}}le.from=de;function Z(Ie){return typeof Ie=="string"?Ie:ke(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}le.to=Z;function $(Ie){const Ge=Ie,We=ge.from(Ge.include);if(!(We&&We instanceof d.RelativePattern||typeof We=="string"))return!1;const st=ge.from(Ge.exclude);return!!(st&&st instanceof d.RelativePattern||typeof st=="string")}function ke(Ie){const Ge=Ie;return Ge&&typeof Ge.base=="string"&&typeof Ge.pattern=="string"}})(ve=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ee;(function(le){function de(Z){return{backgroundColor:Z.backgroundColor,borderColor:Z.borderColor,top:Z.top?k.from(Z.top):void 0}}le.from=de})(ee=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var we;(function(le){function de(Z,$,ke){const Ie=typeof Z.command=="string"?{title:"",command:Z.command}:Z.command;return{alignment:Z.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:$.toInternal(Ie,ke),text:Z.text,tooltip:Z.tooltip,accessibilityInformation:Z.accessibilityInformation,priority:Z.priority}}le.from=de})(we=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var _e;(function(le){function de(Z){return{transientOutputs:Z?.transientOutputs??!1,transientCellMetadata:Z?.transientCellMetadata??{},transientDocumentMetadata:Z?.transientDocumentMetadata??{}}}le.from=de})(_e=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Te;(function(le){function de($){return{uri:$.uri,provides:$.provides}}le.from=de;function Z($){return new d.NotebookRendererScript(p.URI.revive($.uri),$.provides)}le.to=Z})(Te=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Oe;(function(le){function de($){return{message:T.fromStrict($.message)||"",severity:d.TestMessageSeverity.Error,expectedOutput:$.expectedOutput,actualOutput:$.actualOutput,location:$.location?z.from($.location):void 0}}le.from=de;function Z($){const ke=new d.TestMessage(typeof $.message=="string"?$.message:T.to($.message));return ke.actualOutput=$.actualOutput,ke.expectedOutput=$.expectedOutput,ke}le.to=Z})(Oe=e.TestMessage||(e.TestMessage={}));var je;(function(le){function de(Ie){return{extId:h.TestId.fromExtHostTestItem(Ie,(0,m.getPrivateApiFor)(Ie).controllerId).toString(),label:Ie.label,uri:Ie.uri,range:f.from(Ie.range)||null,description:Ie.description||null,error:Ie.error&&T.fromStrict(Ie.error)||null}}le.from=de;function Z(Ie){return{id:h.TestId.fromString(Ie.extId).localId,label:Ie.label,uri:p.URI.revive(Ie.uri),range:f.to(Ie.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ie.description||void 0}}le.toPlain=Z;function $(Ie){const Ge=h.TestId.fromString(Ie.extId),We=new m.TestItemImpl(Ge.controllerId,Ge.localId,Ie.label,p.URI.revive(Ie.uri));return We.range=f.to(Ie.range||void 0),We.description=Ie.description||void 0,We}function ke(Ie){let Ge;for(const We of Ie.tests){const st=$(We.item);(0,m.getPrivateApiFor)(st).parent=Ge,Ge=st}return Ge}le.toItemFromContext=ke})(je=e.TestItem||(e.TestItem={}));var qe;(function(le){const de=($,ke)=>{const Ie={...je.toPlain($.item),parent:void 0,taskStates:$.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.map(Oe.to)})),children:$.children.map(Ge=>ke.get(Ge)).filter(C.isDefined).map(Ge=>de(Ge,ke))};for(const Ge of Ie.children)Ge.parent=Ie;return Ie};function Z($){const ke=[],Ie=new Map;for(const Ge of $.items)Ie.set(Ge.item.extId,Ge),$.request.targets.some(We=>We.controllerId===Ge.controllerId&&We.testIds.includes(Ge.item.extId))&&ke.push(Ge);return{completedAt:$.completedAt,results:ke.map(Ge=>de(Ge,Ie))}}le.to=Z})(qe=e.TestResults||(e.TestResults={}));var Ze;(function(le){function de(Ie){return{covered:Ie.covered,total:Ie.covered}}function Z(Ie){return"line"in Ie?a.from(Ie):f.from(Ie)}function $(Ie){return"branches"in Ie?{count:Ie.executionCount,location:Z(Ie.location),type:1,branches:Ie.branches.length?Ie.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&Z(Ge.location)})):void 0}:{type:0,count:Ie.executionCount,location:Z(Ie.location)}}le.fromDetailed=$;function ke(Ie){return{uri:Ie.uri,statement:de(Ie.statementCoverage),branch:Ie.branchCoverage&&de(Ie.branchCoverage),function:Ie.functionCoverage&&de(Ie.functionCoverage),details:Ie.detailedCoverage?.map($)}}le.fromFile=ke})(Ze=e.TestCoverage||(e.TestCoverage={}));var Je;(function(le){function de(Z){switch(Z){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}le.to=de})(Je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ve;(function(le){function de($){const ke=new d.TypeHierarchyItem(N.to($.kind),$.name,$.detail||"",p.URI.revive($.uri),f.to($.range),f.to($.selectionRange));return ke._sessionId=$._sessionId,ke._itemId=$._itemId,ke}le.to=de;function Z($,ke,Ie){if(ke=ke??$._sessionId,Ie=Ie??$._itemId,ke===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ie,kind:N.from($.kind),name:$.name,detail:$.detail??"",uri:$.uri,range:f.from($.range),selectionRange:f.from($.selectionRange),tags:$.tags?.map(W.from)}}le.from=Z})(Ve=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ce[226],ue([0,1,12,221,15,95,99,104,222,102,105,8,184,103]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let u=class{constructor(S,d,_,f,l,a,t,r,i,s){this._remoteAuthority=S,this._channel=d,this._configurationService=_,this._workspaceContextService=f,this._resolverService=l,this._environmentVariableService=a,this._remoteAuthorityResolverService=t,this._logService=r,this._editorService=i,this._labelService=s}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessTitleChanged(){return this._channel.listen("$onProcessTitleChangedEvent")}get onProcessShellTypeChanged(){return this._channel.listen("$onProcessShellTypeChangedEvent")}get onProcessOverrideDimensions(){return this._channel.listen("$onProcessOverrideDimensionsEvent")}get onProcessResolvedShellLaunchConfig(){return this._channel.listen("$onProcessResolvedShellLaunchConfigEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onProcessDidChangeHasChildProcesses(){return this._channel.listen("$onProcessDidChangeHasChildProcesses")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(S,d,_,f,l,a){await this._configurationService.whenRemoteConfigurationLoaded();const t=Object.create(null),r=_?(0,E.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(_)):void 0;let i;try{i=(await this._resolverService.resolveAnyMap(r,{shellLaunchConfig:S,configuration:d})).resolvedVariables}catch(O){this._logService.error(O)}if(i)for(const[O,Y]of i.entries())(/^config:/.test(O)||O==="selectedText"||O==="lineNumber")&&(t[O]=Y);const s=[];for(const[O,Y]of this._environmentVariableService.collections.entries())s.push([O,(0,C.serializeEnvironmentVariableCollection)(Y.map)]);const c=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),v=c.options&&c.options.extensionHostEnv,y=this._workspaceContextService.getWorkspace(),T=y.folders,R=_?this._workspaceContextService.getWorkspaceFolder(_):null,o=w.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:w.SideBySideEditor.PRIMARY,filterByScheme:[A.Schemas.file,A.Schemas.userData,A.Schemas.vscodeRemote]}),k={configuration:d,resolvedVariables:t,envVariableCollections:s,shellLaunchConfig:S,workspaceId:y.id,workspaceName:this._labelService.getWorkspaceLabel(y),workspaceFolders:T,activeWorkspaceFolder:R,activeFileResource:o,shouldPersistTerminal:f,cols:l,rows:a,resolverEnv:v};return await this._channel.call("$createProcess",k)}requestDetachInstance(S,d){return this._channel.call("$requestDetachInstance",[S,d])}acceptDetachInstanceReply(S,d){return this._channel.call("$acceptDetachInstanceReply",[S,d])}attachToProcess(S){return this._channel.call("$attachToProcess",[S])}detachFromProcess(S){return this._channel.call("$detachFromProcess",[S])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(S,d){return this._channel.call("$processBinary",[S,d])}start(S){return this._channel.call("$start",[S])}input(S,d){return this._channel.call("$input",[S,d])}acknowledgeDataEvent(S,d){return this._channel.call("$acknowledgeDataEvent",[S,d])}shutdown(S,d){return this._channel.call("$shutdown",[S,d])}resize(S,d,_){return this._channel.call("$resize",[S,d,_])}getInitialCwd(S){return this._channel.call("$getInitialCwd",[S])}getCwd(S){return this._channel.call("$getCwd",[S])}orphanQuestionReply(S){return this._channel.call("$orphanQuestionReply",[S])}sendCommandResult(S,d,_){return this._channel.call("$sendCommandResult",[S,d,_])}getDefaultSystemShell(S){return this._channel.call("$getDefaultSystemShell",[S])}getProfiles(S,d,_){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,S,d,_])}acceptPtyHostResolvedVariables(S,d){return this._channel.call("$acceptPtyHostResolvedVariables",[S,d])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(S){return this._channel.call("$getWslPath",[S])}setTerminalLayoutInfo(S){const _={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:S.tabs};return this._channel.call("$setTerminalLayoutInfo",_)}updateTitle(S,d){return this._channel.call("$updateTitle",[S,d])}updateIcon(S,d,_){return this._channel.call("$updateIcon",[S,d,_])}getTerminalLayoutInfo(){const d={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",d)}};u=Le([xe(2,P.IWorkbenchConfigurationService),xe(3,I.IWorkspaceContextService),xe(4,p.IConfigurationResolverService),xe(5,m.IEnvironmentVariableService),xe(6,D.IRemoteAuthorityResolverService),xe(7,g.ILogService),xe(8,n.IEditorService),xe(9,b.ILabelService)],u),e.RemoteTerminalChannelClient=u}),define(ce[227],ue([0,1,189]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var P;(function(D){function I(C,p){if(C===p)return!0;let w=Object.keys(C),n=new Set;for(let A of Object.keys(p))n.add(A);if(w.length!==n.size)return!1;for(let A of w){if(C[A]!==p[A])return!1;n.delete(A)}return n.size===0}D.equals=I})(P=e.Translations||(e.Translations={}));class g{constructor(I){this._messageHandler=I}error(I,C){this._messageHandler(E.Severity.Error,I,C)}warn(I,C){this._messageHandler(E.Severity.Warning,I,C)}info(I,C){this._messageHandler(E.Severity.Info,I,C)}}e.Logger=g}),define(ce[228],ue([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(p,w){this._proxyIdentifierBrand=void 0,this.isMain=p,this.sid=w,this.nid=++E.count}}e.ProxyIdentifier=E,E.count=0;const P=[];function g(C){const p=new E(!0,C);return P[p.nid]=p,p}e.createMainContextProxyIdentifier=g;function D(C){const p=new E(!1,C);return P[p.nid]=p,p}e.createExtHostContextProxyIdentifier=D;function I(C){return P[C].sid}e.getStringIdentifierForProxy=I}),define(ce[229],ue([0,1,46,3,228]),function(X,e,E,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var D;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(D=e.UIKind||(e.UIKind={}));var I;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(I=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var p;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(p=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var w;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(w=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));var b;(function(f){f.name="$ident";function l(t,r){return Object.defineProperty(t,f.name,{value:r,enumerable:!0}),t}f.mixin=l;function a(t){return t[f.name]}f.of=a})(b=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(l){return l._id=m._n++,l}}e.IdObject=m,m._n=0;var u;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(f){f[f.File=1]="File",f[f.Text=2]="Text",f[f.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function d(f){if(f&&f.edits)for(const l of f.edits)typeof l.resource=="object"?l.resource=P.URI.revive(l.resource):(l.newUri=P.URI.revive(l.newUri),l.oldUri=P.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,E.revive)(l.metadata));return f}e.reviveWorkspaceEditDto=d;var _;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,g.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,g.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,g.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,g.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,g.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,g.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,g.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,g.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,g.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,g.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,g.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,g.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,g.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,g.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,g.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,g.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,g.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,g.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,g.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,g.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,g.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,g.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,g.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,g.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,g.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,g.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,g.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,g.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,g.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,g.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,g.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,g.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,g.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,g.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,g.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,g.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,g.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,g.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,g.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,g.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,g.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,g.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,g.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,g.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,g.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,g.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,g.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,g.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,g.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,g.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,g.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,g.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,g.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,g.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,g.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,g.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,g.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,g.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,g.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,g.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,g.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,g.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,g.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,g.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,g.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,g.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,g.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,g.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,g.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,g.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,g.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,g.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,g.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,g.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,g.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,g.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,g.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,g.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,g.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,g.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,g.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,g.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,g.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,g.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,g.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,g.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,g.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,g.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,g.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,g.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,g.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,g.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,g.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,g.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,g.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,g.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,g.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,g.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,g.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,g.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,g.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,g.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,g.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,g.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,g.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,g.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ce[230],ue([0,1,12,101,225,18,229,21,15,46,55,83,3,2,6,215]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(I.MainContext.MainThreadCommands),this._logService=r,this.converter=new d(this,i=>{const s=this._apiCommands.get(i);return s?.result===f.Void?s:void 0},r),this._argumentProcessors=[{processArgument(i){return(0,w.revive)(i)}},{processArgument(i){return(0,D.cloneAndChange)(i,function(s){if(n.Range.isIRange(s))return g.Range.to(s);if(A.Position.isIPosition(s))return g.Position.to(s);if(n.Range.isIRange(s.range)&&b.URI.isUri(s.uri))return g.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...i)=>{const s=t.args.map((v,y)=>{if(!v.validate(i[y]))throw new Error(`Invalid argument '${v.name}' when running '${t.id}', received: ${i[y]}`);return v.convert(i[y])}),c=await this.executeCommand(t.internalId,...s);return t.result.convert(c,i,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new P.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,i,s,c){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:i,thisArg:s,description:c}),t&&this._proxy.$registerCommand(r),new P.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,i){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const s=(0,D.cloneAndChange)(r,function(c){if(c instanceof P.Position)return g.Position.from(c);if(c instanceof P.Range)return g.Range.from(c);if(c instanceof P.Location)return g.location.from(c);if(P.NotebookRange.isNotebookRange(c))return g.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,s,i);return(0,w.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw c}}}async _executeContributedCommand(t,r){const i=this._commands.get(t);if(!i)throw new Error("Unknown command");let{callback:s,thisArg:c,description:v}=i;if(v)for(let y=0;y<v.args.length;y++)try{(0,E.validateConstraint)(r[y],v.args[y].constraint)}catch(T){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${v.args[y].name}' - ${v.args[y].description}`)}try{return await s.apply(c,r)}catch(y){if(t===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...r);T&&(t=T.command)}throw this._logService.error(y,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(i=>this._argumentProcessors.reduce((s,c)=>c.processArgument(s),i)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(i=>i[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,i]of this._commands){let{description:s}=i;s&&(t[r]=s)}return Promise.resolve(t)}};S=Le([xe(0,h.IExtHostRpcService),xe(1,p.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class d{constructor(t,r,i){this._commands=t,this._lookupApiCommand=r,this._logService=i,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const i={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return i;const s=this._lookupApiCommand(t.command);if(s)i.id=s.internalId,i.arguments=s.args.map((c,v)=>c.convert(t.arguments&&t.arguments[v]));else if((0,C.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),r.add((0,m.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),i.$ident=c,i.id=this.delegatingCommandId,i.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return i}fromInternal(t){const r=I.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class _{constructor(t,r,i,s){this.name=t,this.description=r,this.validate=i,this.convert=s}optional(){return new _(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new _(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=_,_.Uri=new _("uri","Uri of a text document",a=>b.URI.isUri(a),a=>a),_.Position=new _("position","A position in a text document",a=>P.Position.isPosition(a),g.Position.from),_.Range=new _("range","A range in a text document",a=>P.Range.isRange(a),g.Range.from),_.Selection=new _("selection","A selection in a text document",a=>P.Selection.isSelection(a),g.Selection.from),_.Number=new _("number","",a=>typeof a=="number",a=>a),_.String=new _("string","",a=>typeof a=="string",a=>a),_.CallHierarchyItem=new _("item","A call hierarchy item",a=>a instanceof P.CallHierarchyItem,g.CallHierarchyItem.from),_.TypeHierarchyItem=new _("item","A type hierarchy item",a=>a instanceof P.TypeHierarchyItem,g.TypeHierarchyItem.from);class f{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=f,f.Void=new f("no result",a=>a);class l{constructor(t,r,i,s,c){this.id=t,this.internalId=r,this.description=i,this.args=s,this.result=c}}e.ApiCommand=l}),define(ce[231],ue([0,1,162,5,49,38,21,135,12,3,16,33,58,44,227]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const h="package.json";class S{constructor(i,s,c,v,y,T){this._ourVersion=i,this._ourProductDate=s,this._log=c,this._absoluteFolderPath=v,this._isBuiltin=y,this._isUnderDevelopment=T,this._absoluteManifestPath=P.join(v,h)}}class d extends S{static _fastParseJSON(i,s){try{return JSON.parse(i)}catch(c){return D.parse(i,s)}}parse(){return n.Promises.readFile(this._absoluteManifestPath).then(i=>{const s=[],c=d._fastParseJSON(i.toString(),s);if(D.getNodeType(c)!=="object")this._log.error(this._absoluteFolderPath,E.localize(0,null,this._absoluteManifestPath));else{if(s.length===0)return c.__metadata&&(c.uuid=c.__metadata.id),c.isUserBuiltin=!!c.__metadata?.isBuiltin,delete c.__metadata,c;s.forEach(v=>{this._log.error(this._absoluteFolderPath,E.localize(1,null,this._absoluteManifestPath,v.offset,v.length,(0,C.getParseErrorMessage)(v.error)))})}return null},i=>(i.code==="ENOENT"||this._log.error(this._absoluteFolderPath,E.localize(2,null,this._absoluteManifestPath,i.message)),null))}}class _ extends S{constructor(i,s,c,v,y,T,R){super(i,s,c,v,y,T);this._nlsConfig=R}replaceNLS(i){const s=(k,O)=>{O.forEach(Y=>{this._log.error(this._absoluteFolderPath,E.localize(3,null,k,(0,C.getParseErrorMessage)(Y.error)))})},c=k=>{this._log.error(this._absoluteFolderPath,E.localize(4,null,k))};let v=P.extname(this._absoluteManifestPath),y=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-v.length);const T=`${i.publisher}.${i.name}`;let R=this._nlsConfig.translations[T],o;return R?o=n.Promises.readFile(R,"utf8").then(k=>{let O=[],Y=D.parse(k,O);return O.length>0?(s(R,O),{values:void 0,default:`${y}.nls.json`}):D.getNodeType(Y)!=="object"?(c(R),{values:void 0,default:`${y}.nls.json`}):{values:Y.contents?Y.contents.package:void 0,default:`${y}.nls.json`}},k=>({values:void 0,default:`${y}.nls.json`})):o=n.SymlinkSupport.existsFile(y+".nls"+v).then(k=>{if(!!k)return _.findMessageBundles(this._nlsConfig,y).then(O=>O.localized?n.Promises.readFile(O.localized,"utf8").then(Y=>{let Q=[],me=D.parse(Y,Q);return Q.length>0?(s(O.localized,Q),{values:void 0,default:O.original}):D.getNodeType(me)!=="object"?(c(O.localized),{values:void 0,default:O.original}):{values:me,default:O.original}},Y=>({values:void 0,default:O.original})):{values:void 0,default:O.original},O=>{})}),o.then(k=>{if(k===void 0)return i;let O=[];return _.resolveOriginalMessageBundle(k.default,O).then(Y=>{if(O.length>0)return s(k.default,O),i;if(D.getNodeType(k)!=="object")return c(k.default),i;const Q=k.values||Object.create(null);return _._replaceNLStrings(this._nlsConfig,i,Q,Y,this._log,this._absoluteFolderPath),i})},k=>i)}static resolveOriginalMessageBundle(i,s){return new Promise((c,v)=>{i?n.Promises.readFile(i).then(y=>{c(D.parse(y.toString(),s))},y=>{c(null)}):c(null)})}static findMessageBundles(i,s){return new Promise((c,v)=>{function y(T,R){let o=`${T}.nls.${R}.json`;n.SymlinkSupport.existsFile(o).then(k=>{k&&c({localized:o,original:`${T}.nls.json`});let O=R.lastIndexOf("-");O===-1?c({localized:`${T}.nls.json`,original:null}):(R=R.substring(0,O),y(T,R))})}if(i.devMode||i.pseudo||!i.locale)return c({localized:s+".nls.json",original:null});y(s,i.locale)})}static _replaceNLStrings(i,s,c,v,y,T){function R(o,k,O){let Y=o[k];if(p.isString(Y)){let Q=Y,me=Q.length;if(me>1&&Q[0]==="%"&&Q[me-1]==="%"){let re=Q.substr(1,me-2),N=c[re];N===void 0&&v&&(N=v[re]),N?(i.pseudo&&(N="\uFF3B"+N.replace(/[aouei]/g,"$&$&")+"\uFF3D"),o[k]=O&&(k==="title"||k==="category")&&v?{value:N,original:v[re]}:N):y.warn(T,E.localize(5,null,re))}}else if(p.isObject(Y))for(let Q in Y)Y.hasOwnProperty(Q)&&(Q==="commands"?R(Y,Q,!0):R(Y,Q,O));else if(p.isArray(Y))for(let Q=0;Q<Y.length;Q++)R(Y,Q,O)}for(let o in s)s.hasOwnProperty(o)&&R(s,o)}}class f extends S{validate(i){let s=i;s.isBuiltin=this._isBuiltin,s.isUserBuiltin=!this._isBuiltin&&!!s.isUserBuiltin,s.isUnderDevelopment=this._isUnderDevelopment;let c=[];return f.isValidExtensionDescription(this._ourVersion,this._ourProductDate,this._absoluteFolderPath,s,c)?(c.forEach(v=>{this._log.warn(this._absoluteFolderPath,v)}),s.publisher||(s.publisher="undefined_publisher"),s.id=(0,A.getExtensionId)(s.publisher,s.name),s.identifier=new m.ExtensionIdentifier(s.id),s.extensionLocation=w.URI.file(this._absoluteFolderPath),s):(c.forEach(v=>{this._log.error(this._absoluteFolderPath,v)}),null)}static isValidExtensionDescription(i,s,c,v,y){return f.baseIsValidExtensionDescription(c,v,y)?g.valid(v.version)?(0,b.isValidExtensionVersion)(i,s,v,y):(y.push(E.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(i,s,c){if(!s)return c.push(E.localize(7,null)),!1;if(typeof s.publisher!="undefined"&&typeof s.publisher!="string")return c.push(E.localize(8,null)),!1;if(typeof s.name!="string")return c.push(E.localize(9,null,"name")),!1;if(typeof s.version!="string")return c.push(E.localize(10,null,"version")),!1;if(!s.engines)return c.push(E.localize(11,null,"engines")),!1;if(typeof s.engines.vscode!="string")return c.push(E.localize(12,null,"engines.vscode")),!1;if(typeof s.extensionDependencies!="undefined"&&!f._isStringArray(s.extensionDependencies))return c.push(E.localize(13,null,"extensionDependencies")),!1;if(typeof s.activationEvents!="undefined"){if(!f._isStringArray(s.activationEvents))return c.push(E.localize(14,null,"activationEvents")),!1;if(typeof s.main=="undefined"&&typeof s.browser=="undefined")return c.push(E.localize(15,null,"activationEvents","main")),!1}if(typeof s.main!="undefined"){if(typeof s.main!="string")return c.push(E.localize(16,null,"main")),!1;{const v=P.join(i,s.main);v.startsWith(i)||c.push(E.localize(17,null,v,i))}if(typeof s.activationEvents=="undefined")return c.push(E.localize(18,null,"activationEvents","main")),!1}if(typeof s.browser!="undefined"){if(typeof s.browser!="string")return c.push(E.localize(19,null,"browser")),!1;{const v=P.join(i,s.browser);v.startsWith(i)||c.push(E.localize(20,null,v,i))}if(typeof s.activationEvents=="undefined")return c.push(E.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(i){if(!Array.isArray(i))return!1;for(let s=0,c=i.length;s<c;s++)if(typeof i[s]!="string")return!1;return!0}}class l{constructor(i,s,c,v,y,T,R,o,k){this.ourVersion=i,this.ourProductDate=s,this.commit=c,this.locale=v,this.devMode=y,this.absoluteFolderPath=T,this.isBuiltin=R,this.isUnderDevelopment=o,this.translations=k}static createNLSConfig(i){return{devMode:i.devMode,locale:i.locale,pseudo:i.locale==="pseudo",translations:i.translations}}static equals(i,s){return i.ourVersion===s.ourVersion&&i.ourProductDate===s.ourProductDate&&i.commit===s.commit&&i.locale===s.locale&&i.devMode===s.devMode&&i.absoluteFolderPath===s.absoluteFolderPath&&i.isBuiltin===s.isBuiltin&&i.isUnderDevelopment===s.isUnderDevelopment&&i.mtime===s.mtime&&u.Translations.equals(i.translations,s.translations)}}e.ExtensionScannerInput=l;class a{constructor(i){this.root=i}resolveExtensions(){return n.Promises.readDirsInDir(this.root).then(i=>i.map(s=>({name:s,path:P.join(this.root,s)})))}}class t{static scanExtension(i,s,c,v,y,T,R){return v=P.normalize(v),new d(i,s,c,v,y,T).parse().then(k=>k===null?null:new _(i,s,c,v,y,T,R).replaceNLS(k)).then(k=>k===null?null:new f(i,s,c,v,y,T).validate(k))}static async scanExtensions(i,s,c=null){const v=i.absoluteFolderPath,y=i.isBuiltin,T=i.isUnderDevelopment;c||(c=new a(v));try{let R={};if(!y)try{const Q=await n.Promises.readFile(P.join(v,".obsolete"),"utf8");R=JSON.parse(Q)}catch(Q){}let o=await c.resolveExtensions();o.sort((Q,me)=>Q.name<me.name?-1:1),y||(o=o.filter(Q=>Q.name.indexOf(".")!==0));const k=l.createNLSConfig(i);let O=await Promise.all(o.map(Q=>this.scanExtension(i.ourVersion,i.ourProductDate,s,Q.path,y,T,k))),Y=I.coalesce(O);return Y=Y.filter(Q=>Q!==null&&!R[new A.ExtensionIdentifierWithVersion({id:(0,A.getGalleryExtensionId)(Q.publisher,Q.name)},Q.version).key()]),y||(Y=(0,A.groupByExtension)(Y,me=>({id:me.identifier.value,uuid:me.uuid})).map(me=>me.sort((re,N)=>g.rcompare(re.version,N.version))[0])),Y.sort((Q,me)=>Q.extensionLocation.fsPath<me.extensionLocation.fsPath?-1:1),Y}catch(R){return s.error(v,R),[]}}static scanOneOrMultipleExtensions(i,s){const c=i.absoluteFolderPath,v=i.isBuiltin,y=i.isUnderDevelopment;return n.SymlinkSupport.existsFile(P.join(c,h)).then(T=>{if(T){const R=l.createNLSConfig(i);return this.scanExtension(i.ourVersion,i.ourProductDate,s,c,v,y,R).then(o=>o===null?[]:[o])}return this.scanExtensions(i,s)},T=>(s.error(c,T),[]))}static scanSingleExtension(i,s){const c=i.absoluteFolderPath,v=i.isBuiltin,y=i.isUnderDevelopment,T=l.createNLSConfig(i);return this.scanExtension(i.ourVersion,i.ourProductDate,s,c,v,y,T)}static mergeBuiltinExtensions(i,s){return Promise.all([i,s]).then(([c,v])=>{let y=Object.create(null);for(let R=0,o=c.length;R<o;R++)y[m.ExtensionIdentifier.toKey(c[R].identifier)]=c[R];for(let R=0,o=v.length;R<o;R++)y[m.ExtensionIdentifier.toKey(v[R].identifier)]=v[R];let T=Object.keys(y).map(R=>y[R]);return T.sort((R,o)=>{const k=P.basename(R.extensionLocation.fsPath),O=P.basename(o.extensionLocation.fsPath);return k<O?-1:k>O?1:0}),T})}}e.ExtensionScanner=t}),define(ce[232],ue([0,1,4,48,3,41,158,27,8,29,231,44,54,100,60,81,199,5,23]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h,S,d,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let f=null;function l(){return f||(f=(0,d.normalize)((0,d.join)(p.FileAccess.asFileUri("",X).fsPath,"..","extensions"))),f}let a=null;function t(){return a||(a=(0,d.normalize)((0,d.join)(p.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions"))),a}class r{constructor(s,c,v,y,T,R){this._connectionToken=s,this.environmentService=c,this.logService=y,this.telemetryService=T,this.telemetryAppender=R,this._logger=new class{error(k,O){y.error(k,O)}warn(k,O){y.warn(k,O)}info(k,O){y.info(k,O)}},c.args["install-builtin-extension"]?this.whenExtensionsReady=v.installExtensions([],c.args["install-builtin-extension"],!!c.args["do-not-sync"],!!c.args.force).then(null,k=>{y.error(k)}):this.whenExtensionsReady=Promise.resolve();const o=c.args["install-extension"];if(o){const k=o.map(O=>/\.vsix$/i.test(O)?g.URI.file((0,d.isAbsolute)(O)?O:(0,d.join)((0,_.cwd)(),O)):O);this.whenExtensionsReady.then(()=>v.installExtensions(k,[],!!c.args["do-not-sync"],!!c.args.force)).then(null,O=>{y.error(O)})}}async call(s,c,v){switch(c){case"disableTelemetry":{this.telemetryService.setEnabled(!1);return}case"getEnvironmentData":{const y=v,T=(0,D.createRemoteURITransformer)(y.remoteAuthority);let R=await this._getEnvironmentData();return R=(0,b.transformOutgoingURIs)(R,T),R}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const y=v,T=y.language;this.logService.trace(`Scanning extensions using UI language: ${T}`);const R=(0,D.createRemoteURITransformer)(y.remoteAuthority),o=y.extensionDevelopmentPath&&y.extensionDevelopmentPath.map(Y=>g.URI.revive(R.transformIncoming(Y))),k=o?o.filter(Y=>Y.scheme===p.Schemas.file).map(Y=>Y.fsPath):void 0;let O=await this._scanExtensions(T,k);return O=(0,b.transformOutgoingURIs)(O,R),this.logService.trace("Scanned Extensions",O),r._massageWhenConditions(O),O}case"scanSingleExtension":{await this.whenExtensionsReady;const y=v,T=y.language,R=y.isBuiltin,o=(0,D.createRemoteURITransformer)(y.remoteAuthority),k=g.URI.revive(o.transformIncoming(y.extensionLocation)),O=k.scheme===p.Schemas.file?k.fsPath:null;if(!O)return null;const Y=await this._getTranslations(T);let Q=await this._scanSingleExtension(O,R,T,Y);return Q?(Q=(0,b.transformOutgoingURIs)(Q,o),r._massageWhenConditions([Q]),Q):null}case"getDiagnosticInfo":{const y=v,T={machineInfo:(0,S.getMachineInfo)()},R=y.includeProcesses?(0,h.listProcesses)(process.pid):Promise.resolve();let o=[];const k={};if(y.folders){const O=(0,D.createRemoteURITransformer)("");o=y.folders.map(Q=>g.URI.revive(O.transformIncoming(Q))).filter(Q=>Q.scheme==="file").map(Q=>(0,S.collectWorkspaceStats)(Q.fsPath,["node_modules",".git"]).then(me=>{k[(0,d.basename)(Q.fsPath)]=me}))}return Promise.all([R,...o]).then(([O,Y])=>(T.processes=O||void 0,T.workspaceMetadata=y.folders?k:void 0,T))}case"logTelemetry":{const{eventName:y,data:T}=v;return this.telemetryAppender?this.telemetryAppender.log(y,T):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${c} not found`)}listen(s,c,v){throw new Error("Not supported")}static _massageWhenConditions(s){const c=(k,O)=>k.replace(/file/g,"vscode-remote"),v=k=>{let O="";return O+=k.global?"g":"",O+=k.ignoreCase?"i":"",O+=k.multiline?"m":"",new RegExp(c(k.source,!0),O)},y=new class{mapDefined(k){return u.ContextKeyDefinedExpr.create(k)}mapNot(k){return u.ContextKeyNotExpr.create(k)}mapEquals(k,O){return k==="resourceScheme"&&typeof O=="string"?u.ContextKeyEqualsExpr.create(k,c(O,!1)):u.ContextKeyEqualsExpr.create(k,O)}mapNotEquals(k,O){return k==="resourceScheme"&&typeof O=="string"?u.ContextKeyNotEqualsExpr.create(k,c(O,!1)):u.ContextKeyNotEqualsExpr.create(k,O)}mapGreater(k,O){return u.ContextKeyGreaterExpr.create(k,O)}mapGreaterEquals(k,O){return u.ContextKeyGreaterEqualsExpr.create(k,O)}mapSmaller(k,O){return u.ContextKeySmallerExpr.create(k,O)}mapSmallerEquals(k,O){return u.ContextKeySmallerEqualsExpr.create(k,O)}mapRegex(k,O){return k==="resourceScheme"&&O?u.ContextKeyRegexExpr.create(k,v(O)):u.ContextKeyRegexExpr.create(k,O)}mapIn(k,O){return u.ContextKeyInExpr.create(k,O)}},T=k=>{if(!k||!k.when||!/resourceScheme/.test(k.when))return;const O=u.ContextKeyExpr.deserialize(k.when);if(!O)return;const Y=O.map(y);k.when=Y.serialize()},R=k=>{if(Array.isArray(k))for(let O of k)T(O);else T(k)},o=k=>{for(let O in k)R(k[O])};s.forEach(k=>{k.contributes&&(k.contributes.menus&&o(k.contributes.menus),k.contributes.keybindings&&R(k.contributes.keybindings),k.contributes.views&&o(k.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken,appRoot:g.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:g.URI.file(this.environmentService.logsPath),extensionsPath:g.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:g.URI.file((0,d.join)(this.environmentService.logsPath,`exthost${r._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:E.OS,marks:P.getMarks(),useHostProxy:this.environmentService.args["use-host-proxy"]!==void 0}}async _getTranslations(s){const c=await(0,m.getNLSConfiguration)(s,this.environmentService.userDataPath);if(m.InternalNLSConfiguration.is(c))try{const v=await C.promises.readFile(c._translationsConfigFile,"utf8");return JSON.parse(v)}catch(v){return Object.create(null)}else return Object.create(null)}async _scanExtensions(s,c){const v=await this._getTranslations(s),[y,T,R]=await Promise.all([this._scanBuiltinExtensions(s,v),this._scanInstalledExtensions(s,v),this._scanDevelopedExtensions(s,v,c)]);let o=new Map;y.forEach(O=>{!O||o.set(A.ExtensionIdentifier.toKey(O.identifier),O)}),T.forEach(O=>{!O||(o.has(A.ExtensionIdentifier.toKey(O.identifier))&&console.warn(I.localize(0,null,o.get(A.ExtensionIdentifier.toKey(O.identifier)).extensionLocation.fsPath,O.extensionLocation.fsPath)),o.set(A.ExtensionIdentifier.toKey(O.identifier),O))}),R.forEach(O=>{!O||o.set(A.ExtensionIdentifier.toKey(O.identifier),O)});const k=[];return o.forEach(O=>k.push(O)),k}_scanDevelopedExtensions(s,c,v){if(v){const y=v.map(T=>n.ExtensionScanner.scanOneOrMultipleExtensions(new n.ExtensionScannerInput(w.default.version,w.default.date,w.default.commit,s,!0,T,!1,!0,c),this._logger));return Promise.all(y).then(T=>{let R=[];for(let o of T)R=R.concat(o);return R})}return Promise.resolve([])}_scanBuiltinExtensions(s,c){const v=w.default.version,y=w.default.commit,T=w.default.date,R=!!process.env.VSCODE_DEV,o=new n.ExtensionScannerInput(v,T,y,s,R,l(),!0,!1,c),k=n.ExtensionScanner.scanExtensions(o,this._logger);let O=k;if(R){class Y{constructor(W){this.builtInExtensions=W}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(W=>({name:W.name,path:(0,d.join)(t(),W.name)})))}}const Q=Promise.resolve(w.default.builtInExtensions||[]),me=new n.ExtensionScannerInput(v,T,y,s,R,t(),!0,!1,{}),re=Q.then(N=>new Y(N)).then(N=>n.ExtensionScanner.scanExtensions(me,this._logger,N));O=n.ExtensionScanner.mergeBuiltinExtensions(k,re)}return O}_scanInstalledExtensions(s,c){const v=!!process.env.VSCODE_DEV,y=new n.ExtensionScannerInput(w.default.version,w.default.date,w.default.commit,s,v,this.environmentService.extensionsPath,!1,!1,c);return n.ExtensionScanner.scanExtensions(y,this._logger)}_scanSingleExtension(s,c,v,y){const T=!!process.env.VSCODE_DEV,R=new n.ExtensionScannerInput(w.default.version,w.default.date,w.default.commit,v,T,s,c,!1,y);return n.ExtensionScanner.scanSingleExtension(R,this._logger)}}e.RemoteAgentEnvironmentChannel=r,r._namePool=1}),define(ce[233],ue([0,1,171]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProvider=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class P extends E.IPCFileSystemProvider{constructor(D){super(D.getConnection().getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME));this.setCaseSensitive(!0),(async()=>{const I=await D.getEnvironment();this.setCaseSensitive(I?.os===3)})()}}e.RemoteFileSystemProvider=P}),define(ce[106],ue([0,1,6]),function(X,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(ce[70],ue([0,1,138,5,27,14,16,247,248,12]),function(X,e,E,P,g,D,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function A(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function b(a){if(a instanceof n)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new n(t,a)}function m(a,t,r,i,s,c){const v=P.dirname(t),y=P.join(i,v);if(!y.startsWith(i))return Promise.reject(new Error(E.localize(0,null,t)));const T=P.join(i,t);let R;return c.onCancellationRequested(()=>{R&&R.destroy()}),Promise.resolve(I.Promises.mkdir(y,{recursive:!0})).then(()=>new Promise((o,k)=>{if(!c.isCancellationRequested)try{R=(0,g.createWriteStream)(T,{mode:r}),R.once("close",()=>o()),R.once("error",k),a.once("error",k),a.pipe(R)}catch(O){k(O)}}))}function u(a,t,r,i){let s=(0,D.createCancelablePromise)(()=>Promise.resolve()),c=0;return i.onCancellationRequested(()=>{s.cancel(),a.close()}),new Promise((v,y)=>{const T=new D.Sequencer,R=o=>{o.isCancellationRequested||(c++,a.readEntry())};a.once("error",y),a.once("close",()=>s.then(()=>{i.isCancellationRequested||a.entryCount===c?v():y(new n("Incomplete",new Error(E.localize(1,null,c,a.entryCount))))},y)),a.readEntry(),a.on("entry",o=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(o.fileName)){R(i);return}const k=o.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(k)){const Q=P.join(t,k);s=(0,D.createCancelablePromise)(me=>I.Promises.mkdir(Q,{recursive:!0}).then(()=>R(me)).then(void 0,y));return}const O=S(a,o),Y=A(o);s=(0,D.createCancelablePromise)(Q=>T.queue(()=>O.then(me=>m(me,k,Y,t,r,Q).then(()=>R(Q)))).then(null,y))})})}function h(a,t=!1){return new Promise((r,i)=>{(0,C.open)(a,t?{lazyEntries:!0}:void 0,(s,c)=>{s?i(b(s)):r((0,w.assertIsDefined)(c))})})}function S(a,t){return new Promise((r,i)=>{a.openReadStream(t,(s,c)=>{s?i(b(s)):r((0,w.assertIsDefined)(c))})})}function d(a,t){return new Promise((r,i)=>{const s=new p.ZipFile;t.forEach(v=>{v.contents?s.addBuffer(typeof v.contents=="string"?Buffer.from(v.contents,"utf8"):v.contents,v.path):v.localPath&&s.addFile(v.localPath,v.path)}),s.end();const c=(0,g.createWriteStream)(a);s.outputStream.pipe(c),s.outputStream.once("error",i),c.once("error",i),c.once("finish",()=>r(a))})}e.zip=d;function _(a,t,r={},i){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let c=h(a,!0);return r.overwrite&&(c=c.then(v=>I.Promises.rm(t).then(()=>v))),c.then(v=>u(v,t,{sourcePathRegex:s},i))}e.extract=_;function f(a,t){return h(a).then(r=>new Promise((i,s)=>{r.on("entry",c=>{c.fileName===t&&S(r,c).then(v=>i(v),v=>s(v))}),r.once("close",()=>s(new Error(E.localize(2,null,t))))}))}function l(a,t){return f(a,t).then(r=>new Promise((i,s)=>{const c=[];r.once("error",s),r.on("data",v=>c.push(v)),r.on("end",()=>i(Buffer.concat(c)))}))}e.buffer=l}),define(ce[234],ue([0,1,70,146]),function(X,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function g(D){return(0,E.buffer)(D,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch(C){throw new Error((0,P.localize)(0,null))}})}e.getManifest=g}),define(ce[235],ue([0,1,49,2,16,5,15,32,33,14,3,28,170,147,45,70,4,21,8,20,19,22,11]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h,S,d,_,f,l,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",s="extracting",c="deleting",v="renaming";let y=class extends P.Disposable{constructor(R,o,k,O,Y){super();this.beforeRemovingExtension=R,this.fileService=o,this.logService=k,this.environmentService=O,this.productService=Y,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=D.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new w.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(R){const o=[];(R===null||R===0)&&o.push(this.scanSystemExtensions().then(null,k=>Promise.reject(new C.ExtensionManagementError(this.joinErrors(k).message,r)))),(R===null||R===1)&&o.push(this.scanUserExtensions(!0).then(null,k=>Promise.reject(new C.ExtensionManagementError(this.joinErrors(k).message,i))));try{const k=await Promise.all(o);return(0,d.flatten)(k)}catch(k){throw this.joinErrors(k)}}async scanUserExtensions(R){this.logService.trace("Started scanning user extensions");let[o,k]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return k=k.filter(O=>!o[new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),R&&(k=(0,p.groupByExtension)(k,Y=>Y.identifier).map(Y=>Y.sort((Q,me)=>E.rcompare(Q.manifest.version,me.manifest.version))[0])),this.logService.trace("Scanned user extensions:",k.length),k}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(R,o,k){const O=R.key(),Y=D.join(this.extensionsPath,`.${(0,a.generateUuid)()}`),Q=D.join(this.extensionsPath,O);try{await g.Promises.rm(Q)}catch(re){try{await g.Promises.rm(Q)}catch(N){}throw new C.ExtensionManagementError((0,m.localize)(0,null,Q,R.id),c)}await this.extractAtLocation(R,o,Y,k);let me=await this.scanExtension(n.URI.file(Y),1);if(!me)throw new Error((0,m.localize)(1,null,Y));await this.storeMetadata(me,{installedTimestamp:Date.now()});try{await this.rename(R,Y,Q,Date.now()+2*60*1e3),this.logService.info("Renamed to",Q)}catch(re){try{await g.Promises.rm(Y)}catch(N){}if(re.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",R.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(re)}. Deleted from extracted location`,Y),re}try{me=await this.scanExtension(n.URI.file(Q),1)}catch(re){}if(me)return me;throw new Error((0,m.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(R,o){return this.setMetadata(R,o),await this.storeMetadata(R,{...o,installedTimestamp:R.installedTimestamp}),R}async storeMetadata(R,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const k=D.join(R.location.fsPath,"package.json"),O=await g.Promises.readFile(k,"utf8"),{manifest:Y}=await this.parseManifest(O);return Y.__metadata=o,await g.Promises.writeFile(k,JSON.stringify(Y,null,"	")),R}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...R){const o=R.map(k=>new p.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version));await this.withUninstalledExtensions(k=>{o.forEach(O=>k[O.key()]=!0)})}async setInstalled(R){await this.withUninstalledExtensions(O=>delete O[R.key()]);const k=(await this.scanExtensions(1)).find(O=>new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(R))||null;return k?(await this.storeMetadata(k,{installedTimestamp:Date.now()}),this.scanExtension(k.location,1)):null}async withUninstalledExtensions(R){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await g.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let k={};if(o)try{k=JSON.parse(o)}catch(O){}return R&&(R(k),Object.keys(k).length?await g.Promises.writeFile(this.uninstalledPath,JSON.stringify(k)):await g.Promises.rm(this.uninstalledPath)),k})}async removeExtension(R,o){this.logService.trace(`Deleting ${o} extension from disk`,R.identifier.id,R.location.fsPath),await g.Promises.rm(R.location.fsPath),this.logService.info("Deleted from disk",R.identifier.id,R.location.fsPath)}async removeUninstalledExtension(R){await this.removeExtension(R,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new p.ExtensionIdentifierWithVersion(R.identifier,R.manifest.version).key()])}async extractAtLocation(R,o,k,O){this.logService.trace(`Started extracting the extension from ${o} to ${k}`);try{await g.Promises.rm(k)}catch(Y){throw new C.ExtensionManagementError(this.joinErrors(Y).message,c)}try{await(0,h.extract)(o,k,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${k}:`,R.id)}catch(Y){try{await g.Promises.rm(k)}catch(Q){}throw new C.ExtensionManagementError(Y.message,Y instanceof h.ExtractError&&Y.type?Y.type:s)}}async rename(R,o,k,O){try{await g.Promises.rename(o,k)}catch(Y){if(S.isWindows&&Y&&Y.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${o} to ${k} with 'EPERM' error. Trying again...`,R.id),this.rename(R,o,k,O);throw new C.ExtensionManagementError(Y.message||(0,m.localize)(3,null,o,k),Y.code||v)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const R=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return R;const o=this.scanDevSystemExtensions(),[k,O]=await Promise.all([R,o]);return[...k,...O]}async scanExtensionsInDir(R,o){const k=new w.Limiter(10),O=await this.fileService.resolve(n.URI.file(R));return O.children?(await Promise.all(O.children.filter(Q=>Q.isDirectory).map(Q=>k.queue(async()=>o===1&&(0,l.basename)(Q.resource).indexOf(".")===0?null:this.scanExtension(Q.resource,o))))).filter(Q=>Q&&Q.identifier):[]}async scanExtension(R,o){try{const k=await this.fileService.resolve(R);if(k.children){const{manifest:O,metadata:Y}=await this.readManifest(R.fsPath),Q=k.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,me=k.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource,re={id:(0,p.getGalleryExtensionId)(O.publisher,O.name)},N={type:o,identifier:re,manifest:O,location:R,readmeUrl:Q,changelogUrl:me,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return Y&&(this.setMetadata(N,Y),N.installedTimestamp=Y.installedTimestamp),N}}catch(k){o!==0&&this.logService.trace(k)}return null}async scanDefaultSystemExtensions(){const R=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",R.length),R}async scanDevSystemExtensions(){const R=this.getDevSystemExtensionsList();if(R.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(k=>R.some(O=>(0,p.areSameExtensions)(k.identifier,{id:O})))}else return[]}setMetadata(R,o){R.publisherDisplayName=o.publisherDisplayName||null,R.publisherId=o.publisherId||null,R.identifier.uuid=o.id,R.isMachineScoped=!!o.isMachineScoped,R.isBuiltin=R.type===0||!!o.isBuiltin}async removeUninstalledExtensions(){const R=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),k=new Set;for(const Q of o)R[new p.ExtensionIdentifierWithVersion(Q.identifier,Q.manifest.version).key()]||k.add(Q.identifier.id.toLowerCase());const O=(0,p.groupByExtension)(o,Q=>Q.identifier);await w.Promises.settled(O.map(async Q=>{const me=Q.sort((re,N)=>E.rcompare(re.manifest.version,N.manifest.version))[0];k.has(me.identifier.id.toLowerCase())||await this.beforeRemovingExtension(me)}));const Y=o.filter(Q=>R[new p.ExtensionIdentifierWithVersion(Q.identifier,Q.manifest.version).key()]);await w.Promises.settled(Y.map(Q=>this.removeUninstalledExtension(Q)))}async removeOutdatedExtensions(){const R=await this.scanAllUserExtensions(),o=[],k=(0,p.groupByExtension)(R,O=>O.identifier);o.push(...(0,d.flatten)(k.map(O=>O.sort((Y,Q)=>E.rcompare(Y.manifest.version,Q.manifest.version)).slice(1)))),await w.Promises.settled(o.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(R=>R.name)}joinErrors(R){const o=Array.isArray(R)?R:[R];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((k,O)=>new Error(`${k.message}${k.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=D.normalize(D.join(_.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(R){const o=[g.Promises.readFile(D.join(R,"package.json"),"utf8").then(Q=>this.parseManifest(Q)),g.Promises.readFile(D.join(R,"package.nls.json"),"utf8").then(void 0,Q=>Q.code!=="ENOENT"?Promise.reject(Q):"{}").then(Q=>JSON.parse(Q))],[{manifest:k,metadata:O},Y]=await Promise.all(o);return{manifest:(0,b.localizeManifest)(k,Y),metadata:O}}parseManifest(R){return new Promise((o,k)=>{try{const O=JSON.parse(R),Y=O.__metadata||null;o({manifest:O,metadata:Y})}catch(O){k(new Error((0,m.localize)(4,null)))}})}};y=Le([xe(1,f.IFileService),xe(2,I.ILogService),xe(3,A.INativeEnvironmentService),xe(4,u.IProductService)],y),e.ExtensionsScanner=y}),define(ce[107],ue([0,1,145,5,16,70,32,33,28,49,3,29,4,15,181,43,37,58,19,22,85,6,8,234,185,235,186,187,20,200]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h,S,d,_,f,l,a,t,r,i,s,c,v,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const R="unsetUninstalled",o="downloading";let k=class extends T.AbstractExtensionManagementService{constructor(N,W,U,j,H,M,q){super(N,W,U);this.environmentService=j,this.downloadService=H;const z=this._register(M.createInstance(c.ExtensionsLifecycle));this.extensionsScanner=this._register(M.createInstance(s.ExtensionsScanner,K=>z.postUninstall(K))),this.manifestCache=this._register(new u.ExtensionsManifestCache(j,this)),this.extensionsDownloader=this._register(M.createInstance(i.ExtensionsDownloader));const V=this._register(new v.ExtensionsWatcher(this,q,j,U));this._register(V.onDidChangeExtensionsByAnotherSource(({added:K,removed:ae})=>{K.length&&this._onDidInstallExtensions.fire(K.map(fe=>({identifier:fe.identifier,operation:0,local:fe}))),ae.forEach(fe=>this._onDidUninstallExtension.fire({identifier:fe}))}))}async zip(N){this.logService.trace("ExtensionManagementService#zip",N.identifier.id);const W=await this.collectFiles(N),U=await(0,D.zip)((0,_.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)()).fsPath,W);return n.URI.file(U)}async unzip(N){return this.logService.trace("ExtensionManagementService#unzip",N.toString()),(await this.install(N)).identifier}async getManifest(N){const W=await this.downloadVsix(N),U=P.resolve(W.fsPath);return(0,r.getManifest)(U)}getInstalled(N=null){return this.extensionsScanner.scanExtensions(N)}async canInstall(N){return!0}async install(N,W={}){this.logService.trace("ExtensionManagementService#install",N.toString());const U=await this.downloadVsix(N),j=await(0,r.getManifest)(P.resolve(U.fsPath));if(j.engines&&j.engines.vscode&&!(0,d.isEngineValid)(j.engines.vscode,A.default.version,A.default.date))throw new Error(E.localize(0,null,(0,C.getGalleryExtensionId)(j.publisher,j.name),A.default.version));return this.installExtension(j,U,W)}async updateMetadata(N,W){return this.logService.trace("ExtensionManagementService#updateMetadata",N.identifier.id),N=await this.extensionsScanner.saveMetadataForLocalExtension(N,{...N.manifest.__metadata||{},...W}),this.manifestCache.invalidate(),N}async updateExtensionScope(N,W){return this.logService.trace("ExtensionManagementService#updateExtensionScope",N.identifier.id),N=await this.extensionsScanner.saveMetadataForLocalExtension(N,{...N.manifest.__metadata||{},isMachineScoped:W}),this.manifestCache.invalidate(),N}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(N){if(N.scheme===t.Schemas.file)return N;if(!this.downloadService)throw new Error("Download service is not available");const W=(0,_.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)());return await this.downloadService.download(N,W),W}createInstallExtensionTask(N,W,U){return n.URI.isUri(W)?new Q(N,W,U,this.galleryService,this.extensionsScanner,this.logService):new Y(W,U,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(N,W){return new me(N,W,this.extensionsScanner)}async collectFiles(N){const W=async j=>{let H=await g.Promises.readdir(j);H=H.map(z=>P.join(j,z));const M=await Promise.all(H.map(z=>g.Promises.stat(z)));let q=Promise.resolve([]);return M.forEach((z,V)=>{const K=H[V];z.isFile()&&(q=q.then(ae=>[...ae,K])),z.isDirectory()&&(q=q.then(ae=>W(K).then(fe=>[...ae,...fe])))}),q};return(await W(N.location.fsPath)).map(j=>({path:`extension/${P.relative(N.location.fsPath,j)}`,localPath:j}))}};k=Le([xe(0,I.IExtensionGalleryService),xe(1,S.ITelemetryService),xe(2,m.ILogService),xe(3,p.INativeEnvironmentService),xe(4,(0,a.optional)(l.IDownloadService)),xe(5,a.IInstantiationService),xe(6,y.IFileService)],k),e.ExtensionManagementService=k;class O extends T.AbstractExtensionTask{constructor(N,W,U,j){super();this.identifier=N,this.source=W,this.extensionsScanner=U,this.logService=j,this._operation=1}get operation(){return this._operation}async installExtension(N,W){try{const U=await this.unsetUninstalledAndGetLocal(N.identifierWithVersion);if(U)return N.metadata?this.extensionsScanner.saveMetadataForLocalExtension(U,N.metadata):U}catch(U){throw b.isMacintosh?new I.ExtensionManagementError(E.localize(1,null),R):new I.ExtensionManagementError(E.localize(2,null),R)}return this.extract(N,W)}async unsetUninstalledAndGetLocal(N){if(!await this.isUninstalled(N))return null;this.logService.trace("Removing the extension from uninstalled list:",N.id);const U=await this.extensionsScanner.setInstalled(N);return this.logService.info("Removed the extension from uninstalled list:",N.id),U}async isUninstalled(N){return!!(await this.extensionsScanner.getUninstalledExtensions())[N.key()]}async extract({zipPath:N,identifierWithVersion:W,metadata:U},j){let H=await this.extensionsScanner.extractUserExtension(W,N,j);return this.logService.info("Extracting completed.",W.id),U&&(H=await this.extensionsScanner.saveMetadataForLocalExtension(H,U)),H}}class Y extends O{constructor(N,W,U,j,H){super(N.identifier,N,j,H);this.gallery=N,this.options=W,this.extensionsDownloader=U}async doRun(N){const U=(await this.extensionsScanner.scanExtensions(null)).find(M=>(0,C.areSameExtensions)(M.identifier,this.gallery.identifier));U&&(this._operation=2);const j=await this.downloadInstallableExtension(this.gallery,this._operation);j.metadata.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,j.metadata.isBuiltin=this.options.isBuiltin||U?.isBuiltin;const H=await this.installExtension(j,N);U&&w.neq(U.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(U);try{await this.extensionsDownloader.delete(n.URI.file(j.zipPath))}catch(M){}return H}async downloadInstallableExtension(N,W){const U={id:N.identifier.uuid,publisherId:N.publisherId,publisherDisplayName:N.publisherDisplayName};let j;try{this.logService.trace("Started downloading extension:",N.identifier.id),j=(await this.extensionsDownloader.downloadExtension(N,W)).fsPath,this.logService.info("Downloaded extension:",N.identifier.id,j)}catch(H){throw new I.ExtensionManagementError((0,T.joinErrors)(H).message,o)}try{const H=await(0,r.getManifest)(j);return{zipPath:j,identifierWithVersion:new C.ExtensionIdentifierWithVersion(N.identifier,H.version),metadata:U}}catch(H){throw new I.ExtensionManagementError((0,T.joinErrors)(H).message,T.INSTALL_ERROR_VALIDATING)}}}class Q extends O{constructor(N,W,U,j,H,M){super({id:(0,C.getGalleryExtensionId)(N.publisher,N.name)},W,H,M);this.manifest=N,this.location=W,this.options=U,this.galleryService=j}async doRun(N){const W=new C.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),j=(await this.extensionsScanner.scanExtensions(1)).find(M=>(0,C.areSameExtensions)(this.identifier,M.identifier)),H=await this.getMetadata(this.identifier.id,N);if(j)if(H.isMachineScoped=this.options.isMachineScoped||j.isMachineScoped,H.isBuiltin=this.options.isBuiltin||j.isBuiltin,this._operation=2,W.equals(new C.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version)))try{await this.extensionsScanner.removeExtension(j,"existing")}catch(M){throw new Error(E.localize(3,null,this.manifest.displayName||this.manifest.name))}else w.gt(j.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(j);else{const M=await this.unsetUninstalledAndGetLocal(W);if(M)try{await this.extensionsScanner.removeExtension(M,"existing")}catch(q){throw new Error(E.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:P.resolve(this.location.fsPath),identifierWithVersion:W,metadata:H},N)}async getMetadata(N,W){try{const U=(await this.galleryService.query({names:[N],pageSize:1},W)).firstPage[0];if(U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId}}catch(U){}return{}}}class me extends T.AbstractExtensionTask{constructor(N,W,U){super();this.extension=N,this.options=W,this.extensionsScanner=U}async doRun(N){const W=[],U=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const j=new C.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);W.push(...U.filter(H=>j.equals(new C.ExtensionIdentifierWithVersion(H.identifier,H.manifest.version))))}else W.push(...U.filter(j=>(0,C.areSameExtensions)(j.identifier,this.extension.identifier)));if(!W.length)throw new Error(E.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...W),this.options.remove)for(const j of W)try{N.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(j)}catch(H){throw new Error(E.localize(6,null,(0,h.toErrorMessage)(H)))}}}}),define(ce[50],ue([0,1,64,79,236,7,36,5,24,22,2,17,82,11,4]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(y){this.socket=y,this._errorListener=T=>{if(T){if(T.code==="EPIPE")return;(0,m.onUnexpectedError)(T)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(y){const T=R=>y(A.VSBuffer.wrap(R));return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(y){const T=R=>{y({type:0,hadError:R,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(y){return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(y){if(!this.socket.destroyed)try{this.socket.write(y.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,m.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,m.onUnexpectedError)(T)}}end(){this.socket.end()}drain(){return new Promise((y,T)=>{if(this.socket.bufferSize===0){y();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),y()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=h;var S;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var d;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(d||(d={}));class _ extends n.Disposable{constructor(y,T,R,o){super();this._onDidZlibFlush=this._register(new D.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=y,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=T,this._recordInflateBytes=o,T?(this._zlibInflate=g.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",k=>{console.error(k),(0,m.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})}),this._zlibInflate.on("data",k=>{this._pendingInflateData.push(k)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=g.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",k=>{console.error(k),(0,m.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})}),this._zlibDeflate.on("data",k=>{this._pendingDeflateData.push(k)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new b.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(k=>this._onClose.fire(k)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):A.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this._onData.event(y)}onClose(y){return this._onClose.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){this._totalOutgoingDataBytes+=y.byteLength,this._zlibDeflate?(this._zlibDeflate.write(y.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let T=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.length-4),this._isEnded||this._write(A.VSBuffer.wrap(T),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(y,!1)}_write(y,T){let R=2;y.byteLength<126?R+=0:y.byteLength<2**16?R+=2:R+=8;const o=A.VSBuffer.alloc(R);if(T?o.writeUInt8(194,0):o.writeUInt8(130,0),y.byteLength<126)o.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){o.writeUInt8(126,1);let k=1;o.writeUInt8(y.byteLength>>>8&255,++k),o.writeUInt8(y.byteLength>>>0&255,++k)}else{o.writeUInt8(127,1);let k=1;o.writeUInt8(0,++k),o.writeUInt8(0,++k),o.writeUInt8(0,++k),o.writeUInt8(0,++k),o.writeUInt8(y.byteLength>>>24&255,++k),o.writeUInt8(y.byteLength>>>16&255,++k),o.writeUInt8(y.byteLength>>>8&255,++k),o.writeUInt8(y.byteLength>>>0&255,++k)}this._totalOutgoingWireBytes+=o.byteLength+y.byteLength,this.socket.write(A.VSBuffer.concat([o,y]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(y){if(y.byteLength!==0){for(this._totalIncomingWireBytes+=y.byteLength,this._incomingData.acceptChunk(y);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),o=(T.readUInt8(0)&128)>>>7,k=T.readUInt8(1),O=(k&128)>>>7,Y=k&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(Y===126?2:0)+(Y===127?8:0),this._state.fin=o,this._state.mask=0}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),R=T.readUInt8(1),o=(R&128)>>>7;let k=R&127,O=1;k===126?k=T.readUInt8(++O)*2**8+T.readUInt8(++O):k===127&&(k=T.readUInt8(++O)*0+T.readUInt8(++O)*0+T.readUInt8(++O)*0+T.readUInt8(++O)*0+T.readUInt8(++O)*2**24+T.readUInt8(++O)*2**16+T.readUInt8(++O)*2**8+T.readUInt8(++O));let Y=0;o&&(Y=T.readUInt8(++O)*2**24+T.readUInt8(++O)*2**16+T.readUInt8(++O)*2**8+T.readUInt8(++O)),this._state.state=3,this._state.readLen=k,this._state.mask=Y}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);f(T,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(T.buffer)),this._zlibInflate.write(T.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(A.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=T.byteLength,this._onData.fire(T))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await D.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=_;function f(v,y){if(y===0)return;let T=v.byteLength>>>2;for(let Q=0;Q<T;Q++){const me=v.readUInt32BE(Q*4);v.writeUInt32BE(me^y,Q*4)}let R=T*4,o=v.byteLength-R;const k=y>>>24&255,O=y>>>16&255,Y=y>>>8&255;o>=1&&v.writeUInt8(v.readUInt8(R)^k,R),o>=2&&v.writeUInt8(v.readUInt8(R+1)^O,R+1),o>=3&&v.writeUInt8(v.readUInt8(R+2)^Y,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function a(){const v=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let y;return e.XDG_RUNTIME_DIR?y=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):y=(0,C.join)((0,p.tmpdir)(),`vscode-ipc-${v}.sock`),r(y),y}e.createRandomIPCHandle=a;function t(v,y,T){const R=(0,E.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${T}-${y}-sock`;let o;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${T}-${y}.sock`):o=(0,C.join)(v,`${T}-${y}.sock`),r(o),o}e.createStaticIPCHandle=t;function r(v){const y=l[u.platform];typeof y=="number"&&v.length>=y&&console.warn(`WARNING: IPC handle "${v}" is longer than ${y} chars, try a shorter --user-data-dir`)}class i extends I.IPCServer{constructor(y){super(i.toClientConnectionEvent(y));this.server=y}static toClientConnectionEvent(y){const T=D.Event.fromNodeEventEmitter(y,"connection");return D.Event.map(T,R=>({protocol:new b.Protocol(new h(R)),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function s(v){return new Promise((y,T)=>{const R=(0,P.createServer)();R.on("error",T),R.listen(v,()=>{R.removeListener("error",T),y(new i(R))})})}e.serve=s;function c(v,y){return new Promise((T,R)=>{const o=(0,P.createConnection)(v,()=>{o.removeListener("error",R),T(b.Client.fromSocket(new h(o),y))});o.once("error",R)})}e.connect=c}),define(ce[108],ue([0,1,236,67,2,12,11,194,34,15,17,28,61]),function(X,e,E,P,g,D,I,C,p,w,n,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends g.Disposable{constructor(h,S,d){super();this.environmentService=S,this.logService=d,this.configure(h.getValue()),this._register(h.onDidChangeConfiguration(()=>this.configure(h.getValue()),this))}configure(h){this.proxyUrl=h.http&&h.http.proxy,this.strictSSL=!!(h.http&&h.http.proxyStrictSSL),this.authorization=h.http&&h.http.proxyAuthorization}async request(h,S){this.logService.trace("RequestService#request",h.url);const{proxyUrl:d,strictSSL:_}=this,f={...process.env,...await(0,b.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},l=h.agent?h.agent:await(0,C.getProxyAgent)(h.url||"",f,{proxyUrl:d,strictSSL:_});return h.agent=l,h.strictSSL=_,this.authorization&&(h.headers={...h.headers||{},"Proxy-Authorization":this.authorization}),this._request(h,S)}async getNodeRequest(h){return((0,P.parse)(h.url).protocol==="https:"?await new Promise((_,f)=>{X(["https"],_,f)}):await new Promise((_,f)=>{X(["http"],_,f)})).request}_request(h,S){return new Promise(async(d,_)=>{let f;const l=(0,P.parse)(h.url),a=h.getRawRequest?h.getRawRequest(h):await this.getNodeRequest(h),t={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,D.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(t.auth=h.user+":"+h.password),f=a(t,r=>{const i=(0,D.isNumber)(h.followRedirects)?h.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&i>0&&r.headers.location)this._request({...h,url:r.headers.location,followRedirects:i-1},S).then(d,_);else{let s=r;r.headers["content-encoding"]==="gzip"&&(s=r.pipe((0,E.createGunzip)())),d({res:r,stream:(0,n.streamToBufferReadableStream)(s)})}}),f.on("error",_),h.timeout&&f.setTimeout(h.timeout),h.data&&typeof h.data=="string"&&f.write(h.data),f.end(),S.onCancellationRequested(()=>{f.abort(),_((0,I.canceled)())})})}async resolveProxy(h){}};m=Le([xe(0,p.IConfigurationService),xe(1,A.INativeEnvironmentService),xe(2,w.ILogService)],m),e.RequestService=m}),define(ce[109],ue([0,1,35,100,41,8,5,17,7,50,61,4]),function(X,e,E,P,g,D,I,C,p,w,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function b(d={},_,f,l,a){const t=await(0,P.getNLSConfiguration)(_,l.userDataPath),r=await(0,n.resolveShellEnv)(a,l.args,process.env),i=l.isBuilt?(0,I.join)(l.appRoot,"bin"):(0,I.join)(l.appRoot,"resources","server","bin-dev"),s=process.env;let c=d.PATH||(r?r.PATH:void 0)||s.PATH;c?c=i+I.delimiter+c:c=i;const v={...s,...r,VSCODE_LOG_NATIVE:String(f),VSCODE_AMD_ENTRYPOINT:"vs/server/remoteExtensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(t,void 0,0),...d};return l.args["without-browser-env-var"]||(v.BROWSER=(0,I.join)(i,"helpers",A.isWindows?"browser.cmd":"browser.sh")),h(v,"PATH",c),S(v),v}e.buildUserEnvironment=b;class m{constructor(_,f,l,a,t,r){this.socket=_,this.socketDrain=f,this.initialDataChunk=l,this.skipWebSocketFrames=a,this.permessageDeflate=t,this.inflateBytes=r}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}class u{constructor(_,f,l,a,t,r){this._environmentService=_,this._logService=f,this._reconnectionToken=l,this._onClose=new p.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=a,this._extensionHostProcess=null,this._connectionData=u._toConnectionData(t,r),this._connectionData.socket.pause(),this._log("New connection established.")}_log(_){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${_}`)}_logError(_){this._logService.error(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${_}`)}static _toConnectionData(_,f){return _ instanceof w.NodeSocket?new m(_.socket,_.drain(),f,!0,!1,C.VSBuffer.alloc(0)):new m(_.socket.socket,_.drain(),f,!1,_.permessageDeflate,_.recordedInflateBytes)}async _sendSocketToExtensionHost(_,f){await f.socketDrain;const l=f.toIExtHostSocketMessage();_.send(l,f.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const _={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(_)}acceptReconnection(_,f,l){this._remoteAddress=_,this._log("The client has reconnected.");const a=u._toConnectionData(f,l);if(a.socket.pause(),!this._extensionHostProcess){this._connectionData=a;return}this._sendSocketToExtensionHost(this._extensionHostProcess,a)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(_){try{let f=[];_.port&&!process.pkg&&(f=[`--inspect${_.break?"-brk":""}=0.0.0.0:${_.port}`]);const a={env:await b(_.env,_.language,!!_.debugId,this._environmentService,this._logService),execArgv:f,silent:!0},t=["--type=extensionHost",`--uriTransformerPath=${g.uriTransformerPath}`],r=this._environmentService.args["use-host-proxy"];r!==void 0&&t.push(`--useHostProxy=${r}`),this._extensionHostProcess=E.fork(D.FileAccess.asFileUri("bootstrap-fork",X).fsPath,t,a);const i=this._extensionHostProcess.pid;this._log(`<${i}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const s=p.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),c=p.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");s(y=>console.log("EXTHOST-STDOUT::::::::"+y)),c(y=>console.log("EXTHOST-STDERR::::::::"+y)),this._extensionHostProcess.on("message",y=>{y&&y.type==="__$console"&&(console.log("EXTHOST-LOG:::::"),console.log(y.arguments))}),this._extensionHostProcess.on("error",y=>{this._logError(`<${i}> Extension Host Process had an error`),this._logService.error(y),this._cleanResources()}),this._extensionHostProcess.on("exit",(y,T)=>{this._log(`<${i}> Extension Host Process exited with code: ${y}, signal: ${T}.`),this._cleanResources()});const v=y=>{y.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",v),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",v)}catch(f){console.error("ExtensionHostConnection errored"),f&&console.error(f)}}}e.ExtensionHostConnection=u;function h(d,_,f){const l=Object.keys(d).filter(t=>t.toLowerCase()===_.toLowerCase()),a=l.length>0?l[0]:_;d[a]=f}function S(d){for(let _ of Object.keys(d))d[_]===null&&delete d[_]}}),define(ce[237],ue([0,1,62,15,59,94,34,66,108,68,37,32,96,107,88,29,2,93,65,8,20,45,91,106,69,86,63,89,11,3,5,23]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h,S,d,_,f,l,a,t,r,i,s,c,v,y,T,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class k extends S.Disposable{constructor(me,re){super();this.args=me,this.remoteDataFolder=re,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async re=>{const N=re.get(P.ILogService),W=re.get(A.IExtensionManagementCLIService);try{await this.doRun(W)}catch(U){throw N.error(U),console.error((0,y.getErrorMessage)(U)),U}})}async initServices(){const me=new E.ServiceCollection,re={_serviceBrand:void 0,...h.default};me.set(a.IProductService,re);const N=new i.ServerEnvironmentService(this.args,re);me.set(i.IServerEnvironmentService,N);const W=new P.LogService(new t.SpdLogLogger(r.RemoteExtensionLogFileName,(0,R.join)(N.logsPath,`${r.RemoteExtensionLogFileName}.log`),!0,(0,P.getLogLevel)(N)));me.set(P.ILogService,W),W.trace(`Remote configuration data at ${this.remoteDataFolder}`),W.trace("process arguments:",this.args);const U=this._register(new d.FileService(W));me.set(l.IFileService,U),U.registerProvider(f.Schemas.file,this._register(new _.DiskFileSystemProvider(W)));const j=this._register(new D.ConfigurationService(N.settingsResource,U));return await j.initialize(),me.set(I.IConfigurationService,j),me.set(C.IRequestService,new g.SyncDescriptor(p.RequestService)),me.set(n.ITelemetryService,w.NullTelemetryService),me.set(A.IExtensionGalleryService,new g.SyncDescriptor(b.ExtensionGalleryService)),me.set(A.IExtensionManagementService,new g.SyncDescriptor(m.ExtensionManagementService)),me.set(A.IExtensionManagementCLIService,new g.SyncDescriptor(s.ExtensionManagementCLIService)),me.set(c.ILocalizationsService,new g.SyncDescriptor(v.LocalizationsService)),new u.InstantiationService(me)}async doRun(me){if(this.args["list-extensions"])return me.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"])return me.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],!!this.args["do-not-sync"],!!this.args.force);if(this.args["uninstall-extension"])return me.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return me.locateExtension(this.args["locate-extension"])}asExtensionIdOrVSIX(me){return me.map(re=>/\.vsix$/i.test(re)?T.URI.file((0,R.isAbsolute)(re)?re:(0,R.join)((0,o.cwd)(),re)):re)}}function O(Q){setTimeout(()=>process.exit(Q),0)}async function Y(Q,me){const re=new k(Q,me);try{await re.run(),O(0)}catch(N){O(1)}finally{re.dispose()}}e.run=Y}),define(ce[238],ue([0,1,50,249,27,230,3,211,15]),function(X,e,E,P,g,D,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class w{constructor(b,m,u){this._commands=b,this.logService=m,this._ipcHandlePath=u,this._server=P.createServer((h,S)=>this.onRequest(h,S)),this.setup().catch(h=>(m.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",b=>this.logService.error(b))}catch(b){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(b,m){const u=[];b.setEncoding("utf8"),b.on("data",h=>u.push(h)),b.on("end",()=>{const h=JSON.parse(u.join(""));switch(h.type){case"open":this.open(h,m);break;case"openExternal":this.openExternal(h,m);break;case"status":this.getStatus(h,m);break;case"extensionManagement":this.manageExtensions(h,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${h.type}`,S=>{S&&this.logService.error(S)}),m.end();break}})}open(b,m){let{fileURIs:u,folderURIs:h,forceNewWindow:S,diffMode:d,addMode:_,forceReuseWindow:f,gotoLineMode:l,waitMarkerFilePath:a}=b;const t=[];if(Array.isArray(h))for(const r of h)try{t.push({folderUri:I.URI.parse(r)})}catch(i){}if(Array.isArray(u))for(const r of u)try{(0,C.hasWorkspaceFileExtension)(r)?t.push({workspaceUri:I.URI.parse(r)}):t.push({fileUri:I.URI.parse(r)})}catch(i){}if(t.length){const r=a?I.URI.file(a):void 0,s={forceNewWindow:S,diffMode:d,addMode:_,gotoLineMode:l,forceReuseWindow:f,preferNewWindow:!f&&!r&&!_,waitMarkerFileURI:r};this._commands.executeCommand("_remoteCLI.windowOpen",t,s)}m.writeHead(200),m.end()}async openExternal(b,m){for(const u of b.uris){const h=I.URI.parse(u),S=h.scheme==="file"?h:u;await this._commands.executeCommand("_remoteCLI.openExternal",S)}m.writeHead(200),m.end()}async manageExtensions(b,m){try{const u=d=>d?.map(_=>/\.vsix$/i.test(_)?I.URI.parse(_):_),h={list:b.list,install:u(b.install),uninstall:u(b.uninstall),force:b.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",h);m.writeHead(200),m.write(S)}catch(u){m.writeHead(500),m.write(String(u),h=>{h&&this.logService.error(h)})}m.end()}async getStatus(b,m){try{const u=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(u),m.end()}catch(u){m.writeHead(500),m.write(String(u),h=>{h&&this.logService.error(h)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&g.existsSync(this._ipcHandlePath)&&g.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=w;let n=class extends w{constructor(b,m){super(b,m,(0,E.createRandomIPCHandle)())}};n=Le([xe(0,D.IExtHostCommands),xe(1,p.ILogService)],n),e.CLIServer=n}),define(ce[239],ue([0,1,24,7,18,2,5,4,3,50,29,41,238,218,104,219,223,109]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class _ extends S.AbstractVariableResolverService{constructor(a,t,r,i){super({getFolderUri:s=>{const c=t.filter(v=>v.name===s);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.length,getConfigurationValue:(s,c)=>i[`config:${c}`],getExecPath:()=>a.VSCODE_EXEC_PATH,getAppRoot:()=>a.VSCODE_CWD,getFilePath:()=>{if(r)return I.normalize(r.fsPath)},getSelectedText:()=>i.selectedText,getLineNumber:()=>i.lineNumber},void 0,Promise.resolve(a))}}class f extends D.Disposable{constructor(a,t,r){super();this._environmentService=a,this._logService=t,this._ptyService=r,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new P.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(a,t,r){switch(t){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,r);case"$createProcess":{const i=(0,A.createRemoteURITransformer)(a.remoteAuthority);return this._createProcess(i,r)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,r);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,r);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,r);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,r);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,r);case"$start":return this._ptyService.start.apply(this._ptyService,r);case"$input":return this._ptyService.input.apply(this._ptyService,r);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,r);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,r);case"$resize":return this._ptyService.resize.apply(this._ptyService,r);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,r);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,r);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,r);case"$sendCommandResult":return this._sendCommandResult(r[0],r[1],r[2]);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,r);case"$getProfiles":return this._getProfiles.apply(this,r);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(r[0]);case"$getTerminalLayoutInfo":return this._getTerminalLayoutInfo(r);case"$setTerminalLayoutInfo":return this._setTerminalLayoutInfo(r);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,r);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,r);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(r[0],r[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(r[0],r[1])}throw new Error(`IPC Command ${t} not found`)}listen(a,t,r){switch(t){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||P.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||P.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||P.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||P.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||P.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessTitleChangedEvent":return this._ptyService.onProcessTitleChanged;case"$onProcessShellTypeChangedEvent":return this._ptyService.onProcessShellTypeChanged;case"$onProcessOverrideDimensionsEvent":return this._ptyService.onProcessOverrideDimensions;case"$onProcessResolvedShellLaunchConfigEvent":return this._ptyService.onProcessResolvedShellLaunchConfig;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onProcessDidChangeHasChildProcesses":return this._ptyService.onProcessDidChangeHasChildProcesses;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||P.Event.None;default:break}throw new Error("Not supported")}async _createProcess(a,t){const r={name:t.shellLaunchConfig.name,executable:t.shellLaunchConfig.executable,args:t.shellLaunchConfig.args,cwd:typeof t.shellLaunchConfig.cwd=="string"||typeof t.shellLaunchConfig.cwd=="undefined"?t.shellLaunchConfig.cwd:p.URI.revive(a.transformIncoming(t.shellLaunchConfig.cwd)),env:t.shellLaunchConfig.env,useShellEnvironment:t.shellLaunchConfig.useShellEnvironment};let i;t.shellLaunchConfig.useShellEnvironment?(this._logService.trace("*"),i=await(0,d.buildUserEnvironment)(t.resolverEnv,C.language,!1,this._environmentService,this._logService)):i=this._getEnvironment(),this._logService.trace("baseEnv",i);const s=W=>({uri:p.URI.revive(a.transformIncoming(W.uri)),name:W.name,index:W.index,toResource:()=>{throw new Error("Not implemented")}}),c=t.workspaceFolders.map(s),v=t.activeWorkspaceFolder?s(t.activeWorkspaceFolder):void 0,y=t.activeFileResource?p.URI.revive(a.transformIncoming(t.activeFileResource)):void 0,T=new _(i,c,y,t.resolvedVariables),R=h.createVariableResolver(v,process.env,T),o=h.getCwd(r,E.homedir(),R,v?.uri,t.configuration["terminal.integrated.cwd"],this._logService);r.cwd=o;const k=C.isWindows?"terminal.integrated.env.windows":C.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",O=t.configuration[k],Y=h.createTerminalEnvironment(r,O,R,n.default.version,t.configuration["terminal.integrated.detectLocale"],i);if(!r.strictEnv){const W=[];for(const[H,M]of t.envVariableCollections)W.push([H,{map:(0,u.deserializeEnvironmentVariableCollection)(M)}]);const U=new Map(W);new m.MergedEnvironmentVariableCollection(U).applyToProcessEnvironment(Y)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:o,cols:t.cols,rows:t.rows,env:Y});const Q=(0,w.createRandomIPCHandle)();Y.VSCODE_IPC_HOOK_CLI=Q;const me={executeCommand:(W,...U)=>this._executeCommand(W,U,a)},re=new b.CLIServerBase(me,this._logService,Q),N=await this._ptyService.createProcess(r,o,t.cols,t.rows,Y,i,!1,t.shouldPersistTerminal,t.workspaceId,t.workspaceName);return this._ptyService.onProcessExit(W=>W.id===N&&re.dispose()),{persistentTerminalId:N,resolvedShellLaunchConfig:r}}_executeCommand(a,t,r){let i,s;const c=new Promise((T,R)=>{i=T,s=R}),v=++this._lastReqId;this._pendingCommands.set(v,{resolve:i,reject:s,uriTransformer:r});const y=(0,g.cloneAndChange)(t,T=>{if(T&&T.$mid===1)return r.transformOutgoing(T);if(T&&T instanceof p.URI)return r.transformOutgoingURI(T)});return this._onExecuteCommand.fire({reqId:v,commandId:a,commandArgs:y}),c}_sendCommandResult(a,t,r){const i=this._pendingCommands.get(a);if(!i)return;this._pendingCommands.delete(a);const s=(0,g.cloneAndChange)(r,c=>{if(c&&c.$mid===1)return i.uriTransformer.transformIncoming(c)});t?i.reject(s):i.resolve(s)}_getDefaultSystemShell(a){return this._ptyService.getDefaultSystemShell(a)}async _getProfiles(a,t,r,i){return this._ptyService.getProfiles?.(a,t,r,i)||[]}_getEnvironment(){return{...process.env}}_getWslPath(a){return this._ptyService.getWslPath(a)}_setTerminalLayoutInfo(a){this._ptyService.setTerminalLayoutInfo(a)}async _getTerminalLayoutInfo(a){return this._ptyService.getTerminalLayoutInfo(a)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=f}),define(ce[240],ue([0,1,64,27,79,67,24,48,241,17,2,22,16,126,4,82,50,109,212,41,15,8,29,28,62,59,94,34,66,108,68,37,32,96,107,88,85,164,63,89,202,201,197,78,93,65,20,45,36,7,232,213,233,193,169,203,163,90,214,3,31,69,5,226,239,110,106,86,91,97,210]),function(X,e,E,P,g,D,I,C,p,w,n,A,b,m,u,h,S,d,_,f,l,a,t,r,i,s,c,v,y,T,R,o,k,O,Y,Q,me,re,N,W,U,j,H,M,q,z,V,K,ae,fe,De,Pe,Fe,Ne,ze,Xe,nt,it,rt,pe,Ce,Ae,Re,Me,$e,He,Ye,tt,ne,Se,Ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const Ue=5*60*1e3,he=`

*
* Visual Studio Code Server
*
* Reminder: You may only use this software with Visual Studio family products,
* as described in the license https://aka.ms/vscode-remote/license
*

`,ge="monacoworkbench";class ye extends ae.IPCServer{constructor(){const ee=new fe.Emitter;super(ee.event);this._onDidConnectEmitter=ee}acceptConnection(ee,we){this._onDidConnectEmitter.fire({protocol:ee,onDidClientDisconnect:we})}}function G(ve){return ve<10?`0${ve}`:String(ve)}function J(){const ve=new Date;return`${G(ve.getHours())}:${G(ve.getMinutes())}:${G(ve.getSeconds())}`}class te extends l.AbstractLogger{constructor(ee=l.DEFAULT_LOG_LEVEL){super();this.setLevel(ee),this.useColors=Boolean(process.stdout.isTTY)}trace(ee,...we){this.getLevel()<=l.LogLevel.Trace&&(this.useColors?console.log(`[90m[${J()}][0m`,ee,...we):console.log(`[${J()}]`,ee,...we))}debug(ee,...we){this.getLevel()<=l.LogLevel.Debug&&(this.useColors?console.log(`[90m[${J()}][0m`,ee,...we):console.log(`[${J()}]`,ee,...we))}info(ee,...we){this.getLevel()<=l.LogLevel.Info&&(this.useColors?console.log(`[90m[${J()}][0m`,ee,...we):console.log(`[${J()}]`,ee,...we))}warn(ee,...we){this.getLevel()<=l.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${J()}][0m`,ee,...we):console.warn(`[${J()}]`,ee,...we))}error(ee,...we){this.getLevel()<=l.LogLevel.Error&&(this.useColors?console.error(`[91m[${J()}][0m`,ee,...we):console.error(`[${J()}]`,ee,...we))}critical(ee,...we){this.getLevel()<=l.LogLevel.Critical&&(this.useColors?console.error(`[90m[${J()}][0m`,ee,...we):console.error(`[${J()}]`,ee,...we))}dispose(){}flush(){}}class oe extends n.Disposable{constructor(ee,we,_e,Te,Oe,je){super();this._environmentService=ee,this._productService=we,this._connectionToken=_e,this._connectionTokenIsMandatory=Te;const qe=se(this._environmentService);qe.trace(`Remote configuration data at ${je}`),qe.trace("process arguments:",this._environmentService.args),qe.info(he),this._logService=new l.MultiplexLogService([new te((0,l.getLogLevel)(this._environmentService)),qe]),this._socketServer=new ye,this._uriTransformerCache=Object.create(null),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),Oe?this._webClientServer=new rt.WebClientServer(this._connectionToken,this._environmentService,this._logService):this._webClientServer=null,this._logService.info("Extension host agent started.")}async initialize(){const ee=await this._createServices();return setTimeout(()=>this._cleanupOlderLogs(this._environmentService.logsPath).then(null,we=>this._logService.error(we)),1e4),ee}async _createServices(){const ee=new i.ServiceCollection;this._socketServer.registerChannel(nt.ExtensionHostDebugBroadcastChannel.ChannelName,new nt.ExtensionHostDebugBroadcastChannel);const we=new ae.StaticRouter(Je=>Je.clientId==="renderer");this._socketServer.registerChannel("logger",new it.LogLevelChannel(this._logService)),ee.set(r.IEnvironmentService,this._environmentService),ee.set(r.INativeEnvironmentService,this._environmentService),ee.set(l.ILogService,this._logService),ee.set(K.IProductService,this._productService);const _e=this._register(new q.FileService(this._logService));ee.set(V.IFileService,_e),_e.registerProvider(a.Schemas.file,this._register(new z.DiskFileSystemProvider(this._logService))),ee.set(v.IConfigurationService,new s.SyncDescriptor(c.ConfigurationService,[this._environmentService.machineSettingsResource,_e])),ee.set(y.IRequestService,new s.SyncDescriptor(T.RequestService));let Te=R.NullAppender;if(!this._environmentService.args["disable-telemetry"]&&t.default.enableTelemetry){t.default.aiConfig&&t.default.aiConfig.asimovKey&&(Te=new U.AppInsightsAppender(ge,null,t.default.aiConfig.asimovKey),this._register((0,n.toDisposable)(()=>Te.flush())));const Je=await(0,M.getMachineId)(),Ve={appender:Te,commonProperties:(0,H.resolveCommonProperties)(_e,(0,I.release)(),(0,I.hostname)(),process.arch,t.default.commit,t.default.version+"-remote",Je,t.default.msftInternalDomains,this._environmentService.installSourcePath,"remoteAgent"),piiPaths:[this._environmentService.appRoot]};ee.set(o.ITelemetryService,new s.SyncDescriptor(j.TelemetryService,[Ve]))}else ee.set(o.ITelemetryService,R.NullTelemetryService);ee.set(k.IExtensionGalleryService,new s.SyncDescriptor(O.ExtensionGalleryService));const Oe=this._socketServer.getChannel("download",we);ee.set(me.IDownloadService,new re.DownloadServiceChannelClient(Oe,()=>this._getUriTransformer("renderer"))),ee.set(k.IExtensionManagementService,new s.SyncDescriptor(Y.ExtensionManagementService));const je=new Q.InstantiationService(ee);ee.set(N.ILocalizationsService,je.createInstance(W.LocalizationsService));const qe=je.createInstance(tt.ExtensionManagementCLIService);ee.set(k.IExtensionManagementCLIService,qe);const Ze=je.createInstance(Ee.PtyHostService,{GraceTime:108e5,ShortGraceTime:3e5});return ee.set(Se.IPtyService,Ze),je.invokeFunction(Je=>{const Ve=new De.RemoteAgentEnvironmentChannel(this._connectionToken,this._environmentService,qe,this._logService,Je.get(o.ITelemetryService),Te);this._socketServer.registerChannel("remoteextensionsenvironment",Ve),this._socketServer.registerChannel(Me.REMOTE_TERMINAL_CHANNEL_NAME,new $e.RemoteTerminalChannel(this._environmentService,this._logService,Ze));const le=new Pe.RemoteAgentFileSystemChannel(this._logService,this._environmentService);this._socketServer.registerChannel(Fe.REMOTE_FILE_SYSTEM_CHANNEL_NAME,le),this._socketServer.registerChannel("request",new Ne.RequestChannel(Je.get(y.IRequestService)));const de=Je.get(k.IExtensionManagementService),Z=new ze.ExtensionManagementChannel(de,$=>this._getUriTransformer($.remoteAuthority));return this._socketServer.registerChannel("extensions",Z),de.removeDeprecatedExtensions(),this._register(new Xe.default(Je.get(o.ITelemetryService))),{telemetryService:Je.get(o.ITelemetryService)}})}_getUriTransformer(ee){return this._uriTransformerCache[ee]||(this._uriTransformerCache[ee]=(0,f.createRemoteURITransformer)(ee)),this._uriTransformerCache[ee]}async handleRequest(ee,we){if(ee.method!=="GET")return(0,rt.serveError)(ee,we,405,`Unsupported method ${ee.method}`);if(!ee.url)return(0,rt.serveError)(ee,we,400,"Bad request.");const _e=D.parse(ee.url,!0),Te=_e.pathname;if(!Te)return(0,rt.serveError)(ee,we,400,"Bad request.");if(Te==="/version")return we.writeHead(200,{"Content-Type":"text/plain"}),we.end(t.default.commit||"");if(Te==="/delay-shutdown")return this._delayShutdown(),we.writeHead(200),we.end("OK");if(Te==="/vscode-remote-resource"){if(_e.query.tkn!==this._connectionToken)return(0,rt.serveError)(ee,we,403,"Forbidden.");const Oe=_e.query.path;if(typeof Oe!="string")return(0,rt.serveError)(ee,we,400,"Bad request.");let je;try{je=pe.URI.from({scheme:a.Schemas.file,path:Oe}).fsPath}catch(Ze){return(0,rt.serveError)(ee,we,400,"Bad request.")}const qe=Object.create(null);return this._environmentService.isBuilt&&((0,Ce.isEqualOrParent)(je,this._environmentService.builtinExtensionsPath,!u.isLinux)||(0,Ce.isEqualOrParent)(je,this._environmentService.extensionsPath,!u.isLinux))&&(qe["Cache-Control"]="public, max-age=31536000"),(0,rt.serveFile)(this._logService,ee,we,je,qe)}if(this._webClientServer){this._webClientServer.handle(ee,we,_e);return}return we.writeHead(404,{"Content-Type":"text/plain"}),we.end("Not found")}handleUpgrade(ee,we){let _e=(0,A.generateUuid)(),Te=!1,Oe=!1;if(ee.url){const le=D.parse(ee.url,!0).query;typeof le.reconnectionToken=="string"&&(_e=le.reconnectionToken),le.reconnection==="true"&&(Te=!0),le.skipWebSocketFrames==="true"&&(Oe=!0)}if(ee.headers.upgrade!=="websocket"){we.end("HTTP/1.1 400 Bad Request");return}const je=ee.headers["sec-websocket-key"],qe=E.createHash("sha1");qe.update(je+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const Ze=qe.digest("base64"),Je=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${Ze}`];let Ve=!1;if(!Oe&&!this._environmentService.args["disable-websocket-compression"]&&ee.headers["sec-websocket-extensions"]){const le=Array.isArray(ee.headers["sec-websocket-extensions"])?ee.headers["sec-websocket-extensions"]:[ee.headers["sec-websocket-extensions"]];for(const de of le)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(de)){if(/\b(permessage-deflate)\b/.test(de)){Ve=!0,Je.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(de)){Ve=!0,Je.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}we.write(Je.join(`\r
`)+`\r
\r
`),we.setTimeout(0),Oe?this._handleWebSocketConnection(new S.NodeSocket(we),Te,_e):this._handleWebSocketConnection(new S.WebSocketNodeSocket(new S.NodeSocket(we),Ve,null,!0),Te,_e)}handleServerError(ee){this._logService.error("Error occurred in server"),this._logService.error(ee)}async _cleanupOlderLogs(ee){const we=(0,Re.basename)(ee),_e=(0,Re.dirname)(ee),je=(await b.Promises.readdir(_e)).filter(Ze=>/^\d{8}T\d{6}$/.test(Ze)).sort().filter(Ze=>Ze!==we),qe=je.slice(0,Math.max(0,je.length-9));await Promise.all(qe.map(Ze=>b.Promises.rm((0,Re.join)(_e,Ze))))}_getRemoteAddress(ee){let we;return ee instanceof S.NodeSocket?we=ee.socket:we=ee.socket.socket,we.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(ee,we,_e){const Te=we.getSocket();this._logService.error(`${ee} ${_e}.`);const Oe={type:"error",reason:_e};we.sendControl(w.VSBuffer.fromString(JSON.stringify(Oe))),we.dispose(),await Te.drain(),Te.dispose()}_handleWebSocketConnection(ee,we,_e){const Te=this._getRemoteAddress(ee),Oe=`[${Te}][${_e.substr(0,8)}]`,je=new h.PersistentProtocol(ee);let qe;try{const de=X.__$__nodeRequire("vsda");qe=new de.validator}catch(de){}let Ze;(function(de){de[de.WaitingForAuth=0]="WaitingForAuth",de[de.WaitingForConnectionType=1]="WaitingForConnectionType",de[de.Done=2]="Done",de[de.Error=3]="Error"})(Ze||(Ze={}));let Je=0;const Ve=de=>{Je=3,le.dispose(),this._rejectWebSocketConnection(Oe,je,de)},le=je.onControlMessage(de=>{if(Je===0){let Z;try{Z=JSON.parse(de.toString())}catch(Ie){return Ve("Malformed first message")}if(Z.type!=="auth")return Ve("Invalid first message");if(this._connectionTokenIsMandatory&&Z.auth!==this._connectionToken)return Ve("Unauthorized client refused: auth mismatch");let $="VS Code Headless is cool";if(qe)try{$=qe.createNewMessage($)}catch(Ie){}const ke={type:"sign",data:$};je.sendControl(w.VSBuffer.fromString(JSON.stringify(ke))),Je=1}else if(Je===1){let Z;try{Z=JSON.parse(de.toString())}catch(Ge){return Ve("Malformed second message")}if(Z.type!=="connectionType")return Ve("Invalid second message");if(typeof Z.signedData!="string")return Ve("Invalid second message field type");const $=Z.commit,ke=t.default.commit;if($&&ke&&$!==ke)return Ve("Client refused: version mismatch");let Ie=!1;if(Z.signedData===this._connectionToken)Ie=!0;else if(qe)try{Ie=qe.validate(Z.signedData)==="ok"}catch(Ge){}if(!Ie){if(this._environmentService.isBuilt)return Ve("Unauthorized client refused");this._logService.error(`${Oe} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let Ge in this._managementConnections)this._managementConnections[Ge].shortenReconnectionGraceTimeIfNecessary();for(let Ge in this._extHostConnections)this._extHostConnections[Ge].shortenReconnectionGraceTimeIfNecessary();Je=2,le.dispose(),this._handleConnectionType(Te,Oe,je,ee,we,_e,Z)}})}async _handleConnectionType(ee,we,_e,Te,Oe,je,qe){const Ze=qe.desiredConnectionType===1?`${we}[ManagementConnection]`:qe.desiredConnectionType===2?`${we}[ExtensionHostConnection]`:we;if(qe.desiredConnectionType===1)if(Oe){if(!this._managementConnections[je])return this._rejectWebSocketConnection(Ze,_e,"Unknown reconnection token");_e.sendControl(w.VSBuffer.fromString(JSON.stringify({type:"ok"})));const Je=_e.readEntireBuffer();_e.dispose(),this._managementConnections[je].acceptReconnection(ee,Te,Je)}else{if(this._managementConnections[je])return this._rejectWebSocketConnection(Ze,_e,"Duplicate reconnection token");_e.sendControl(w.VSBuffer.fromString(JSON.stringify({type:"ok"})));const Je=new _.ManagementConnection(this._logService,je,ee,_e);this._socketServer.acceptConnection(Je.protocol,Je.onClose),this._managementConnections[je]=Je,Je.onClose(()=>{delete this._managementConnections[je]})}else if(qe.desiredConnectionType===2){const Je=qe.args||{language:"en"},Ve=await this._updateWithFreeDebugPort(Je);if(Ve.port&&this._logService.trace(`${Ze} - startParams debug port ${Ve.port}`),this._logService.trace(`${Ze} - startParams language: ${Ve.language}`),this._logService.trace(`${Ze} - startParams env: ${JSON.stringify(Ve.env)}`),Oe){if(!this._extHostConnections[je])return this._rejectWebSocketConnection(Ze,_e,"Unknown reconnection token");_e.sendControl(w.VSBuffer.fromString(JSON.stringify(Ve.port?{debugPort:Ve.port}:{})));const le=_e.readEntireBuffer();_e.dispose(),this._extHostConnections[je].acceptReconnection(ee,Te,le)}else{if(this._extHostConnections[je])return this._rejectWebSocketConnection(Ze,_e,"Duplicate reconnection token");_e.sendControl(w.VSBuffer.fromString(JSON.stringify(Ve.port?{debugPort:Ve.port}:{})));const le=_e.readEntireBuffer();_e.dispose();const de=new d.ExtensionHostConnection(this._environmentService,this._logService,je,ee,Te,le);this._extHostConnections[je]=de,de.onClose(()=>{delete this._extHostConnections[je],this._onDidCloseExtHostConnection()}),de.start(Ve)}}else if(qe.desiredConnectionType===3){const Je=qe.args;this._createTunnel(_e,Je)}else return this._rejectWebSocketConnection(Ze,_e,"Unknown initial data received")}async _createTunnel(ee,we){const _e=ee.getSocket().socket,Te=ee.readEntireBuffer();ee.dispose(),_e.pause();const Oe=await this._connectTunnelSocket(we.port);Te.byteLength>0&&Oe.write(Te.buffer),Oe.on("end",()=>_e.end()),Oe.on("close",()=>_e.end()),Oe.on("error",()=>_e.destroy()),_e.on("end",()=>Oe.end()),_e.on("close",()=>Oe.end()),_e.on("error",()=>Oe.destroy()),Oe.pipe(_e),_e.pipe(Oe)}_connectTunnelSocket(ee){return new Promise((we,_e)=>{const Te=g.createConnection({port:ee},()=>{Te.removeListener("error",_e),Te.pause(),we(Te)});Te.once("error",_e)})}_updateWithFreeDebugPort(ee){return typeof ee.port=="number"?(0,m.findFreePort)(ee.port,10,5e3).then(we=>(ee.port=we,ee)):(ee.debugId=void 0,ee.port=void 0,ee.break=void 0,Promise.resolve(ee))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},Ue))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}}e.RemoteExtensionHostAgentServer=oe;function B(ve){if(ve["connection-secret"]){ve.connectionToken&&(console.warn("Please do not use the argument connectionToken at the same time as connection-secret."),process.exit(1));let ee=P.readFileSync(ve["connection-secret"]).toString();return ee=ee.replace(/\r?\n$/,""),/^[0-9A-Za-z\-]+$/.test(ee)||(console.warn(`The secret defined in ${ve["connection-secret"]} does not adhere to the characters 0-9, a-z, A-Z or -.`),process.exit(1)),{connectionToken:ee,connectionTokenIsMandatory:!0}}else return{connectionToken:ve.connectionToken||(0,A.generateUuid)(),connectionTokenIsMandatory:!1}}async function ie(ve,ee,we){const _e={_serviceBrand:void 0,...t.default},Te=new Ae.ServerEnvironmentService(ee,_e);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const ke=(0,Re.join)(process.env.HOMEDRIVE,"node_modules"),Ie=(0,Re.dirname)((0,Re.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Ge=(0,Re.join)(Ie,"node_modules");if(P.existsSync(ke)||P.existsSync(Ge)){const We=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${ke}
* ${Ge}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;se(Te).warn(We),console.warn(We),process.exit(0)}}const{connectionToken:Oe,connectionTokenIsMandatory:je}=B(ee),qe=P.existsSync(a.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",X).fsPath);qe&&ve&&typeof ve!="string"&&console.log(`Web UI available at http://localhost${ve.port===80?"":`:${ve.port}`}/?tkn=${Oe}`);const Ze=new oe(Te,_e,Oe,je,qe,we),Je=await Ze.initialize(),{telemetryService:Ve}=Je;C.mark("code/server/ready");const le=p.performance.now(),de=global.vscodeServerStartTime,Z=global.vscodeServerListenTime,$=global.vscodeServerCodeLoadedTime;if(Ve.publicLog2("serverStart",{startTime:de,startedTime:Z,codeLoadedTime:$,readyTime:le}),ee["print-startup-performance"]){const ke=He.LoaderStats.get();let Ie="";Ie+=`

### Load AMD-module
`,Ie+=He.LoaderStats.toMarkdownTable(["Module","Duration"],ke.amdLoad),Ie+=`

### Load commonjs-module
`,Ie+=He.LoaderStats.toMarkdownTable(["Module","Duration"],ke.nodeRequire),Ie+=`

### Invoke AMD-module factory
`,Ie+=He.LoaderStats.toMarkdownTable(["Module","Duration"],ke.amdInvoke),Ie+=`

### Invoke commonjs-module
`,Ie+=He.LoaderStats.toMarkdownTable(["Module","Duration"],ke.nodeEval),Ie+=`Start-up time: ${Z-de}
`,Ie+=`Code loading time: ${$-de}
`,Ie+=`Initialized time: ${le-de}
`,Ie+=`
`,console.log(Ie)}return Ze}e.createServer=ie;const se=function(){let ve;return function(we){return ve||(ve=new l.LogService(new ne.SpdLogLogger(Ye.RemoteExtensionLogFileName,(0,Re.join)(we.logsPath,`${Ye.RemoteExtensionLogFileName}.log`),!0,(0,l.getLogLevel)(we)))),ve}}()}),define(ce[250],ue([0,1,24,27,8,237,240,57,5,241,69,48]),function(X,e,E,P,g,D,I,C,p,w,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,A.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=w.performance.now();const b={onMultipleValues:(r,i)=>{console.error(`Option ${r} can only be defined once. Using value ${i}.`)},onUnknownOption:r=>{console.error(`Ignoring option ${r}: not supported for server.`)}},m=(0,C.parseArgs)(process.argv.slice(2),n.serverOptions,b),u=process.env.VSCODE_AGENT_FOLDER||(0,p.join)(E.homedir(),".vscode-remote"),h=(0,p.join)(u,"data"),S=(0,p.join)(h,"User"),d=(0,p.join)(S,"globalStorage"),_=(0,p.join)(h,"Machine");m["user-data-dir"]=h;const f=(0,p.dirname)(g.FileAccess.asFileUri("",X).fsPath),l=(0,p.join)(f,"extensions");m["builtin-extensions-dir"]=l,m["extensions-dir"]=m["extensions-dir"]||(0,p.join)(u,"extensions"),[u,m["extensions-dir"],h,S,_,d].forEach(r=>{try{P.existsSync(r)||P.mkdirSync(r)}catch(i){console.error(i)}});function a(){(0,D.run)(m,u)}e.spawnCli=a;function t(r){return(0,I.createServer)(r,m,u)}e.createServer=t})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/379476f0e13988d90fab105c5c19e7abc8b1dea8/core/vs/server/remoteExtensionHostAgent.js.map
